package assays.com;
import java.util.*;

import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.StatelessSession;
import org.hibernate.Query;
import org.hibernate.HibernateException;

import javax.servlet.http.*;
import assays.hibernate.*;

import java.lang.reflect.Method;
import javax.servlet.ServletContext;

import java.io.File;
import assays.pri.WebappConfig;
import sims.hibernate.BottomMetaData;
import sims.hibernate.MiddleMetaData;
import sims.hibernate.TopMetaData;
import sims.hibernate.STechnology;
import assays.services.RequestTechnology;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author Andris Zarins
 * @version 1.0
 */

public final class UserHttpSession {
  public UserHttpSession() {
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  private HttpSession httpSess = null;
  private String httpSessId = null;
  private Session hibSess = null;
  private Session sampleSess = null;
  private File protocolTempFile = null;
  private File dataTempFile = null;
  private File parameterTempFile = null;
  private File XMLTempFile = null;
  private File zipTempFile = null;
  private File exportcfgTempFile = null;
  private FileString protocolFileString = null;
  private FileString dataFileString = null;
  private File protTechnDirectory = null;
  private File dataTechnDirectory = null;
//batch upload
  private BatchAnalyser ban = null;
//batch edit
  private int assayBatchLevel = 0; //0 no; 1 edit; 2 export 
  private int studyBatchLevel = 0; //0 no; 1 edit; 2 export; 3 viewdef 
  private int viewBatchLevel = 0; //0 no; 1 edit; 2 export 
//  private String[] assayBatchArray = null;
//  private String[] studyBatchArray = null;
//  private String[] viewBatchArray = null;
//aliquots selected by user,while assay dialog remains open
  private String[] additionalSimsRef = null;
  private int simsRefType = 0;   //1-top; 2--middle; 3-bottom;
  private TechnologyData tempTechnologyData = null;
  private Long tempBottomId;
  private Long tempMiddleId;
  private Long tempTopId;
  private String tempSysId = null;
  private boolean tempMultiple = false;
  private String tempAliquotName;
  private String tempCohortName;
  
  private AssayUser currentUser = null;
//currentUser rights
  private int[] grantingOwners = null;
  private int[] grantedRights = null;
  private int[] grantedDefineView = null;
  private int grantingUserCount = 0;
  private int[] grantingGroups = null;
  private int[] grantedGroupRights = null;
  private int[] grantedGroupDefineView = null;
  private int grantingGroupCount = 0;
  private int technolCount = 0;
//mdm collects metadata used by view pages
  private MetadataManager mdm = null;
  private ViewAssayManager vam = null;
  private ViewGroupManager vgm = null;
  private ViewViewManager vvm = null;
  private ViewBatchManager batchMan = null;
  private RequestTechnology srt = null;
  private Technology currentTechnology = null;
  private StudyView currentStudyView = null;
  private StudyGroup currentStudyGroup = null;
  private Assay currentAssay = null;
  private StudyView tempStudyView = null;
  private StudyGroup tempStudyGroup = null;
  private Assay tempAssay = null;
  private String viewSortCol = AssayFieldname.IDENTIFSTRING;
  private String groupSortCol = AssayFieldname.IDENTIFSTRING;
  private String assaySortCol = AssayFieldname.IDENTIFSTRING;
  private boolean viewSortDir = true; //true - asc; false - desc
  private boolean groupSortDir = true; //true - asc; false - desc
  private boolean assaySortDir = true;
  private HashMap<String,Integer> invalidFields = null;
  //filtering
  private FilterObject filter = null;
  private HashMap<String, String> filterValues = null;
  private HashMap aliquotFilterValues = null;
  private String aliquotSearchString = null;

  private static final String[] myMessage = {
      "", "Internal error",
      "Invalid or missing identifier",
      "Duplicate identifier in database",
      "Error while retrieving data",
      "Invalid or missing date",
      "You have read rights only",
      "Invalid or missing number",
      "(position mouse on highlighted field).",
      "Length of string exceeds 200 characters",
      "Mandatory value missing",   //10
      "Invalid or missing time",
      "Misuse of \"Back\" command",
      "Length of comment exceeds 4000 characters",
      "Data non-accessible"
  };

  private int topNum = 0;
  public void setTopNum( int val){ topNum = val;}
  public int getTopNum(){ return topNum;}
//-------------------------------------------
  private int dataTransferRights = 0;
  private int dataExportRights = 0;
  private int dataFileExportRights = 0;
  private int createRights = 0;
  private int vocabularyRights = 0;
  private int configurationRights = 0;
//-------------------------------------------
  private void initializeRights() {
    if (currentUser.isWriteAdministrator())
      initializeRights(3000, 3000, 3000, 2000, 1000, 1000);
    else
    if (currentUser.isAdministrator())
      initializeRights(0, 1000, 1000, 2000, 1000, 1000);
    else
      initializeRights(0, 0, 0, 0, 0, 0);
  }
  private void initializeRights( int creat, int vocab, int config,
		  int export, int fexport, int transf) {
    configurationRights = config;
    vocabularyRights = vocab;
    createRights = creat;
    dataExportRights = export;
    dataFileExportRights = fexport;
    dataTransferRights = transf;
  }
  public boolean hasExportRights() {
    return dataExportRights > 0||dataTransferRights > 0||dataFileExportRights > 0;
  }
  public boolean hasDataTransferRights() {
    return dataTransferRights > 0;
  }
  public boolean hasDataFileExportRights() {
    return dataFileExportRights > 0;
  }
  public boolean hasPredefinedExportRights() {
    return dataExportRights >= 1000;
  }
  public boolean hasUserDefinedExportRights() {
    return dataExportRights >= 2000;
  }
  public boolean isVocabSession(){
    return vocabularyRights >= 1000;
  }
  public boolean isWriteVocabSession(){
    return vocabularyRights >= 2000;
  }
  public boolean isPowerVocabSession(){
    return vocabularyRights >= 3000;
  }
  public boolean isConfigSession(){
    return configurationRights >= 1000;
  }
  public boolean isWriteConfigSession(){
    return configurationRights >= 2000;
  }
  public boolean isPowerConfigSession(){
    return configurationRights >= 3000;
  }
  public boolean isCreateSession(){
    return createRights > 0;
  }
  public RequestTechnology getRequestTechnology() {
	if (srt==null) srt = new RequestTechnology();
	return srt;
  }

  public void resetRequestTechnology() {
	srt = null;  
  }
  
  public void setAliquotFilter(HttpServletRequest request) {
    AliquotFilterObject afo = new AliquotFilterObject();
    aliquotFilterValues = afo.setAliquotFilter(request);
    aliquotSearchString = afo.getAliquotString();
  }

  public void resetAliquotFilter() {
    aliquotFilterValues = null;
    aliquotSearchString = null;
  }

  public void setFilter(HttpServletRequest request) {
    filter = new FilterObject();
    filterValues = filter.setFilter( request);
    vvm.clearValues(); vgm.clearValues(); vam.clearValues();
  }
  public void setFilterViewId( String idValue) {
    filter.setViewId( idValue, filterValues);
    vvm.clearValues(); vgm.clearValues(); vam.clearValues();
  }
  public void clearFilterViewId() {
    filter.clearViewId( filterValues);
    if (filterValues.isEmpty()) filter = null;
    vvm.clearValues(); vgm.clearValues(); vam.clearValues();
  }
  public void setFilterGroupId( String idValue) {
    filter.setGroupId( idValue, filterValues);
    vvm.clearValues(); vgm.clearValues(); vam.clearValues();
  }
  public void clearFilterGroupId() {
    filter.clearGroupId( filterValues);
    if (filterValues.isEmpty()) filter = null;
    vvm.clearValues(); vgm.clearValues(); vam.clearValues();
  }

  public String getFilterValue( String key) {
    String xyz = null;
    if ( filterValues != null) xyz = (String) filterValues.get( key);
    return xyz;
  }

  public void cancelFilter() {
    filter = null;
    vvm.clearValues(); vgm.clearValues(); vam.clearValues();//added 13.07.07
  }

  public boolean isFilter() {
    return (filter != null && !filterValues.isEmpty());
  }
  public String getFilterText() {
    return (filter != null)?filter.getFilterText():"";
  }
  public boolean isFiltered( int level) {
    return (filter != null && filter.isFiltered( level));
  }
//-------batch assay edit-----------------------------------------
  public boolean isBatchAvailable(){
    return batchMan!=null && batchMan.getSelectedCount()>0;
  }  
  public Long[] getSelectedBatchArray(){
    return batchMan.getBatchArray();                   
  }
  public List getSelectedBatchList(){
    return Arrays.asList(batchMan.getBatchArray());                   
  }
//  public List getAssayBatchArray(){
//    return Arrays.asList(assayBatchArray);
//  }
//  public List getStudyBatchArray(){
//    return Arrays.asList(studyBatchArray);
//  }
//  public List getViewBatchArray(){
//    return Arrays.asList(viewBatchArray);
//}
  public void setAssayBatchForEdit() throws Exception{
    assayBatchLevel = 1;
	batchMan = new ViewBatchManager( this, vam.getAssayTotal(), 2, assayBatchLevel);  
  }
  public void setAssayBatchForExport() throws Exception{
    assayBatchLevel = 2;
	batchMan = new ViewBatchManager( this, vam.getAssayTotal(), 2, assayBatchLevel);  
  }
  public void changeAssayBatch() throws Exception{
	batchMan = new ViewBatchManager( this, vam.getAssayTotal(), 2, assayBatchLevel);  
  }
  public void setStudyBatchForEdit() throws Exception{
    studyBatchLevel = 1;
    batchMan = new ViewBatchManager( this, vgm.getGroupTotal(), 1, studyBatchLevel);  
  }
  public void setStudyBatchForExport() throws Exception{
    studyBatchLevel = 2;
    batchMan = new ViewBatchManager( this, vgm.getGroupTotal(), 1, studyBatchLevel);  
  }
  public void changeStudyBatch() throws Exception{
    batchMan = new ViewBatchManager( this, vgm.getGroupTotal(), 1, studyBatchLevel);  
  }
  public void setViewBatchForEdit() throws Exception{
    viewBatchLevel = 1;
    batchMan = new ViewBatchManager( this, vvm.getViewTotal(), 0, viewBatchLevel);  
  }
  public void setViewBatchForExport() throws Exception{
    viewBatchLevel = 2;
    batchMan = new ViewBatchManager( this, vvm.getViewTotal(), 0, viewBatchLevel);  
  }
  public void changeViewBatch() throws Exception{
    batchMan = new ViewBatchManager( this, vvm.getViewTotal(), 0, viewBatchLevel);  
  }
//----------------------------------------------------------//
//----------------------------------------------------------//
 public void setStudyBatchForViewDefine( Long viewId) throws Exception {
    int total = getAllGroupsCount( getCurrentTechnologyId(), null);
    studyBatchLevel = 3;
    batchMan = new ViewBatchManager( this, total, 3, studyBatchLevel);  //level=3!! 
    Query q = hibSess.createQuery(
	  	      "select distinct myMemb.theGroup.id from ViewStudyMembership myMemb" +
	  	      " where myMemb.theView = :vie");
    q.setLong("vie", viewId.longValue());
    List memList = q.list();
    Iterator iter = memList.iterator();
    while (iter.hasNext()) 
   	  batchMan.changeCheck((Long)(iter.next()));
  }

//  public boolean setAssayBatchList( HttpServletRequest request){
//    assayBatchArray = request.getParameterValues("check");
//    return (assayBatchArray!=null && assayBatchArray.length > 0);
// }
//  public boolean setAssayBatchList( String[] array){
//    assayBatchArray = array;
//    return (assayBatchArray!=null && assayBatchArray.length > 0);
// }
// public boolean setStudyBatchList( HttpServletRequest request){
//   studyBatchArray = request.getParameterValues("check");
//   return (studyBatchArray!=null && studyBatchArray.length > 0);
//}
// public boolean setStudyBatchList( String[] array){
//   studyBatchArray = array;
//   return (studyBatchArray!=null && studyBatchArray.length > 0);
//}
// public boolean setViewBatchList( HttpServletRequest request){
//   viewBatchArray = request.getParameterValues("check");
//   return (viewBatchArray!=null && viewBatchArray.length > 0);
//}
// public boolean setViewBatchList( String[] array){
//   viewBatchArray = array;
//   return (viewBatchArray!=null && viewBatchArray.length > 0);
//}
//  public Assay getBatchAssay() throws Exception {
//    if (assayBatchArray==null || assayBatchArray.length == 0) return null;
//    return (Assay)getObjectById(Assay.class, assayBatchArray[0]);
//}
//  public StudyGroup getBatchStudy() throws Exception {
//    if (studyBatchArray==null || studyBatchArray.length == 0) return null;
//    return (StudyGroup)getObjectById(StudyGroup.class, studyBatchArray[0]);
//}
// public StudyView getBatchView() throws Exception {
//    if (viewBatchArray==null || viewBatchArray.length == 0) return null;
//    return (StudyView)getObjectById(StudyView.class, viewBatchArray[0]);
//}
  public void resetAllBatch(){
    assayBatchLevel = 0;  batchMan = null;
    studyBatchLevel = 0;  
    viewBatchLevel = 0;  
  }
  public void resetAssayBatch(){
    assayBatchLevel = 0;  batchMan = null;
//    assayBatchArray = null;
  }
  public void resetStudyBatch(){
    studyBatchLevel = 0;  batchMan = null;
//    studyBatchArray = null;
  }
  public void resetViewBatch(){
    viewBatchLevel = 0;  batchMan = null;
//    viewBatchArray = null;
  }
  public boolean isAssayBatch(){
   return assayBatchLevel > 0;
 }
 public boolean isAssayBatchForEdit(){
   return assayBatchLevel == 1;
 }
 public boolean isAssayBatchForExport(){
   return assayBatchLevel == 2;
 }
 public boolean isStudyBatch(){
   return studyBatchLevel > 0;
}
 public boolean isStudyBatchForEdit(){
   return studyBatchLevel == 1;
}
 public boolean isStudyBatchForExport(){
   return studyBatchLevel == 2;
}
 public boolean isStudyBatchForView(){
   return studyBatchLevel == 3;
}
 public boolean isViewBatch(){
   return viewBatchLevel > 0;
 }
 public boolean isViewBatchForEdit(){
   return viewBatchLevel == 1;
 }
 public boolean isViewBatchForExport(){
   return viewBatchLevel == 2;
 }
//-------------------------------------------------------------------
  public static String getMyMessage(int messageNum) {
    return myMessage[messageNum];
  }

  public static void init(){
    try {
      MetadataManager.processConstants(WebappConfig.getSystemConstants());
      MetadataManager.processStrings(WebappConfig.getStringConstants());
      if (WebappConfig.isUseSamples()) {
        Session samplSes = WebappConfig.getSamplesSessionFactory().openSession();
        List list = samplSes.createQuery("from " + BottomMetaData.class.getName()).list();
        AliquotMetadataManager.buildAliquotData(list);
        list = samplSes.createQuery("from " + MiddleMetaData.class.getName()).list();
        AliquotMetadataManager.buildSampleData(list);
        list = samplSes.createQuery("from " + TopMetaData.class.getName()).list();
        AliquotMetadataManager.buildPersonData(list);
        samplSes.close();
      }
    }
    catch (Exception ex) {
      Util.writeLog("Init sample metadata", ex.getMessage(), "");
    }
  }

  public void buildMetaData() throws HibernateException {
    hibSess = WebappConfig.getAssaySessionFactory().openSession();
    buildMetaDataI();
    hibSess.close();
  }

  private void buildMetaDataI() throws HibernateException {
    Long technolId = this.getCurrentTechnologyId();
    mdm = new MetadataManager();
    List list1 = null;
    List list2 = null;
    list1 = hibSess.createQuery("from CommonParameter myP where myP.technology = '"
                        + technolId + "'").list();
    list2 = hibSess.createQuery("from Parameter myP where myP.technology = '"
                        + technolId + "'").list();
    mdm.buildAssayData(list1, list2);
    mdm.buildStudyGroupData(list1, list2);
    mdm.buildStudyViewData(list1, list2);
  }

  public MetadataManager getMetadataManager(){
    return mdm;
  }

  public int getViewLimit() {
      return (currentUser==null)?WebappConfig.getViewLimit()
                                :currentUser.getViewLimit();
  }

  public boolean showFullId() {
      return (currentUser==null)?false:currentUser.isShowFullId();
  }

  public static boolean useSamples() {
      return WebappConfig.isUseSamples();
  }

  public void setViewSortCol(String sortCol) {
    if (viewSortCol.equals(sortCol)) {
      viewSortDir = !viewSortDir;
    }
    else {
      viewSortCol = sortCol;
      viewSortDir = true;
    }
  }
  public void setGroupSortCol(String sortCol) {
    if (groupSortCol.equals(sortCol)) {
      groupSortDir = !groupSortDir;
    }
    else {
      groupSortCol = sortCol;
      groupSortDir = true;
    }
  }

  public void setAssaySortCol(String sortCol) {
    if (assaySortCol.equals(sortCol)) {
      assaySortDir = !assaySortDir;
    }
    else {
      assaySortCol = sortCol;
      assaySortDir = true;
    }
  }

  public String getViewSortId(String sortCol) {
    return (!viewSortCol.equals(sortCol)) ? "normal" :
        (viewSortDir) ? "normalu" : "normalo";
  }
  public String getGroupSortId(String sortCol) {
    return (!groupSortCol.equals(sortCol)) ? "normal" :
        (groupSortDir) ? "normalu" : "normalo";
  }

  public String getAssaySortId(String sortCol) {
    return (!assaySortCol.equals(sortCol)) ? "normal" :
        (assaySortDir) ? "normalu" : "normalo";
  }

  public UserHttpSession(HttpSession s) {
// this constructor is called by SessionListener
    httpSess = s;
    httpSessId = s.getId();
    vam = new ViewAssayManager( this);
    vgm = new ViewGroupManager( this);
    vvm = new ViewViewManager( this);
  }

  public void openHibSession() throws HibernateException {
    if (hibSess == null || !hibSess.isOpen())
      hibSess = WebappConfig.getAssaySessionFactory().openSession();
  }

  public void openSampleSession() throws HibernateException {
    if (WebappConfig.isUseSamples()) {
      if (sampleSess == null || !sampleSess.isOpen()) {
        sampleSess = WebappConfig.getSamplesSessionFactory().openSession();
      }
    }
  }
  public void flushHibSession() throws HibernateException {
    if (hibSess != null && hibSess.isOpen()) hibSess.flush();
  }
  public void closeHibSession() {
    tempTechnologyData = null;
    tempStudyView = null;
    tempStudyGroup = null;
    tempAssay = null;
    try {
      if (hibSess != null && hibSess.isOpen()) hibSess.close();
    }
    catch (Exception ex) {
      Util.writeLog("Close assay session", ex.getMessage(), httpSessId);
    }
  }

  public void closeAllSessions() {
    try {
      if (hibSess != null && hibSess.isOpen()) hibSess.close();
      if (sampleSess != null && sampleSess.isOpen()) sampleSess.close();
    }
    catch (Exception ex) {
      Util.writeLog("Close all sessions", ex.getMessage(), httpSessId);
    }
  }
  public void closeSampleSession() {
    //retain tempStudyGroup and tempAssay by BrowseAliquot
    try {
      if (sampleSess != null && sampleSess.isOpen()) sampleSess.close();
    }
    catch (Exception ex) {
      Util.writeLog("Close sample session", ex.getMessage(), httpSessId);
    }
  }

  public void destroySession(long accessTime) {
    closeSampleSession();
    closeHibSession();
    if (currentUser!=null)
      Util.writeAccessLog( currentUser.getVisibleName(),
                     "End of session "+Util.truncateTime(accessTime),
                     httpSessId);
    resetTransactionObjects();
  }

  public String checkDataBaseVersion(String dbVersion){
    String result = "NOK";
    String actVers = "none";
    List list = null;
    try {
      list = getAllObjects(VersionNumber.class);
      if (list != null && list.size() > 0) {
        VersionNumber obj = (VersionNumber) list.get(0);
        actVers = obj.getVersionNumber().toString();
        if (dbVersion.equals(actVers)) result = "OK";
        else result = "Inappropriate db version " + actVers;
      }
    }
    catch (Exception ex) {result = ex.getMessage();}
    if (!result.equals("OK"))
      Util.writeLog( result, dbVersion, actVers);
    return result;
  }

  public int logIn(String userName, String pswwd) throws Exception {
    resetCurrents();
    int answer = -1;
    if (pswwd != null && userName != null) {
      String pswd = Util.criptString(pswwd);
      Query q = hibSess.createQuery("from AssayUser user"
                       + " where user.loginName = :username"
                       + " and user.password = :pswd");
      q.setString("username", userName);
      q.setString("pswd", pswd);
      List list = q.list();
      if (list.size() == 0) {
        q = hibSess.createQuery("select count(*) from  AssayUser");
        int count = ((Long) q.iterate().next()).intValue();
        if (count == 0)
          currentUser = addUser("First user", userName, pswwd);
        else
          if (WebappConfig.getSecondUser() != null &&
              WebappConfig.getSecondUser().equals(userName+'/'+pswwd)) {
            currentUser = addUser("Second user", userName, pswwd);
            WebappConfig.setSecondUser(null);
        }
      }
      else {
        currentUser = (AssayUser) list.get(0);
      }
      if (currentUser != null) {
        currentUser.importSettings(WebappConfig.getViewLimit(), false);
        currentUser.importSettingsFileExport();
//---------------- current user rights --------------------
        initializeRights();
        if (!currentUser.isWriteAdministrator()){
//------------------ user rights --------------------------
          q = hibSess.createQuery("from AssayUserRights rights"
          + " where rights.grantedTo = :current or rights.grantedTo is null");
          q.setLong( "current", currentUser.getId().longValue());
          list = q.list();
          grantingUserCount = list.size() + 1;
          grantingOwners = new int[grantingUserCount];
          grantedRights = new int[grantingUserCount];
          grantedDefineView = new int[grantingUserCount];
          grantingOwners[0] = currentUser.getId().intValue();
          grantedRights[0] = 3000;
          grantedDefineView[0] = 1;
          grantingUserCount = 1;
          Iterator useriter = list.iterator();
          while (useriter.hasNext()) {
            AssayUserRights obj = (AssayUserRights) useriter.next();
            int iOwner = obj.getGrantedBy().getId().intValue();
            int iRights = obj.getAccessRights().intValue();
            int dwRights = obj.getDefineViewRightsValue();
            int i = 0;
            boolean toBe = true;
            while (i < grantingUserCount) {
              if (iOwner < grantingOwners[i]) {
                for (int k = grantingUserCount; k > i; k--) {
                  grantingOwners[k] = grantingOwners[k - 1];
                  grantedRights[k] = grantedRights[k - 1];
                  grantedDefineView[k] = grantedDefineView[k - 1];
                }
                break;
              }
              else
              if (iOwner == grantingOwners[i]) {
                if (iRights > grantedRights[i]) grantedRights[i] = iRights;
                if (dwRights > grantedDefineView[i]) grantedDefineView[i] = dwRights;
                toBe = false;
                break;
              }
              else i++;
            }
            if (toBe) {
              grantingUserCount++;
              grantingOwners[i] = iOwner;
              grantedRights[i] = iRights;
              grantedDefineView[i] = dwRights;
            }
          }
//------------------ group rights --------------------------
          q = hibSess.createQuery("select rights from UserGroupRights rights,"
          + " UserGroupMembership memb where (memb.theUser = :current and"
          + " rights.grantedTo = memb.belongsTo) or rights.grantedTo is null");
          q.setLong( "current", currentUser.getId().longValue());
          list = q.list();
          grantingGroupCount = list.size() + 1;
          grantingGroups = new int[grantingGroupCount];
          grantedGroupRights = new int[grantingGroupCount];
          grantedGroupDefineView = new int[grantingGroupCount];
          grantingGroupCount = 0;
          Iterator groupiter = list.iterator();
          while (groupiter.hasNext()) {
            UserGroupRights obj = (UserGroupRights) groupiter.next();
            int iOwner = obj.getGrantedBy().getId().intValue();
            int iRights = obj.getAccessRights().intValue();
            int dwRights = obj.getDefineViewRightsValue();
            int i = 0;
            boolean toBe = true;
            while (i < grantingGroupCount) {
              if (iOwner < grantingGroups[i]) {
                for (int k = grantingGroupCount; k > i; k--) {
                  grantingGroups[k] = grantingGroups[k - 1];
                  grantedGroupRights[k] = grantedGroupRights[k - 1];
                  grantedGroupDefineView[k] = grantedGroupDefineView[k - 1];
                }
                break;
              }
              else
              if (iOwner == grantingGroups[i]) {
                if (iRights > grantedGroupRights[i]) grantedGroupRights[i] = iRights;
                if (dwRights > grantedGroupDefineView[i]) grantedGroupDefineView[i] = dwRights;
                toBe = false;
                break;
              }
              else i++;
            }
            if (toBe) {
              grantingGroupCount++;
              grantingGroups[i] = iOwner;
              grantedGroupRights[i] = iRights;
              grantedGroupDefineView[i] = dwRights;
            }
          }
//---------------- technology access -------------------
          q = hibSess.createQuery("from TechnologyAccess rights"
                                  + " where rights.user = :current");
          q.setLong( "current", currentUser.getId().longValue());
          list = q.list();
          technolCount = 0;
          Technology xyz = null;
          TechnologyAccess abc = null;
          Iterator techniter = list.iterator();
          while (techniter.hasNext()) {
            abc = (TechnologyAccess) techniter.next();
            xyz = abc.getTechnology();
            if (xyz == null) technolCount = -100;
            else technolCount++;
          }
          if (technolCount == 1 && abc != null && xyz != null) {
//---------------  Single technology  --------------------------
            currentTechnology = xyz;
            String technDir = getTechnologyFtpDirectory();
            protTechnDirectory = new File(WebappConfig.getProtocolDirectory(), technDir);
            protTechnDirectory.mkdir();
            dataTechnDirectory = new File(WebappConfig.getDataDirectory(), technDir);
            dataTechnDirectory.mkdir();
            buildMetaDataI();
            initializeRights(abc.getCanCreateSGX().intValue(),
                    abc.getVocabularyAccess().intValue(),
                    abc.getConfigurationAccess().intValue(),
                    abc.getDataExportRights().intValue(),
                    abc.getDataFileExportRightsX().intValue(),
                    abc.getDataTransferRightsX().intValue());
          }
        }
        Util.writeAccessLog(currentUser.getVisibleName(),
                             currentUser.getLoginName(),
                             httpSessId);
        if (currentUser.isAdministrator() || technolCount != 0){
          if (currentUser.isAdministrator() &&
        		(getInstanceCount(PendingTask.class) > 0 ||
             	 getInstanceCount(PendingExport.class) > 0))
        	answer = 2;
          else 	
          if (currentUser.isWithWelcomeStart()) answer = 2; else answer = 1;
        }
        else { currentUser = null; answer = 0;}
        return answer;
      }
    }
    return answer;
  }

  private int[] makeSArray( List objList){
    int sCount = objList.size();
    int[] sArray = new int[sCount];
    Iterator siter = objList.iterator();
    int tCount = 0;
    while (siter.hasNext()) {
      AssayPersistent obj = (AssayPersistent) siter.next();
      int iOwner = obj.getId().intValue();
      int i = 0;
      while (i < tCount) {
        if (iOwner < sArray[i]) {
          for (int k = tCount; k > i; k--) {
            sArray[k] = sArray[k - 1];
          }
          break;
        }
        else i++;
      }
      tCount++;
      sArray[i] = iOwner;
    }
    return sArray;
  }
  private boolean setSValue( int value, int subject, int[] sArray, int[] vArray){
    boolean rez = false;
    int low = 0;
    int high = sArray.length - 1;
    while (low <= high) {
        int mid = (low + high) >> 1;
        if (sArray[mid] > subject)
            high = mid - 1;
        else if (sArray[mid] < subject)
            low = mid + 1;
        else {
           if (value > vArray[mid]){ vArray[mid] = value; rez = true;}
           break;
        }
    }
    return rez;
  }
  private int getSValue( int subject, int[] sArray, int[] vArray){
    int low = 0;
    int high = sArray.length - 1;
    while (low <= high) {
        int mid = (low + high) >> 1;
        if (sArray[mid] > subject)
            high = mid - 1;
        else if (sArray[mid] < subject)
            low = mid + 1;
        else {
           return vArray[mid];
        }
    }
    return 0;
  }

  public String createGrantedRights( long defGroupId) throws Exception{
//--------------------  users  ----------------------------
    List userList = getAllObjects(AssayUser.class);
    int grantoUserCount = userList.size();
    int[] grantoOwners = makeSArray( userList);
    int[] grantoRights = new int[grantoUserCount];
    int[] grantoGroupsA = new int[grantoUserCount];
    int[] grantoGroupsARights = new int[grantoUserCount];
    int[] grantoDefineView = new int[grantoUserCount];
    int[] grantoGroupsADefineView = new int[grantoUserCount];
    for (int i = 0; i < grantoUserCount; i++) grantoRights[i] = 0;
    for (int i = 0; i < grantoUserCount; i++) grantoGroupsA[i] = 0;
    for (int i = 0; i < grantoUserCount; i++) grantoGroupsARights[i] = 0;
    for (int i = 0; i < grantoUserCount; i++) grantoDefineView[i] = 0;
    for (int i = 0; i < grantoUserCount; i++) grantoGroupsADefineView[i] = 0;
    long currid = currentUser.getId().longValue();
//------------------ user rights --------------------------
    Query q = hibSess.createQuery("from AssayUserRights rights"
            + " where rights.grantedBy = :current");
    q.setLong( "current", currid);
    List list = q.list();
    Iterator rightsiter = list.iterator();
    while (rightsiter.hasNext()) {
      AssayUserRights obj = (AssayUserRights) rightsiter.next();
      int iRights = obj.getAccessRights().intValue();
      int dwRights = obj.getDefineViewRightsValue();
      AssayUser grantedTo = obj.getGrantedTo();
      if (grantedTo==null){
        for (int i = 0; i < grantoUserCount; i++){
          setSValue(iRights, grantoOwners[i], grantoOwners, grantoRights);
          setSValue(dwRights, grantoOwners[i], grantoOwners, grantoDefineView);
        }  
      } else {
        int iOwner = grantedTo.getId().intValue();
        setSValue(iRights, iOwner, grantoOwners, grantoRights);
        setSValue(dwRights, iOwner, grantoOwners, grantoDefineView);
      }
    }
//--------------------  groups  ----------------------------
    List groupList = getAllObjects(UserGroup.class);
    int grantoGroupCount = groupList.size();
    int[] grantoGroups = makeSArray( groupList);
    int[] grantoGroupRights = new int[grantoGroupCount];
    int[] grantoGroupDefineView = new int[grantoGroupCount];
//------------------ group rights --------------------------
    for (int i = 0; i < grantoGroupCount; i++) grantoGroupRights[i] = 0;
    for (int i = 0; i < grantoGroupCount; i++) grantoGroupDefineView[i] = 0;
    q = hibSess.createQuery("select rights from UserGroupRights rights"
    + " where (rights.grantedBy = :current)");
    q.setLong( "current", defGroupId);
    list = q.list();
    Iterator groupiter = list.iterator();
    while (groupiter.hasNext()) {
      UserGroupRights obj = (UserGroupRights) groupiter.next();
      int iOwner = obj.getGrantedTo().getId().intValue();
      int iRights = obj.getAccessRights().intValue();
      int dwRights = obj.getDefineViewRightsValue();
      setSValue( iRights, iOwner, grantoGroups, grantoGroupRights);
      setSValue( dwRights, iOwner, grantoGroups, grantoGroupDefineView);
    }
//--------------- user group membership   --------------
    List usergroupList = getAllObjects(UserGroupMembership.class);
    Iterator memberiter = usergroupList.iterator();
    while (memberiter.hasNext()) {
      UserGroupMembership obj = (UserGroupMembership) memberiter.next();
      int iUser = obj.getTheUser().getId().intValue();
      int iGroup = obj.getBelongsTo().getId().intValue();
      int iValue = getSValue( iGroup, grantoGroups, grantoGroupRights);
      int dwValue = getSValue( iGroup, grantoGroups, grantoGroupDefineView);
      boolean f1 = setSValue( iValue, iUser, grantoOwners, grantoGroupsARights);
      boolean f2 = setSValue( dwValue, iUser, grantoOwners, grantoGroupsADefineView);
      if (f1||f2) setSValue( iGroup, iUser, grantoOwners, grantoGroupsA);
    }
//-----------------------------------------------------------
    Iterator useriter = userList.iterator();
    StringBuffer textBuf = new StringBuffer();
    textBuf.append("<span id=\"accessDiv\"><table border=\"1\">");
    textBuf.append("<tr><td class=\"larger\">User</td>");
    textBuf.append("<td class=\"larger\" colspan=\"2\">Granted by owner</td>");
    textBuf.append("<td class=\"larger\">Granted via group</td>");
    textBuf.append("<td class=\"larger\" colspan=\"2\">Granted by group</td></tr>");
    while (useriter.hasNext()) {
      AssayUser obj = (AssayUser) useriter.next();
      long lUser = obj.getId().longValue();
      if (lUser==currid) continue;
      int iUser = obj.getId().intValue();
      int iValue = getSValue(iUser, grantoOwners, grantoRights);
      int rValue = getSValue(iUser, grantoOwners, grantoGroupsARights);
      int dwValue = getSValue(iUser, grantoOwners, grantoDefineView);
      int rwValue = getSValue(iUser, grantoOwners, grantoGroupsADefineView);
      if ((iValue>0)||(rValue>0)||(dwValue>0)||(rwValue>0)) {
        textBuf.append("<tr><td><b>");
        textBuf.append(obj.getLoginName());
        if (iValue>=rValue) textBuf.append("</b></td><td style=\"background-color:#C0C0FF;\">");
        else textBuf.append("</b></td><td>");
        if (iValue>0) textBuf.append(AssayUserRights.getAccessRightText( iValue));
        else textBuf.append("&nbsp;");
        if (dwValue>=rwValue) textBuf.append("</td><td style=\"background-color:#C0C0FF;\">");
        else textBuf.append("</td><td>");
        textBuf.append(AssayUserRights.getDefineViewRightText( dwValue));
        textBuf.append("</td><td>");
        if (rValue>0||(rwValue>0)){
          int gValue = getSValue(iUser, grantoOwners, grantoGroupsA);
          AssayPersistent gName =
              (AssayPersistent)hibSess.load( UserGroup.class, new Long( gValue));
          textBuf.append(gName.getVisibleName());
          if (rValue>=iValue) textBuf.append("</td><td style=\"background-color:#C0C0FF;\">");
          else textBuf.append("</td><td>");
          if (rValue>0) textBuf.append(AssayUserRights.getAccessRightText( rValue));
          else textBuf.append("&nbsp;");
          if (rwValue>=dwValue) textBuf.append("</td><td style=\"background-color:#C0C0FF;\">");
          else textBuf.append("</td><td>");
          textBuf.append(AssayUserRights.getDefineViewRightText( rwValue));
          textBuf.append("</td><tr>");
        }
        else textBuf.append("&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><tr>");
      }
    }
    textBuf.append("</table></span>");
    return textBuf.toString();
}

  public String createGrantedRightsTemp( Long defGroupL) throws Exception{
    Session ses11 = WebappConfig.getAssaySessionFactory().openSession();
//--------------------  users  ----------------------------
    long defGroupId = defGroupL.longValue();
    List userList =
            ses11.createQuery("from " + AssayUser.class.getName()).list();
    int grantoUserCount = userList.size();
    int[] grantoOwners = makeSArray( userList);
    int[] grantoRights = new int[grantoUserCount];
    int[] grantoGroupsA = new int[grantoUserCount];
    int[] grantoGroupsARights = new int[grantoUserCount];
    int[] grantoDefineView = new int[grantoUserCount];
    int[] grantoGroupsADefineView = new int[grantoUserCount];
    for (int i = 0; i < grantoUserCount; i++) grantoRights[i] = 0;
    for (int i = 0; i < grantoUserCount; i++) grantoGroupsA[i] = 0;
    for (int i = 0; i < grantoUserCount; i++) grantoGroupsARights[i] = 0;
    for (int i = 0; i < grantoUserCount; i++) grantoDefineView[i] = 0;
    for (int i = 0; i < grantoUserCount; i++) grantoGroupsADefineView[i] = 0;
    long currid = currentUser.getId().longValue();
//------------------ user rights --------------------------
    Query q = ses11.createQuery("from AssayUserRights rights"
                + " where rights.grantedBy = :current");
    q.setLong( "current", currentUser.getId().longValue());
    List list = q.list();
    Iterator rightsiter = list.iterator();
    while (rightsiter.hasNext()) {
      AssayUserRights obj = (AssayUserRights) rightsiter.next();
      int iRights = obj.getAccessRights().intValue();
      int dwRights = obj.getDefineViewRightsValue();
      AssayUser grantedTo = obj.getGrantedTo();
      if (grantedTo==null){
        for (int i = 0; i < grantoUserCount; i++){
          setSValue(iRights, grantoOwners[i], grantoOwners, grantoRights);
          setSValue(dwRights, grantoOwners[i], grantoOwners, grantoDefineView);
        }  
      } else {
        int iOwner = grantedTo.getId().intValue();
        setSValue(iRights, iOwner, grantoOwners, grantoRights);
        setSValue(dwRights, iOwner, grantoOwners, grantoDefineView);
      }
    }
//--------------------  groups  ----------------------------
    List groupList =
            ses11.createQuery("from " + UserGroup.class.getName()).list();
    int grantoGroupCount = groupList.size();
    int[] grantoGroups = makeSArray( groupList);
    int[] grantoGroupRights = new int[grantoGroupCount];
    int[] grantoGroupDefineView = new int[grantoGroupCount];
//------------------ group rights --------------------------
    for (int i = 0; i < grantoGroupCount; i++) grantoGroupRights[i] = 0;
    for (int i = 0; i < grantoGroupCount; i++) grantoGroupDefineView[i] = 0;
    q = ses11.createQuery("select rights from UserGroupRights rights"
        + " where (rights.grantedBy = :current)");
    q.setLong( "current", defGroupId);
    list = q.list();
    Iterator groupiter = list.iterator();
    while (groupiter.hasNext()) {
      UserGroupRights obj = (UserGroupRights) groupiter.next();
      int iOwner = obj.getGrantedTo().getId().intValue();
      int iRights = obj.getAccessRights().intValue();
      int dwRights = obj.getDefineViewRightsValue();
      setSValue( iRights, iOwner, grantoGroups, grantoGroupRights);
      setSValue( dwRights, iOwner, grantoGroups, grantoGroupDefineView);
    }
//--------------- user group membership   --------------
    List usergroupList =
        ses11.createQuery("from " + UserGroupMembership.class.getName()).list();
    Iterator memberiter = usergroupList.iterator();
    while (memberiter.hasNext()) {
      UserGroupMembership obj = (UserGroupMembership) memberiter.next();
      int iUser = obj.getTheUser().getId().intValue();
      int iGroup = obj.getBelongsTo().getId().intValue();
      int iValue = getSValue( iGroup, grantoGroups, grantoGroupRights);
      int dwValue = getSValue( iGroup, grantoGroups, grantoGroupDefineView);
      boolean f1 = setSValue( iValue, iUser, grantoOwners, grantoGroupsARights);
      boolean f2 = setSValue( dwValue, iUser, grantoOwners, grantoGroupsADefineView);
      if (f1||f2) setSValue( iGroup, iUser, grantoOwners, grantoGroupsA);
    }
//-----------------------------------------------------------
    StringBuffer textBuf = new StringBuffer();
    AssayPersistent defGroup =
            (AssayPersistent)ses11.load( UserGroup.class, defGroupL);
    textBuf.append(defGroup.getVisibleName());
    textBuf.append("<table border=\"1\">");
    textBuf.append("<tr><td class=\"larger\">User</td>");
    textBuf.append("<td class=\"larger\" colspan=\"2\">Granted by owner</td>");
    textBuf.append("<td class=\"larger\">Granted via group</td>");
    textBuf.append("<td class=\"larger\" colspan=\"2\">Granted by group</td></tr>");
    Iterator useriter = userList.iterator();
    while (useriter.hasNext()) {
      AssayUser obj = (AssayUser) useriter.next();
      long lUser = obj.getId().longValue();
      if (lUser==currid) continue;
      int iUser = obj.getId().intValue();
      int iValue = getSValue(iUser, grantoOwners, grantoRights);
      int rValue = getSValue(iUser, grantoOwners, grantoGroupsARights);
      int dwValue = getSValue(iUser, grantoOwners, grantoDefineView);
      int rwValue = getSValue(iUser, grantoOwners, grantoGroupsADefineView);
      if ((iValue>0)||(rValue>0)||(dwValue>0)||(rwValue>0)) {
        textBuf.append("<tr><td><b>");
        textBuf.append(obj.getLoginName());
        if (iValue>=rValue) textBuf.append("</b></td><td style=\"background-color:#C0C0FF;\">");
        else textBuf.append("</b></td><td>");
        if (iValue>0) textBuf.append(AssayUserRights.getAccessRightText( iValue));
        else textBuf.append("&nbsp;");
        if (dwValue>=rwValue) textBuf.append("</td><td style=\"background-color:#C0C0FF;\">");
        else textBuf.append("</td><td>");
        textBuf.append(AssayUserRights.getDefineViewRightText( dwValue));
        textBuf.append("</td><td>");
        if (rValue>0||(rwValue>0)){
          int gValue = getSValue(iUser, grantoOwners, grantoGroupsA);
          AssayPersistent gName =
              (AssayPersistent)ses11.load( UserGroup.class, new Long( gValue));
          textBuf.append(gName.getVisibleName());
          if (rValue>=iValue) textBuf.append("</td><td style=\"background-color:#C0C0FF;\">");
          else textBuf.append("</td><td>");
          if (rValue>0) textBuf.append(AssayUserRights.getAccessRightText( rValue));
          else textBuf.append("&nbsp;");
          if (rwValue>=dwValue) textBuf.append("</td><td style=\"background-color:#C0C0FF;\">");
          else textBuf.append("</td><td>");
          textBuf.append(AssayUserRights.getDefineViewRightText( rwValue));
          textBuf.append("</td><tr>");
        }
        else textBuf.append("&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><tr>");
      }
    }
    textBuf.append("</table>");
    ses11.close();
    return textBuf.toString();
  }

  private int getGrantedRights( int iGrantor){
    int low = 0;
    int high = grantingUserCount - 1;
    while (low <= high) {
        int mid = (low + high) >> 1;
        if (grantingOwners[mid] > iGrantor)
            high = mid - 1;
        else if (grantingOwners[mid] < iGrantor)
            low = mid + 1;
        else
            return grantedRights[mid]; // found
    }
    return 0; // not found
}
  private int getGrantedGroupRights( int iGrantor){
    int low = 0;
    int high = grantingGroupCount - 1;
    while (low <= high) {
        int mid = (low + high) >> 1;
        if (grantingGroups[mid] > iGrantor)
            high = mid - 1;
        else if (grantingGroups[mid] < iGrantor)
            low = mid + 1;
        else
            return grantedGroupRights[mid]; // found
    }
    return 0; // not found
}
  private int getGrantedDefineView( int iGrantor){
    int low = 0;
    int high = grantingUserCount - 1;
    while (low <= high) {
      int mid = (low + high) >> 1;
      if (grantingOwners[mid] > iGrantor)
          high = mid - 1;
      else if (grantingOwners[mid] < iGrantor)
          low = mid + 1;
      else
          return grantedDefineView[mid]; // found
	}
    return 0; // not found
  }
  private int getGrantedGroupDefineView( int iGrantor){
    int low = 0;
    int high = grantingGroupCount - 1;
    while (low <= high) {
        int mid = (low + high) >> 1;
        if (grantingGroups[mid] > iGrantor)
            high = mid - 1;
        else if (grantingGroups[mid] < iGrantor)
            low = mid + 1;
        else
            return grantedGroupDefineView[mid]; // found
    }
    return 0; // not found
  }

  public int getGrantedRights( StudyGroup grantor){
    int result1 = 0;  int result2 = 0;
    AssayUser own = grantor.getOwner();
    if  (own == null || isWriteAdminSession()) result1 = 3000;
    else result1 = getGrantedRights(own.getId().intValue());
    UserGroup ownGroup = grantor.getOwnerGroup();
    if  (ownGroup != null) result2 = getGrantedGroupRights(ownGroup.getId().intValue());
    return (result1 > result2)?result1:result2;
  }
  public int getGrantedRights( StudyView grantor){
    int result1 = 0; int result2 = 0;
    AssayUser own = grantor.getOwner();
    if  (own == null || isWriteAdminSession()) result1 = 3000;
    else result1 = getGrantedRights(own.getId().intValue());
    UserGroup ownGroup = grantor.getOwnerGroup();
    if  (ownGroup != null) result2 = getGrantedGroupRights(ownGroup.getId().intValue());
    return (result1 > result2)?result1:result2;
  }
  public int getGrantedDefineView( StudyView grantor){
    int result1 = 0; int result2 = 0;
    AssayUser own = grantor.getOwner();
    if  (own == null || isWriteAdminSession()) result1 = 1;
    else result1 = getGrantedDefineView(own.getId().intValue());
    UserGroup ownGroup = grantor.getOwnerGroup();
    if  (ownGroup != null) result2 = getGrantedGroupDefineView(ownGroup.getId().intValue());
    return (result1 > result2)?result1:result2;
  }
  public int getGrantedRights( AssayUser own, UserGroup ownGroup){
    int result1 = 0;
    int result2 = 0;
    if  (own == null || isWriteAdminSession()) result1 = 3000;
    else result1 = getGrantedRights(own.getId().intValue());
    if  (ownGroup != null) result2 = getGrantedGroupRights(ownGroup.getId().intValue());
    return (result1 > result2)?result1:result2;
  }
//used by CheckFile.jsp
  public int getGrantedRights( String grantor){
    int result = 0;
    if  (grantor.equals("0") || isWriteAdminSession()) result = 3000;
    else result = getGrantedRights(Util.getIntegerValue( grantor));
    return result;
  }
//used by CheckFile.jsp after previous method
  public int getGrantedGroupRights( String grantor){
    int result = 0;
    if  (!grantor.equals("0"))
      result = getGrantedGroupRights(Util.getIntegerValue( grantor));
    return result;
  }
//mrthods used by batch upload pages 
  public String getStudyGroupPrompterFromList( List list, int rights){
    StringBuffer xyz = new StringBuffer();
    if (list != null){
      Iterator iter = list.iterator();
      while (iter.hasNext()) {
    	StudyGroup obj = (StudyGroup) iter.next();
	    if (getGrantedRights( obj)>=rights){
	      xyz.append("<option value=\"");
	      xyz.append(obj.getId())
	         .append("\">")
	         .append(obj.getVisibleIdentifString());
	    }
      }
    }
    return xyz.toString();
  }
  public String getStudyViewPrompterForDefine( List list){
    StringBuffer xyz = new StringBuffer();
    if (list != null){
      Iterator iter = list.iterator();
      while (iter.hasNext()) {
    	StudyView obj = (StudyView) iter.next();
	    if (getGrantedDefineView( obj)>0){
	      xyz.append("<option value=\"");
	      xyz.append(obj.getId())
	         .append("\">")
	         .append(obj.getVisibleIdentifString());
	    }
      }
    }
    return xyz.toString();
  }
 

  public boolean logOut() {
    if (currentUser!=null){
      Util.writeAccessLog(currentUser.getVisibleName(),
                    "End of session",
                    httpSessId);
      if (WebappConfig.getLogoutProc()!=null)
        LogoutProc.execLogoutProc(WebappConfig.getLogoutProc());
    }
    resetCurrents();
    return true;
  }

  public String getUserString() {
    return (currentUser == null) ? "NONE" : currentUser.getVisibleName();
  }

  public AssayUser getCurrentUser() {
    return currentUser;
  }

  public Long getCurrentUserId() {
    return (currentUser==null)?null:currentUser.getId();
  }

  public String getCurrentUserPartnerName() {//used by J.V.
	if (currentUser!=null){
	  AssayUser us = (AssayUser) getObjectById( AssayUser.class, currentUser.getId());
	  AssayProjectPartner pp = us.getProjectPartner();
	  if (pp!=null) return pp.getVisibleName();
	}
    return "NONE";
  }

  public HttpSession getHttpSess() {
    return httpSess;
  }

  public String getHttpSessId() {
    return (httpSess == null) ? "NONE" : httpSess.getId();
  }

//----------------------------------------------------------//
//----------------------------------------------------------//
//----------------------------------------------------------//
  public List getAllObjects(String className) throws Exception {
    return hibSess.createQuery("from " + className).list();
  }

  public List getAllObjects(Class cl) throws Exception {
    return hibSess.createQuery("from " + cl.getName()).list();
  }

  public List getAllObjectsSafe(Class cl) {
    List list = null;
    try {
      list = hibSess.createQuery("from " + cl.getName()).list();
    }
    catch (HibernateException ex) {}
    return list;
  }
//----------------------------------------------------------//
  public void setAdditionalSimsRef(String[]val, int refType){
     additionalSimsRef = val;  simsRefType = refType;
   }

   public void setAdditionalSimsRef(String val, int refType){
     String[] xyz = {val};
     additionalSimsRef = xyz;  simsRefType = refType;
   }
   public String[] getAdditionalSimsRef(){
     return additionalSimsRef;
   }
  public TechnologyData getTempTechnologyData() throws Exception {
    return tempTechnologyData;
  }
  public void setTempTechnologyData(TechnologyData val) throws Exception {
	if (val==null){
	  simsRefType =	0;
	  tempBottomId = null;
	  tempMiddleId = null;
	  tempTopId = null;
	  tempAliquotName = null;
	  tempCohortName = null;
	} else {
	  simsRefType =	val.getSimsReferenceType();
	  tempBottomId = val.getSimsBottomRef();
	  tempMiddleId = val.getSimsMiddleRef();
	  tempTopId = val.getSimsTopRef();
	  tempAliquotName = val.getSimsRefId();
	  tempCohortName = val.getSimsCollectionName();
	}
	additionalSimsRef = null;
  }
  public String getTempAliquotName(){
	  return tempAliquotName;
  }
  public void setTempAliquotName(String val){
	  tempAliquotName = val;
  }
  public String getTempCohortName(){
	  return tempCohortName;
  }
  public void setTempCohortName(String val){
	  tempCohortName = val;
  }
  public Long getTempBottomId(){
    return tempBottomId;
  }
  public Long getTempMiddleId(){
    return tempMiddleId;
  }
  public Long getTempTopId(){
    return tempTopId;
  }
  public void setTempBottomId(Long val){
    tempBottomId = val;
  }
  public void setTempMiddleId(Long val){
    tempMiddleId = val;
  }
  public void setTempTopId(Long val){
    tempTopId = val;
  }

  public String getTempSysId(){
    return tempSysId;
  }

  public boolean getTempMultiple(){
    return tempMultiple;
  }
//  private List getAllObjectsFromSims(Class cl) throws HibernateException {
//    return sampleSess.createQuery("from " + cl.getName()).list();
//  }

  private List getAllIdAndNamesFromSims(Class cl) throws HibernateException {
    return sampleSess.createQuery("select myObj.id, myObj.visibleName from "
                             + cl.getName() + " myObj").list();
  }

  public List getAllBottoms(Long technId) throws HibernateException {
    String orderClause = " order by myBot.visibleName";
    Query q;
        q = sampleSess.createQuery(
    "select myBot.id, myBot.visibleName from Bottom myBot where myBot.technology=:technid"
    + orderClause);
    q.setLong("technid",technId.longValue());
    return q.list();
}
  public List getAllMiddles(Long technId) throws HibernateException {
    String orderClause = " order by myMid.visibleName";
    Query q;
        q = sampleSess.createQuery(
    "select myMid.id, myMid.visibleName from Middle myMid where myMid.technology=:technid"
    + orderClause);
    q.setLong("technid",technId.longValue());
    return q.list();
}
  public List getAllTops(Long technId) throws HibernateException {
    String orderClause = " order by myTop.visibleName";
    Query q;
        q = sampleSess.createQuery(
    "select myTop.id, myTop.visibleName from Top myTop where myTop.technology=:technid"
    + orderClause);
    q.setLong("technid",technId.longValue());
    return q.list();
}

  public Long getTempCohortId( Long simsId, int type) throws HibernateException  {
    Long rezult = null;
    if (simsId != null){
      Query q =
          (type==1)?sampleSess.createQuery(
        		  "select obj.technology from Top obj where obj.id = :simsId"):
          (type==2)?sampleSess.createQuery(
        		  "select obj.technology from Middle obj where obj.id = :simsId"):
            sampleSess.createQuery(
            	"select obj.technology from Bottom obj where obj.id = :simsId");
      q.setLong("simsId", simsId.longValue());
      List list = q.list();
      if (list.size() > 0){
    	 STechnology xyz = (STechnology) list.get(0);
    	 rezult = xyz.getId();
      }
    }      
    return rezult;
  }

  public List getAllCohorts() throws HibernateException {
    String orderClause = " order by myCollect.visibleName";
    Query q;
        q = sampleSess.createQuery(
    "select myCollect.id, myCollect.visibleName from STechnology myCollect"
    + orderClause);
    return q.list();
}
  public String getSimsPrompterTemp( String collectId, String dependent,
          String objTable, String multiple){
    String orderClause = " order by myObj.visibleName";
    StringBuffer xyz = new StringBuffer();
    Session ses11 = WebappConfig.getSamplesSessionFactory().openSession();
    Query q = ses11.createQuery(
      "select myObj.id, myObj.visibleName from " + objTable + " myObj" +
      " where myObj.technology = " + collectId + orderClause);
    List cList = q.list();
    xyz.append("<select name=\"")
      .append(dependent)
      .append("\" size=\"30\" onchange=\"changeXYZ();\" style=\"width:200:\"");
    if (multiple.equals("new")) xyz.append(" multiple ");
    xyz.append(">\r\n");
    if (cList != null){
      Iterator iter = cList.iterator();
      while (iter.hasNext()) {
        Object[] obj = (Object[])iter.next();
        Long id = (Long)obj[0];
        String name = (String)obj[1];
        xyz.append("<option value=\"");
        xyz.append( id)
          .append("/")
          .append( name)
          .append("\">")
          .append( name);
      }
    }
    xyz.append("\r\n</select>");
    ses11.close();
    return xyz.toString();
  }

  

  public String getAssayUserPrompter(Long objId) throws Exception {
    Query q = hibSess.createQuery(
      "select myUser.id, myUser.loginName from AssayUser myUser" +
      " order by myUser.loginName");
    return PromptUtil.getNamePrompter( q.list(), objId);
}

  public String getUserGroupPrompter() throws Exception {
    Query q = hibSess.createQuery(
      "from UserGroup myGroup order by myGroup.visibleName");
    return PromptUtil.getUserGroupPrompter( q.list());
}
  public String getUserGroupPrompter(Long objId, Long userId) throws Exception {
    Query q = hibSess.createQuery(
      "select myGroup.id, myGroup.visibleName from UserGroup myGroup," +
      " UserGroupMembership myMemb where myMemb.theUser = :usr and"+
      " myGroup.id = myMemb.belongsTo");
    q.setLong("usr",userId.longValue());
    return PromptUtil.getNamePrompter( q.list(), objId);
}

  public List getAllObjectsForTechnology(Class cl) throws Exception {
    Query q;
    Long technologyId = getCurrentTechnologyId();
    if (technologyId == null) {
      q = hibSess.createQuery("from " + cl.getName() + " myObj");
    }
    else {
      q = hibSess.createQuery(
          "from " + cl.getName() + " myObj where myObj.technology = '"
          + technologyId.toString() + "'");
    }
    return q.list();
  }
  public List getAllObjectsForTechnology(Class cl, Technology techn) throws Exception {
    Query q;
    if (techn == null) {
      q = hibSess.createQuery(
          "from " + cl.getName() + " myObj where myObj.technology is null");
    }
    else {
      q = hibSess.createQuery(
          "from " + cl.getName() + " myObj where myObj.technology = '"
          + techn.getId().toString() + "'");
    }
    return q.list();
  }
  public List getAllObjectsForTechnologyAll(Class cl) throws Exception {
    Query q;
    Long technologyId = getCurrentTechnologyId();
    if (technologyId == null) {
      q = hibSess.createQuery("from " + cl.getName() + " myObj");
    }
    else {
      q = hibSess.createQuery(
          "from " + cl.getName() + " myObj where myObj.technology = '"
          + technologyId.toString() + "' or myObj.technology is null");
    }
    return q.list();
  }

  public List getAllParametersSorted( int level) throws Exception {
    Long technologyId = getCurrentTechnologyId();
    Query q = hibSess.createQuery( "select myParam "
          + "from Parameter as myParam, ParameterGroup as myGroup "
          + "where myParam.technology = :techn and "
          + "myParam.parameterGroup = myGroup.id "
          + "order by myGroup."
          + ((level==0)?"viewPosition":(level==1)?"stgrPosition":"assayPosition")
          + ",myParam."
          + ((level==0)?"viewRowNumber":(level==1)?"stgrRowNumber":"assayRowNumber"));
    q.setLong("techn",technologyId.longValue());
    return q.list();
  }
  public List getAllParametersSorted( long technologyId, int level) throws Exception {
    Query q = hibSess.createQuery( "select myParam "
          + "from Parameter as myParam, ParameterGroup as myGroup "
          + "where myParam.technology = :techn and "
          + "myParam.parameterGroup = myGroup.id "
          + "order by myGroup."
          + ((level==0)?"viewPosition":(level==1)?"stgrPosition":"assayPosition")
          + ",myParam."
          + ((level==0)?"viewRowNumber":(level==1)?"stgrRowNumber":"assayRowNumber"));
    q.setLong("techn", technologyId);
    return q.list();
  }

  public List getAllParametersSorted_MO( int level) throws Exception {
    Long technologyId = getCurrentTechnologyId();
    Query q = hibSess.createQuery( "select myParam "
          + "from Parameter as myParam "
          + "where myParam.technology = :techn and "
          + ((level==0)?"viewColumnName":(level==1)?"stgrColumnName":"assayColumnName")
          + " is not null and "
          + ((level==0)?"viewColumnName":(level==1)?"stgrColumnName":"assayColumnName")
          + "<>'' "
          + "order by "
          + ((level==0)?"viewColumnName":(level==1)?"stgrColumnName":"assayColumnName"));
    q.setLong("techn",technologyId.longValue());
    return q.list();
  }


/*
  private List getAllParameters() throws HibernateException {
    Long technologyId = getCurrentTechnologyId();
    Query q = hibSess.createQuery( "select myParam "
          + "from Parameter as myParam, ParameterGroup as myGroup "
          + "where myParam.technology = '"
          + technologyId.toString() + "' and "
          + "myParam.parameterGroup = myGroup.id "
          + "order by myGroup.assayPosition,"
          + "myParam.assayRowNumber");
    return q.list();
  }
*/
//----------------------------------------------------------//
//----------------------------------------------------------//
public List getAllViews() throws  Exception {
Long technologyId = getCurrentTechnologyId();
String orderClause = " order by myView." +
    ((viewSortDir) ? viewSortCol : viewSortCol + " desc");
String qText = "select myView from StudyView as myView where myView.technology = '"
 	 + technologyId.toString() + "' and myView.viewIdentif = '"
   + String.valueOf(this.getTopNum() + "'");
Query q = hibSess.createQuery( qText + orderClause);
return q.list();
}

public List getAllViews(Long technologyId, int startPosition) throws
    Exception {
  String orderClause = " order by myView." +
      ((viewSortDir) ? viewSortCol : viewSortCol + " desc");
  String prefix = "select myView from StudyView as myView";
  Query q;
  if (isFilter()) {
	  
    q = hibSess.createQuery(prefix + filter.getViewString(technologyId) + orderClause);

  }
  else { //technologyId!=null
    String qText =
     " where myView.technology = '"
   	 + technologyId.toString() + "' and myView.viewIdentif = '"
     + String.valueOf(this.getTopNum() + "'");
    q = hibSess.createQuery(prefix + qText + orderClause);
  }
  int viewL = getViewLimit();
  if (viewL > 0 && startPosition >=0){
     q.setFirstResult(startPosition);
     q.setMaxResults(viewL);
  }
  return q.list();
}

public int getAllViewsCount(Long technologyId) throws Exception {
  String prefix = "select count(*) from StudyView as myView";
  Query q;
  if (isFilter()) {
    q = hibSess.createQuery(prefix + filter.getViewString(technologyId));
  }
  else { //technologyId!=null
    String qText =
	     " where myView.technology = '"
	   	 + technologyId.toString() + "' and myView.viewIdentif = '"
	     + String.valueOf(this.getTopNum() + "'");
    q = hibSess.createQuery(prefix + qText);
  }
  int count = ((Long) q.iterate().next()).intValue();
  return count;
}

  public List getAllGroups(Long technologyId, Long viewId, int startPosition) throws
      Exception {
//	Util.writeLog("sg_key", groupSortCol, "");
//	Util.writeLog("as_key", assaySortCol, "");
    String orderClause = " order by myGroup." +
        ((groupSortDir) ? groupSortCol : groupSortCol + " desc");
    String prefix = "select distinct myGroup from StudyGroup as myGroup";
    Query q;
    if (isFilter()) {
      q = hibSess.createQuery(prefix + filter.getGroupString(technologyId) + orderClause);
/*    Util.writeLog("---Query:",
                    prefix + filter.getGroupString() + orderClause,
                    "----");*/
  }
    else { //technologyId!=null
        String qText = (viewId==null)?
      		  (" where myGroup.technology = '"
      		   + technologyId.toString() + "'"):
      		  (", ViewStudyMembership myMembership"
      		   + " where myGroup.technology = '"
      		   + technologyId.toString() + "' and myMembership.theView = '"
      		   + viewId.toString()
      		   + "' and myMembership.theGroup = myGroup.id");
      q = hibSess.createQuery(prefix + qText + orderClause);
    }
    int viewL = getViewLimit();
    if (viewL > 0 && startPosition >=0){
       q.setFirstResult(startPosition);
       q.setMaxResults(viewL);
    }
    return q.list();
  }

  public int getAllGroupsCount(Long technologyId, Long viewId) throws Exception {
    String prefix = "select count(distinct myGroup) from StudyGroup as myGroup";
    Query q;
    if (isFilter()) {
      q = hibSess.createQuery(prefix + filter.getGroupString(technologyId));
/*      Util.writeLog("---Query:",
                    prefix + filter.getGroupString(),
                    "----");*/
    }
    else { //technologyId!=null
      String qText = (viewId==null)?
    		  (" where myGroup.technology = '"
    		   + technologyId.toString() + "'"):
    		  (", ViewStudyMembership myMembership"
    		   + " where myGroup.technology = '"
    		   + technologyId.toString() + "' and myMembership.theView = '"
    		   + viewId.toString()
    		   + "' and myMembership.theGroup = myGroup.id");
      q = hibSess.createQuery(prefix + qText);
    }
    int count = ((Long) q.iterate().next()).intValue();
    return count;
  }

  public List getAllAssays(Long technologyId, Long viewId, Long groupId, int startPosition) throws
      Exception {
    String orderClause = " order by myAssay." +
        ((assaySortDir) ? assaySortCol : assaySortCol + " desc");
    String prefix = "select distinct myAssay from Assay as myAssay";
    Query q;
    if (isFilter()) {
      q = hibSess.createQuery(prefix + filter.getAssayString(technologyId) + orderClause);
/*      Util.writeLog("---Query:",
                    prefix +
                    ", StudyGroup as myGroup" +
                    " where myAssay.studyGroup = myGroup.id" +
                    " and myGroup.technology = '" +
                    technologyId.toString() + "'" +
                    filter.getAssayString() + orderClause,
                    "----");*/
    }
    else
    if (groupId == null) { //technologyId!=null
      if (viewId == null)	
        q = hibSess.createQuery(prefix +
                    ", StudyGroup as myGroup" +
                    " where myAssay.studyGroup = myGroup.id" +
                    " and myGroup.technology = '" +
                    technologyId.toString() + "'" + orderClause);
      else
        q = hibSess.createQuery(prefix +
                  ", StudyGroup as myGroup" +
        		  ", ViewStudyMembership myMembership" +
                  " where myAssay.studyGroup = myGroup.id" +
                  " and myGroup.technology = '" +
                  technologyId.toString() + 
    		      "' and myMembership.theView = '" +
    		      viewId.toString() + "' and myMembership.theGroup = myGroup.id" +
                  orderClause);
    }
    else {  //groupId!=null
      q = hibSess.createQuery(prefix +
          " where myAssay.studyGroup = '"
          + groupId.toString() + "'" + orderClause);
    }
    int viewL = getViewLimit();
    if (viewL > 0 && startPosition >=0){
       q.setFirstResult(startPosition);
       q.setMaxResults(viewL);
    }
    return q.list();
  }

  public int getAllAssaysCount(Long technologyId, Long viewId, Long groupId) throws
      Exception {  //technologyId!=null
    String prefix = "select count(distinct myAssay) from Assay as myAssay";
    Query q;
    if (isFilter()) {
      q = hibSess.createQuery(prefix + filter.getAssayString(technologyId));
/*      Util.writeLog("---Query:",
                    prefix +
                    ", StudyGroup as myGroup" +
                    " where myAssay.studyGroup = myGroup.id" +
                    " and myGroup.technology = '" +
                    technologyId.toString() + "'" +
                    filter.getAssayString(),
                    "----");*/
    }
    else
    if (groupId == null) { //technologyId!=null
      if (viewId == null)	
        q = hibSess.createQuery(prefix +
                  ", StudyGroup as myGroup" +
                  " where myAssay.studyGroup = myGroup.id" +
                  " and myGroup.technology = '" +
                  technologyId.toString() + "'");
      else
        q = hibSess.createQuery(prefix +
                  ", StudyGroup as myGroup" +
          		  ", ViewStudyMembership myMembership" +
                  " where myAssay.studyGroup = myGroup.id" +
                  " and myGroup.technology = '" +
                  technologyId.toString() + 
      		      "' and myMembership.theView = '" +
      		      viewId.toString() + "' and myMembership.theGroup = myGroup.id");
    }
    else {
      q = hibSess.createQuery(prefix +
          " where myAssay.studyGroup = '"
          + groupId.toString() + "'");
    }
    int count = ((Long) q.iterate().next()).intValue();
    return count;
  }
//----------------------------------------------------------//
//----------------------------------------------------------//
  public List getAllUserGroups(Long userId) throws Exception {
    String usr = userId.toString();
    String pref = "select myGroup from StudyGroup as myGroup"
    + " where myGroup.owner = '" + usr
    + "' or myGroup.creator = '" + usr
    + "' or myGroup.modifier = '" + usr
    + "'";
    Query q = hibSess.createQuery(pref);
    return q.list();
  }
  public int getAllUserGroupsCount(Long userId) throws Exception {
    String usr = userId.toString();
    String pref = "select count(*) from StudyGroup as myGroup"
    + " where myGroup.owner = '" + usr
    + "' or myGroup.creator = '" + usr
    + "' or myGroup.modifier = '" + usr
    + "'";
    Query q = hibSess.createQuery(pref);
    int count = ((Long) q.iterate().next()).intValue();
    return count;
  }
  public List getAllUserAssays(Long userId) throws
      Exception {
    String usr = userId.toString();
    String pref = "select myAssay from Assay as myAssay"
    + " where myAssay.creator = '" + usr
    + "' or myAssay.modifier = '" + usr
    + "'";
    Query q = hibSess.createQuery(pref);
    return q.list();
  }
  public int getAllUserAssaysCount(Long userId) throws Exception {
    String usr = userId.toString();
    String pref = "select count(*) from Assay as myAssay"
    + " where myAssay.creator = '" + usr
    + "' or myAssay.modifier = '" + usr
    + "'";
    Query q = hibSess.createQuery(pref);
    int count = ((Long) q.iterate().next()).intValue();
    return count;
  }
//----------------------------------------------------------//
//----------------------------------------------------------//
  public List promptViewsForTechnology(Long technologyId) throws Exception {
      return hibSess.createQuery(
            "from StudyView obj " +
            " where obj.technology = '" +
            technologyId.toString() +
            "' order by obj.identifString").list();
  }
  public List promptGroupsForTechnology(Long technologyId) throws Exception {
      return hibSess.createQuery(
            "from StudyGroup obj " +
            " where obj.technology = '" +
            technologyId.toString() +
            "' order by obj.identifString").list();
  }
  public List promptGroupsForTechnology(Long technologyId, boolean promptNames) throws Exception {
    String quer = (promptNames)?
  		"select obj.id, obj.visibleName from StudyGroup obj where obj.technology = :technid"+
    	" order by obj.visibleName":	
   		"select obj.id, obj.identifString from StudyGroup obj where obj.technology = :technid"+
       	" order by obj.identifString";	
    Query q = hibSess.createQuery(quer);
    q.setLong("technid", technologyId.longValue());
    return q.list();
  }
  public List promptGroupsForView( Long viewId, boolean promptNames ) throws
  Exception {
Query q;
    String qText = ((promptNames)?
    	    "select myGroup.id, myGroup.visibleName from StudyGroup myGroup,":
       	    "select myGroup.id, myGroup.identifString from StudyGroup myGroup,")
  		   + " ViewStudyMembership myMembership"
  		   + " where myMembership.theView = '"
  		   + viewId.toString()
  		   + "' and myMembership.theGroup = myGroup.id"
  		   + ((promptNames)?" order myGroup obj.visibleName":" order by myGroup.identifString");
  q = hibSess.createQuery( qText);
return q.list();
}

  public String getTransferTypePrompter( Long objId) throws Exception {
    List list = getAllObjects(TransferType.class);
    return PromptUtil.getTransferTypePrompterFromList( list, objId);
  }

  public String getObjectPrompter(Class cl, Long objId) throws Exception {
    List list = getAllObjects(cl);
    return PromptUtil.getObjectPrompterFromList( list, objId);
  }

  public String getObjectPrompterForTechnology(Class cl, Long objId) throws Exception {
    List list1 = getAllObjectsForTechnology(cl, null); //for all techn
    List list2 = getAllObjectsForTechnology(cl);       //for current techn
    return PromptUtil.getObjectPrompterFrom2Lists( list1, list2, objId);
  }
  public String getObjectPrompterForTechnologyAll(Class cl, Long objId) throws Exception {
    List list1 = getAllObjectsForTechnology(cl, null); //for all techn
    return PromptUtil.getObjectPrompterFromList( list1, objId);
  }

  public String getAliquotSearchPrompter(Class cl, String fieldName) throws
      Exception {
    StringBuffer xyz = new StringBuffer();
    List list = getAllIdAndNamesFromSims(cl);
    if (list != null) {
      xyz.append("<td><select name='");
      xyz.append(fieldName);
      xyz.append("' multiple size='");
      xyz.append(list.size());
      xyz.append("' onchange='changeSelection()'>");
      Iterator iter = list.iterator();
      while (iter.hasNext()) {
        Object[] obj = (Object[])iter.next();
        Long id = (Long)obj[0];
        String visibleName = (String)obj[1];
        xyz.append("<option");
        if (aliquotFilterValues != null &&
            aliquotFilterValues.containsKey(fieldName + id)) {
          xyz.append(" selected");
        }
        xyz.append(" value='");
        xyz.append(id)
            .append("'>")
            .append(visibleName);
      }
    }
    xyz.append("</select></td>");
    return xyz.toString();
  }

  public String getAliquotSearchDatePrompter(String fieldName) {
    StringBuffer xyz = new StringBuffer();
    Date aDate = null;
    Date bDate = null;
    if (aliquotFilterValues != null) {
      aDate = (Date) aliquotFilterValues.get(fieldName + "a");
      bDate = (Date) aliquotFilterValues.get(fieldName + "b");
    }
    xyz.append("<td><table><tr><td class='dialh'>from(yyyy)</td>");
    xyz.append("<td><input type='text' name='");
    xyz.append(fieldName);
    xyz.append("ayear' maxlength='4' size='4' value='");
    if (aDate != null) {
      xyz.append(Util.getYear(aDate));
    }
    xyz.append("' onchange='changeSelection()'></td></tr><tr><td class='dialh'>to(yyyy)</td>");
    xyz.append("<td><input type='text' name='");
    xyz.append(fieldName);
    xyz.append("byear' maxlength='4' size='4' value='");
    if (bDate != null) {
      xyz.append(Util.getYear(bDate));
    }
    xyz.append("' onchange='changeSelection()'></td></tr></table></td>");
    return xyz.toString();
  }

  //------method used by AJAX only
  public String getDependentPrompterTemp( String indepId, String dependent,
                                      String depTable, boolean optional){
    StringBuffer xyz = new StringBuffer();
    Session ses11 = WebappConfig.getSamplesSessionFactory().openSession();
    Query q = ses11.createQuery(
      "from " + depTable + " myObj" +
      " where myObj.server = " + indepId);
    List list = q.list();

    xyz.append("<select name=\"")
       .append(dependent)
       .append("\"");
    xyz.append(">\r\n");
    if (optional) xyz.append("<option value=\"0\">");
    if (list != null){
      Iterator iter = list.iterator();
      while (iter.hasNext()) {
        sims.hibernate.Dependency dep = (sims.hibernate.Dependency) iter.next();
        sims.hibernate.Persistent obj = dep.getClient();
        xyz.append("<option value=\"");
        xyz.append(obj.getId())
           .append("\">")
           .append(obj.getVisibleName());
      }
    }
    xyz.append("\r\n</select>");
    ses11.close();
    return xyz.toString();
  }
  public String getUserPrompterTemp( String groupId, String userId)throws Exception {
    StringBuffer xyz = new StringBuffer();
    xyz.append("<span id=\"ow_userDiv\">");
    xyz.append("<select name=\"ow_user\"");
    xyz.append(">\r\n");
    xyz.append("<option value=\"\">--select value--");
    Session ses11 = WebappConfig.getAssaySessionFactory().openSession();
    List depList = null;
    Long objId = (userId==null||userId=="")?null:new Long( userId);
    if (groupId==null||groupId.equals("")){
      depList = ses11.createQuery("from AssayUser").list();
      xyz.append(PromptUtil.getUserPrompterFromList( depList,objId));
    } else {
      Long indepId = new Long(groupId);
      Query q = ses11.createQuery(
          "from UserGroupMembership myObj" +
          " where myObj.belongsTo = :group");
      q.setLong("group", indepId.longValue());
      depList = q.list();
      Iterator iter = depList.iterator();
      while (iter.hasNext()) {
        UserGroupMembership dep = (UserGroupMembership) iter.next();
        AssayUser obj = dep.getTheUser();
        if (obj.getId().equals(objId))
          xyz.append("<option selected value=\"");
        else
          xyz.append("<option value=\"");
        xyz.append(obj.getId())
           .append("\">")
           .append(obj.getLoginName()); //bija getVisibleName()
      }
    }
    ses11.close();
    xyz.append("\r\n</select>");
    xyz.append("</span>");
    return xyz.toString();
  }

  public String getUserPrompter( String groupId, String userId, boolean disabled)throws Exception {
    StringBuffer xyz = new StringBuffer();
    xyz.append("<span id=\"ow_userDiv\">");
    xyz.append("<select name=\"ow_user\"");
    if (disabled) xyz.append(" disabled");
    xyz.append(">\r\n");
    xyz.append("<option value=\"\">--select value--");
    List depList = null;
    Long objId = (userId==null||userId=="")?null:new Long( userId);
    if (groupId==null||groupId.equals("")){
      depList = getAllObjects(AssayUser.class);
      xyz.append(PromptUtil.getUserPrompterFromList( depList,objId));
    } else {
      Long indepId = new Long(groupId);
      Query q = hibSess.createQuery(
          "from UserGroupMembership myObj" +
          " where myObj.belongsTo = :group");
      q.setLong("group", indepId.longValue());
      depList = q.list();
      Iterator iter = depList.iterator();
      while (iter.hasNext()) {
        UserGroupMembership dep = (UserGroupMembership) iter.next();
        AssayUser obj = dep.getTheUser();
        if (obj.getId().equals(objId))
          xyz.append("<option selected value=\"");
        else
          xyz.append("<option value=\"");
        xyz.append(obj.getId())
           .append("\">")
           .append(obj.getLoginName());
      }
    }
    xyz.append("\r\n</select>");
    xyz.append("</span>");
    return xyz.toString();
  }
//----------------------------------------------------------//
//---------- Administrator tables --------------------------//
//----------------------------------------------------------//
  public boolean addPersistentWithoutClose(AssayPersistent myObj, String name,
                     String comment) throws Exception {
    if (currentUser == null || myObj == null) {
      return false;
    }
    myObj.setCreateInfo(currentUser);
    myObj.setVisibleName(name);
    myObj.setComment(comment);
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      hibSess.save(myObj);
      tx.commit();
      return true;
    }
    catch (Exception e) {
      if (tx != null) {
        tx.rollback();
      }
      throw e;
    }
  }
  public boolean addPersistent(AssayPersistent myObj, String name,
                     String comment) throws Exception {
    if (currentUser == null || myObj == null) {
      return false;
    }
    myObj.setCreateInfo(currentUser);
    myObj.setVisibleName(name);
    myObj.setComment(comment);
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      hibSess.save(myObj);
      tx.commit();
      return true;
    }
    catch (Exception e) {
      if (tx != null) {
        tx.rollback();
      }
      throw e;
    }
    finally {
      hibSess.close(); //needs before forward
    }
  }

  private boolean updatePersistent(AssayPersistent myObj, String name,
            String comment) throws Exception {
    if (currentUser == null || myObj == null) {
      return false;
    }
    myObj.setModifInfo(currentUser);
    myObj.setVisibleName(name);
    myObj.setComment(comment);
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      hibSess.update(myObj);
      tx.commit();
      return true;
    }
    catch (Exception e) {
      if (tx != null) {
        tx.rollback();
      }
      throw e;
    }
    finally {
      hibSess.close(); //needs before forward
    }
  }

  public boolean updatePersistent(AssayPersistent myObj) throws Exception {
    if (currentUser == null || myObj == null) {
      return false;
    }
    myObj.setModifInfo(currentUser);
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      hibSess.update(myObj);
      tx.commit();
      return true;
    }
    catch (Exception e) {
      if (tx != null) {
        tx.rollback();
      }
      throw e;
    }
    finally {
      hibSess.close(); //needs before forward
    }
  }
  public boolean updatePersistentSimple(AssayPersistent myObj) throws Exception {
    if (currentUser == null || myObj == null) {
      return false;
    }
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      hibSess.update(myObj);
      tx.commit();
      return true;
    }
    catch (Exception e) {
      if (tx != null) {
        tx.rollback();
      }
      throw e;
    }
  }
  public boolean deletePersistentSimple(AssayPersistent myObj) throws Exception {
	    if (currentUser == null || myObj == null) {
	      return false;
	    }
	    Transaction tx = null;
	    try {
	      tx = hibSess.beginTransaction();
	      hibSess.delete(myObj);
	      tx.commit();
	      return true;
	    }
	    catch (Exception e) {
	      if (tx != null) {
	        tx.rollback();
	      }
	      throw e;
	    }
	  }
//------------------------------------------------------//
//------------------------------------------------------//
  public Object getObjectByName(Class cl, String name) throws Exception {
    Object obj = null;
    Query q = hibSess.createQuery(
          "from " + cl.getName() + " myObj where myObj.visibleName = '"
          + name + "'");
    List list = q.list();
    if (list!=null && list.size()>0) obj = list.get(0);
    return obj;
  }

  public Object getObjectByNameForTechnology(Class cl, Technology techn, String name) throws Exception {
    Object obj = null;
    Query q;
    if ( techn == null) q = hibSess.createQuery(
            "from " + cl.getName() + " myObj where myObj.visibleName = '"
            + name + "' and myObj.technology is null");
    else q = hibSess.createQuery(
            "from " + cl.getName() + " myObj where myObj.visibleName = '"
            + name + "' and myObj.technology = '"
            + techn.getId().toString() + "'");
    List list = q.list();
    if (list!=null && list.size()>0) obj = list.get(0);
    return obj;
  }
  public Object getObjectByNameForCurrentTechnology(Class cl, String name) throws Exception {
    Object obj = null;
    Long technologyId = getCurrentTechnologyId();
    if ( technologyId != null){
      Query q = hibSess.createQuery(
	     "from " + cl.getName() + " myObj where myObj.visibleName = '"
	     + name + "' and myObj.technology = :techn");
      q.setLong("techn",technologyId.longValue());
      List list = q.list();
      if (list!=null && list.size()>0) obj = list.get(0);
    }  
    return obj;
  }
//next three methods used by XMLimport
  public Object getParameterByAssayColumnName(Class cl, Technology techn, String name) throws Exception {
    Object obj = null;
    Query q;
    if ( techn == null) q = hibSess.createQuery(
            "from " + cl.getName() + " myObj where myObj.assayColumnName = '"
            + name + "' and myObj.technology is null");
    else q = hibSess.createQuery(
            "from " + cl.getName() + " myObj where myObj.assayColumnName = '"
            + name + "' and myObj.technology = '"
            + techn.getId().toString() + "'");
    List list = q.list();
    if (list!=null && list.size()>0) obj = list.get(0);
    return obj;
  }
  public Object getParameterByStgrColumnName(Class cl, Technology techn, String name)
  throws HibernateException {
    Object obj = null;
    Query q;
    if ( techn == null) q = hibSess.createQuery(
            "from " + cl.getName() + " myObj where myObj.stgrColumnName = '"
            + name + "' and myObj.technology is null");
    else q = hibSess.createQuery(
            "from " + cl.getName() + " myObj where myObj.stgrColumnName = '"
            + name + "' and myObj.technology = '"
            + techn.getId().toString() + "'");
    List list = q.list();
    if (list!=null && list.size()>0) obj = list.get(0);
    return obj;
  }
  public Object getParameterByViewColumnName(Class cl, Technology techn, String name)
  throws HibernateException {
    Object obj = null;
    Query q;
    if ( techn == null) q = hibSess.createQuery(
            "from " + cl.getName() + " myObj where myObj.viewColumnName = '"
            + name + "' and myObj.technology is null");
    else q = hibSess.createQuery(
            "from " + cl.getName() + " myObj where myObj.viewColumnName = '"
            + name + "' and myObj.technology = '"
            + techn.getId().toString() + "'");
    List list = q.list();
    if (list!=null && list.size()>0) obj = list.get(0);
    return obj;
  }

  public Object getObjectById(Class cl, String sysId) throws HibernateException {
    Object obj = null;
    if (sysId!=null && !sysId.equals("") && !sysId.equals("0") && !sysId.equals("X")) {
      Long id = new Long( sysId);
      obj = hibSess.load(cl,id);
    }
    return obj;
  }

  public Object getObjectById(Class cl, Long sysId) throws HibernateException {
    Object obj = null;
    if (sysId!=null) {
        obj = hibSess.load(cl,sysId);
    }
    return obj;
  }

  public String getObjectNameById(Class cl, String sysId) throws HibernateException {
    String myString = null;
    if (sysId!=null && !sysId.equals("0")) {
      Long id = new Long( sysId);
      AssayPersistent obj = (AssayPersistent)hibSess.load(cl,id);
      if (obj!=null) myString = obj.getVisibleName();
    }
    return myString;
  }

  public String getObjectNameById(Class cl, Long sysId) throws HibernateException {
    String myString = null;
    if (sysId!=null && !sysId.equals("0")) {
      AssayPersistent obj = (AssayPersistent)hibSess.load(cl,sysId);
      if (obj!=null) myString = obj.getVisibleName();
    }
    return myString;
  }

  public boolean addPersistent(Class cl,
                               HttpServletRequest request) throws Exception {
    String visname = request.getParameter("visname");
    if (visname != null && !visname.trim().equals("")) {
      AssayPersistent tmpObj = (AssayPersistent) cl.newInstance();
      return addPersistent(tmpObj, visname, request.getParameter("comment"));
    }
    return false;
  }

  public int addTechnologyPersistent(Class cl,
               HttpServletRequest request, Technology techn) throws Exception {
    String visname = request.getParameter("visname");
    if (visname == null || visname.trim().equals("")) return 10;
    TechnologyPersistent tmpObj = (TechnologyPersistent) cl.newInstance();
    tmpObj.setTechnology( techn);
    if (addPersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
    return 1;
  }

  public int updatePersistent(Class cl,
                                  HttpServletRequest request) throws Exception {
    String sysId = request.getParameter("sysId");
    String visname = request.getParameter("visname");
    if (visname == null || visname.trim().equals("")) return 10;
    AssayPersistent tmpObj = (AssayPersistent) getObjectById(cl, sysId);
    if (updatePersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
    return 1;
  }

  public boolean deletePersistent(Class cl,
                                  HttpServletRequest request) throws Exception {
    String sysId = request.getParameter("sysId");
    Object myObj = getObjectById(cl, sysId);
    if (currentUser == null || myObj == null) return false;
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      hibSess.delete(myObj);
      tx.commit();
      return true;
    }
    catch (Exception e) {
      if (tx != null) {
        tx.rollback();
      }
      throw e;
    }
    finally {
      hibSess.close(); //needs before forward
    }
  }

  public int addDataType( 
          HttpServletRequest request, Technology techn) throws Exception {
    String visname = request.getParameter("visname");
    if (visname == null || visname.trim().equals("")) return 10;
    DataType tmpObj = DataType.class.newInstance();
    tmpObj.setTechnology( techn);
    tmpObj.setFileExtension(request.getParameter("extension"));
    if (addPersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
    return 1;
  }
  public int updateDataType( 
             HttpServletRequest request) throws Exception {
    String sysId = request.getParameter("sysId");
    String visname = request.getParameter("visname");
    if (visname == null || visname.trim().equals("")) return 10;
    DataType tmpObj = (DataType) getObjectById(DataType.class, sysId);
    tmpObj.setFileExtension(request.getParameter("extension"));
    if (updatePersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
    return 1;
  }
  public int addProtocolType( 
          HttpServletRequest request, Technology techn) throws Exception {
    String visname = request.getParameter("visname");
    if (visname == null || visname.trim().equals("")) return 10;
    ProtocolType tmpObj = ProtocolType.class.newInstance();
    tmpObj.setTechnology( techn);
    tmpObj.setFileExtension(request.getParameter("extension"));
    if (addPersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
    return 1;
  }
  public int updateProtocolType( 
             HttpServletRequest request) throws Exception {
    String sysId = request.getParameter("sysId");
    String visname = request.getParameter("visname");
    if (visname == null || visname.trim().equals("")) return 10;
    ProtocolType tmpObj = (ProtocolType) getObjectById(ProtocolType.class, sysId);
    tmpObj.setFileExtension(request.getParameter("extension"));
    if (updatePersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
    return 1;
  }
//---Persistent--------------------------------------
  public int getInstanceCount( Class cls) {
	     Long cnt = null;
	     try{
	       Query q = hibSess.createQuery(
	        "select count(*) from "+cls.getName());
	       cnt = (Long) q.iterate().next();
	     }catch(Exception ex) {};
	     return (cnt != null)? cnt.intValue():0;
	  }

  public int usedByCount( Class cls, String fld, long objidval) {
     Long cnt = null;
     try{
       Query q = hibSess.createQuery(
        "select count(*) from "+cls.getName()+
        " obj where obj."+fld+"=:objid");
       q.setLong("objid",objidval);
       cnt = (Long) q.iterate().next();
     }catch(Exception ex) {};
     return (cnt != null)? cnt.intValue():0;
  }

    public boolean notUsedBy( Class cls, String fld, AssayPersistent obj) {
       Long cnt = null;
       long objid = obj.getId().longValue();
       try{
         Query q = hibSess.createQuery(
          "select count(*) from "+cls.getName()+
          " obj where obj."+fld+"=:objid");
         q.setLong("objid",objid);
         cnt = (Long) q.iterate().next();
       }catch(Exception ex) {};
/*
       try{
           cnt = (Long) hibSess.createQuery(
           "select count(*) from "+cls.getName()+
           " obj where obj."+fld+
           "='"+obj.getId().toString()+"'").iterate().next();
       }catch(Exception ex) {};
*/
       return (cnt==null || cnt.intValue()==0);
    }

    public boolean notProcessedByMe( Class cls, AssayUser obj) {
       Long cnt = null;
       long userid = obj.getId().longValue();
       try{
         Query q = hibSess.createQuery(
          "select count(*) from "+cls.getName()+
          " obj where obj.creator=:creid or obj.modifier=:modid");
         q.setLong("creid",userid);
         q.setLong("modid",userid);
         cnt = (Long) q.iterate().next();
       }catch(Exception ex) {};
/*
       try{
           cnt = (Long) hibSess.createQuery(
           "select count(*) from "+cls.getName()
           +" obj where obj.creator = '"
           +obj.getId().toString()
           +"' or obj.modifier = '"
           +obj.getId().toString()
           +"'").iterate().next();
       }catch(Exception ex) {};
*/
       return (cnt==null || cnt.intValue()==0);
    }

    public int getStudyViewMax() {
      int max = 0;
      long userid = currentUser.getId().longValue();
      long technid = currentTechnology.getId().longValue();
/*    try{
        Query q = hibSess.createQuery(
         "select max(grobj.identif) from StudyView as grobj"
         +" where grobj.creator=:creid and grobj.technology=:tecid");
        q.setLong("creid",userid);
        q.setLong("tecid",technid);
        max = ((Long) q.iterate().next()).intValue();
      }catch(Exception ex) {};
*/    try{
        Query q = hibSess.createQuery(
         "select vwobj.identifString from StudyView as vwobj"
        +" where vwobj.creator=:creid and vwobj.technology=:tecid");
        q.setLong("creid",userid);
        q.setLong("tecid",technid);
        max = getIdentifMaxFromList( q.list());
      }catch(Exception ex) {};
      return max + 1;
    }
    public int checkStudyViewMax( Long uId, Long tId, int m) {
      int result = 0;
      if (tId.equals(getCurrentTechnologyId()) &&
          uId.equals(this.getCurrentUserId()) && m<=m) result = 1;
      return result;
    }
    public String makeStudyViewIdentif( int max){
      String usr = currentUser.getIdPrefix();
      String techn = currentTechnology.getIdPrefix();
      return StudyView.makeIdentifString(
          MetadataManager.getTopNamePrefix(getTopNum()),
          usr, techn, max);
    }
    public int getIdentifMaxFromList( List idList){
      int max = 0;
      Iterator iter = idList.iterator();
      while (iter.hasNext()) {
        String idString = (String) iter.next();
        int l = idString.lastIndexOf('-') + 1;
        if (l!=0){
          int x = Util.getIntegerValue( idString.substring(l));
          if (x > max) max = x; 
        }
      }
      return max;    	
    }
    
    public int getStudyGroupMax() {
      int max = 0;
      long userid = currentUser.getId().longValue();
      long technid = currentTechnology.getId().longValue();
/*    try{
        Query q = hibSess.createQuery(
         "select max(grobj.identif) from StudyGroup as grobj"
         +" where grobj.creator=:creid and grobj.technology=:tecid");
        q.setLong("creid",userid);
        q.setLong("tecid",technid);
        max = ((Long) q.iterate().next()).intValue();
      }catch(Exception ex) {};
*/    try{
        Query q = hibSess.createQuery(
         "select grobj.identifString from StudyGroup as grobj"
         +" where grobj.creator=:creid and grobj.technology=:tecid");
        q.setLong("creid",userid);
        q.setLong("tecid",technid);
        max = getIdentifMaxFromList( q.list());
      }catch(Exception ex) {};
      return max + 1;
    }

    public int checkStudyGroupMax( Long uId, Long tId, int m) {
      int result = 0;
      if (tId.equals(getCurrentTechnologyId()) &&
          uId.equals(this.getCurrentUserId()) && m<=m) result = 1;
      return result;
    }

    public String makeStudyGroupIdentif( int max){
      String usr = currentUser.getIdPrefix();
      String techn = currentTechnology.getIdPrefix();
      return StudyGroup.makeIdentifString( usr, techn, max);
    }

    public int getAssayMax(Long groupId) {
      if (groupId==null) return 1;
      int max = 0;
      long grpid = groupId.longValue();
/*    try{
        Query q = hibSess.createQuery(
         "select max(assay.identif) from Assay as assay"
         +" where assay.studyGroup=:groupid");
        q.setLong("groupid",grpid);
        max = ((Long) q.iterate().next()).intValue();
      }catch(Exception ex) {};
*/    try{
        Query q = hibSess.createQuery(
         "select assay.identifString from Assay as assay"
        +" where assay.studyGroup=:groupid");
        q.setLong("groupid",grpid);
        max = getIdentifMaxFromList( q.list());
      }catch(Exception ex) {};
      return max + 1;
    }
//----------------------------------------------------------
//---User (is not AssayPersistent)--------------------------
//----------------------------------------------------------
//this method used by logIn
  private AssayUser addUser( String visName, String userName,
                          String pasWord ) throws Exception {
     AssayUser tmpUser = new AssayUser();
     tmpUser.setCreateDate(new Date());
     tmpUser.setModifDate(new Date());
     tmpUser.setLoginName( userName);
     tmpUser.setAdminRights( new Integer(2000));
     tmpUser.setIdPrefix( "XYZ");
     tmpUser.setPassword( Util.criptString( pasWord));
     tmpUser.setFtpDirectory( "XYZ");
     tmpUser.setVisibleName( visName);
     tmpUser.setComment("");
     Transaction tx = null;
     try {
       tx = hibSess.beginTransaction();
       hibSess.save(tmpUser);
       tx.commit();
     }
     catch (Exception e) {
       if (tx != null) {
         tx.rollback();
       }
       throw e;
     }
     currentUser = tmpUser;
     UserGroup defaultGroupO = getDefaultUserGroup();
     tmpUser.setDefaultUserGroup(defaultGroupO);
     tmpUser.setCreateInfo(currentUser);
     tx = null;
     try {
       tx = hibSess.beginTransaction();
       hibSess.update(tmpUser);
       tx.commit();
     }
     catch (Exception e) {
       if (tx != null) {
         tx.rollback();
       }
       throw e;
     }
     UserGroupMembership tmpMemb = new UserGroupMembership();
     tmpMemb.setTheUser(tmpUser);
     tmpMemb.setBelongsTo(defaultGroupO);
     addPersistentWithoutClose(tmpMemb, "", "");
     return tmpUser;
   }
//called from AdminPageE.jsp
  public int addUser(HttpServletRequest request
                         ) throws Exception {
    if (currentUser == null) return 1;
    String visname = request.getParameter("visname");
    if (visname.equals(""))return 10;
    String prefix = request.getParameter("idPrefix").trim();
    if (prefix.equals(""))return 10;
    String psswd = request.getParameter("password").trim();
    if (psswd.equals(""))return 10;
    String loginName = request.getParameter("loginName"); 
    if (loginName.equals(""))return 10;
    if (!checkUserLoginName( loginName, 0))return 3; 
    AssayUser tmpUser = new AssayUser();
    tmpUser.setLoginName( loginName);
    tmpUser.setAdminRights(Util.getInteger(request.getParameter("adminrights")));
//    tmpUser.setExportRights( Util.getInteger( request.getParameter("exportAllow")));
//    tmpUser.setExportEGARights( Util.getInteger( request.getParameter("exportEGAAllow")));
    tmpUser.setIdPrefix( prefix);
    tmpUser.setPassword( Util.criptString( psswd));
    tmpUser.setStartWithWelcome( Util.getInteger( request.getParameter("startWithWelcome")));
    tmpUser.setFtpIsAllowed( Util.getInteger( request.getParameter("ftpAllow")));
    tmpUser.setFtpDirectory(request.getParameter("ftpDir"));
    String defaultGroup = request.getParameter("defaultgroup");
    UserGroup defaultGroupO  = (UserGroup)getObjectById(UserGroup.class, defaultGroup);
    if (defaultGroupO == null) return 10;
    tmpUser.setDefaultUserGroup(defaultGroupO);
    String projectPartner = request.getParameter("projectpartner");
    AssayProjectPartner partner  = (AssayProjectPartner)getObjectById(AssayProjectPartner.class, projectPartner);
    tmpUser.setProjectPartner( partner);
    addPersistentWithoutClose(tmpUser, visname, request.getParameter("comment"));

    UserGroupMembership tmpMemb = new UserGroupMembership();
    tmpMemb.setTheUser(tmpUser);
    tmpMemb.setBelongsTo(defaultGroupO);
    addPersistent(tmpMemb, "", "");

    return 0;
  }
//called from AdminPageE.jsp
  public int updateUser( HttpServletRequest request
                            ) throws Exception {
    if (currentUser == null) return 1;
    String sysId = request.getParameter("sysId");
    String visname = request.getParameter("visname");
    if (visname.equals(""))return 10;
    String prefix = request.getParameter("idPrefix").trim();
    if (prefix.equals(""))return 10;
    String loginName = request.getParameter("loginName"); 
    if (loginName.equals(""))return 10;
    if (!checkUserLoginName( loginName, Util.getLongValue( sysId)))return 3; 
    AssayUser tmpUser = (AssayUser) getObjectById(AssayUser.class, sysId);
    if (tmpUser != null) {
      tmpUser.setLoginName( loginName);
      tmpUser.setAdminRights(Util.getInteger(request.getParameter("adminrights")));
//      tmpUser.setExportRights( Util.getInteger( request.getParameter("exportAllow")));
//      tmpUser.setExportEGARights( Util.getInteger( request.getParameter("exportEGAAllow")));
      String oldPrefix =  tmpUser.getIdPrefix();
      boolean flag = !prefix.equals(oldPrefix);
      if (flag) tmpUser.setIdPrefix( prefix);
      String psswd = request.getParameter("password");
      if (psswd!=null){
        psswd = psswd.trim();
        if (psswd.equals(""))return 10;
        tmpUser.setPassword( Util.criptString( psswd));
      }
      tmpUser.setStartWithWelcome( Util.getInteger( request.getParameter("startWithWelcome")));
      tmpUser.setFtpIsAllowed( Util.getInteger( request.getParameter("ftpAllow")));
      tmpUser.setFtpDirectory(request.getParameter("ftpDir"));
      String defaultGroup = request.getParameter("defaultgroup");
      UserGroup defaultGroupO = (UserGroup)getObjectById(UserGroup.class, defaultGroup);
      if (defaultGroupO == null) return 10;
      tmpUser.setDefaultUserGroup(defaultGroupO);
      String projectPartner = request.getParameter("projectpartner");
      AssayProjectPartner partner  = (AssayProjectPartner)getObjectById(AssayProjectPartner.class, projectPartner);
      tmpUser.setProjectPartner( partner);
      boolean result = updatePersistent(tmpUser, visname, request.getParameter("comment"));
      if (result && flag)
        result = updateUserIdentifiers( tmpUser, oldPrefix, prefix);
    }
    return 0;
  }
//called from AdminPageE.jsp
  public boolean addUserRights(HttpServletRequest request
                         ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String grantBy = request.getParameter("grantby");
    String grantTo = request.getParameter("grantto");
    String rights = request.getParameter("rights");
    AssayUserRights tmpRights = new AssayUserRights();
    tmpRights.setAccessRights( Util.getInteger(rights));
    tmpRights.setDefineViewRights( Util.getInteger( request.getParameter("defineView")));
    tmpRights.setGrantedBy((AssayUser)getObjectById(AssayUser.class, grantBy));
    tmpRights.setGrantedTo((AssayUser)getObjectById(AssayUser.class, grantTo));
    result = addPersistent(tmpRights, "", request.getParameter("comment"));
    return result;
  }
//called from AdminPageE.jsp
  public boolean updateUserRights( HttpServletRequest request
                            ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String sysId = request.getParameter("sysId");
    String grantBy = request.getParameter("grantby");
    String grantTo = request.getParameter("grantto");
    String rights = request.getParameter("rights");
    AssayUserRights tmpRights = (AssayUserRights) getObjectById(AssayUserRights.class, sysId);
    if (tmpRights != null) {
      tmpRights.setAccessRights( Util.getInteger(rights));
      tmpRights.setDefineViewRights( Util.getInteger( request.getParameter("defineView")));
      tmpRights.setGrantedBy((AssayUser)getObjectById(AssayUser.class, grantBy));
      tmpRights.setGrantedTo((AssayUser)getObjectById(AssayUser.class, grantTo));
      result = updatePersistent(tmpRights, "", request.getParameter("comment"));
    }
    return result;
  }
  //called from AdminPageE.jsp
  public boolean addUserGroupRights(HttpServletRequest request
                         ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String grantBy = request.getParameter("grantby");
    String grantTo = request.getParameter("grantto");
    String rights = request.getParameter("rights");
    UserGroupRights tmpRights = new UserGroupRights();
    tmpRights.setAccessRights( Util.getInteger(rights));
    tmpRights.setDefineViewRights( Util.getInteger( request.getParameter("defineView")));
    tmpRights.setGrantedBy((UserGroup)getObjectById(UserGroup.class, grantBy));
    tmpRights.setGrantedTo((UserGroup)getObjectById(UserGroup.class, grantTo));
    result = addPersistent(tmpRights, "", request.getParameter("comment"));
    return result;
  }
//called from AdminPageE.jsp
  public boolean updateUserGroupRights( HttpServletRequest request
                            ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String sysId = request.getParameter("sysId");
    String grantBy = request.getParameter("grantby");
    String grantTo = request.getParameter("grantto");
    String rights = request.getParameter("rights");
    UserGroupRights tmpRights = (UserGroupRights) getObjectById(UserGroupRights.class, sysId);
    if (tmpRights != null) {
      tmpRights.setAccessRights( Util.getInteger(rights));
      tmpRights.setDefineViewRights( Util.getInteger( request.getParameter("defineView")));
      tmpRights.setGrantedBy((UserGroup)getObjectById(UserGroup.class, grantBy));
      tmpRights.setGrantedTo((UserGroup)getObjectById(UserGroup.class, grantTo));
      result = updatePersistent(tmpRights, "", request.getParameter("comment"));
    }
    return result;
  }

  private boolean resetDefaultUserGroup() throws Exception {
    boolean result = false;
      Transaction tx = null;
      try {
        tx = hibSess.beginTransaction();
        List gr = hibSess.createQuery("from UserGroup").list();
        Iterator groupIterator = gr.iterator();
        while (groupIterator.hasNext()) {
          UserGroup ugr = (UserGroup) groupIterator.next();
          if (ugr.isDefault()){
            ugr.setDefaultX(new Integer(0));
            hibSess.update(ugr);
          }
        }
      }
      catch (Exception e) {
        if (tx != null) tx.rollback();
        throw e;
      }
    return result;
  }
  private UserGroup getDefaultUserGroup() throws Exception {
    UserGroup tmpUGroup = null;
    List gr = hibSess.createQuery("from UserGroup").list();
    Iterator groupIterator = gr.iterator();
    while (groupIterator.hasNext()) {
      UserGroup ugr = (UserGroup) groupIterator.next();
      if (ugr.isDefault()){
        tmpUGroup = ugr;
        break;
      }
    }
    if (tmpUGroup == null){
      tmpUGroup = new UserGroup();
      tmpUGroup.setDefaultX( new Integer(1));
      addPersistentWithoutClose(tmpUGroup, "default group","");
    }
    return tmpUGroup;
  }
//called from AdminPageE.jsp
  public boolean addUserGroup(HttpServletRequest request
                         ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String visname = request.getParameter("visname");
    Integer dx = Util.getInteger( request.getParameter("default"));
    if (dx.byteValue()>0) resetDefaultUserGroup();
    UserGroup tmpUGroup = new UserGroup();
    tmpUGroup.setDefaultX( dx);
    result = addPersistent(tmpUGroup, visname, request.getParameter("comment"));
    return result;
  }
//called from AdminPageE.jsp
  public boolean updateUserGroup( HttpServletRequest request
                            ) throws Exception {
    boolean result = false;
    if (currentUser == null) return false;
    String visname = request.getParameter("visname");
    String defstr = request.getParameter("default");
    String sysId = request.getParameter("sysId");
    UserGroup tmpUGroup = (UserGroup) getObjectById(UserGroup.class, sysId);
    if (tmpUGroup != null) {
      if (defstr!=null){
        Integer dx = Util.getInteger(defstr);
        if (dx.byteValue() > 0) resetDefaultUserGroup();
        tmpUGroup.setDefaultX(dx);
      }
      result = updatePersistent(tmpUGroup, visname, request.getParameter("comment"));
    }
    return result;
  }
//called from AdminPageE.jsp
  public boolean deleteUserGroup(HttpServletRequest request
                         ) throws Exception {
    String sysId = request.getParameter("sysId");
    UserGroup myObj = (UserGroup)getObjectById(UserGroup.class, sysId);
    if (currentUser == null || myObj == null) return false;
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      Query q1 = hibSess.createQuery(
        "from UserGroupRights myRights" +
        " where myRights.grantedBy = :grBy or myRights.grantedTo = :grTo");
      q1.setLong("grBy",myObj.getId().longValue());
      q1.setLong("grTo",myObj.getId().longValue());
      List rList = q1.list();
      Iterator rIterator = rList.iterator();
      while (rIterator.hasNext()) {
        UserGroupRights myRights = (UserGroupRights) rIterator.next();
        hibSess.delete( myRights);
      }
      hibSess.delete(myObj);
      tx.commit();
      return true;
    }
    catch (Exception e) {
      if (tx != null) {
        tx.rollback();
      }
      throw e;
    }
    finally {
      hibSess.close(); //needs before forward
    }
  }
//called from AdminPageE.jsp
  public int addUserGroupMembership(HttpServletRequest request
                         ) throws Exception {
    String theUser = request.getParameter("theuser");
    String belongsTo = request.getParameter("belongsto");
    AssayUser user = (AssayUser)getObjectById(AssayUser.class, theUser);
    UserGroup group = (UserGroup)getObjectById(UserGroup.class, belongsTo);
    if (!checkUserGroupMembership( user, group, 0)) return 3;
    UserGroupMembership tmpMemb = new UserGroupMembership();
    tmpMemb.setTheUser(user);
    tmpMemb.setBelongsTo(group);
    if (addPersistent(tmpMemb, "", request.getParameter("comment"))) return 0;
    return 1;
  }
//called from AdminPageE.jsp
  public int updateUserGroupMembership( HttpServletRequest request
                            ) throws Exception {
    String sysId = request.getParameter("sysId");
    String theUser = request.getParameter("theuser");
    String belongsTo = request.getParameter("belongsto");
    UserGroupMembership tmpMemb = (UserGroupMembership) getObjectById(UserGroupMembership.class, sysId);
    if (tmpMemb != null) {
      AssayUser user = (AssayUser)getObjectById(AssayUser.class, theUser);
      UserGroup group = (UserGroup)getObjectById(UserGroup.class, belongsTo);
      if (!checkUserGroupMembership( user, group, tmpMemb.getId().longValue())) return 3;
      tmpMemb.setTheUser(user);
      tmpMemb.setBelongsTo(group);
      if (updatePersistent(tmpMemb, "", request.getParameter("comment"))) return 0;
    }
    return 1;
  }
  private boolean checkUserGroupMembership(AssayUser user, UserGroup group, long sysId){
  try {
    Query q1 = hibSess.createQuery(
      "from UserGroupMembership myMemb" +
      " where myMemb.theUser = :grBy and myMemb.belongsTo = :grTo");
    q1.setLong("grBy",user.getId().longValue());
    q1.setLong("grTo",group.getId().longValue());
    List rList = q1.list();
    if (rList.size() > 0){
      AssayPersistent memb = (AssayPersistent) rList.get(0);
      if (memb.getId().longValue()!=sysId) return false;
    }
  }
  catch (Exception e) { return false; }
  return true;
}
  private boolean checkUserLoginName(String lname, long sysId){
  try {
    Query q1 = hibSess.createQuery(
      "from AssayUser user" +
      " where user.loginName = :uln");
    q1.setString("uln", lname);
    List rList = q1.list();
    if (rList.size() > 0){
      AssayPersistent memb = (AssayPersistent) rList.get(0);
      if (memb.getId().longValue()!=sysId) return false;
    }
  }
  catch (Exception e) { return false; }
  return true;
}
//this method used by UserSettings.jsp
  public int checkUserPassword(String psswd0, String psswd1, String psswd2) throws Exception {
    if (currentUser == null) return 1;
    if (!currentUser.getPassword().equals(Util.criptString(psswd0)))return 1;
    if (psswd1.length()<3) return 2;
    if (!psswd1.equals(psswd2)) return 3;
    return 0;
  }
//this method used by UserWelcome.jsp
  public boolean updateUserDefaultGroup( HttpServletRequest request)
      throws Exception {
    if (currentUser == null) return false;
//-------- current user in current session  -------------
    currentUser = (AssayUser)getObjectById( AssayUser.class, getCurrentUserId());
    currentUser.importSettings(WebappConfig.getViewLimit(), false);
//-------- current user in current session  -------------
    UserGroup dGroup = currentUser.getDefaultUserGroup();
    long did = (dGroup!=null)?dGroup.getId().longValue():0;
    String defaultGroup = request.getParameter("defaultgroup");
    UserGroup uGroup = (UserGroup)getObjectById(UserGroup.class, defaultGroup);
    if (uGroup!=null){
      long uid = uGroup.getId().longValue();
      if (uid!=did){
        currentUser.setDefaultUserGroup(uGroup);
        currentUser.setModifDate(new Date());
        Transaction tx = null;
        try {
          tx = hibSess.beginTransaction();
          hibSess.update(currentUser);
          tx.commit();
        }
        catch (Exception ex) {
          if (tx != null) tx.rollback();
          throw ex;
        }
        finally { 
          hibSess.close(); //needs before forward
        }
      }
    }
    return true;
  }
//this method used by UserSettings.jsp
  public boolean updateUser(String psswd, HttpServletRequest request)
      throws Exception {
    if (currentUser == null) return false;
//-------- current user in current session  -------------
    currentUser = (AssayUser)getObjectById( AssayUser.class, getCurrentUserId());
    currentUser.importSettings(WebappConfig.getViewLimit(), false);
//-------- current user in current session  -------------
    String usviewlim = request.getParameter("viewlim");
    currentUser.setViewLimit( Util.getIntegerValue( usviewlim));
    String usshowfid = request.getParameter("showfid");
    currentUser.setShowFullId( usshowfid!=null && usshowfid.equals("true"));
    currentUser.exportSettings();
    currentUser.setStartWithWelcome( Util.getInteger( request.getParameter("startWithWelcome")));
    String defaultGroup = request.getParameter("defaultgroup");
    UserGroup uGroup = (UserGroup)getObjectById(UserGroup.class, defaultGroup);
    currentUser.setDefaultUserGroup(uGroup);
    if (psswd!=null) currentUser.setPassword( Util.criptString( psswd));
    currentUser.setModifDate(new Date());
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      hibSess.update(currentUser);
      tx.commit();
    }
    catch (Exception e) {
      if (tx != null) tx.rollback();
      throw e;
    }
    finally {
      hibSess.close(); //needs before forward
    }
    return true;
  }
//this method used by Export..Data.jsp
  public boolean updateUserSettingsFTP( RequestParserAjax request)
      throws Exception {
    if (currentUser == null) return false;
    boolean modif = false;
//-------- current user in current session  -------------
    String value = request.getParameter("ftpusername");
    if (value!=null && !value.equals(currentUser.getFtpUserName())){
      currentUser.setFtpUserName(value); modif = true;	
    }
    value = request.getParameter("ftppassword");
    if (value!=null && !value.equals(currentUser.getFtpPassWord())){
      currentUser.setFtpPassWord(value); modif = true;	
    }
    value = request.getParameter("ftpserver");
    if (value!=null && !value.equals(currentUser.getFtpServer())){
      currentUser.setFtpServer(value); modif = true;	
    }
    value = request.getParameter("ftpdirectory");
    if (value!=null && !value.equals(currentUser.getFtpRemoteDirectory())){
      currentUser.setFtpRemoteDirectory(value); modif = true;	
    }
    if (modif){
      currentUser.exportSettingsFileExport();
      currentUser.setModifDate(new Date());
      Transaction tx = null;
      try {
        tx = hibSess.beginTransaction();
        hibSess.update(currentUser);
        tx.commit();
      }
      catch (Exception e) {
        if (tx != null) tx.rollback();
        throw e;
      }
    }  
    return true;
  }
  public boolean updateUserIdentifiers( AssayUser user,
                   String oldA, String newA) throws Exception {
      Query q = null;
      int oldL = oldA.length();
//      int newL = newA.length();
      Transaction tx = null;
      try {
        hibSess = WebappConfig.getAssaySessionFactory().openSession();
        tx = hibSess.beginTransaction();
        q = hibSess.createQuery(
                "select myStgr from StudyGroup as myStgr"
                + " where myStgr.creator = '"
                + user.getId().toString() + "'");
        List groups = q.list();
        Iterator groupIterator = groups.iterator();
        while (groupIterator.hasNext()) {
          StudyGroup stgr = (StudyGroup) groupIterator.next();
          String genId = stgr.getIdentifString();
          int k = genId.indexOf('-');
          if (k==oldL){
            if (genId.substring(0,oldL).equals(oldA)){
                genId = newA + genId.substring(k);
                stgr.setIdentifString(genId);
                hibSess.update(stgr);
            }
          }
        }
        groups = null; //remove reference
        q = hibSess.createQuery(
                "select myAssay from Assay as myAssay"
                + " where myAssay.creator = '"
                + user.getId().toString() + "'");
        List assays = q.list();
        Iterator assayIterator = assays.iterator();
        while (assayIterator.hasNext()) {
          Assay assay = (Assay) assayIterator.next();
          String genId = assay.getIdentifString();
          int k = genId.indexOf('-');
          if (k==oldL){
            if (genId.substring(0,oldL).equals(oldA)){
                genId = newA + genId.substring(k);
                assay.setIdentifString(genId);
                hibSess.update(assay);
            }
          }
        }
        assays = null; //remove reference
        tx.commit();
      } catch (Exception e) {
          if (tx!=null) tx.rollback();
          throw e;
      }
      finally {
          hibSess.close(); //needs before forward
      }
      return true;
  }

  public boolean deleteUser( HttpServletRequest request) throws Exception {
    String sysId = request.getParameter("sysId");
    AssayUser myObj = (AssayUser)getObjectById(AssayUser.class, sysId);
    if (currentUser == null || myObj == null) return false;
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      Query q1 = hibSess.createQuery(
        "from AssayUserRights myRights" +
        " where myRights.grantedBy = :usrBy or myRights.grantedTo = :usrTo");
      q1.setLong("usrBy",myObj.getId().longValue());
      q1.setLong("usrTo",myObj.getId().longValue());
      List rList = q1.list();
      Iterator rIterator = rList.iterator();
      while (rIterator.hasNext()) {
        AssayUserRights myRights = (AssayUserRights) rIterator.next();
        hibSess.delete( myRights);
      }
      Query q2 = hibSess.createQuery(
        "from UserGroupMembership myMemb where myMemb.theUser = :usr");
      q2.setLong("usr",myObj.getId().longValue());
      List mList = q2.list();
      Iterator mIterator = mList.iterator();
      while (mIterator.hasNext()) {
        UserGroupMembership myMemb = (UserGroupMembership) mIterator.next();
        hibSess.delete( myMemb);
      }
      hibSess.delete(myObj);
      tx.commit();
      return true;
    }
    catch (Exception e) {
      if (tx != null) {
        tx.rollback();
      }
      throw e;
    }
    finally {
      hibSess.close(); //needs before forward
    }
  }
//---Technology Access-----------------------------------------------
//---Technology Access-----------------------------------------------
    public boolean addTechnologyAccess( HttpServletRequest request
                               ) throws Exception {
      String technolId = request.getParameter("technology");
      String userId = request.getParameter("user");
      String createSG = request.getParameter("createSG");
      String createView = request.getParameter("createView");
      String vocabAcc = request.getParameter("vocabAccess");
      String configAcc = request.getParameter("configAccess");
      String dataExport = request.getParameter("dataExport");
      String fileExport = request.getParameter("fileExport");
      String dataTransfer = request.getParameter("dataTransfer");
      TechnologyAccess tmpObj = (TechnologyAccess) TechnologyAccess.class.newInstance();
      if (tmpObj!=null){
        Technology techn = (Technology) getObjectById(Technology.class,
            technolId);
        tmpObj.setTechnology(techn);
        AssayUser user = (AssayUser) getObjectById(AssayUser.class, userId);
        tmpObj.setUser(user);
        tmpObj.setCanCreateSGX(Util.getInteger(createSG));
        tmpObj.setCanCreateViewX(Util.getInteger(createView));
        tmpObj.setVocabularyAccess(Util.getInteger(vocabAcc));
        tmpObj.setConfigurationAccess(Util.getInteger(configAcc));
        tmpObj.setDataExportRights(Util.getInteger(dataExport));
        tmpObj.setDataFileExportRightsX(Util.getInteger(fileExport));
        tmpObj.setDataTransferRightsX(Util.getInteger(dataTransfer));
        return addPersistent(tmpObj, "", request.getParameter("comment"));
      }
      return false;
    }

    public boolean updateTechnologyAccess( HttpServletRequest request
                               ) throws Exception {
      String sysId = request.getParameter("sysId");
      String technolId = request.getParameter("technology");
      String userId = request.getParameter("user");
      String createSG = request.getParameter("createSG");
      String createView = request.getParameter("createView");
      String vocabAcc = request.getParameter("vocabAccess");
      String configAcc = request.getParameter("configAccess");
      String dataExport = request.getParameter("dataExport");
      String fileExport = request.getParameter("fileExport");
      String dataTransfer = request.getParameter("dataTransfer");
      TechnologyAccess tmpObj = (TechnologyAccess) getObjectById(TechnologyAccess.class, sysId);
      if (tmpObj!=null){
        Technology techn = (Technology) getObjectById(Technology.class,
            technolId);
        tmpObj.setTechnology(techn);
        AssayUser user = (AssayUser) getObjectById(AssayUser.class, userId);
        tmpObj.setUser(user);
        tmpObj.setCanCreateSGX(Util.getInteger(createSG));
        tmpObj.setCanCreateViewX(Util.getInteger(createView));
        tmpObj.setVocabularyAccess(Util.getInteger(vocabAcc));
        tmpObj.setConfigurationAccess(Util.getInteger(configAcc));
        tmpObj.setDataExportRights(Util.getInteger(dataExport));
        tmpObj.setDataFileExportRightsX(Util.getInteger(fileExport));
        tmpObj.setDataTransferRightsX(Util.getInteger(dataTransfer));
        return updatePersistent(tmpObj, "", request.getParameter("comment"));
      }
      return false;
    }
//---Technology-------------------------------------------------
//---Technology-------------------------------------------------
    public boolean isStudyIdGener() {
        return (currentTechnology!=null && currentTechnology.useIdGeneration());
    }
    public int addTechnology( HttpServletRequest request) throws Exception {
      String visname = request.getParameter("visname").trim();
      if (visname.equals(""))return 10;;
      String prefix = request.getParameter("idPrefix").trim();
      if (prefix.equals(""))return 10;;
      Technology tmpObj = (Technology)Technology.class.newInstance();
      String transfertype = request.getParameter("transfertype");
      TransferType transfer = (TransferType) getObjectById(TransferType.class,
              transfertype);
      tmpObj.setTransferType(transfer);
      tmpObj.setIdPrefix( prefix);
      tmpObj.setFtpDirectory(request.getParameter("ftpDir"));
      tmpObj.setPublicX(Util.getInteger(request.getParameter("public")));
      tmpObj.setUseIdGenerationX(Util.getInteger(request.getParameter("useIdGener")));
      tmpObj.setShowViewLevelsX(Util.getInteger(request.getParameter("showViewB")));
      boolean result = addPersistent(tmpObj, visname, request.getParameter("comment"));
      //copy common parameters for new techn.
      if (result){
        hibSess = WebappConfig.getAssaySessionFactory().openSession();
        Transaction tx = null;
        try {
          tx = hibSess.beginTransaction();
          List cpList = this.getAllObjectsForTechnology(CommonParameter.class, null);
          Iterator cpIterator = cpList.iterator();
          while (cpIterator.hasNext()) {
            CommonParameter source = (CommonParameter) cpIterator.next();
            CommonParameter target = (CommonParameter) CommonParameter.class.
                newInstance();
            source.CopyTo(target);
            target.setTechnology(tmpObj);
            target.setCreateInfo(currentUser);
            hibSess.save(target);
          }
          tx.commit();
          return 0;
        }
        catch (Exception e) {
          if (tx != null) {
            tx.rollback();
          }
          throw e;
        }
        finally {
          hibSess.close(); //needs before forward
        }
      }
      return 1;
    }

    public int updateTechnology( HttpServletRequest request) throws Exception {
      String sysId = request.getParameter("sysId");
      String visname = request.getParameter("visname").trim();
      if (visname.equals(""))return 10;;
      String prefix = request.getParameter("idPrefix").trim();
      if (prefix.equals(""))return 10;;
      Technology tmpObj = (Technology) getObjectById( Technology.class, sysId);
      if (tmpObj != null) {
        String transfertype = request.getParameter("transfertype");
        TransferType transfer = (TransferType) getObjectById(TransferType.class,
                  transfertype);
        tmpObj.setTransferType(transfer);
        String oldPrefix = tmpObj.getIdPrefix();
        boolean flag = !prefix.equals(oldPrefix);
        if (flag) tmpObj.setIdPrefix( prefix);
        tmpObj.setFtpDirectory(request.getParameter("ftpDir"));
        tmpObj.setPublicX(Util.getInteger(request.getParameter("public")));
        tmpObj.setUseIdGenerationX(Util.getInteger(request.getParameter("useIdGener")));
        tmpObj.setShowViewLevelsX(Util.getInteger(request.getParameter("showViewB")));
        boolean result = updatePersistent(tmpObj, visname, request.getParameter("comment"));
        if (flag && result)
          result = updateTechnologyIdentifiers( tmpObj, oldPrefix, prefix);
        return 0;
      }
      return 1;
    }
//---Transfer type-------------------------------------------------
    public int addTransferType( HttpServletRequest request) throws Exception {
      String visname = request.getParameter("visname").trim();
      if (visname.equals(""))return 10;;
      String abbrev = request.getParameter("abbr").trim();
      if (abbrev.equals(""))return 10;;
      String fromlev = request.getParameter("fromLevel");
      if (fromlev.equals("0"))return 10;;
      TransferType tmpObj = (TransferType)TransferType.class.newInstance();
      tmpObj.setAbbr( abbrev);
      tmpObj.setTransferFromLevel( Util.getInteger(fromlev));
      tmpObj.setDataDirectory(request.getParameter("dataDir"));
      if (addPersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
      return 1;
    }

    public int updateTransferType( HttpServletRequest request) throws Exception {
      String sysId = request.getParameter("sysId");
      String visname = request.getParameter("visname").trim();
      if (visname.equals(""))return 10;;
      String abbrev = request.getParameter("abbr").trim();
      if (abbrev.equals(""))return 10;;
      String fromlev = request.getParameter("fromLevel");
      if (fromlev.equals("0"))return 10;;
      TransferType tmpObj = (TransferType) getObjectById( TransferType.class, sysId);
      if (tmpObj != null) {
        tmpObj.setAbbr(abbrev);
        tmpObj.setTransferFromLevel( Util.getInteger(fromlev));
        tmpObj.setDataDirectory(request.getParameter("dataDir"));
        if (updatePersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
      }
      return 1;
    }

    public boolean updateTechnologyIdentifiers( Technology techn,
                     String oldA, String newA) throws Exception {
        Query q = null;
        int oldL = oldA.length();
        int newL = newA.length();
        Transaction tx = null;
        try {
          hibSess = WebappConfig.getAssaySessionFactory().openSession();
          tx = hibSess.beginTransaction();
          q = hibSess.createQuery(
                  "select myStgr from StudyGroup as myStgr"
                  + " where myStgr.technology = '"
                  + techn.getId().toString() + "'");
          List groups = q.list();
          Iterator groupIterator = groups.iterator();
          while (groupIterator.hasNext()) {
            StudyGroup stgr = (StudyGroup) groupIterator.next();
            String genId = stgr.getIdentifString();
            int k = genId.indexOf('-') + 1;
            if (k > 1 && k+oldL <= genId.length()){
              if (genId.substring(k,k+oldL).equals(oldA)){
                  genId = genId.substring(0, k) + newA +
                          genId.substring(k + oldL);
                  stgr.setIdentifString(genId);
                  hibSess.update(stgr);
              }
            }
          }
          groups = null;
          q = hibSess.createQuery(
                  "select myAssay from Assay as myAssay"
                  + " where myAssay.technology = '"
                  + techn.getId().toString() + "'");
          List assays = q.list();
          Iterator assayIterator = assays.iterator();
          while (assayIterator.hasNext()) {
            Assay assay = (Assay) assayIterator.next();
            String genId = assay.getIdentifString();
            int k = genId.indexOf('-') + 1;
            if (k > 1 && k+oldL <= genId.length()){
              if (genId.substring(k,k+oldL).equals(oldA)){
                  genId = genId.substring(0, k) + newA +
                          genId.substring(k + oldL);
                  assay.setIdentifString(genId);
                  hibSess.update(assay);
              }
            }
          }
          assays = null;
          tx.commit();
        } catch (Exception e) {
            if (tx!=null) tx.rollback();
            throw e;
        }
        finally {
            hibSess.close(); //needs before forward
        }
        return true;
    }
//---ParameterGroup-------------------------------------------------
//---ParameterGroup-------------------------------------------------
  public int addParameterGroup( HttpServletRequest request) throws Exception {
    String visname = request.getParameter("visname");
    String shortname = request.getParameter("shortname");
    String assayPosition = request.getParameter("assayPosition");
    String stgrPosition = request.getParameter("stgrPosition");
    String viewPosition = request.getParameter("viewPosition");
    if (visname == null || visname.trim().equals("")) return 10;
    ParameterGroup tmpObj = (ParameterGroup) ParameterGroup.class.newInstance();
    tmpObj.setShortName(shortname);
    tmpObj.setAssayPosition(Util.getInteger( assayPosition));
    tmpObj.setStgrPosition(Util.getInteger( stgrPosition));
    tmpObj.setViewPosition(Util.getInteger( viewPosition));
    if (addPersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
    return 1;
  }

  public int updateParameterGroup( HttpServletRequest request) throws Exception {
    String sysId = request.getParameter("sysId");
    String visname = request.getParameter("visname");
    String shortname = request.getParameter("shortname");
    String assayPosition = request.getParameter("assayPosition");
    String stgrPosition = request.getParameter("stgrPosition");
    String viewPosition = request.getParameter("viewPosition");
    if (visname == null || visname.trim().equals("")) return 10;
    ParameterGroup tmpObj = (ParameterGroup) getObjectById(ParameterGroup.class, sysId);
    if (tmpObj != null) {
      tmpObj.setShortName(shortname);
      tmpObj.setAssayPosition(Util.getInteger( assayPosition));
      tmpObj.setStgrPosition(Util.getInteger( stgrPosition));
      tmpObj.setViewPosition(Util.getInteger( viewPosition));
      if (updatePersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
    }
    return 1;
  }
//---ParameterType-------------------------------------------------
//---ParameterType-------------------------------------------------
  public int addParameterType( HttpServletRequest request,
                                 Technology techn) throws Exception {
    String visname = request.getParameter("visname");
    String typeId = request.getParameter("type");
    String display1 = request.getParameter("display1");
    String display2 = request.getParameter("display2");
    String refTable = request.getParameter("refTable");
    String popupName = request.getParameter("popup");
    if (visname == null || visname.trim().equals("")) return 10;
    ParameterType tmpObj = (ParameterType) ParameterType.class.newInstance();
    Integer ptn = new Integer(typeId);
    tmpObj.setTechnology( techn);
    tmpObj.setBaseType( ptn);
    tmpObj.setDisplay1(Util.getInteger( display1));
    tmpObj.setDisplay2(Util.getInteger( display2));
    Vocabulary vocab = (Vocabulary) getObjectById(Vocabulary.class, refTable);
    tmpObj.setVocabulary( vocab);
    tmpObj.setPopupName( popupName);
    if (addPersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
    return 1;
  }

  public int updateParameterType( HttpServletRequest request) throws Exception {
    String sysId = request.getParameter("sysId");
    String typeId = request.getParameter("type");
    String visname = request.getParameter("visname");
    String display1 = request.getParameter("display1");
    String display2 = request.getParameter("display2");
    String refTable = request.getParameter("refTable");
    String popupName = request.getParameter("popup");
    if (visname == null || visname.trim().equals("")) return 10;
    ParameterType tmpObj = (ParameterType) getObjectById(ParameterType.class, sysId);
    if (tmpObj != null) {
      Integer ptn = new Integer(typeId);
      tmpObj.setBaseType( ptn);
      tmpObj.setDisplay1(Util.getInteger( display1));
      tmpObj.setDisplay2(Util.getInteger( display2));
      Vocabulary vocab = (Vocabulary) getObjectById(Vocabulary.class, refTable);
      tmpObj.setVocabulary( vocab);
      tmpObj.setPopupName( popupName);
      if (updatePersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
    }
    return 1;
  }
//---Parameter-------------------------------------------------
//---Parameter-------------------------------------------------
  public int addParameter( HttpServletRequest request,
                             Technology techn) throws Exception {
    String longname = request.getParameter("longname").trim();
    if (longname.equals("")) return 10;
    String visname = request.getParameter("visname").trim();
    if (visname.equals("")) visname = longname;
    String uploadname = request.getParameter("uploadname").trim();
    if (uploadname.equals("")) uploadname = longname;
    String groupId = request.getParameter("group");
    String typeId = request.getParameter("type");
    String required = request.getParameter("required");
//    String colnumInr = request.getParameter("colnumInr");
    String showInr = request.getParameter("rpshow");
//    String sortInr = request.getParameter("sortInr");
//    String filterInr = request.getParameter("filterInr");
    String notetd = request.getParameter("notetd");
    Parameter tmpObj = (Parameter) Parameter.class.newInstance();
    if (tmpObj!=null){
      tmpObj.setTechnology( techn);
      ParameterGroup group = (ParameterGroup) getObjectById(ParameterGroup.class, groupId);
      tmpObj.setParameterGroup(group);
      ParameterType type = (ParameterType) getObjectById(ParameterType.class, typeId);
      tmpObj.setParameterType(type);
      tmpObj.setLongName(longname);
      tmpObj.setUploadName(uploadname);
      String ascolname = request.getParameter("ascolname");
      tmpObj.setAssayColumnName(ascolname);
      String sgcolname = request.getParameter("sgcolname");
      tmpObj.setStgrColumnName(sgcolname);
      String v1colname = request.getParameter("v1colname");
      tmpObj.setViewColumnName(v1colname);
      tmpObj.setRequiredX( Util.getInteger( required));
      String ascolnum = request.getParameter("ascolnum");
      tmpObj.setAssayViewColumnNumber(Util.getInteger( ascolnum));
      String assort = request.getParameter("assort");
      tmpObj.setAssaySortableX( Util.getInteger( assort));
      String sgcolnum = request.getParameter("sgcolnum");
      tmpObj.setStgrViewColumnNumber(Util.getInteger( sgcolnum));
      String sgsort = request.getParameter("sgsort");
      tmpObj.setStgrSortableX( Util.getInteger( sgsort));
      String v1colnum = request.getParameter("v1colnum");
      tmpObj.setViewViewColumnNumber(Util.getInteger( v1colnum));
      String v1sort = request.getParameter("v1sort");
      tmpObj.setViewSortableX( Util.getInteger( v1sort));
      String asrownum = request.getParameter("asrownum");
      tmpObj.setAssayRowNumber(Util.getInteger( asrownum));
      String sgrownum = request.getParameter("sgrownum");
      tmpObj.setStgrRowNumber(Util.getInteger( sgrownum));
      String v1rownum = request.getParameter("v1rownum");
      tmpObj.setViewRowNumber(Util.getInteger( v1rownum));
//      tmpObj.setColumnNumberInReports(Util.getInteger(colnumInr));
      tmpObj.setShowInFilterX( Util.getInteger( showInr));
//      tmpObj.setSortInReports( new Boolean(sortInr));
//      tmpObj.setFilterInReports( new Boolean(filterInr));
      tmpObj.setNoteToDisplay(notetd);
      addPersistent(tmpObj, visname, request.getParameter("comment"));
      return 0;
    }
    return 1;
  }

  public int updateParameter( HttpServletRequest request) throws Exception {
    String sysId = request.getParameter("sysId");
    String longname = request.getParameter("longname").trim();
    if (longname.equals("")) return 10;
    String visname = request.getParameter("visname").trim();
    if (visname.equals("")) visname = longname;
    String uploadname = request.getParameter("uploadname").trim();
    if (uploadname.equals("")) uploadname = longname;
    String groupId = request.getParameter("group");
    String typeId = request.getParameter("type");
    String required = request.getParameter("required");
//    String colnumInr = request.getParameter("colnumInr");
    String showInr = request.getParameter("rpshow");
//    String sortInr = request.getParameter("sortInr");
//    String filterInr = request.getParameter("filterInr");
    Parameter tmpObj = (Parameter) getObjectById(Parameter.class, sysId);
    if (tmpObj != null) {
//        tmpObj.setTechnology(currentTechnology);
      ParameterGroup group = (ParameterGroup) getObjectById(ParameterGroup.class, groupId);
      tmpObj.setParameterGroup(group);
      ParameterType type = (ParameterType) getObjectById(ParameterType.class, typeId);
      tmpObj.setParameterType(type);
      tmpObj.setLongName(longname);
      tmpObj.setUploadName(uploadname);
      String ascolname = request.getParameter("ascolname");
      if (ascolname!=null) tmpObj.setAssayColumnName(ascolname);
      String sgcolname = request.getParameter("sgcolname");
      if (sgcolname!=null) tmpObj.setStgrColumnName(sgcolname);
      String v1colname = request.getParameter("v1colname");
      if (v1colname!=null) tmpObj.setViewColumnName(v1colname);
      tmpObj.setRequiredX( Util.getInteger( required));
      String ascolnum = request.getParameter("ascolnum");
      tmpObj.setAssayViewColumnNumber(Util.getInteger( ascolnum));
      String assort = request.getParameter("assort");
      tmpObj.setAssaySortableX( Util.getInteger( assort));
      String sgcolnum = request.getParameter("sgcolnum");
      tmpObj.setStgrViewColumnNumber(Util.getInteger( sgcolnum));
      String sgsort = request.getParameter("sgsort");
      tmpObj.setStgrSortableX( Util.getInteger( sgsort));
      String v1colnum = request.getParameter("v1colnum");
      tmpObj.setViewViewColumnNumber(Util.getInteger( v1colnum));
      String v1sort = request.getParameter("v1sort");
      tmpObj.setViewSortableX( Util.getInteger( v1sort));
      String asrownum = request.getParameter("asrownum");
      tmpObj.setAssayRowNumber(Util.getInteger( asrownum));
      String sgrownum = request.getParameter("sgrownum");
      tmpObj.setStgrRowNumber(Util.getInteger( sgrownum));
      String v1rownum = request.getParameter("v1rownum");
      tmpObj.setViewRowNumber(Util.getInteger( v1rownum));
//        tmpObj.setColumnNumberInReports(Util.getInteger(colnumInr));
      tmpObj.setShowInFilterX( Util.getInteger( showInr));
//        tmpObj.setSortInReports( new Boolean(sortInr));
//        tmpObj.setFilterInReports( new Boolean(filterInr));
      String notetd = request.getParameter("notetd");
      tmpObj.setNoteToDisplay(notetd);
      updatePersistent(tmpObj, visname, request.getParameter("comment"));
      return 0;
    }
    return 1;
  }
//---CommonParameter-------------------------------------------------
//---CommonParameter-------------------------------------------------
  public int addCommonParameter( HttpServletRequest request,
                Technology techn) throws Exception {
    String longname = request.getParameter("longname").trim();
    if (longname.equals("")) return 10;
    String visname = request.getParameter("visname").trim();
    if (visname.equals("")) visname = longname;
//    String colnumInr = request.getParameter("colnumInr");
    String showInr = request.getParameter("rpshow");
//    String sortInr = request.getParameter("sortInr");
//    String filterInr = request.getParameter("filterInr");
    CommonParameter tmpObj = (CommonParameter) CommonParameter.class.newInstance();
    if (tmpObj != null) {
      tmpObj.setTechnology(techn);
      tmpObj.setLongName(longname);
      String ascolname = request.getParameter("ascolname");
      int use = Util.getInteger( request.getParameter("botuse"));
      if (use>0) tmpObj.setAssayColumnName(ascolname);
      use = Util.getInteger( request.getParameter("miduse"));
      if (use>0) tmpObj.setStgrColumnName(ascolname);
      use = Util.getInteger( request.getParameter("topuse"));
      if (use>0) tmpObj.setViewColumnName(ascolname);
      String uploadname = MetadataManager.getUploadName(ascolname);
      tmpObj.setUploadName(uploadname);

//      String sgcolname = request.getParameter("sgcolname");
//      if (sgcolname!=null) tmpObj.setStgrColumnName(sgcolname);
//      String v1colname = request.getParameter("v1colname");
//      if (v1colname!=null) tmpObj.setViewColumnName(v1colname);
      String ascolnum = request.getParameter("ascolnum");
      tmpObj.setAssayViewColumnNumber(Util.getInteger( ascolnum));
      String assort = request.getParameter("assort");
      tmpObj.setAssaySortableX( Util.getInteger( assort));
      String sgcolnum = request.getParameter("sgcolnum");
      tmpObj.setStgrViewColumnNumber(Util.getInteger( sgcolnum));
      String sgsort = request.getParameter("sgsort");
      tmpObj.setStgrSortableX( Util.getInteger( sgsort));
      String v1colnum = request.getParameter("v1colnum");
      tmpObj.setViewViewColumnNumber(Util.getInteger( v1colnum));
      String v1sort = request.getParameter("v1sort");
      tmpObj.setViewSortableX( Util.getInteger( v1sort));
      //      tmpObj.setColumnNumberInReports(Util.getInteger(colnumInr));
      tmpObj.setShowInFilterX(Util.getInteger(showInr));
      //      tmpObj.setSortInReports( new Boolean(sortInr));
      //      tmpObj.setFilterInReports( new Boolean(filterInr));

      addPersistent(tmpObj, visname, request.getParameter("comment"));
      return 0;
    }
    return 1;
  }

  public int updateCommonParameter( HttpServletRequest request) throws Exception {
    String sysId = request.getParameter("sysId");
    String longname = request.getParameter("longname").trim();
    if (longname.equals(""))  return 10;
    String visname = request.getParameter("visname").trim();
    if (visname.equals("")) visname = longname;
//    String colnumInr = request.getParameter("colnumInr");
    String showInr = request.getParameter("rpshow");
//    String sortInr = request.getParameter("sortInr");
//    String filterInr = request.getParameter("filterInr");
    CommonParameter tmpObj = (CommonParameter) getObjectById(CommonParameter.class, sysId);
    if (tmpObj != null) {
//        tmpObj.setTechnology(currentTechnology);
      tmpObj.setLongName(longname);
      String ascolname = request.getParameter("ascolname");
      int use = Util.getInteger( request.getParameter("botuse"));
      if (use>0) tmpObj.setAssayColumnName(ascolname);
      else tmpObj.setAssayColumnName("");
      use = Util.getInteger( request.getParameter("miduse"));
      if (use>0) tmpObj.setStgrColumnName(ascolname);
      else tmpObj.setStgrColumnName("");
      use = Util.getInteger( request.getParameter("topuse"));
      if (use>0) tmpObj.setViewColumnName(ascolname);
      else tmpObj.setViewColumnName("");
      String uploadname = MetadataManager.getUploadName(ascolname);
      tmpObj.setUploadName(uploadname);
//      if (ascolname!=null) tmpObj.setAssayColumnName(ascolname);
//      String sgcolname = request.getParameter("sgcolname");
//      if (sgcolname!=null) tmpObj.setStgrColumnName(sgcolname);
//      String v1colname = request.getParameter("v1colname");
//      if (v1colname!=null) tmpObj.setViewColumnName(v1colname);
      String ascolnum = request.getParameter("ascolnum");
      tmpObj.setAssayViewColumnNumber(Util.getInteger( ascolnum));
      String assort = request.getParameter("assort");
      tmpObj.setAssaySortableX( Util.getInteger( assort));
      String sgcolnum = request.getParameter("sgcolnum");
      tmpObj.setStgrViewColumnNumber(Util.getInteger( sgcolnum));
      String sgsort = request.getParameter("sgsort");
      tmpObj.setStgrSortableX( Util.getInteger( sgsort));
      String v1colnum = request.getParameter("v1colnum");
      tmpObj.setViewViewColumnNumber(Util.getInteger( v1colnum));
      String v1sort = request.getParameter("v1sort");
      tmpObj.setViewSortableX( Util.getInteger( v1sort));
//        tmpObj.setColumnNumberInReports(Util.getInteger(colnumInr));
      tmpObj.setShowInFilterX( Util.getInteger( showInr));
//        tmpObj.setSortInReports( new Boolean(sortInr));
//        tmpObj.setFilterInReports( new Boolean(filterInr));
      updatePersistent(tmpObj, visname, request.getParameter("comment"));
      return 0;
    }
    return 1;
  }
//---Vocabulary-------------------------------------------------
//---Vocabulary-------------------------------------------------
    public int addVocabulary( HttpServletRequest request,
               Technology techn) throws Exception {
      String visname = request.getParameter("visname");
      String longname = request.getParameter("longname");
      if (visname == null || visname.trim().equals("")) return 10;
      Vocabulary tmpObj = (Vocabulary) Vocabulary.class.newInstance();
      tmpObj.setTechnology( techn);
      tmpObj.setLongName(longname);
      if (addPersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
      return 1;
    }

    public int updateVocabulary( HttpServletRequest request) throws Exception {
      String sysId = request.getParameter("sysId");
      String visname = request.getParameter("visname");
      String longname = request.getParameter("longname");
      if (visname == null || visname.trim().equals("")) return 10;
      Vocabulary tmpObj = (Vocabulary) getObjectById(Vocabulary.class, sysId);
      if (tmpObj != null) {
        tmpObj.setLongName(longname);
        if (updatePersistent(tmpObj, visname, request.getParameter("comment"))) return 0;
      }
      return 1;
    }
//  ---ProjectPartner-------------------------------------------------
//  ---ProjectPartner-------------------------------------------------
    public int addProjectPartner( HttpServletRequest request) throws Exception {
      String visname = request.getParameter("visname").trim();
      if (visname == null || visname.trim().equals("")) return 10;
      AssayProjectPartner tmpObj = (AssayProjectPartner) AssayProjectPartner.class.newInstance();
      if (tmpObj != null) {
        tmpObj.setExternalPartnerX(Util.getInteger(request.getParameter("isExternal")));
        addPersistent(tmpObj, visname, request.getParameter("comment"));
        return 0;
      }
      return 1;
    }
    public int updateProjectPartner( HttpServletRequest request) throws Exception {
      String sysId = request.getParameter("sysId");
      String visname = request.getParameter("visname").trim();
      if (visname == null || visname.trim().equals("")) return 10;
      AssayProjectPartner tmpObj = (AssayProjectPartner) getObjectById(AssayProjectPartner.class, sysId);
      if (tmpObj != null) {
        tmpObj.setExternalPartnerX(Util.getInteger(request.getParameter("isExternal")));
        updatePersistent(tmpObj, visname, request.getParameter("comment"));
        return 0;
      }
      return 1;
    }
//---Study View-------------------------------------------
//---Study Group-------------------------------------------
  private String getComment( RequestParser request){
    String value = request.getParameter("comment");
    if (value!=null && value.length()>4000)setInvalidFields("comment",13);
    return value;
  }
  public int ProcessStudyViewMembership( Long viewId) throws Exception {
    Long[] studyArray = batchMan.getBatchArray();
    StudyView stView = (StudyView)getObjectById(StudyView.class, viewId);
    Query q = hibSess.createQuery(
        "select myMemb,myMemb.theGroup.id from ViewStudyMembership myMemb" +
        " where myMemb.theView = :vie");
    q.setLong("vie",viewId.longValue());
    List memList = q.list();
    if (studyArray==null){
      if (memList.size()>0){
    	Transaction tx0 = null;
        try {
          tx0 = hibSess.beginTransaction();
          for (int i = 0; i < memList.size(); i++){
            Object[] xy = (Object[])memList.get(i);
            ViewStudyMembership uvz = (ViewStudyMembership) xy[0];
            hibSess.delete(uvz);
          }
          tx0.commit();
        }  
        catch (Exception e) {
          if (tx0 != null) {
            tx0.rollback();
          }
          throw e;
        }  
        finally {
          hibSess.close(); //needs before forward
        }  
      }
      return 17;
    }
    HashSet<Long> xyz = new HashSet<Long>(studyArray.length);
    for (int i = 0; i < studyArray.length; i++) xyz.add( studyArray[i]);
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      for (int i = 0; i < memList.size(); i++){
        Object[] xy = (Object[])memList.get(i);
        Long stId = (Long)xy[1];
        if (xyz.contains(stId)) xyz.remove(stId);
        else {
          ViewStudyMembership uvz = (ViewStudyMembership) xy[0];
          hibSess.delete(uvz);
        }
      }
      Iterator iter = xyz.iterator();
      while (iter.hasNext()) {
        Long studyId = (Long) iter.next();
//        Util.writeLog("newmeb", studyId.toString(), "");
        StudyGroup stGroup = (StudyGroup)getObjectById(StudyGroup.class, studyId);
        ViewStudyMembership uvz = new ViewStudyMembership();
        uvz.setTheView( stView);
        uvz.setTheGroup( stGroup);
        uvz.setCreateInfo(currentUser);
        uvz.setComment("");
        uvz.setVisibleName("");
        hibSess.save( uvz);
      }
      tx.commit();
    }
    catch (Exception e) {
      if (tx != null) {
        tx.rollback();
      }
      throw e;
    }
    finally {
      hibSess.close(); //needs before forward
    }
    return 0;
  }

  public int deleteStudyView(String selfId) throws Exception {
    if (currentUser == null) {
      return 1;
    }
    StudyView tmpView = currentStudyView;
    if (tmpView == null) {
      return 1;
    }
    Long viewId = tmpView.getId();
    String viewIds = viewId.toString();
    if (!selfId.equals(viewIds)) {
      return 1;
    }
    if (viewId.equals(vgm.getGroupViewId())) vgm.setGroupViewId(null);
    hibSess.refresh(tmpView);   //this avoids duplicate instance
    Query q = hibSess.createQuery(
      "from ViewStudyMembership as myMemb where myMemb.theView = :vie");
    q.setLong("vie",viewId.longValue());
    List memberList = q.list();
    int memberCount = memberList.size();
    Transaction tx = null; 
    try {
      tx = hibSess.beginTransaction();
      if (memberCount > 0){
        Iterator memberIterator = memberList.iterator();
        while (memberIterator.hasNext()) {
          ViewStudyMembership tmpMemb = (ViewStudyMembership) memberIterator.next();
          hibSess.delete(tmpMemb);
        }
      }
      if (tmpView.isPending()||tmpView.isFileError())deletePendingTask(tmpView);
      /*if (tmpView.isExported())*/deletePendingExport(tmpView);
      hibSess.delete(tmpView);
      tx.commit();
      deleteProtocolFile( protocolFileString.getAllFileNames());
      deleteDataFile( dataFileString.getAllFileNames());
      vvm.changeViewTotal( -1);
    }
    catch (Exception e) {
      if (tx != null) {
        tx.rollback();
      }
      throw e;
    }
    finally {
      hibSess.close(); //needs before forward
      currentAssay = null;
      currentStudyGroup = null;
      currentStudyView = null;
      resetTransactionObjects();
    }
    return 0;
  }
  public int addStudyView(
      RequestParser request) throws Exception {
    int rezult = 0;
    clearInvalidFields();
    if (currentUser == null) return 1;
    tempStudyView = new StudyView();
    List paramList = getAllObjectsForTechnology(Parameter.class);
    Iterator paramIterator = paramList.iterator();
    Class[] paramTypes = {String.class};
    while (paramIterator.hasNext()) {
      Parameter param = (Parameter) paramIterator.next();
      String fieldName = param.getViewColumnNameF();
      if (fieldName != null && !fieldName.equals("")) {
        String value = getParameterValue( fieldName, param, request);
        Object[] args = { value};
        Method xyz = StudyView.class.getMethod("set" + fieldName, paramTypes);
        xyz.invoke(tempStudyView, args);
      }
    }
    tempStudyView.setViewIdentif( new Long(getTopNum()));
    tempStudyView.setTechnology( currentTechnology);
    tempStudyView.setCreateInfo(currentUser);
    tempStudyView.setComment( getComment( request));
    tempStudyView.setVisibleName(request.getParameter("stgrId"));
    tempStudyView.setIdentif( new Long(request.getParameter("identif")));
    if (isStudyIdGener())
      tempStudyView.setIdentifString( request.getParameter("identifString"));
    else {
      String identifString = request.getParameter("identifStringUser");
      int x = checkStudyViewId(identifString);
      if (x>0) setInvalidFields("identifStringUser",x);
      else tempStudyView.setIdentifString( identifString);  
    }
    tempStudyView.setProtocolFiles( getProtocolFileString().getContents( request));
    tempStudyView.setDataFiles( getDataFileString().getContents( request));
    tempStudyView.setOwner( currentUser);
    tempStudyView.setOwnerGroup( currentUser.getDefaultUserGroup());
    processSimsRef( request, tempStudyView);
    if (isInvalidField()) rezult = 2; else {
      Transaction tx = null;
      try {
        tx = hibSess.beginTransaction();
        hibSess.save(tempStudyView);
        tx.commit();
        tx = null;
        vvm.changeViewTotal(1);
        renameTempFile( tempStudyView.getId());
        currentStudyView = tempStudyView;
        currentStudyGroup = null;
        currentAssay = null;
      }
      catch (Exception e) {
        if (tx != null) {
          tx.rollback();
        }
        throw e;
      }
      finally {
        hibSess.close(); //needs before forward
        resetTransactionObjects();
      }
    }
    return rezult;
  }
  public int updateStudyView(
      RequestParser request) throws Exception {
    int rezult = 0;
    clearInvalidFields();
    if (currentUser == null) return 1;
    StudyView tmpView = currentStudyView;
    if (tmpView == null) return 1;
    String sysId = request.getParameter("sysId");
    if (!sysId.equals(tmpView.getId().toString())) return 1;
    List paramList = getAllObjectsForTechnology(Parameter.class);
    Iterator paramIterator = paramList.iterator();
    Class[] paramTypes = {String.class};
    while (paramIterator.hasNext()) {
      Parameter param = (Parameter) paramIterator.next();
      String fieldName = param.getViewColumnNameF();
      if (fieldName != null && !fieldName.equals("")) {
        String value = getParameterValue( fieldName, param, request);
        Object[] args = { value};
        Method xyz = StudyView.class.getMethod("set" + fieldName, paramTypes);
        xyz.invoke(tmpView, args);
      }
    }
    tmpView.setModifInfo(currentUser);
    tmpView.setComment( getComment( request));
    tmpView.setVisibleName(request.getParameter("stgrId"));
    if (!isStudyIdGener()){
      String identifString = request.getParameter("identifStringUser");
      if (!identifString.equals(tmpView.getIdentifString())){
        int x = checkStudyViewId(identifString);
        if (x>0) setInvalidFields("identifStringUser",x);
        else tmpView.setIdentifString( identifString); 
      }
    }  
    processSimsRef( request, tmpView);
    tmpView.setProtocolFiles( getProtocolFileString().getContents( request));
    tmpView.setDataFiles( getDataFileString().getContents( request));
    String ownerId = request.getParameter("ow_user");
    AssayUser owner = (AssayUser)getObjectById(AssayUser.class, ownerId);
    if (owner!=null) tmpView.setOwner( owner);
    String groupId = request.getParameter("ow_group");
    UserGroup group = (UserGroup)getObjectById(UserGroup.class, groupId);
    if (group!=null) tmpView.setOwnerGroup( group);
    if (isInvalidField()) rezult = 2; else {
      Transaction tx = null;
      try {
        tx = hibSess.beginTransaction();
        hibSess.update(tmpView);
        tx.commit();
        tx = null;
        deleteProtocolFile( protocolFileString.getDeletedFileNames());
        deleteDataFile( dataFileString.getDeletedFileNames());
        renameTempFile( tmpView.getId());
      }
      catch (Exception e) {
        if (tx != null) {
          tx.rollback();
        }
        throw e;
      }
      finally {
        hibSess.close(); //needs before forward
        resetTransactionObjects();
      }
    }
    return rezult;
  }
  public void saveStudyView( RequestParser request) throws Exception {
    tempStudyView = new StudyView();
    tempTechnologyData = tempStudyView;
    List paramList = getAllObjectsForTechnology(Parameter.class);
    Iterator paramIterator = paramList.iterator();
    Class[] paramTypes = {String.class};
    while (paramIterator.hasNext()) {
      Parameter param = (Parameter) paramIterator.next();
      String fieldName = param.getViewColumnNameF();
      if (fieldName != null && !fieldName.equals("")) {
        String value = getParameterValueForSave(fieldName, param, request);
        Object[] args = {value};
        Method xyz = StudyView.class.getMethod("set" + fieldName, paramTypes);
        xyz.invoke(tempStudyView, args);
      }
    }
    tempSysId = request.getParameter("sysId");
    tempMultiple = false;//(tempSysId.equals("0"));
    tempStudyView.setIdentif(new Long(request.getParameter("identif")));
    if (isStudyIdGener())
      tempStudyView.setIdentifString( request.getParameter("identifString"));
    else 
      tempStudyView.setIdentifString(request.getParameter("identifStringUser"));
    tempStudyView.setComment(getComment(request));
    tempStudyView.setVisibleName(request.getParameter("stgrId"));
    tempStudyView.setProtocolFiles(getProtocolFileString().getContents(request));
    tempStudyView.setDataFiles(getDataFileString().getContents(request));
    StudyView curStudyView = getCurrentStudyView();
    if (curStudyView != null) {
      tempStudyView.setCreator(curStudyView.getCreator());
      tempStudyView.setModifier(curStudyView.getModifier());
      tempStudyView.setCreateDate(curStudyView.getCreateDate());
      tempStudyView.setModifDate(curStudyView.getModifDate());
    }
  }

//---Study Group-------------------------------------------
//---Study Group-------------------------------------------
  public int addStudyGroup(
      RequestParser request) throws Exception {
    int rezult = 0;
    clearInvalidFields();
    if (currentUser == null) return 1;
    tempStudyGroup = new StudyGroup();
    List paramList = getAllObjectsForTechnology(Parameter.class);
    Iterator paramIterator = paramList.iterator();
    Class[] paramTypes = {String.class};
    while (paramIterator.hasNext()) {
      Parameter param = (Parameter) paramIterator.next();
      String fieldName = param.getStgrColumnNameF();
      if (fieldName != null && !fieldName.equals("")) {
        String value = getParameterValue( fieldName, param, request);
        Object[] args = { value};
        Method xyz = StudyGroup.class.getMethod("set" + fieldName, paramTypes);
        xyz.invoke(tempStudyGroup, args);
      }
    }
    tempStudyGroup.setTechnology( currentTechnology);
    tempStudyGroup.setCreateInfo(currentUser);
    tempStudyGroup.setComment( getComment( request));
    tempStudyGroup.setVisibleName(request.getParameter("stgrId"));
    tempStudyGroup.setIdentif( new Long(request.getParameter("identif")));
    if (isStudyIdGener())
      tempStudyGroup.setIdentifString( request.getParameter("identifString"));
    else {
      String identifString = request.getParameter("identifStringUser");
      int x = checkStudyGroupId(identifString);
      if (x>0) setInvalidFields("identifStringUser",x);
      else tempStudyGroup.setIdentifString( identifString);  
    }
    tempStudyGroup.setProtocolFiles( getProtocolFileString().getContents( request));
    tempStudyGroup.setDataFiles( getDataFileString().getContents( request));
    tempStudyGroup.setOwner( currentUser);
    tempStudyGroup.setOwnerGroup( currentUser.getDefaultUserGroup());
    processSimsRef( request, tempStudyGroup);
    if (isInvalidField()) rezult = 2; else {
      Transaction tx = null;
      try {
        tx = hibSess.beginTransaction();
        hibSess.save(tempStudyGroup);
        tx.commit();
        tx = null;
        vgm.changeGroupTotal(1);
        renameTempFile( tempStudyGroup.getId());
        currentStudyGroup = tempStudyGroup;
        currentAssay = null;
      }
      catch (Exception e) {
        if (tx != null) {
          tx.rollback();
        }
        throw e;
      }
      finally {
        hibSess.close(); //needs before forward
        resetTransactionObjects();
      }
    }
    return rezult;
  }

  public int updateStudyGroup(
      RequestParser request) throws Exception {
    int rezult = 0;
    clearInvalidFields();
    if (currentUser == null) return 1;
    StudyGroup tmpGroup = currentStudyGroup;
    if (tmpGroup == null) return 1;
    String sysId = request.getParameter("sysId");
    if (!sysId.equals(tmpGroup.getId().toString())) return 1;
    List paramList = getAllObjectsForTechnology(Parameter.class);
    Iterator paramIterator = paramList.iterator();
    Class[] paramTypes = {String.class};
    while (paramIterator.hasNext()) {
      Parameter param = (Parameter) paramIterator.next();
      String fieldName = param.getStgrColumnNameF();
      if (fieldName != null && !fieldName.equals("")) {
        String value = getParameterValue( fieldName, param, request);
        Object[] args = { value};
        Method xyz = StudyGroup.class.getMethod("set" + fieldName, paramTypes);
        xyz.invoke(tmpGroup, args);
      }
    }
    tmpGroup.setModifInfo(currentUser);
    tmpGroup.setComment( getComment( request));
    tmpGroup.setVisibleName(request.getParameter("stgrId"));
    if (!isStudyIdGener()){
      String identifString = request.getParameter("identifStringUser");
      if (!identifString.equals(tmpGroup.getIdentifString())){
        int x = checkStudyGroupId(identifString);
        if (x>0) setInvalidFields("identifStringUser",x);
        else tmpGroup.setIdentifString( identifString); 
      }
    }  
    processSimsRef( request, tmpGroup);
/*
    String identifString = tmpGroup.getIdentifString();
    if (identifString==null||identifString.equals("")){//for very old groups
      tmpGroup.setIdentif( new Long(request.getParameter("identif")));
      tmpGroup.setIdentifString( request.getParameter("identifString"));
    }
*/    
    tmpGroup.setProtocolFiles( getProtocolFileString().getContents( request));
    tmpGroup.setDataFiles( getDataFileString().getContents( request));
    String ownerId = request.getParameter("ow_user");
    AssayUser owner = (AssayUser)getObjectById(AssayUser.class, ownerId);
    if (owner!=null) tmpGroup.setOwner( owner);
    String groupId = request.getParameter("ow_group");
    UserGroup group = (UserGroup)getObjectById(UserGroup.class, groupId);
    if (group!=null) tmpGroup.setOwnerGroup( group);
    if (isInvalidField()) rezult = 2; else {
      Transaction tx = null;
      try {
        tx = hibSess.beginTransaction();
        hibSess.update(tmpGroup);
        tx.commit();
        tx = null;
        deleteProtocolFile( protocolFileString.getDeletedFileNames());
        deleteDataFile( dataFileString.getDeletedFileNames());
        renameTempFile( tmpGroup.getId());
      }
      catch (Exception e) {
        if (tx != null) {
          tx.rollback();
        }
        throw e;
      }
      finally {
        hibSess.close(); //needs before forward
        resetTransactionObjects();
      }
    }
    return rezult;
  }

  public void saveStudyGroup( RequestParser request) throws Exception {
    tempStudyGroup = new StudyGroup();
    tempTechnologyData = tempStudyGroup;
    List paramList = getAllObjectsForTechnology(Parameter.class);
    Iterator paramIterator = paramList.iterator();
    Class[] paramTypes = {String.class};
    while (paramIterator.hasNext()) {
      Parameter param = (Parameter) paramIterator.next();
      String fieldName = param.getStgrColumnNameF();
      if (fieldName != null && !fieldName.equals("")) {
        String value = getParameterValueForSave(fieldName, param, request);
        Object[] args = {value};
        Method xyz = StudyGroup.class.getMethod("set" + fieldName, paramTypes);
        xyz.invoke(tempStudyGroup, args);
      }
    }
    tempSysId = request.getParameter("sysId");
    tempMultiple = false;//(tempSysId.equals("0"));
    tempStudyGroup.setIdentif(new Long(request.getParameter("identif")));
    if (isStudyIdGener())
      tempStudyGroup.setIdentifString( request.getParameter("identifString"));
    else 
      tempStudyGroup.setIdentifString(request.getParameter("identifStringUser"));
    tempStudyGroup.setComment(getComment(request));
    tempStudyGroup.setVisibleName(request.getParameter("stgrId"));
    tempStudyGroup.setProtocolFiles(getProtocolFileString().getContents(request));
    tempStudyGroup.setDataFiles(getDataFileString().getContents(request));
    StudyGroup curStudyGroup = getCurrentStudyGroup();
    if (curStudyGroup != null) {
      tempStudyGroup.setCreator(curStudyGroup.getCreator());
      tempStudyGroup.setModifier(curStudyGroup.getModifier());
      tempStudyGroup.setCreateDate(curStudyGroup.getCreateDate());
      tempStudyGroup.setModifDate(curStudyGroup.getModifDate());
    }
  }
  public int deleteStudyGroup(String selfId) throws Exception {
    if (currentUser == null) {
      return 1;
    }
    StudyGroup tmpGroup = currentStudyGroup;
    if (tmpGroup == null) {
      return 1;
    }
    Long groupId = tmpGroup.getId();
    String groupIds = groupId.toString();
    if (!selfId.equals(groupIds)) {
      return 1;
    }
    if (groupId.equals(vam.getAssayGroupId()))	vam.setAssayGroupId( null);
//deletes all child assays
//  List assayList = tmpGroup.getAssays(); //no session or session was closed
    hibSess.refresh(tmpGroup);   //this avoids duplicate instance
    Query q = hibSess.createQuery(
      "from Assay as myAssay where myAssay.studyGroup = :group");
    q.setLong("group", groupId.longValue());
    List assayList = q.list(); 
    int assayCount = assayList.size();
    Object[] prootoclFileNames = null;
    Object[] dataFileNames = null;
    Transaction tx = null; int index = 0;
    try {
      tx = hibSess.beginTransaction();
      if (assayCount > 0){
        prootoclFileNames = new Object[assayCount];
        dataFileNames = new Object[assayCount];
        Iterator assayIterator = assayList.iterator();
        while (assayIterator.hasNext()) {
          Assay tmpAssay = (Assay) assayIterator.next();
          prootoclFileNames[index] = FileString.getAllFileNames(2, false,
              tmpAssay.getProtocolFiles(), tmpAssay.getId());
          dataFileNames[index] = FileString.getAllFileNames(2, true,
              tmpAssay.getDataFiles(), tmpAssay.getId());
          if (tmpAssay.isPending()||tmpAssay.isFileError())deletePendingTask(tmpAssay);
          /*if (tmpAssay.isExported())*/deletePendingExport(tmpAssay);
          hibSess.delete(tmpAssay);
          index++;
        }
      }
//    deletes all membership items
      Query qq = hibSess.createQuery(
        "from ViewStudyMembership as myMemb where myMemb.theGroup = :group");
      qq.setLong("group", groupId.longValue());
      List memberList = qq.list();
      int memberCount = memberList.size();
      if (memberCount > 0){
        Iterator memberIterator = memberList.iterator();
        while (memberIterator.hasNext()) {
          ViewStudyMembership tmpMemb = (ViewStudyMembership) memberIterator.next();
          hibSess.delete(tmpMemb);
        }
      }
      if (tmpGroup.isPending()||tmpGroup.isFileError())deletePendingTask(tmpGroup);
      /*if (tmpGroup.isExported())*/deletePendingExport(tmpGroup);
      hibSess.delete(tmpGroup);
      tx.commit();
      for (int i = 0; i < assayCount; i++){
        deleteProtocolFile( (String[])prootoclFileNames[i]);
        deleteDataFile( (String[])dataFileNames[i]);
      }
      deleteProtocolFile( protocolFileString.getAllFileNames());
      deleteDataFile( dataFileString.getAllFileNames());
      vam.changeAssayTotal( -assayCount);
      vgm.changeGroupTotal( -1);
    }
    catch (Exception e) {
      if (tx != null) {
        tx.rollback();
      }
      throw e;
    }
    finally {
      hibSess.close(); //needs before forward
      currentAssay = null;
      currentStudyGroup = null;
      resetTransactionObjects();
    }
    return 0;
  }
  //----------Upload groups-------------------------------
    public int importBatchStudyGroup() throws Exception {
      int rezult = 0;
      boolean start = true; String batchId = null;
      if (currentUser == null) return 1;
      BatchAnalyser analyser = getBatchAnalyser();
      analyser.startIterator();
      while (analyser.hasNextElement()){
        tempStudyGroup = new StudyGroup();
        tempStudyGroup.setTechnology(currentTechnology);
        tempStudyGroup.setCreateInfo(currentUser);
        tempStudyGroup.setOwner( currentUser);
        tempStudyGroup.setOwnerGroup( currentUser.getDefaultUserGroup());
        analyser.nextElement(tempStudyGroup);  //sets identifString from input
        if (start){ batchId = tempStudyGroup.getIdentifString(); start = false;}
        tempStudyGroup.setBatchId(batchId);
        if (isInvalidField()) rezult = 2; else {
          Transaction tx = null;
          try {
            tx = hibSess.beginTransaction();
            hibSess.save(tempStudyGroup);
            analyser.ProcessFiles(tempStudyGroup); //new method!!!
            StudyView stView = analyser.getStudyView();
            if (stView!=null){
              ViewStudyMembership uvz = new ViewStudyMembership();
              uvz.setTheView( stView);
              uvz.setTheGroup( tempStudyGroup);
              uvz.setCreateInfo(currentUser);
              uvz.setComment("");
              uvz.setVisibleName("");
              hibSess.save( uvz);
            }
            tx.commit();
            vgm.changeGroupTotal(1);
            currentStudyGroup = tempStudyGroup;
          }
          catch (Exception e) {
            if (tx != null) {
              tx.rollback();
            }
            throw e;
          }
        }
      }
      hibSess.close(); //needs before forward
      resetTransactionObjects();
      return rezult;
    }
  public int importBatchStudyView() throws Exception {
    int rezult = 0;
    boolean start = true; String batchId = null;
    if (currentUser == null) return 1;
    BatchAnalyser analyser = getBatchAnalyser();
    analyser.startIterator();
    while (analyser.hasNextElement()){
      tempStudyView = new StudyView();
      tempStudyView.setViewIdentif( new Long(getTopNum()));
      tempStudyView.setTechnology(currentTechnology);
      tempStudyView.setCreateInfo(currentUser);
      tempStudyView.setOwner( currentUser);
      tempStudyView.setOwnerGroup( currentUser.getDefaultUserGroup());
      analyser.nextElement(tempStudyView);  //sets identifString from input
      if (start){ batchId = tempStudyView.getIdentifString(); start = false;}
      tempStudyView.setBatchId(batchId);
      if (isInvalidField()) rezult = 2; else {
        Transaction tx = null;
        try {
          tx = hibSess.beginTransaction();
          hibSess.save(tempStudyView);
          analyser.ProcessFiles(tempStudyView); //new method!!!
          tx.commit();
          vvm.changeViewTotal(1);
          currentStudyView = tempStudyView;
        }
        catch (Exception e) {
          if (tx != null) {
          tx.rollback();
        }
        throw e;
      }
    }
  }
  hibSess.close(); //needs before forward
  resetTransactionObjects();
  return rezult;
}
//----------------Study batch edit --------------
  public boolean[] compareBatchStudies(Long[] studyArray) throws Exception {
      if (currentUser == null || studyArray == null) return null;
      StudyGroup firstStudy = (StudyGroup)
                getObjectById(StudyGroup.class, studyArray[0]);
      if (firstStudy == null) return null;
      boolean[] batchBools = new boolean[64];
      for ( int i = 0; i < 64; i++) batchBools[i] = true;

      for ( int i = 1; i < studyArray.length; i++) {
          StudyGroup tmpStudy = (StudyGroup)
                    getObjectById(StudyGroup.class, studyArray[i]);
          if (tmpStudy != null)
            firstStudy.compareWith(batchBools,tmpStudy);
      }

      return batchBools;
  }

  public int checkStudiesBatchEdit( Long[] studyArray,
      HttpServletRequest request) throws Exception {
      int rezult = 0;
      clearInvalidFields();
      if (currentUser == null || studyArray == null) return 1;
      tempStudyGroup = (StudyGroup) getObjectById(StudyGroup.class, studyArray[0]);
      if (tempStudyGroup == null) return 1;
      List paramList = getAllObjectsForTechnology(Parameter.class);
      Iterator paramIterator = paramList.iterator();
      Class[] paramTypes = {String.class};
      while (paramIterator.hasNext()) {
        Parameter param = (Parameter) paramIterator.next();
        String fieldName = param.getStgrColumnNameF();
        if (fieldName != null && !fieldName.equals("")) {
          String value = getParameterValue0( fieldName, param, request);
          if (value!=null){
            Object[] args = { value};
            Method xyz = StudyGroup.class.getMethod("set" + fieldName, paramTypes);
            xyz.invoke(tempStudyGroup, args);
          }
        }
      }
      if (isInvalidField()) rezult = 2;
      return rezult;
  }

  public int updateBatchStudies( Long[] studyArray,
      HttpServletRequest request) throws Exception {
      int rezult = 0;
      if (currentUser == null || studyArray == null) return 1;
      Transaction tx = null;
      try {
        List paramList = getAllObjectsForTechnology(Parameter.class);
        tx = hibSess.beginTransaction();
        for (int i = 0; i < studyArray.length; i++) {
          StudyGroup tmpStudy = (StudyGroup) getObjectById(StudyGroup.class, studyArray[i]);
          if (tmpStudy == null) continue;
          Iterator paramIterator = paramList.iterator();
          Class[] paramTypes = {String.class};
          while (paramIterator.hasNext()) {
            Parameter param = (Parameter) paramIterator.next();
            String fieldName = param.getStgrColumnNameF();
            if (fieldName != null && !fieldName.equals("")) {
              String value = getParameterValue0( fieldName, param, request);
              if (value!=null){
                Object[] args = { value};
                Method xyz = StudyGroup.class.getMethod("set" + fieldName, paramTypes);
                xyz.invoke(tmpStudy, args);
              }
            }
          }
          String ownerId = request.getParameter("ow_user");
          AssayUser owner = (AssayUser)getObjectById(AssayUser.class, ownerId);
          if (owner!=null) tmpStudy.setOwner( owner);
          String groupId = request.getParameter("ow_group");
          UserGroup group = (UserGroup)getObjectById(UserGroup.class, groupId);
          if (group!=null) tmpStudy.setOwnerGroup( group);

          tmpStudy.setModifInfo(currentUser);
          hibSess.update(tmpStudy);
        }
        tx.commit();
      } catch (Exception e) {
          rezult = 1;
          if (tx != null) tx.rollback();
          throw e;
      } finally {
          hibSess.close(); //needs before forward
      }
      return rezult;
  }
//----------------View batch edit --------------
  public boolean[] compareBatchViews(Long[] viewArray) throws Exception {
      if (currentUser == null || viewArray == null) return null;
      StudyView firstView = (StudyView)
                getObjectById(StudyView.class, viewArray[0]);
      if (firstView == null) return null;
      boolean[] batchBools = new boolean[64];
      for ( int i = 0; i < 64; i++) batchBools[i] = true;
      for ( int i = 1; i < viewArray.length; i++) {
          StudyView tmpView = (StudyView)
                    getObjectById(StudyView.class, viewArray[i]);
          if (tmpView != null)
            firstView.compareWith(batchBools,tmpView);
      }
      return batchBools;
  }

  public int checkViewsBatchEdit( Long[] viewArray,
      HttpServletRequest request) throws Exception {
      int rezult = 0;
      clearInvalidFields();
      if (currentUser == null || viewArray == null) return 1;
      tempStudyView = (StudyView) getObjectById(StudyView.class, viewArray[0]);
      if (tempStudyView == null) return 1;
      List paramList = getAllObjectsForTechnology(Parameter.class);
      Iterator paramIterator = paramList.iterator();
      Class[] paramTypes = {String.class};
      while (paramIterator.hasNext()) {
        Parameter param = (Parameter) paramIterator.next();
        String fieldName = param.getViewColumnNameF();
        if (fieldName != null && !fieldName.equals("")) {
          String value = getParameterValue0( fieldName, param, request);
          if (value!=null){
            Object[] args = { value};
            Method xyz = StudyView.class.getMethod("set" + fieldName, paramTypes);
            xyz.invoke(tempStudyView, args);
          }
        }
      }
      if (isInvalidField()) rezult = 2;
      return rezult;
  }

  public int updateBatchViews( Long[] viewArray,
      HttpServletRequest request) throws Exception {
      int rezult = 0;
      if (currentUser == null || viewArray == null) return 1;
      Transaction tx = null;
      try {
        List paramList = getAllObjectsForTechnology(Parameter.class);
        tx = hibSess.beginTransaction();
        for (int i = 0; i < viewArray.length; i++) {
          StudyView tmpView = (StudyView) getObjectById(StudyView.class, viewArray[i]);
          if (tmpView == null) continue;
          Iterator paramIterator = paramList.iterator();
          Class[] paramTypes = {String.class};
          while (paramIterator.hasNext()) {
            Parameter param = (Parameter) paramIterator.next();
            String fieldName = param.getViewColumnNameF();
            if (fieldName != null && !fieldName.equals("")) {
              String value = getParameterValue0( fieldName, param, request);
              if (value!=null){
                Object[] args = { value};
                Method xyz = StudyView.class.getMethod("set" + fieldName, paramTypes);
                xyz.invoke(tmpView, args);
              }
            }
          }
          String ownerId = request.getParameter("ow_user");
          AssayUser owner = (AssayUser)getObjectById(AssayUser.class, ownerId);
          if (owner!=null) tmpView.setOwner( owner);
          String groupId = request.getParameter("ow_group");
          UserGroup group = (UserGroup)getObjectById(UserGroup.class, groupId);
          if (group!=null) tmpView.setOwnerGroup( group);

          tmpView.setModifInfo(currentUser);
          hibSess.update(tmpView);
        }
        tx.commit();
      } catch (Exception e) {
          rezult = 1;
          if (tx != null) tx.rollback();
          throw e;
      } finally {
          hibSess.close(); //needs before forward
      }
      return rezult;
  }
//----------------------------------------------------------//
//----------------- Assay table ---------------------------//
//----------------------------------------------------------//
  public int checkAssayId(Long groupId, String assayId) throws HibernateException {
    // used by batch analyser only
    int rezult = 0;
    if (assayId == null || assayId.trim().equals("")) rezult = 2;
    else
    if (groupId!=null) {
      Query q = hibSess.createQuery("select count(*) from Assay obj"
                 + " where obj.identifString = :assayId"
                 + " and obj.studyGroup = :sgId");
      q.setString("assayId",assayId);
      q.setLong("sgId",groupId.longValue());
      int cnt = ((Long) q.iterate().next()).intValue();
      if (cnt > 0) rezult = 3;
    }
    return rezult;  //out
  }

  public int checkStudyGroupId(String studyId) {
    int rezult = 0;
    if (studyId == null || studyId.trim().equals("")) rezult = 2;
    else
      try {
        Long technologyId = getCurrentTechnologyId();
        Query q = hibSess.createQuery("select count(*) from StudyGroup obj"
        + " where obj.technology = :technolId and obj.identifString = :identif");
        q.setLong("technolId", technologyId.longValue());
        q.setString("identif", studyId);
        int cnt = ((Long) q.iterate().next()).intValue();
        if (cnt > 0) rezult = 3;
      }
      catch (Exception s) {}
    return rezult;
  }
  public StudyGroup getStudyGroupFromId(String studyId) {
	    //used by batch analyser only
    StudyGroup rezult = null;
	if (studyId != null && !studyId.trim().equals(""))
	try {
	  Long technologyId = getCurrentTechnologyId();
	  Query q = hibSess.createQuery("select obj from StudyGroup obj"
	    + " where obj.technology = :technolId and obj.identifString = :identif");
	  q.setLong("technolId", technologyId.longValue());
	  q.setString("identif", studyId);
	  List list = q.list();
	  if (list.size() > 0) rezult = (StudyGroup) list.get(0);
	}
	catch (Exception s) {}
	return rezult;
  }
  public int checkStudyViewId(String viewId) {
	    //used by batch analyser only
    int rezult = 0;
    if (viewId == null || viewId.trim().equals("")) rezult = 2;
    else
      try {
        Long technologyId = getCurrentTechnologyId();
        Query q = hibSess.createQuery("select count(*) from StudyView obj"
	        + " where obj.technology = :technolId and obj.identifString = :identif");
	        q.setLong("technolId", technologyId.longValue());
	        q.setString("identif", viewId);
	        int cnt = ((Long) q.iterate().next()).intValue();
	        if (cnt > 0) rezult = 3;
	      }
	      catch (Exception s) {}
	    return rezult;
	  }
  public StudyView getStudyViewFromId(String viewId) {
    //used by batch analyser only
	StudyView rezult = null;
    if (viewId != null && !viewId.trim().equals(""))
      try {
        Long technologyId = getCurrentTechnologyId();
        Query q = hibSess.createQuery("select obj from StudyView obj"
        + " where obj.technology = :technolId and obj.identifString = :identif");
        q.setLong("technolId", technologyId.longValue());
        q.setString("identif", viewId);
        List list = q.list();
        if (list.size() > 0) rezult = (StudyView) list.get(0);
      }
      catch (Exception s) {}
    return rezult;
  }

  public Long checkSimsId( String collectId, String simsId, int type) {
//used by batch analyser only
//  	Util.writeLog("checkSimsId", simsId+'/'+collectId, String.valueOf(type));
    Long rezult = null;
    if (WebappConfig.isUseSamples()){
      if (simsId != null && !simsId.trim().equals(""))
        try {
          Query q =
          (type==1)?
            sampleSess.createQuery("select obj.id from Top obj, STechnology collect"+
              " where obj.visibleName=:simsId and collect.visibleName=:collectId"+
              " and obj.technology=collect.id"):
          (type==2)?
            sampleSess.createQuery("select obj.id from Middle obj, STechnology collect"+
              " where obj.visibleName=:simsId and collect.visibleName=:collectId"+
              " and obj.technology=collect.id"):
            sampleSess.createQuery("select obj.id from Bottom obj, STechnology collect"+
              " where obj.visibleName=:simsId and collect.visibleName=:collectId"+
              " and obj.technology=collect.id")
          ;
          q.setString("simsId", simsId);
          q.setString("collectId", collectId);
          List list = q.list();
          if (list.size() > 0) rezult = (Long) list.get(0);
          else rezult = new Long(0);  //not found
        }
        catch (Exception s) {
        	Util.writeLog("checkSimsId", simsId+'/'+collectId, s.getMessage());
        }
    }
    return rezult;
  }

  private void processSimsRef( RequestParser request, TechnologyData assay) {
    if (WebappConfig.isUseSamples()){
//      int rezult = 0;  Query q = null;
      String aliquotId = request.getParameter("aliquotId");
      assay.setSimsRefId( tempAliquotName);
      assay.setSimsCollectionName( tempCohortName);
//      Session sampleSession = null;
      if (aliquotId == null || aliquotId.trim().equals("") || simsRefType == 0){
        assay.setSimsReference( null, 0);
      }
      else
        switch ( simsRefType){
          case 1:
            assay.setSimsReference( tempTopId, 1); break;
          case 2:
              assay.setSimsReference( tempMiddleId, 2); break;
          case 3:
              assay.setSimsReference( tempBottomId, 3); break;
        }
/*    	  
        try {
          sampleSession = WebappConfig.getSamplesSessionFactory().openSession();
          switch ( simsRefType){
            case 1:
              q = sampleSession.createQuery("select obj.id from Top obj"
                  +" where obj.visibleName = :aliquotId"); break;
            case 2:
              q = sampleSession.createQuery("select obj.id from Middle obj"
                 +" where obj.visibleName = :aliquotId"); break;
            case 3:
              q = sampleSession.createQuery("select obj.id from Bottom obj"
                 +" where obj.visibleName = :aliquotId"); break;
          }
          q.setString("aliquotId", aliquotId);
          List list = q.list();
          if (list.size() < 1) rezult = 2;
          else
            assay.setSimsReference( (Long) list.get(0), simsRefType);
        }
        catch (Exception s) {
          rezult = 4;
        }
      finally {
        try {
          sampleSession.close();
        }
        catch (Exception ex) {
          rezult = 4;
        }
      }
      if (rezult > 0) setInvalidFields("aliquotId", rezult);
*/      
    }
  }

  public int addAssay(
      RequestParser request, boolean newGroup) throws Exception {
    int rezult = 0;
    clearInvalidFields();
    if (currentUser == null) return 1;
    tempAssay = new Assay();
    tempAssay.setVisibleName(request.getParameter("assayId"));
    processSimsRef( request, tempAssay);
    tempAssay.setIdentif( new Long(request.getParameter("identif")));
    tempAssay.setIdentifString( request.getParameter("identifString"));
    StudyGroup stGr = currentStudyGroup;
    if (newGroup){
      tempStudyGroup = new StudyGroup();
      tempStudyGroup.setVisibleName(request.getParameter("stgrId"));
      tempStudyGroup.setIdentif( new Long(request.getParameter("sgIdentif")));
      tempStudyGroup.setIdentifString( request.getParameter("sgIdentifString"));
      tempStudyGroup.setTechnology( currentTechnology);
      tempStudyGroup.setCreateInfo(currentUser);
      tempStudyGroup.setComment( request.getParameter("sgComment"));
      stGr = tempStudyGroup;
    }
    List paramList = getAllObjectsForTechnology(Parameter.class);
    Iterator paramIterator = paramList.iterator();
    Class[] paramTypes = {String.class};
    while (paramIterator.hasNext()) {
      Parameter param = (Parameter) paramIterator.next();
      boolean fromGroup = false;
      String value = null;
      String fieldName = null;
      if (newGroup){
        fieldName = param.getStgrColumnNameF();
        if (fieldName != null && !fieldName.equals("")) {
          value = getParameterValue( "sg_" + fieldName, param, request);
          fromGroup = true;
          Object[] args = { value};
          Method xyz = StudyGroup.class.getMethod("set" + fieldName, paramTypes);
          xyz.invoke(tempStudyGroup, args);
        }
      }
      fieldName = param.getAssayColumnNameF();
      if (fieldName != null && !fieldName.equals("")) {
        if (!fromGroup)
          value = getParameterValue( fieldName, param, request);
        Object[] args = { value};
        Method xyz = Assay.class.getMethod("set" + fieldName, paramTypes);
        xyz.invoke(tempAssay, args);
      }
    }
    tempAssay.setTechnology(currentTechnology);
    tempAssay.setCreateInfo(currentUser);
    tempAssay.setComment( getComment( request));

    tempAssay.setProtocolFiles( getProtocolFileString().getContents( request));
    tempAssay.setDataFiles( getDataFileString().getContents( request));
    if (isInvalidField()) rezult = 2; else {
      Transaction tx = null;
      try {
        tx = hibSess.beginTransaction();
        if (newGroup){
          hibSess.save(tempStudyGroup);
          vgm.changeGroupTotal(1);
        }
        tempAssay.setStudyGroup(stGr);
        hibSess.save(tempAssay);
        tx.commit();
        tx = null;
        vam.changeAssayTotal(1);
        renameTempFile( tempAssay.getId());
        currentAssay = tempAssay;
        currentStudyGroup = stGr;
        addAssayAdditional( request, newGroup);
      }
      catch (Exception e) {
        if (tx != null) { tx.rollback(); }
        throw e;
      }
      finally {
        hibSess.close(); //needs before forward
        resetTransactionObjects();
      }
    }
    return rezult;
  }

  private int addAssayAdditional(
      RequestParser request, boolean newGroup) throws Exception {
    int rezult = 0;
    int currentMax = currentAssay.getIdentif().intValue();
    String curentStgrId = currentStudyGroup.getIdentifString();
    if (additionalSimsRef!=null)
      for (int i = 1; i < additionalSimsRef.length; i++) {
      tempAssay = new Assay();
      tempAssay.setVisibleName(request.getParameter("assayId"));
      String idAndName = additionalSimsRef[i];
      int j = idAndName.indexOf('/');
      String id = idAndName.substring(0,j);
      String name = idAndName.substring(j+1);
      tempAssay.setSimsRefId(name);
      tempAssay.setSimsCollectionName( tempCohortName);
      tempAssay.setSimsReference( new Long(id), simsRefType);
      currentMax++;
      tempAssay.setIdentif( new Long(currentMax));
      tempAssay.setIdentifString(
            Assay.makeIdentifString(curentStgrId,currentMax));
      List paramList = getAllObjectsForTechnology(Parameter.class);
      Iterator paramIterator = paramList.iterator();
      Class[] paramTypes = {String.class};
      while (paramIterator.hasNext()) {
        Parameter param = (Parameter) paramIterator.next();
        boolean fromGroup = false;
        String value = null;
        String fieldName = null;
        if (newGroup){
          fieldName = param.getStgrColumnNameF();
          if (fieldName != null && !fieldName.equals("")) {
            value = getParameterValue( "sg_" + fieldName, param, request);
            fromGroup = true;
          }
        }
        fieldName = param.getAssayColumnNameF();
        if (fieldName != null && !fieldName.equals("")) {
          if (!fromGroup)
            value = getParameterValue( fieldName, param, request);
          Object[] args = { value};
          Method xyz = Assay.class.getMethod("set" + fieldName, paramTypes);
          xyz.invoke(tempAssay, args);
        }
      }
      tempAssay.setTechnology( currentTechnology);
      tempAssay.setCreateInfo(currentUser);
      tempAssay.setComment( getComment( request));
      Transaction tx = null;
      try {
        tx = hibSess.beginTransaction();
        tempAssay.setStudyGroup( currentStudyGroup);
        hibSess.save(tempAssay);
        tx.commit();
        vam.changeAssayTotal(1);
      }
      catch (Exception e) {
        if (tx != null) {
          tx.rollback();
        }
        throw e;
      }
    }
    return rezult;
  }

  public int updateAssay(
      RequestParser request) throws Exception {
    int rezult = 0;
    clearInvalidFields();
    if (currentUser == null) return 1;
    Assay tmpAssay = getCurrentAssay();
    if (tmpAssay == null) return 1;
    String sysId = request.getParameter("sysId");
    if (!sysId.equals(tmpAssay.getId().toString())) return 1;
    tmpAssay.setVisibleName(request.getParameter("assayId"));
    processSimsRef( request, tmpAssay);
    String identifString = tmpAssay.getIdentifString();
    if (identifString==null||identifString.equals("")){//for very old assays
      tmpAssay.setIdentif( new Long(request.getParameter("identif")));
      tmpAssay.setIdentifString( request.getParameter("identifString"));
    }
    List paramList = getAllObjectsForTechnology(Parameter.class);
    Iterator paramIterator = paramList.iterator();
    Class[] paramTypes = {String.class};
    while (paramIterator.hasNext()) {
      Parameter param = (Parameter) paramIterator.next();
      String fieldName = param.getAssayColumnNameF();
      if (fieldName != null && !fieldName.equals("")) {
        String value = getParameterValue( fieldName, param, request);
        Object[] args = { value};
        Method xyz = Assay.class.getMethod("set" + fieldName, paramTypes);
        xyz.invoke(tmpAssay, args);
      }
    }
    tmpAssay.setModifInfo(currentUser);
    tmpAssay.setComment( getComment( request));
    tmpAssay.setProtocolFiles( getProtocolFileString().getContents( request));
    tmpAssay.setDataFiles( getDataFileString().getContents( request));
    if (isInvalidField()) rezult = 2; else {
      Transaction tx = null;
      try {
        tx = hibSess.beginTransaction();
        hibSess.update(tmpAssay);
        tx.commit();
        tx = null;
        deleteProtocolFile( protocolFileString.getDeletedFileNames());
        deleteDataFile( dataFileString.getDeletedFileNames());
        renameTempFile( tmpAssay.getId());
      }
      catch (Exception e) {
        if (tx != null) {
          tx.rollback();
        }
        throw e;
      }
      finally {
        hibSess.close(); //needs before forward
        resetTransactionObjects();
      }
    }
    return rezult;
  }

  public void saveAssay(
      RequestParser request, boolean newGroup) throws Exception {
    tempAssay = new Assay();
    if (newGroup) tempStudyGroup = new StudyGroup();
    tempTechnologyData = tempAssay;
    List paramList = getAllObjectsForTechnology(Parameter.class);
    Iterator paramIterator = paramList.iterator();
    Class[] paramTypes = {String.class};
    while (paramIterator.hasNext()) {
      Parameter param = (Parameter) paramIterator.next();
      boolean fromGroup = false;
      String value = null;
      String fieldName = null;
      if (newGroup){
        fieldName = param.getStgrColumnNameF();
        if (fieldName != null && !fieldName.equals("")) {
          value = getParameterValueForSave( "sg_" + fieldName, param, request);
          fromGroup = true;
          Object[] args = { value};
          Method xyz = StudyGroup.class.getMethod("set" + fieldName, paramTypes);
          xyz.invoke(tempStudyGroup, args);
        }
      }
      fieldName = param.getAssayColumnNameF();
      if (fieldName != null && !fieldName.equals("")) {
        if (!fromGroup)
          value = getParameterValueForSave( fieldName, param, request);
        Object[] args = { value};
        Method xyz = Assay.class.getMethod("set" + fieldName, paramTypes);
        xyz.invoke(tempAssay, args);
      }
    }
    tempSysId = request.getParameter("sysId");
    tempMultiple = (tempSysId.equals("0"));
    tempAssay.setIdentif( new Long(request.getParameter("identif")));
    tempAssay.setIdentifString( request.getParameter("identifString"));
    tempAssay.setComment( getComment( request));
    tempAssay.setVisibleName(request.getParameter("assayId"));
    tempAssay.setProtocolFiles( getProtocolFileString().getContents( request));
    tempAssay.setDataFiles( getDataFileString().getContents( request));
    Assay curAssay = getCurrentAssay();
    if (curAssay!=null){
      tempAssay.setStudyGroup(curAssay.getStudyGroup());
      tempAssay.setCreator(curAssay.getCreator());
      tempAssay.setModifier(curAssay.getModifier());
      tempAssay.setCreateDate(curAssay.getCreateDate());
      tempAssay.setModifDate(curAssay.getModifDate());
    }
    if (newGroup){
      tempStudyGroup.setIdentif( new Long(request.getParameter("sgIdentif")));
      tempStudyGroup.setIdentifString( request.getParameter("sgIdentifString"));
      tempStudyGroup.setComment( request.getParameter("sgComment"));
      tempStudyGroup.setVisibleName(request.getParameter("stgrId"));
      tempStudyGroup.setProtocolFiles( null);
      tempStudyGroup.setDataFiles( null);
    }
  }//------------Upload assays-----------------------------------
  /**
   * komentars
   * @param request RequestParser
   * @param newGroup boolean
   * @return int
   * @throws Exception
   */
/*  
  public int checkAssaysBatchUpload(
      RequestParser request, boolean newGroup) throws Exception {
    int rezult = 0;
    clearInvalidFields();
    if (currentUser == null) return 1;
    tempAssay = new Assay();
    if (newGroup){
      tempStudyGroup = new StudyGroup();
      tempStudyGroup.setVisibleName(request.getParameter("stgrId"));
      List paramList = getAllObjectsForTechnology(Parameter.class);
      Iterator paramIterator = paramList.iterator();
      Class[] paramTypes = { String.class};
      while (paramIterator.hasNext()) {
        Parameter param = (Parameter) paramIterator.next();
        String value = null;
        String fieldName = param.getStgrColumnNameF();
        if (fieldName != null && !fieldName.equals("")) {
          value = getParameterValue("sg_" + fieldName, param, request);
          Object[] args = { value};
          Method xyz = StudyGroup.class.getMethod("set" + fieldName, paramTypes);
          xyz.invoke(tempStudyGroup, args);
        }
      }
    }
    if (isInvalidField()) rezult = 2;
    return rezult;
  }
*/  
  /**
   * makes upload of assays
   * @param request RequestParser
   * @param newGroup boolean
   * @return int  ( 0 if successful)
   * @throws Exception
   */
  public int importBatchAssay() throws Exception {
    int rezult = 0;
    boolean start = true; String batchId = null;
    if (currentUser == null) return 1;
    BatchAnalyser analyser = getBatchAnalyser();
    analyser.startIterator();
    while (analyser.hasNextElement()){
      tempAssay = new Assay();
      tempAssay.setTechnology(currentTechnology);
      tempAssay.setCreateInfo(currentUser);
      analyser.nextElement(tempAssay);
      if (isInvalidField()) rezult = 2; else {
        if (start){ batchId = tempAssay.getIdentifString(); start = false;}
        tempAssay.setBatchId(batchId);
        Transaction tx = null;
        try {
          tx = hibSess.beginTransaction();
          hibSess.save(tempAssay);
          analyser.ProcessFiles(tempAssay); //new method!!!
          tx.commit();
          vam.changeAssayTotal(1);
          currentAssay = tempAssay;
        }
        catch (Exception e) {
          if (tx != null) tx.rollback();
          throw e;
        }
      }
    }
    hibSess.close(); //needs before forward
    resetTransactionObjects();
    return rezult;
  }

  public Long addPendingExport( PendingExport ape) throws Exception {
    Long rezult = new Long(0);
    if (currentUser == null) return rezult;
      Transaction tx = null;
      try {
    	ape.setId(null);  
    	ape.setCreateInfo(currentUser);
        tx = hibSess.beginTransaction();
        hibSess.save(ape);
        tx.commit();
        rezult = ape.getId();	
        if (ape.getIsTopLevel().longValue()>0){
          ape.setExportId( rezult);
   	      tx = hibSess.beginTransaction();
          hibSess.update(ape);
          tx.commit();
        }
      }
      catch (Exception e) {
        if (tx != null) {
          tx.rollback();
        }
        throw e;
      }
    return rezult;
  }

  public void addPendingTask( PendingTask pending, TechnologyData techDat, int level){
    switch ( level){
      case 0:pending.setStudyView((StudyView)techDat);break;
      case 1:pending.setStudyGroup((StudyGroup)techDat);break;
      case 2:pending.setAssay((Assay)techDat);break;
    }
    pending.setBatchId( techDat.getBatchId());
    pending.setCreateInfo(currentUser);
    hibSess.save(pending);
  }
  private void deletePendingTask( Assay assay){
        Query q = hibSess.createQuery(
                "select myPen from PendingTask as myPen"
                + " where myPen.assay = :kid");
        q.setLong( "kid", assay.getId().longValue());
        List pens = q.list();
        if (pens.size()>0){
          Iterator penIterator = pens.iterator();
          while (penIterator.hasNext()) {
            PendingTask pen = (PendingTask) penIterator.next();
            hibSess.delete(pen);
          }
        }
      }
  private void deletePendingTask( StudyGroup study){
        Query q = hibSess.createQuery(
                "select myPen from PendingTask as myPen"
                + " where myPen.studyGroup = :kid");
        q.setLong( "kid", study.getId().longValue());
        List pens = q.list();
        if (pens.size()>0){
          Iterator penIterator = pens.iterator();
          while (penIterator.hasNext()) {
            PendingTask pen = (PendingTask) penIterator.next();
            hibSess.delete(pen);
          }
        }  
      }
  private void deletePendingTask( StudyView view){
      Query q = hibSess.createQuery(
              "select myPen from PendingTask as myPen"
              + " where myPen.studyView = :kid");
      q.setLong( "kid", view.getId().longValue());
      List pens = q.list();
      if (pens.size()>0){
        Iterator penIterator = pens.iterator();
        while (penIterator.hasNext()) {
          PendingTask pen = (PendingTask) penIterator.next();
          hibSess.delete(pen);
        }
      }  
    }
  private void deletePendingExport( Assay assay){
          Query q = hibSess.createQuery(
                  "select myPen from PendingExport as myPen"
                  + " where myPen.assay = :kid");
          q.setLong( "kid", assay.getId().longValue());
          List pens = q.list();
          if (pens.size()>0){
            Iterator penIterator = pens.iterator();
            while (penIterator.hasNext()) {
              PendingExport pen = (PendingExport) penIterator.next();
              hibSess.delete(pen);
            }
          }  
        }
  private void deletePendingExport( StudyGroup study){
       Query q = hibSess.createQuery(
                "select myPen from PendingExport as myPen"
              + " where myPen.studyGroup = :kid");
        q.setLong( "kid", study.getId().longValue());
        List pens = q.list();
        if (pens.size()>0){
          Iterator penIterator = pens.iterator();
          while (penIterator.hasNext()) {
            PendingExport pen = (PendingExport) penIterator.next();
            hibSess.delete(pen);
          }
        }  
      }
  private void deletePendingExport( StudyView view){
      Query q = hibSess.createQuery(
              "select myPen from PendingExport as myPen"
            + " where myPen.studyView = :kid");
      q.setLong( "kid", view.getId().longValue());
      List pens = q.list();
      if (pens.size()>0){
        Iterator penIterator = pens.iterator();
        while (penIterator.hasNext()) {
          PendingExport pen = (PendingExport) penIterator.next();
          hibSess.delete(pen);
        }
      }  
    }
//----------------Assays batch edit --------------
  public boolean[] compareBatchAssays(Long[] assayArray) throws Exception {
      if (currentUser == null || assayArray == null) return null;
      Assay firstAssay = (Assay)
                getObjectById(Assay.class, assayArray[0]);
      if (firstAssay == null) return null;
      boolean[] batchBools = new boolean[64];
      for ( int i = 0; i < 64; i++) batchBools[i] = true;

      for ( int i = 1; i < assayArray.length; i++) {
          Assay tmpAssay = (Assay)
                    getObjectById(Assay.class, assayArray[i]);
          if (tmpAssay != null)
            firstAssay.compareWith(batchBools,tmpAssay);
      }

      return batchBools;
  }

  public int checkAssaysBatchEdit( Long[] assayArray,
      HttpServletRequest request) throws Exception {
      int rezult = 0;
      clearInvalidFields();
      if (currentUser == null || assayArray == null) return 1;
      tempAssay = (Assay) getObjectById(Assay.class, assayArray[0]);
      if (tempAssay == null) return 1;
      List paramList = getAllObjectsForTechnology(Parameter.class);
      Iterator paramIterator = paramList.iterator();
      Class[] paramTypes = {String.class};
      while (paramIterator.hasNext()) {
        Parameter param = (Parameter) paramIterator.next();
        String fieldName = param.getAssayColumnNameF();
        if (fieldName != null && !fieldName.equals("")) {
          String value = getParameterValue0( fieldName, param, request);
          if (value!=null){
            Object[] args = { value};
            Method xyz = Assay.class.getMethod("set" + fieldName, paramTypes);
            xyz.invoke(tempAssay, args);
          }
        }
      }
      if (isInvalidField()) rezult = 2;
      return rezult;
  }

  public int updateBatchAssays( Long[] assayArray,
      HttpServletRequest request) throws Exception {
      int rezult = 0;
      if (currentUser == null || assayArray == null) return 1;
      Transaction tx = null;
      try {
        List paramList = getAllObjectsForTechnology(Parameter.class);
        tx = hibSess.beginTransaction();
        for (int i = 0; i < assayArray.length; i++) {
          Assay tmpAssay = (Assay) getObjectById(Assay.class, assayArray[i]);
          if (tmpAssay == null) continue;
          Iterator paramIterator = paramList.iterator();
          Class[] paramTypes = {String.class};
          while (paramIterator.hasNext()) {
            Parameter param = (Parameter) paramIterator.next();
            String fieldName = param.getAssayColumnNameF();
            if (fieldName != null && !fieldName.equals("")) {
              String value = getParameterValue0( fieldName, param, request);
              if (value!=null){
                Object[] args = { value};
                Method xyz = Assay.class.getMethod("set" + fieldName, paramTypes);
                xyz.invoke(tmpAssay, args);
              }
            }
          }
          tmpAssay.setModifInfo(currentUser);
          hibSess.update(tmpAssay);
        }
        tx.commit();
      } catch (Exception e) {
          rezult = 1;
          if (tx != null) tx.rollback();
          throw e;
      } finally {
          hibSess.close(); //needs before forward
      }
      return rezult;
  }
//-----------------------------------------------------------------
//-----------------------------------------------------------------
  public int deleteAssay(String selfId) throws Exception {
    if (currentUser == null) {
      return 1;
    }
    Assay tmpAssay = getCurrentAssay();
    if (tmpAssay == null) {
      return 1;
    }
    if (!selfId.equals(tmpAssay.getId().toString())) {
      return 1;
    }
    hibSess.refresh(tmpAssay);   //this avoids duplicate instance
    Transaction tx = null;
    try {
      tx = hibSess.beginTransaction();
      if (tmpAssay.isPending()||tmpAssay.isFileError())deletePendingTask(tmpAssay);
      if (tmpAssay.isExported())deletePendingExport(tmpAssay);
      hibSess.delete(tmpAssay);
      tx.commit();
      vam.changeAssayTotal( -1);
      deleteProtocolFile( protocolFileString.getAllFileNames());
      deleteDataFile( dataFileString.getAllFileNames());
    }
    catch (Exception e) {
      if (tx != null) {
        tx.rollback();
      }
      throw e;
    }
    finally {
      hibSess.close(); //needs before forward
      resetTransactionObjects();
      currentAssay = null;
    }
    return 0;
  }

//----------------------------------------------------------//
//----------------------------------------------------------//
//----------------------------------------------------------//
//----------------------------------------------------------//
  public void setCurrentAssay(String assayId) throws Exception {
    currentAssay = (Assay)getObjectById(Assay.class, assayId);
    if (currentAssay != null) currentStudyGroup = currentAssay.getStudyGroup();
  }
  public void setCurrentStudyGroup(String groupId) throws Exception {
    currentAssay = null;
    currentStudyGroup = (StudyGroup)getObjectById(StudyGroup.class, groupId);
  }
  public void setCurrentStudyView(String viewId) throws Exception {
    currentAssay = null;
    currentStudyGroup = null;
    currentStudyView = (StudyView)getObjectById(StudyView.class, viewId);
  }

  public void setCurrentTechnology(String technologyId) throws Exception {
    cancelFilter(); filterValues = null;
    resetAliquotFilter();
    resetAllBatch();
    vam.clearValues(); vgm.clearValues(); vvm.clearValues();      //
    currentStudyGroup = null;
    currentAssay = null;
    currentTechnology = (Technology)getObjectById( Technology.class, technologyId);
    if (currentTechnology!=null){
      initializeRights();	
      if (!currentUser.isWriteAdministrator()){
        Query q = hibSess.createQuery("from TechnologyAccess rights"
             + " where rights.user = :current and"
             + " rights.technology = :technol");
        q.setLong( "current", currentUser.getId().longValue());
        q.setLong( "technol", currentTechnology.getId().longValue());
        List list = q.list();
        if (list.size()>0){
          TechnologyAccess abc = (TechnologyAccess) list.get(0);
          initializeRights(abc.getCanCreateSGX().intValue(),
                  abc.getVocabularyAccess().intValue(),
                  abc.getConfigurationAccess().intValue(),
                  abc.getDataExportRights().intValue(),
                  abc.getDataFileExportRightsX().intValue(),
                  abc.getDataTransferRightsX().intValue());
        }
        else {
          q = hibSess.createQuery("from TechnologyAccess rights"
                                  + " where rights.user = :current and"
                                  + " rights.technology is null");
          q.setLong("current", currentUser.getId().longValue());
          list = q.list();
          if (list.size() > 0) {
            TechnologyAccess abc = (TechnologyAccess) list.get(0);
            initializeRights(abc.getCanCreateSGX().intValue(),
                    abc.getVocabularyAccess().intValue(),
                    abc.getConfigurationAccess().intValue(),
                    abc.getDataExportRights().intValue(),
                    abc.getDataFileExportRightsX().intValue(),
                    abc.getDataTransferRightsX().intValue());
          }
        }
      }
      String technDir = getTechnologyFtpDirectory();
      protTechnDirectory = new File( WebappConfig.getProtocolDirectory(), technDir);
      protTechnDirectory.mkdir();
      dataTechnDirectory = new File( WebappConfig.getDataDirectory(), technDir);
      dataTechnDirectory.mkdir();
      buildMetaDataI();
    }
  }

  public boolean withTechnologies() throws Exception {
      return (isAdminSession() || technolCount != 1);
    }

  public String getTechnologyPrompter() throws Exception {
    if (isWriteAdminSession()) return getObjectPrompter( Technology.class, null);
    Query q = hibSess.createQuery("from TechnologyAccess rights"
                                  + " where rights.user = :current");
    q.setLong( "current", currentUser.getId().longValue());
    List list1 = q.list();
    if (technolCount < 0){ //all public + some specific!!!!
      List list2 = getAllObjects(Technology.class);
      return PromptUtil.getTechnologyPrompterFromTechnologyList( list1, list2);
    }
    else{   //only specific
      return PromptUtil.getTechnologyPrompterFromAccessList(list1);
    }
  }

  public Technology getTechnologyById(String technologyId) {
     return (Technology)getObjectById( Technology.class, technologyId);
  }


  public String getTechnologyPrompter(String technologyId) throws Exception {

   try
   {
    if (isWriteAdminSession())
        if (technologyId == null)
            return getObjectPrompter( Technology.class, null);
        else return getObjectPrompter( Technology.class, Long.parseLong(technologyId));

    Query q = hibSess.createQuery("from TechnologyAccess rights"
                                  + " where rights.user = :current");
    q.setLong( "current", currentUser.getId().longValue());
    List list1 = q.list();
    if (technolCount < 0){ //all public + some specific!!!!
      List list2 = getAllObjects(Technology.class);
      String s = PromptUtil.getTechnologyPrompterFromTechnologyList1( list1, list2, technologyId);
      return s;
    }
    else{   //only specific
      String s =  PromptUtil.getTechnologyPrompterFromAccessList1(list1, technologyId);
      return s;
    }

   }
   catch (Exception e)
   {
       System.out.println(e.getMessage()); System.out.flush();
       return "";
   }

  }

  public Long getCurrentTechnologyId() {
    return (currentTechnology==null)?null:currentTechnology.getId();
  }
  public Technology getCurrentTechnology() {
    return currentTechnology;
  }
  public Long getCurrentStudyViewId() {
    return (currentStudyView==null)?null:currentStudyView.getId();
  }
  public StudyView getCurrentStudyView() {
    return currentStudyView;
  }
  public Long getCurrentStudyGroupId() {
    return (currentStudyGroup==null)?null:currentStudyGroup.getId();
  }

  public StudyGroup getCurrentStudyGroup() {
    return currentStudyGroup;
  }

  public Long getCurrentAssayId() {
    return (currentAssay==null)?null:currentAssay.getId();
  }

  public Assay getCurrentAssay() {
    return currentAssay;
  }

  public StudyView getTempStudyView() {
    return tempStudyView;
  }
   public StudyGroup getTempStudyGroup() {
//    if (tempStudyGroup==null)
//        throw new Exception(this.getMyMessage(12));
    return tempStudyGroup;
  }

  public Assay getTempAssay() throws Exception {
    if (tempAssay==null)
        throw new Exception( UserHttpSession.getMyMessage(12));
    return tempAssay;
  }

  private boolean resetCurrents() {
	resetRequestTechnology();
	resetTransactionObjects();
    mdm = null;
    currentAssay = null;
    currentStudyGroup = null;
    currentStudyView = null;
    currentTechnology = null;
    currentUser = null;
    resetAliquotFilter();
    resetAllBatch();
    return true;
  }

//----------------------------------------------------------//
//----------------------------------------------------------//
//used by batch edit only
  private String getParameterValue0( String fieldName, Parameter param,
                          HttpServletRequest request) {
    String value = request.getParameter(fieldName);
    ParameterType paramType = param.getParameterType();
    int baseType = paramType.getBaseType().intValue();
    int attribute1 = paramType.getAttribute1();
    if (value == null) ;
    else if (param.isRequired() && value.equals(""))
      setInvalidFields(fieldName,10);
    else if (baseType == AssayTypeName.BIGSTRING) {
      if (value.length() > 200)
        setInvalidFields(fieldName,9);
    }
    else if (baseType == AssayTypeName.NUMBER) {
      if (!Util.checkIntegerValue(value))
        setInvalidFields(fieldName,7);
    }
    else if (baseType == AssayTypeName.FLOAT) {
      if (!Util.checkFloatValue(value))
        setInvalidFields(fieldName,7);
    }
    else if (baseType == AssayTypeName.FLOAT_ARRAY) {
      StringBuffer floatBuf = new StringBuffer();
      if (value!=null && !value.equals("")) {
        if (!Util.checkFloatValue(value))
          setInvalidFields(fieldName, 7);
        floatBuf.append(value);
      }
      floatBuf.append(',');
      for (int i = 1; i < attribute1; i++){
        value = request.getParameter(fieldName+i);
        if (value!=null && !value.equals("")) {
          if (!Util.checkFloatValue(value))
            setInvalidFields(fieldName+i, 7);
          floatBuf.append(value);
        }
        floatBuf.append(',');
      }
      value = floatBuf.toString();
    }
    else if (baseType == AssayTypeName.NUMBER_ARRAY) {
      StringBuffer numberBuf = new StringBuffer();
      if (value!=null && !value.equals("")) {
        if (!Util.checkIntegerValue(value))
          setInvalidFields(fieldName, 7);
        numberBuf.append(value);
      }
      numberBuf.append(',');
      for (int i = 1; i < attribute1; i++){
        value = request.getParameter(fieldName+i);
        if (value!=null && !value.equals("")) {
          if (!Util.checkIntegerValue(value))
            setInvalidFields(fieldName+i, 7);
          numberBuf.append(value);
        }
        numberBuf.append(',');
      }
      value = numberBuf.toString();
    }
    else if (baseType == AssayTypeName.DATETIME) {
      StringBuffer dateBuf = new StringBuffer();
      boolean emptyFlag = true;
      if (value!=null && !value.equals("")) {
        dateBuf.append( value); emptyFlag = false;
        if (!Util.checkInteger(value, 1900, Util.getThisYear()))
          setInvalidFields(fieldName, 5);
      }
      dateBuf.append(',');
      String prevname = null;
      String fname = null;
      if (attribute1 > 1){
        prevname = fieldName;
        fname = fieldName+'1';
        value = request.getParameter(fname);
        if (value!=null && !value.equals("")) {
          if (emptyFlag) setInvalidFields(prevname, 5);
          if (!Util.checkInteger(value, 1, 12))
            setInvalidFields(fname, 5);
          else if (value.length()==1)dateBuf.append('0');
          dateBuf.append( value); emptyFlag = false;
        } else
          if (!emptyFlag) setInvalidFields(fname, 5);
      }
      dateBuf.append(',');
      if (attribute1 > 1){
        prevname = fname;
        fname = fieldName+'2';
        value = request.getParameter(fname);
        if (value!=null && !value.equals("")) {
          if (emptyFlag) setInvalidFields(prevname, 5);
          if (!Util.checkInteger(value, 1, 31))
            setInvalidFields(fname, 5);
          else if (value.length()==1)dateBuf.append('0');
          dateBuf.append( value); emptyFlag = false;
        } else
          if (!emptyFlag) setInvalidFields(fname, 5);
      }
      dateBuf.append(',');
      if (attribute1 > 2){
        prevname = fname;
        fname = fieldName+'3';
        value = request.getParameter(fname);
        if (value!=null && !value.equals("")) {
          if (emptyFlag) setInvalidFields(prevname, 5);
          if (!Util.checkInteger(value, 0, 23))
            setInvalidFields(fname, 5);
          else if (value.length()==1)dateBuf.append('0');
          dateBuf.append( value); emptyFlag = false;
        } else
          if (!emptyFlag) setInvalidFields(fname, 5);
      }
      dateBuf.append(',');
      if (attribute1 > 2){
        prevname = fname;
        fname = fieldName+'4';
        value = request.getParameter(fname);
        if (value!=null && !value.equals("")) {
          if (emptyFlag) setInvalidFields(prevname, 5);
          if (!Util.checkInteger(value, 0, 59))
            setInvalidFields(fname, 5);
          else if (value.length()==1)dateBuf.append('0');
          dateBuf.append( value); emptyFlag = false;
        } else
          if (!emptyFlag) setInvalidFields(fname, 5);
      }
      dateBuf.append(',');
      value = dateBuf.toString();
    }
    else if (baseType == AssayTypeName.TIME) {
      StringBuffer timeBuf = new StringBuffer();
      String fname = fieldName;
      int fieldNum = 0;
      if (attribute1 >= 4){
        attribute1 -= 4;
        if (value != null && !value.equals("")) {
          timeBuf.append(value);
          if (!Util.checkIntegerValue(value))
            setInvalidFields( fname, 11);
        }
        fieldNum++; fname = fieldName+fieldNum;
        value = request.getParameter(fname);
      }
      timeBuf.append(',');
      if (attribute1 >= 2){
        attribute1 -= 2;
        if (value != null && !value.equals("")) {
          timeBuf.append(value);
          if (((fieldNum==0) && !Util.checkIntegerValue(value))||
            (!Util.checkInteger(value, 0, 59)))
            setInvalidFields(fname, 11);
        }
        fieldNum++; fname = fieldName+fieldNum;
        value = request.getParameter(fname);
      }
      timeBuf.append(',');
      if (attribute1 >= 1){
        if (value != null && !value.equals("")) {
          timeBuf.append(value);
          if (((fieldNum==0) && !Util.checkIntegerValue(value))||
            (!Util.checkInteger(value, 0, 59)))
            setInvalidFields(fname, 11);
        }
      }
      timeBuf.append(',');
      value = timeBuf.toString();
    }
    else if (baseType == AssayTypeName.HTML_REF) {
      StringBuffer hrefBuf = new StringBuffer();
      if (value!=null && !value.equals("")) hrefBuf.append( value);   
      hrefBuf.append("\\\\\\");
      value = request.getParameter(fieldName+'x');
      if (value!=null && !value.equals(""))	hrefBuf.append(value);
      value = hrefBuf.toString();
    }    
    return value;
  }
//----------------------------------------------------------//
//----------------------------------------------------------//
//used by all edits
  private String getParameterValue( String fieldName, Parameter param,
                                  RequestParser request) {
    String value = request.getParameter(fieldName);
    ParameterType paramType = param.getParameterType();
    int baseType = paramType.getBaseType().intValue();
    int attribute1 = paramType.getAttribute1();
    if (baseType == AssayTypeName.BOOLEAN && attribute1 < 2){
      if (value == null) value = "0";	
    }
    else
    if (param.isRequired() && (value == null || value.equals("")))
      setInvalidFields(fieldName,10);
    else if (baseType == AssayTypeName.BIGSTRING) {
      if (value.length() > 200)
        setInvalidFields(fieldName,9);
    }
    else if (baseType == AssayTypeName.NUMBER) {
      if (!Util.checkIntegerValue(value))
        setInvalidFields(fieldName,7);
    }
    else if (baseType == AssayTypeName.FLOAT) {
      if (!Util.checkFloatValue(value))
        setInvalidFields(fieldName,7);
    }
    else if (baseType == AssayTypeName.FLOAT_ARRAY) {
      StringBuffer floatBuf = new StringBuffer();
      if (value!=null && !value.equals("")) {
        if (!Util.checkFloatValue(value))
          setInvalidFields(fieldName, 7);
        floatBuf.append(value);
      }
      floatBuf.append(',');
      for (int i = 1; i < attribute1; i++){
        value = request.getParameter(fieldName+i);
        if (value!=null && !value.equals("")) {
          if (!Util.checkFloatValue(value))
            setInvalidFields(fieldName+i, 7);
          floatBuf.append(value);
        }
        floatBuf.append(',');
      }
      value = floatBuf.toString();
    }
    else if (baseType == AssayTypeName.NUMBER_ARRAY) {
      StringBuffer numberBuf = new StringBuffer();
      if (value!=null && !value.equals("")) {
        if (!Util.checkIntegerValue(value))
          setInvalidFields(fieldName, 7);
        numberBuf.append(value);
      }
      numberBuf.append(',');
      for (int i = 1; i < attribute1; i++){
        value = request.getParameter(fieldName+i);
        if (value!=null && !value.equals("")) {
          if (!Util.checkIntegerValue(value))
            setInvalidFields(fieldName+i, 7);
          numberBuf.append(value);
        }
        numberBuf.append(',');
      }
      value = numberBuf.toString();
    }
    else if (baseType == AssayTypeName.DATETIME) {
      StringBuffer dateBuf = new StringBuffer();
      boolean emptyFlag = true;
      if (value!=null && !value.equals("")) {
        dateBuf.append( value); emptyFlag = false;
        if (!Util.checkInteger(value, 1900, Util.getThisYear()))
          setInvalidFields(fieldName, 5);
      }
      dateBuf.append(',');
      String prevname = null;
      String fname = null;
      if (attribute1 > 1){
        prevname = fieldName;
        fname = fieldName+'1';
        value = request.getParameter(fname);
        if (value!=null && !value.equals("")) {
          if (emptyFlag) setInvalidFields(prevname, 5);
          if (!Util.checkInteger(value, 1, 12))
            setInvalidFields(fname, 5);
          else if (value.length()==1)dateBuf.append('0');
          dateBuf.append( value); emptyFlag = false;
        } else
          if (!emptyFlag) setInvalidFields(fname, 5);
      }
      dateBuf.append(',');
      if (attribute1 > 1){
        prevname = fname;
        fname = fieldName+'2';
        value = request.getParameter(fname);
        if (value!=null && !value.equals("")) {
          if (emptyFlag) setInvalidFields(prevname, 5);
          if (!Util.checkInteger(value, 1, 31))
            setInvalidFields(fname, 5);
          else if (value.length()==1)dateBuf.append('0');
          dateBuf.append( value); emptyFlag = false;
        } else
          if (!emptyFlag) setInvalidFields(fname, 5);
      }
      dateBuf.append(',');
      if (attribute1 > 2){
        prevname = fname;
        fname = fieldName+'3';
        value = request.getParameter(fname);
        if (value!=null && !value.equals("")) {
          if (emptyFlag) setInvalidFields(prevname, 5);
          if (!Util.checkInteger(value, 0, 23))
            setInvalidFields(fname, 5);
          else if (value.length()==1)dateBuf.append('0');
          dateBuf.append( value); emptyFlag = false;
        } else
          if (!emptyFlag) setInvalidFields(fname, 5);
      }
      dateBuf.append(',');
      if (attribute1 > 2){
        prevname = fname;
        fname = fieldName+'4';
        value = request.getParameter(fname);
        if (value!=null && !value.equals("")) {
          if (emptyFlag) setInvalidFields(prevname, 5);
          if (!Util.checkInteger(value, 0, 59))
            setInvalidFields(fname, 5);
          else if (value.length()==1)dateBuf.append('0');
          dateBuf.append( value); emptyFlag = false;
        } else
          if (!emptyFlag) setInvalidFields(fname, 5);
      }
      dateBuf.append(',');
      value = dateBuf.toString();
    }
    else if (baseType == AssayTypeName.TIME) {
      StringBuffer timeBuf = new StringBuffer();
      int fieldNum = 0;
      String fname = fieldName;
      if (attribute1 >= 4){
        attribute1 -= 4;
        if (value != null && !value.equals("")) {
          timeBuf.append(value);
          if (!Util.checkIntegerValue(value))
            setInvalidFields(fname, 11);
        }
        fieldNum++; fname = fieldName+fieldNum;
        value = request.getParameter(fname);
      }
      timeBuf.append(',');
      if (attribute1 >= 2){
        attribute1 -= 2;
        if (value != null && !value.equals("")) {
          timeBuf.append(value);
          if (((fieldNum==0) && !Util.checkIntegerValue(value))||
            (!Util.checkInteger(value, 0, 59)))
            setInvalidFields(fname, 11);
        }
        fieldNum++; fname = fieldName+fieldNum;
        value = request.getParameter(fname);
      }
      timeBuf.append(',');
      if (attribute1 >= 1){
        if (value != null && !value.equals("")) {
          timeBuf.append(value);
          if (((fieldNum==0) && !Util.checkIntegerValue(value))||
            (!Util.checkInteger(value, 0, 59)))
            setInvalidFields(fname, 11);
        }
      }
      timeBuf.append(',');
      value = timeBuf.toString();
    }
    else if (baseType == AssayTypeName.HTML_REF) {
      StringBuffer hrefBuf = new StringBuffer();
      if (value!=null && !value.equals("")) hrefBuf.append( value);   
      hrefBuf.append("\\\\\\");
      value = request.getParameter(fieldName+'x');
      if (value!=null && !value.equals(""))	hrefBuf.append(value);
      value = hrefBuf.toString();
    }    
    return value;
  }

  private String getParameterValueForSave( String fieldName, Parameter param,
                                  RequestParser request) {
    String value = request.getParameter(fieldName);
    ParameterType paramType = param.getParameterType();
    int baseType = paramType.getBaseType().intValue();
    int attribute1 = paramType.getAttribute1();
    if (baseType == AssayTypeName.DATETIME) {
      StringBuffer dateBuf = new StringBuffer();
      if (value!=null && !value.equals("")) {
        dateBuf.append( value);     //year
      }
      dateBuf.append(',');
      if (attribute1 > 1){
        value = request.getParameter(fieldName+'1');
        if (value!=null && !value.equals("")) {
          dateBuf.append( value);   //month
        }
      }
      dateBuf.append(',');
      if (attribute1 > 1){
        value = request.getParameter(fieldName+'2');
        if (value!=null && !value.equals("")) {
          dateBuf.append( value);   //day
        }
      }
      dateBuf.append(',');
      if (attribute1 > 2){
        value = request.getParameter(fieldName+'3');
        if (value!=null && !value.equals("")) {
          dateBuf.append( value);    //hour
        }
      }
      dateBuf.append(',');
      if (attribute1 > 2){
        value = request.getParameter(fieldName+'4');
        if (value!=null && !value.equals("")) {
          dateBuf.append( value);    //minute
        }
      }
      dateBuf.append(',');
      value = dateBuf.toString();
    }
    else if (baseType == AssayTypeName.TIME) {
      StringBuffer timeBuf = new StringBuffer();
      int fieldNum = 0;
      if (attribute1 >= 4){
        attribute1 -= 4;
        if (value != null && !value.equals("")) {
          timeBuf.append(value);
        }
        fieldNum++;
        value = request.getParameter(fieldName+fieldNum);
      }
      timeBuf.append(',');
      if (attribute1 >= 2){
        attribute1 -= 2;
        if (value != null && !value.equals("")) {
          timeBuf.append(value);
        }
        fieldNum++;
        value = request.getParameter(fieldName+fieldNum);
      }
      timeBuf.append(',');
      if (attribute1 >= 1){
        if (value != null && !value.equals("")) {
          timeBuf.append(value);
        }
      }
      timeBuf.append(',');
      value = timeBuf.toString();
    }
    else if (baseType == AssayTypeName.FLOAT_ARRAY ||
        baseType == AssayTypeName.NUMBER_ARRAY) {
      StringBuffer floatBuf = new StringBuffer();
      if (value!=null && !value.equals("")) {
        floatBuf.append(value);
      }
      floatBuf.append(',');
      for (int i = 1; i < attribute1; i++){
        value = request.getParameter(fieldName+i);
        if (value!=null && !value.equals("")) {
          floatBuf.append(value);
        }
        floatBuf.append(',');
      }
      value = floatBuf.toString();
    }
    else if (baseType == AssayTypeName.HTML_REF) {
      StringBuffer hrefBuf = new StringBuffer();
      if (value!=null && !value.equals("")) hrefBuf.append( value);   
      hrefBuf.append("\\\\\\");
      value = request.getParameter(fieldName+'x');
      if (value!=null && !value.equals(""))	hrefBuf.append(value);
      value = hrefBuf.toString();
    }    
    return value;
  }
  private String getFigureBackgr( int styl) {
    String myBackgr = (styl<1)?"":
      (styl<2)?" disabled style=\"background-color:#FFFFFF;\"":
      (styl<3)?" disabled style=\"background-color:#E5EAF0;\"":
               " style=\"background-color:#F0C0C0;\"";
    return myBackgr;
  }
  private String getFigureError( String fieldName) {
    if (invalidFields != null){
      Integer rezult = (Integer)invalidFields.get(fieldName);
      if (rezult != null)
        return " id=\"kluda\" title=\""
                +getMyMessage(rezult.intValue())
                +"\"";
    }
    return "";
  }  
  public String getParameterHTML( String fieldName, Parameter param,
                 String value, boolean forGroup, int styl) throws Exception {
    StringBuffer xyz = new StringBuffer();
    ParameterType paramType = param.getParameterType();
    int baseType = paramType.getBaseType().intValue();
    String myValue = Util.getHTMLString(value);
//    String myBackgr = (styl<1)?" style=\"background-color:#FFFFFF;\"":
//        (styl<2)?" disabled style=\"background-color:#FFFFFF;\"":
//        (styl<3)?" disabled style=\"background-color:#E5EAF0;\"":
//                 " style=\"background-color:#F0C0C0;\"";
    if (baseType == AssayTypeName.TABLE) {
      Vocabulary vocab = paramType.getVocabulary();
      if (vocab!=null){
        int m = paramType.getAttribute1();
        if (myValue.equals("")) myValue = "0";
        if (m<2){  
          xyz.append("<select name=\"")
            .append(fieldName)
            .append("\"")
            .append(getFieldBackgr(fieldName,styl))//(errorField(fieldName))?getFieldId(fieldName):myBackgr)
            .append(">")
            .append(vocab.getObjectPrompter( myValue))
            .append("</select>");
        } else {
            xyz.append("<a ")
            .append(getFigureError( fieldName))
            .append(">");
          xyz.append(vocab.getObjectPrompter( myValue, fieldName,styl));	
          xyz.append("</a>");
        }
    }} else
    if (baseType == AssayTypeName.BIGSTRING) {
      xyz.append("<textarea cols=\"36\" rows=\"5\" name=\"")
         .append(fieldName)
         .append("\"")
         .append(getFieldBackgr(fieldName,styl))
         .append(">");
      xyz.append(myValue);
      xyz.append("</textarea>");
    } else
    if (baseType == AssayTypeName.NUMBER || baseType == AssayTypeName.FLOAT) {
      xyz.append("<input type=\"text\" name=\"")
         .append(fieldName)
         .append("\" value=\"")
         .append(myValue)
         .append("\"");
      xyz.append(" size=\"6\" maxlength=\"12\"")
          .append(getFieldBackgr(fieldName,styl))
          .append("/>");
    } else
    if (baseType == AssayTypeName.FLOAT_ARRAY ||
          baseType == AssayTypeName.NUMBER_ARRAY) {
      int m = paramType.getAttribute1();
      int k = 0; int l;
      for ( int i = 0; i < m; i++){
        String fname;
        if (i>0){
          fname = fieldName+i;
          xyz.append("<b>,</b>");
          if (i % 6 == 0) xyz.append("<br>");
        } else
          fname = fieldName;
        xyz.append("<input type=\"text\" name=\"")
            .append(fname)
            .append("\"");
        l = myValue.indexOf(',', k);
        if (l > k)
          xyz.append(" value=\"")
              .append(myValue.substring(k, l))
              .append("\"");
        xyz.append(" size=\"6\" maxlength= \"12\"")
           .append(getFieldBackgr(fname,styl))
           .append("/>");
        if (l >= k) k = l + 1;
      }
    } else
    if (baseType == AssayTypeName.DATETIME) {
      int m = paramType.getAttribute1();
      int k = 0;
      String fname;
      xyz.append("<input type=\"text\" name=\"")
         .append(fieldName)
         .append("\"");
      if (myValue != null){
        int l = myValue.indexOf(',', k);
        if (l > k)
          xyz.append(" value=\"")
             .append(myValue.substring(k, l))
             .append("\"");
        k = l + 1;
      }
      xyz.append(" size=\"4\" maxlength=\"4\"")
         .append(getFieldBackgr(fieldName,styl))
         .append("/>");
      if ( m > 1){
        fname = fieldName+'1';
        xyz.append("<b>-</b>");
        xyz.append("<input type=\"text\" name=\"")
           .append(fname)
           .append("\"");
        if (myValue != null){
          int l = myValue.indexOf(',', k);
          if (l > k)
            xyz.append(" value=\"")
               .append(myValue.substring(k, l))
               .append("\"");
          k = l + 1;
        }
        xyz.append(" size=\"2\" maxlength=\"2\"")
           .append(getFieldBackgr(fname,styl))
           .append("/>");
        fname = fieldName+'2';
        xyz.append("<b>-</b>");
        xyz.append("<input type=\"text\" name=\"")
           .append(fname)
           .append("\"");
        if (myValue != null){
          int l = myValue.indexOf(',', k);
          if (l > k)
            xyz.append(" value=\"")
               .append(myValue.substring(k, l))
               .append("\"");
          k = l + 1;
        }
        xyz.append(" size=\"2\" maxlength=\"2\"")
           .append(getFieldBackgr(fname,styl))
           .append("/>");
      }
      if ( m > 2){
        fname = fieldName+'3';
        xyz.append("&nbsp;");
        xyz.append("<input type=\"text\" name=\"")
           .append(fname)
           .append("\"");
        if (myValue != null){
          int l = myValue.indexOf(',', k);
          if (l > k)
            xyz.append(" value=\"")
               .append(myValue.substring(k, l))
               .append("\"");
          k = l + 1;
        }
        xyz.append(" size=\"2\" maxlength=\"2\"")
           .append(getFieldBackgr(fname,styl))
           .append("/>");
        fname = fieldName+'4';
        xyz.append("<b>:</b>");
        xyz.append("<input type=\"text\" name=\"")
           .append(fname)
           .append("\"");
        if (myValue != null){
          int l = myValue.indexOf(',', k);
          if (l > k)
            xyz.append(" value=\"")
               .append(myValue.substring(k, l))
               .append("\"");
          k = l + 1;
        }
        xyz.append(" size=\"2\" maxlength=\"2\"")
           .append(getFieldBackgr(fname,styl))
           .append("/>");
     }} else
     if (baseType == AssayTypeName.BOOLEAN) {
       boolean yes = myValue != null && myValue.equals("1");
       int m = paramType.getAttribute1();
       if (m<2){   
         xyz.append("<input type=\"checkbox\" name=\"")
          .append(fieldName)
          .append("\" value=\"1\"");
         if (yes) xyz.append(" checked");
         xyz.append(getFigureBackgr(styl))
          .append("/>");
       } else {
    	 boolean no = (m<3)?!yes:myValue!=null&&myValue.equals("0");  
         xyz.append("<a ")
            .append(getFigureError( fieldName))
            .append(">");
         xyz.append("<input type=\"radio\" name=\"")
          .append(fieldName)
          .append("\" value=\"1\"");
         if (yes) xyz.append(" checked");
         xyz.append(getFigureBackgr(styl))
          .append("/>yes");
         xyz.append("<input type=\"radio\" name=\"")
          .append(fieldName)
          .append("\" value=\"0\"");
         if (no) xyz.append(" checked");
         xyz.append(getFigureBackgr(styl))
          .append("/>no");
         xyz.append("</a>");
       }  
     }else
     if (baseType == AssayTypeName.TIME) {
//   1 - ss       2 - mm       3 - mm:ss
//   4 - hh       6 - hh:mm    7 - hh:mm:ss
       int m = paramType.getAttribute1();
       int k = 0;
       String fname;
       xyz.append("<input type=\"text\" name=\"")
          .append(fieldName)
          .append("\"");
       if (myValue != null){
         if (m < 4) k = myValue.indexOf(',', k) + 1;
         if (m < 2) k = myValue.indexOf(',', k) + 1;
         int l = myValue.indexOf(',', k);
         if (l > k)
           xyz.append(" value=\"")
              .append(myValue.substring(k, l))
              .append("\"");
         k = l + 1;
       }
       xyz.append(" size=\"2\" maxlength=\"2\"")
          .append(getFieldBackgr(fieldName,styl))
          .append("/>");
       if ( m >= 4) m -= 4;
       else if ( m >= 2) m -= 2;
       else m -= 1;
       if ( m > 0){
         fname = fieldName+1;
//         fname = fieldName+((m>=2)?'m':'s');
         xyz.append("<b>:</b>");
         xyz.append("<input type=\"text\" name=\"")
            .append(fname)
            .append("\"");
         if (myValue != null){
           int l = myValue.indexOf(',', k);
           if (l > k)
             xyz.append(" value=\"")
                .append(myValue.substring(k, l))
                .append("\"");
           k = l + 1;
         }
         xyz.append(" size=\"2\" maxlength=\"2\"")
            .append(getFieldBackgr(fname,styl))
            .append("/>");
         if ( m >= 2) m -= 2;
         else m -= 1;
         if ( m > 0){
           fname = fieldName+2;
//           fname = fieldName+'s';
           xyz.append("<b>:</b>");
           xyz.append("<input type=\"text\" name=\"")
              .append(fname)
              .append("\"");
           if (myValue != null){
             int l = myValue.indexOf(',', k);
             if (l > k)
               xyz.append(" value=\"")
                  .append(myValue.substring(k, l))
                  .append("\"");
           }
           xyz.append(" size=\"2\" maxlength=\"2\"")
              .append(getFieldBackgr(fname,styl))
              .append("/>");
       }}} else 
  	   if (baseType == AssayTypeName.HTML_REF) {
  		 int l = -1;  
  		 if (myValue != null) l = myValue.indexOf("\\\\\\");
         xyz.append("<input type=\"text\" name=\"")
           .append(fieldName)
           .append("\"");
         if (myValue != null) xyz.append(" value=\"")
            .append((l<0)?myValue:myValue.substring(0,l))
            .append("\"");
         xyz.append(" size=\"20\" maxlength=\"200\"")
           .append(getFieldBackgr(fieldName,styl))
           .append("/>");
         xyz.append("&nbsp;&nbsp;&nbsp;");  
         xyz.append("<input type=\"text\" name=\"")
          .append(fieldName)
          .append("x\"");
         if (l>=0) xyz.append(" value=\"")
          .append(myValue.substring(l+3))
          .append("\"");
         xyz.append(" size=\"40\" maxlength=\"200\"")
          .append(getFieldBackgr(fieldName,styl))
          .append("/>");
   	   } else {  //other types
       xyz.append("<input type=\"text\" name=\"")
          .append(fieldName)
          .append("\"");
       if (myValue != null) xyz.append(" value=\"")
                             .append(myValue)
                             .append("\"");
       xyz.append(" size=\"30\" maxlength=\"200\"")
          .append(getFieldBackgr(fieldName,styl))
          .append("/>");
     }
     String icon = AssayTypeName.getIconName(baseType);
     String title = paramType.getPopupName();
     if (title==null||title.equals(""))title = paramType.getVisibleName();
     if (!icon.equals(""))
       xyz.append("<img border=\"0\" src=\"./images/")
          .append( icon)
          .append("a.gif\" onmouseover=\"this.src='./images/")
          .append( icon)
          .append("b.gif'\" onmouseout=\"this.src='./images/")
          .append( icon)
          .append("a.gif'\" title=\"")
          .append(title)
          .append("\" alt=\"\">");
     if (param.isRequired())
       xyz.append("<img border=\"0\" src=\"./images/star_a.gif\"")
           .append(" onmouseover=\"this.src='./images/star_b.gif'\"")
           .append(" onmouseout=\"this.src='./images/star_a.gif'\"")
           .append(" title=\"mandatory value\" alt=\"\">");
     if (forGroup){
       String columnName = param.getStgrColumnName();
       if (columnName != null && !columnName.equals("")) {
         columnName = param.getAssayColumnName();
         if (columnName != null && !columnName.equals(""))
           xyz.append("<img border=\"0\" src=\"./images/arrow_a.gif\"")
               .append(" onmouseover=\"this.src='./images/arrow_b.gif'\"")
               .append(" onmouseout=\"this.src='./images/arrow_a.gif'\"")
               .append(" title=\"default for assays\" alt=\"\">");
       }
     }
     String note = param.getNoteToDisplay();
     if (note!=null&&note.length()>0)
    	 xyz.append(" <font size=2 color=green>")
    	    .append(note)
    	    .append("</font>");
     return xyz.toString();
   }

// rights: A.. all edit; G.. edit group O.. edit own V.. view only
/*
  public boolean canAddObject( AssayUser creator) {
    if (currentUser != null)
       switch (currentUser.getRights().charAt(0)){
           case 'A' : return true;
           case 'O' : if (creator == null ||
            creator.getId().equals(currentUser.getId())) return true;
                      break;
           case 'G' : if (creator == null || currentPartner == null ||
           (creator.getPartner() != null &&
            creator.getPartner().getId().equals( currentPartner))) return true;
                      break;
       }
       return false;
  }

  public boolean canEditObject( AssayUser creator) {
    if (currentUser != null)
      switch (currentUser.getRights().charAt(0)){
          case 'A' : return true;
          case 'O' : if (creator == null ||
           creator.getId().equals(currentUser.getId())) return true;
                     break;
          case 'G' : if (creator == null || currentPartner == null ||
          (creator.getPartner() != null &&
           creator.getPartner().getId().equals( currentPartner))) return true;
                     break;
      }
      return false;
  }

  public boolean canDeleteObject( AssayUser creator) {
    if (currentUser != null)
       switch (currentUser.getRights().charAt(0)){
           case 'A' : return true;
           case 'O' : if (creator == null ||
            creator.getId().equals(currentUser.getId())) return true;
                      break;
           case 'G' : if (creator == null || currentPartner == null ||
           (creator.getPartner() != null &&
            creator.getPartner().getId().equals( currentPartner))) return true;
                      break;
       }
       return false;
   }
*/
  public void clearInvalidField() {
    invalidFields = null;
  }

  private void clearInvalidFields() {
    invalidFields = null;
  }

  private boolean isInvalidField() {
    return invalidFields != null;
  }

  private void setInvalidFields(String fieldName, int rezult) {
    if (invalidFields == null) invalidFields = new HashMap<String,Integer>();
    invalidFields.put(fieldName, new Integer(rezult));
  }
/*
  public boolean errorField(String fieldName) {
    if (invalidFields == null) return false;
    Integer rezult = (Integer)invalidFields.get(fieldName);
    if (rezult==null)return false;
    return true;
  }

  public String getFieldId(String fieldName) {
    if (invalidFields == null) return "";
    Integer rezult = (Integer)invalidFields.get(fieldName);
    if (rezult==null)return "";
    return " id=\"kluda\" title=\""
            +getMyMessage(rezult.intValue())
            +"\"";
  }
*/
  public String getFieldBackgr(String fieldName, int styl) {
    if (invalidFields != null){
      Integer rezult = (Integer)invalidFields.get(fieldName);
      if (rezult != null)
        return " id=\"kluda\" title=\""
                +getMyMessage(rezult.intValue())
                +"\"";
    }
    String myBackgr = (styl<1)?" style=\"background-color:#FFFFFF;\"":
      (styl<2)?" disabled style=\"background-color:#FFFFFF;\"":
      (styl<3)?" disabled style=\"background-color:#E5EAF0;\"":
               " style=\"background-color:#F0C0C0;\"";
    return myBackgr;
  }
//----------------------------------------------------------//
//----------------------------------------------------------//
    public File newProtocolTempFile(){ //used by RequestParser
       protocolTempFile = new File( protTechnDirectory, httpSessId);
       return protocolTempFile;
    }
    public File newDataTempFile(){ //used by RequestParser
       dataTempFile = new File( dataTechnDirectory, httpSessId);
       return dataTempFile;
    }
    public File newParameterTempFile(){ //used by RequestParser
       parameterTempFile = new File( WebappConfig.getWorkDirectory(), httpSessId+".par");
       return parameterTempFile;
    }
    public File newXMLTempFile(){ //used by RequestTechnology
       XMLTempFile = new File( WebappConfig.getWorkDirectory(), httpSessId+".xml");
       return XMLTempFile;
    }
    public File newZipTempFile(){ //used by RequestParser
       zipTempFile = new File( WebappConfig.getWorkDirectory(), httpSessId+".zip");
       return zipTempFile;
    }
    public File newExportcfgTempFile(){ //used by RequestParser
    	exportcfgTempFile = new File( WebappConfig.getWorkDirectory(), httpSessId+".cfg");
        return exportcfgTempFile;
     }
    public File getParameterTempFile(){ //used by BatchAnalyser
       return parameterTempFile;
    }
    public File getXMLTempFile(){
       return XMLTempFile;
    }
    public File getZipTempFile(){ //used by BatchAnalyser
       return zipTempFile;
    }
    public File getExportcfgTempFile(){ //used by BatchAnalyser
       return exportcfgTempFile;
   }

    public File getProtTechnDirectory(){ //used by ExportFile,BatchAnalyser
       return protTechnDirectory;
    }
    public File getDataTechnDirectory(){ //used by ExportFile,BatchAnalyser
       return dataTechnDirectory;
    }

  private void renameTempFile( Long id){//used by addassay etc.
     File permFile; String fileName; String knd;
     knd = protocolFileString.getKindOfFile();
     if (knd!=null){
       fileName = protocolFileString.getFileName(id);
       if (knd.equals("u")){  //uploaded protocol file
         if (protocolTempFile != null) {
           if (fileName != null) {
             permFile = new File(protTechnDirectory, fileName);
             permFile.delete();
             protocolTempFile.renameTo(permFile);
           }
           else
             protocolTempFile.delete();
           protocolTempFile = null;
         }
       } else
       if (knd.equals("f")){  // not implemented
         if (fileName != null) {
           permFile = new File(protTechnDirectory, fileName);
           permFile.delete();
           File ftpFile = new File( WebappConfig.getFtpDirectory(),
//                getUserFtpDirectory()+File.separatorChar+
//                getTechnologyFtpDirectory()+File.separatorChar+
              protocolFileString.getUserFilePath());
//             ftpFile.renameTo(permFile);
           Util.copyFile( ftpFile, permFile);
         }
       }
     }  
     knd = dataFileString.getKindOfFile();
     if (knd!=null){
       fileName = dataFileString.getFileName(id);
       if (knd.equals("u")){    //uploaded data file
         if (dataTempFile != null) {
           if (fileName != null) {
             permFile = new File(dataTechnDirectory, fileName);
             permFile.delete();
             dataTempFile.renameTo(permFile);
           }
           else
             dataTempFile.delete();
           dataTempFile = null;
         }
       } else                  // ftp data file
       if (knd.equals("f")){
         if (fileName != null) {
           permFile = new File(dataTechnDirectory, fileName);
           permFile.delete();
           File ftpFile = new File( WebappConfig.getFtpDirectory(),
//                getUserFtpDirectory()+File.separatorChar+
//                getTechnologyFtpDirectory()+File.separatorChar+
              dataFileString.getUserFilePath());
//             ftpFile.renameTo(permFile);
           Util.copyFile( ftpFile, permFile);
         }
       }
     }
   }  

  private void deleteProtocolFile( String[] names){
    if (names!=null)	
      for ( int k=0; k < names.length; k++){
//          Util.writeLog("delete protocol",":",names[k]);
        File permFile = new File(protTechnDirectory, names[k]);
        permFile.delete();
      }
  }

  private void deleteDataFile( String[] names){
    if (names!=null)	
      for ( int k=0; k < names.length; k++){
//          Util.writeLog("delete data",":",names[k]);
        File permFile = new File(dataTechnDirectory, names[k]);
        permFile.delete();
      }
  }
    public void newProtocolFileString( int level, String fileString, Long sysId)
        throws Exception {
         protocolFileString = new FileString( level, false, fileString, sysId);
         protocolFileString.setTypeBook( getAllObjectsForTechnology(ProtocolType.class));
    }
    public void newDataFileString( int level, String fileString, Long sysId)
        throws Exception {
         dataFileString = new FileString( level, true, fileString, sysId);
         dataFileString.setTypeBook( getAllObjectsForTechnology(DataType.class));
    }

   public FileString getProtocolFileString() throws Exception {
     if (protocolFileString==null)
         throw new Exception( UserHttpSession.getMyMessage(12));
     return protocolFileString;
   }
   public FileString getDataFileString() throws Exception {
     if (dataFileString==null)
         throw new Exception( UserHttpSession.getMyMessage(12));
     return dataFileString;
   }
   public void resetTransactionObjects(){
        additionalSimsRef = null; //clearAdditionalAliquots();
        ban = null;
        protocolFileString = null;
        dataFileString = null;
        if (protocolTempFile!=null){
            protocolTempFile.delete();
            protocolTempFile = null;
        }
        if (dataTempFile!=null){
            dataTempFile.delete();
            dataTempFile = null;
        }
        if (parameterTempFile!=null){
            parameterTempFile.delete();
            parameterTempFile = null;
        }
        if (XMLTempFile!=null){
            XMLTempFile.delete();
            XMLTempFile = null;
        }
        if (zipTempFile!=null){
            zipTempFile.delete();
            zipTempFile = null;
        }
        if (exportcfgTempFile!=null){
        	exportcfgTempFile.delete();
        	exportcfgTempFile = null;
        }
   }

   public void clearFileStrings() throws Exception {
        getProtocolFileString().clearFileString();
        getDataFileString().clearFileString();
        if (protocolTempFile!=null){
            protocolTempFile.delete();
            protocolTempFile = null;
        }
        if (dataTempFile!=null){
            dataTempFile.delete();
            dataTempFile = null;
        }
   }

   public BatchAnalyser newBatchAnalyser( int level){
     ban = new BatchAnalyser( this, level);
     return ban;
   }

   public BatchAnalyser getBatchAnalyser() throws Exception {
     if (ban==null)
         throw new Exception( UserHttpSession.getMyMessage(12));
     return ban;
   }

//-----------------------Ftp used by BatchAnalyser and elsewhere--
   public boolean isFtp(){
      return (currentUser==null)?false:
          WebappConfig.isFtp() && currentUser.isFtpAllowed();
   }
   public boolean isAdminSession(){
     return (currentUser!=null &&
             currentUser.isAdministrator());
   }
   public boolean isWriteAdminSession(){
     return (currentUser!=null &&
             currentUser.isWriteAdministrator());
   }
   public boolean isPowerAdminSession(){
     return (currentUser!=null &&
             currentUser.isPowerAdministrator());
   }
   public boolean withViews(){
     return (currentTechnology!=null &&
         currentTechnology.showViewLevels());
   }
   public String getUserFtpDirectory(){
     return (currentUser==null)?"":currentUser.getFtpDirectory();
   }
   public String getTechnologyFtpDirectory(){
     return (currentTechnology==null)?"":currentTechnology.getVisibleFtpDirectory();
   }
   public String getTechnologyName(){
     return (currentTechnology==null)?"":currentTechnology.getVisibleName();
   }
//----------------------------------------------------------//
   public boolean repair20090704() throws Exception {
       Transaction tx = null;
       try {
         tx = hibSess.beginTransaction();
           List list = getAllObjects(CommonParameter.class);
           Iterator cpIterator = list.iterator();
           while (cpIterator.hasNext()) {
        	 CommonParameter cp = (CommonParameter) cpIterator.next();
             boolean flag = false;
        	 String colname = cp.getAssayColumnName();
	             if (colname.equals("aliquotId")){ flag = true;
	            	 cp.setAssayColumnName("simsRefId");}
	             colname = cp.getStgrColumnName();
	             if (colname.equals("aliquotId")){ flag = true;
	            	 cp.setStgrColumnName("simsRefId");}
	             colname = cp.getViewColumnName();
	             if (colname.equals("aliquotId")){ flag = true;
	            	 cp.setViewColumnName("simsRefId");}
	             if (flag)  hibSess.update(cp);
	             }
	             tx.commit();
	           } catch (Exception e) {
	               if (tx!=null) tx.rollback();
	               throw e;
	           }
	           finally {
	               hibSess.close(); //needs before forward
	           }
	           return true;
	       }
//	   ----------------------------------------------------------//
   public boolean repair20070215() throws Exception {
/*
       Query q = null;
       Transaction tx = null;
       try {
//           hibSess = hibFactory.openSession();
         tx = hibSess.beginTransaction();
         q = hibSess.createQuery(
                 "select myAssay from Assay as myAssay");
         List assays = q.list();
         Iterator assayIterator = assays.iterator();
         while (assayIterator.hasNext()) {
           Assay assay = (Assay) assayIterator.next();
           String pf = assay.getProtocolFiles();
           if ( pf != null && !pf.equals("")) {
             assay.setProtocolFiles("");
             Long gp = assay.getPending();
             if (gp!=null) {
               pf = assay.getDataFiles();
               if ( pf != null && !pf.equals("")) {
                 if (gp.intValue() > 1) assay.setPending(new Long(1));
               }
               else
               if (gp.intValue() > 0) assay.setPending(new Long(0));
             }
             hibSess.update(assay);
           }
         }
         q = hibSess.createQuery(
                 "select mypt from PendingTask as mypt");
         List ptasks = q.list();
         Iterator ptaskIterator = ptasks.iterator();
         while (ptaskIterator.hasNext()) {
           PendingTask ptask = (PendingTask) ptaskIterator.next();
           String toFile = ptask.getToFile();
           if (toFile.endsWith(".pro")){
                 hibSess.delete(ptask);
             }
           }
         tx.commit();
       } catch (Exception e) {
           if (tx!=null) tx.rollback();
           throw e;
       }
       finally {
           hibSess.close(); //needs before forward
       }
*/
       return true;
   }

   public ViewBatchManager getViewBatchManager(){
     return batchMan;
   }
   public ViewAssayManager getViewAssayManager(){
     return vam;
   }
   public ViewGroupManager getViewGroupManager(){
     return vgm;
   }
   public ViewViewManager getViewViewManager(){
     return vvm;
   }

  private void jbInit() throws Exception {
//this one never called
    vam = new ViewAssayManager( this);
    vgm = new ViewGroupManager( this);
    vvm = new ViewViewManager( this);
  }
//----------------------------------------------------------//
//----------------------------------------------------------//
  /*Divas jaunas metodes Natalijai */
     public Session getAssaySess(){
       openHibSession();
       return hibSess;
     }

     public Session getSampleSess(){
       openSampleSession();
       return sampleSess;
     }
     public String getRealPath(String virtualPath){
       ServletContext sc = httpSess.getServletContext();
       return sc.getRealPath( virtualPath);
     }
//----------------------------------------------------------//
//----------------------------------------------------------//
    public StatelessSession openStatelessSession(){
      return WebappConfig.getAssaySessionFactory().openStatelessSession();
    }
}
