package assays.com;
import java.util.*;
import sims.hibernate.MetaData;
import sims.hibernate.VocabulName;

public final class AliquotMetadataManager {
    private static HashMap<String,String> aliquotData = null;
    private static HashMap<String,String> sampleData = null;
    private static HashMap<String,String> personData = null;

    private static String topName;
    private static String middleName;
    private static String bottomName;

    public static void buildAliquotData( List aliquotMD){
      bottomName = VocabulName.getBottomSingular();
      aliquotData = new HashMap<String,String>(aliquotMD.size());
      Iterator iter = aliquotMD.iterator();
      while (iter.hasNext()) {
          MetaData metadata = (MetaData) iter.next();
          String key = metadata.getVisibleName();
          aliquotData.put( key, new String(metadata.getShortName()));
      }
    }

    public static void buildSampleData( List sampleMD){
      middleName = VocabulName.getMiddleSingular();
      sampleData = new HashMap<String,String>(sampleMD.size());
      Iterator iter = sampleMD.iterator();
      while (iter.hasNext()) {
          MetaData metadata = (MetaData) iter.next();
          String key = metadata.getVisibleName();
          sampleData.put( key, new String(metadata.getShortName()));
      }
    }

    public static void buildPersonData( List personMD){
      topName = VocabulName.getTopSingular();
      personData = new HashMap<String,String>(personMD.size());
      Iterator iter = personMD.iterator();
      while (iter.hasNext()) {
          MetaData metadata = (MetaData) iter.next();
          String key = metadata.getVisibleName();
          personData.put( key, new String(metadata.getShortName()));
      }
    }
    public static String getBottomShortName( String key){
        String shortName = (String)aliquotData.get(key);
        return (shortName!=null)?shortName:key;
    }
    public static String getMiddleShortName( String key){
        String shortName = (String)sampleData.get(key);
        return (shortName!=null)?shortName:key;
    }
    public static String getTopShortName( String key){
        String shortName = (String)personData.get(key);
        return (shortName!=null)?shortName:key;
    }
    public static String getTopSingular(){
        return topName;
    }
    public static String getMiddleSingular(){
        return middleName;
    }
    public static String getBottomSingular(){
        return bottomName;
    }
    public static String getTopPlural(){
        return VocabulName.getTopPlural();
    }
    public static String getMiddlePlural(){
        return VocabulName.getMiddlePlural();
    }
    public static String getBottomPlural(){
        return VocabulName.getBottomPlural();
    }
    public static boolean hasTopField(String key){
        return personData.containsKey(key);
    }
    public static boolean hasMiddleField(String key){
        return sampleData.containsKey(key);
    }
    public static boolean hasBottomField(String key){
        return aliquotData.containsKey(key);
    }

}
