package assays.com;

import java.io.FileInputStream;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;
import java.io.StringWriter;

import assays.hibernate.*;

import java.lang.reflect.*;
import java.util.HashSet;
import java.util.Date;
import assays.pri.WebappConfig;

/**
 *
 * <p>Title: </p>
 *
 * <p>Description:klasi lieto batch upload operacijas,
 *  lai nolasitu un izanalizetu tab-delimited data
 *    AddTopBatchUpload.jsp,AddMiddleBatchUpload.jsp,AddBottomBatchUpload.jsp,
 * </p>
 *
 * <p>Copyright: Copyright (c) 2008</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public final class BatchAnalyser implements Iterator{
  private UserHttpSession session;
  private FileInputStream fis = null;
  private int head = 0;
  private int tail = 0;
  private int bufSize = 16334;//49202;//65536;//32768;
  private byte buffer[] = new byte[bufSize];
  private boolean eol = false;
  private boolean eof = false;
  private boolean isError = false;
  private boolean isHeaderError = true;
  private boolean isZipError = false;
  private boolean isFtpFile = false;
  private boolean isFtpDirec = false;
  private boolean underFix = false;
  private boolean underView = false;
  private String missingFieldName = null;
  private int level;
  private int topNum;
  private int maxcolumncount = 128;
  private int maxcolumncount05 = 64;
  private int simsCollectNum=-1;
  private int simsBottomNum=-1;
  private int simsMiddleNum=-1;
  private int simsTopNum=-1;
/*
  private static final String[] myParam = {
    "ALIQUOT",
    "NAME",
    "COMMENT",
    "DATA FILE",
    "PROTOCOL FILE"
  };

  private static final int[] myParamValue = {9,0,1,7,6};
*/
  private static final String[] errorMessage = {
      "ALIQUOT",                      //0
      "Parameter file read error",
      "Unknown keyword in header",
      "Unknown file type",
      "Invalid structure of header",
      "Missing field",                //5
      "Too many fields",
      "Duplicate ID",
      "Zip file not uploaded",
      "File not in zip",
      "Invalid SIMS reference",            //10
      "Duplicate id in data base",
      "Unzip error",
      "Invalid value",
      "Sorry, unsupported type",
      "File not in directory",         //15
      "Mandatory value missing",
      "Mandatory keyword missing:",
      "File used repeatedly",          //18 24.OKT.2007
      "Object doesn't exist",
      "Missing top id",                //20
      "Missing middle id",
      "Missing bottom id",
      "Unused field",
      "Duplicate file type",
      "Insufficient user rights",       //25
      "Insufficient user rights for file read"      
  };
  private int startNum = 5; //0-th 'DUPL'
  							//1-st position for top
  							//2-nd position for middle
  							//3-rd position for owner rights
  							//4-th position for sims ref
  private int sizeNum = startNum;
  private TempMetaData[] paramArray;
  private List<String[]> recordList = null;
  private List<byte[]> errorList = null;
  private Iterator recordIterator;
  private Iterator errorIterator;
  private byte[] headerError;
  private String[] headerRecord;
  private String[] myNextRecord;
  private int viewNum = 0;
  private int studyNum = 0;
  private int assayNum = 0;
  private int dataFileNum = 0;   //number of data files
  private int dataFileNum1;      //number of data files
  private String[] dataFileNames;
  private int protocolFileNum = 0;   //number of data files
  private int protocolFileNum1;      //number of data files
  private String[] protocolFileNames;
  private int[] fileToTypeKey;
  private String dataType = "0";
  private String protocolType = "0";
  private int generIds = 0;
  private int unrecIds = 0;
  private int duplicIds = 0;
  private File ftpFile = null;
  private File ftpDirec = null;
  private String topId = null;
  private String middleId = null;
  private StudyView topEl = null;
  private StudyGroup middleEl = null;
  private int generNum = 0;

  public BatchAnalyser( UserHttpSession tmpHttpSessObj, int level) {
// level: 0=top; 1=middle; 2=bottom;
    session = tmpHttpSessObj;
    this.level = level;
    topNum = session.getTopNum();
  }
//--------------- my lexer -----------------------------------------
  private int readByte() throws IOException{
      if (head >= tail){
          head = 0;
          tail = fis.read(buffer, head, bufSize);
          if (tail < 1) return -1;
      }
      return buffer[head++];
  }

  private String getLexem()throws IOException{
    StringWriter sw = new StringWriter(100);
    int b = readByte();
    while (b > 0){
      if (b == '\t') break;
      if (b == '\r' || b == '\n'){ eol = true; break;}
      sw.write(b);
      b = readByte();
    }
    if (b < 0) {eol = true; eof = true;}
    return sw.toString();
  }

  private void getStartOfLine() throws IOException{
    int b = '\r';
     while (b == '\r' || b == '\n') b = readByte();
    if (b < 0) {eof = true; eol = true;}
    else {eol = false; head--;}
  }

  private void flashLine()throws IOException{
    int b = 1;
    while (b > 0){
      if (b == '\r' || b == '\n') break;
      b = readByte();
    }
    eol = true;
    if ( b <= 0 ) eof = true;
  }
  private String findKey( String pName){
	int j = pName.indexOf('#');
	String key = (j < 3) ? "" : pName.substring(j);
	return key;
  }
  private int addTypeKey( String key, String[] keys, int keyCount){
    for (int i = 0; i < keyCount; i++){
      if (key.equals(keys[i])) return i;
    }
    keys[ keyCount] = key; return keyCount;
  }
 
//---------------------------------------------------------
  /**
   * noolasa un parbauda batch upload header
   * @throws Exception
   */
  public void startOfAnalysis() throws Exception {    //get header
    File paramFile = session.getParameterTempFile();
    headerError = new byte[maxcolumncount];     //maxcolumncount = 128
    headerRecord = new String[maxcolumncount];
    paramArray = new TempMetaData[maxcolumncount];

    String[] dataTypeKey = new String[maxcolumncount05];
    String[] protTypeKey = new String[maxcolumncount05];
    fileToTypeKey = new int[maxcolumncount];
    for (int k = 0; k < maxcolumncount; k++) fileToTypeKey[k] = -1;
    int[] keyToDataType = new int[maxcolumncount05];
    for (int k = 0; k < maxcolumncount05; k++) keyToDataType[k] = -1;
    int[] keyToProtType = new int[maxcolumncount05];
    for (int k = 0; k < maxcolumncount05; k++) keyToProtType[k] = -1;
    int dataTypeKeyCount = 0;
    int protTypeKeyCount = 0;
    int wNum;

    MetadataManager mdm = session.getMetadataManager();
    mdm.clearTempColumnNumber( level);
    for (int i = 0; i < maxcolumncount; i++) headerError [i] = 0;
    if (paramFile==null){
      headerError[sizeNum] = 1;
      isError = true;
      return;
    }
    try{
      fis = new FileInputStream(paramFile);
      getStartOfLine();
      while (!eol){
        TempMetaData tmd = null;
        String lex = getLexem();
        headerRecord[sizeNum] = lex;
        int myLevel = -1; 
        int k = lex.indexOf('.');
        if (k > 0) {  //test prefix
          String prefix = lex.substring(0, k + 1).trim();
          if (prefix.equals( MetadataManager.getTopPrefix( topNum))){
            myLevel = 0;
          } else
          if (prefix.equals( MetadataManager.getMiddlePrefix())){
            myLevel = 1;
          } else
          if (prefix.equals( MetadataManager.getBottomPrefix())){
            myLevel = 2;
          }
          if ( myLevel >= 0) {
            lex = lex.substring(k + 1);  //group name.upload name
            k = lex.indexOf('.');
          }
        }
        lex = lex.trim();
        if (myLevel<0) myLevel = level;
        if (k > 0) {  //test group
          if (myLevel==level){
            String gName = lex.substring(0, k).trim();
            String pName = lex.substring(k + 1).trim();
            tmd = mdm.findParameter(level, gName, pName);
          }
        }
        else {       //common pasrameter
          tmd = mdm.findParameter( level, lex);
          if (tmd!=null && level==myLevel){
            int num = tmd.getValueNumber();
            switch( num){
              case AssayFieldname.SIMSCOLLECTIONnum:
                simsCollectNum = sizeNum; break;
              case AssayFieldname.SIMSBOTTOMnum:
                  simsBottomNum = sizeNum; break;
              case AssayFieldname.SIMSMIDDLEnum:
                  simsMiddleNum = sizeNum; break;
              case AssayFieldname.SIMSTOPnum:
                  simsTopNum = sizeNum; break;
              case AssayFieldname.DATAFILESnum: dataFileNum++;
                wNum = addTypeKey( findKey(lex), dataTypeKey, dataTypeKeyCount);
                if (wNum==dataTypeKeyCount) dataTypeKeyCount++;
                fileToTypeKey[ sizeNum] = wNum;
                if (isFtpDirec && !ftpDirec.canRead()){
                  isError = true; headerError[sizeNum] = 26;
                }
                if (isFtpFile && !ftpFile.canRead()){
                  isError = true; headerError[sizeNum] = 26;
                }
                break;
              case AssayFieldname.PROTOCOLnum: protocolFileNum++;
                wNum = addTypeKey( findKey(lex), protTypeKey, protTypeKeyCount);
                if (wNum==protTypeKeyCount) protTypeKeyCount++;
                fileToTypeKey[ sizeNum] = wNum;
                if (isFtpDirec && !ftpDirec.canRead()){
                  isError = true; headerError[sizeNum] = 26;
                }
                if (isFtpFile && !ftpFile.canRead()){
                  isError = true; headerError[sizeNum] = 26;
                }
                break;
              case AssayFieldname.DATAFILESTYPEnum:
                wNum = addTypeKey( findKey(lex), dataTypeKey, dataTypeKeyCount);
                if (wNum==dataTypeKeyCount) dataTypeKeyCount++;
                if (keyToDataType[ wNum]!=-1){isError = true; headerError[sizeNum] = 24;}
                else
                keyToDataType[ wNum] = sizeNum;
                break;
              case AssayFieldname.PROTOCOLTYPEnum:
                wNum = addTypeKey( findKey(lex), protTypeKey, protTypeKeyCount);
                if (wNum==protTypeKeyCount) protTypeKeyCount++;
                if (keyToProtType[ wNum]!=-1){isError = true; headerError[sizeNum] = 24;}
                else
                keyToProtType[ wNum] = sizeNum;
                break;
              }
           }           
        }
        if (tmd!=null){
          tmd.setTempColumnNumber(sizeNum);
          int num = tmd.getValueNumber();
          if (num==AssayFieldname.IDENTIFSTRINGnum){
            if (myLevel==0) viewNum = sizeNum;
            if (myLevel==1) studyNum = sizeNum;
            if (myLevel==2) assayNum = sizeNum;
        	if (generIds > 0) headerError[sizeNum] = 123;
          }	else {
        	if (myLevel!=level){  
              tmd = null;
              if (unrecIds==0) {isError = true; headerError[sizeNum] = 2;}
              else headerError[sizeNum] = 102;
        	}  
          }
          paramArray[sizeNum] = tmd;
        } else {  //tmd==null
           if (unrecIds==0) {isError = true; headerError[sizeNum] = 2;}
           else headerError[sizeNum] = 102;
        }
        if (++sizeNum==(maxcolumncount-1)) break;
      }
    } catch ( Exception ex ){
//      headerError[sizeNum] = 1;
      throw ex;
    }

    for (int k = startNum; k <= sizeNum; k++){
      TempMetaData param = paramArray[k];
      if (param!=null){
        int num = param.getValueNumber();
        if (num==AssayFieldname.DATAFILESnum){
          int j = fileToTypeKey[ k];
          int l = keyToDataType[ j];
          fileToTypeKey[ k] = l;  //may be -1
          if (l>=0) fileToTypeKey[ l] = 1;  
        } else
        if (num==AssayFieldname.PROTOCOLnum){
          int j = fileToTypeKey[ k];
          int l = keyToProtType[ j];
          fileToTypeKey[ k] = l;  //may be -1
          if (l>=0) fileToTypeKey[ l] = 1; 
        }
      }
    }
    for (int k = startNum; k <= sizeNum; k++){
        TempMetaData param = paramArray[k];
        if (param!=null){
          int num = param.getValueNumber();
          if (num==AssayFieldname.DATAFILESTYPEnum){
            int j = fileToTypeKey[ k];
            if (j < 0) headerError[k] = 123;
          } else
          if (num==AssayFieldname.PROTOCOLTYPEnum){
            int j = fileToTypeKey[ k];
            if (j < 0) headerError[k] = 123;
          }
        }
      }
    
    // test some errors
    if (simsCollectNum>=0){
      if (simsBottomNum<0&&simsMiddleNum<0&&simsTopNum<0)
    	{headerError[simsCollectNum] = 10; isError = true;}
    } else {
      if (simsBottomNum>=0){headerError[simsBottomNum] = 10; isError = true;}
      if (simsMiddleNum>=0){headerError[simsMiddleNum] = 10; isError = true;}
      if (simsTopNum>=0){headerError[simsTopNum] = 10; isError = true;}
    }
    if (underFix && level==1 && topEl==null){headerError[sizeNum] = 20; isError = true;}
    if (underFix && level==2 && middleEl==null){headerError[sizeNum] = 21; isError = true;}
    if (generIds==0){
      if (level==0){	
        if (viewNum==0) headerError[ sizeNum] = 20;	
        if (studyNum!=0) headerError[studyNum] = 123;	
        if (assayNum!=0) headerError[assayNum] = 123;	
      }
      else
      if (level==1){
    	if (underFix){
    	  if (viewNum!=0)headerError[viewNum] = 123;
    	} /*else {
       	  if (viewNum==0)headerError[sizeNum] = 20;
    	}*/  
        if (studyNum==0) headerError[ sizeNum] = 21;	
        if (assayNum!=0) headerError[assayNum] = 123;
      }
      else
      if (level==2){
    	if ( viewNum!=0)headerError[viewNum] = 123;
      	if (underFix){
      	  if ( studyNum!=0)headerError[studyNum] = 123;
      	} else {
          if ( studyNum==0)headerError[sizeNum] = 21;
      	}    	  
        if (assayNum==0) headerError[sizeNum] = 22;
      }
    }
    if (sizeNum==(maxcolumncount-1)) headerError[sizeNum] = 4;
    missingFieldName = mdm.checkRequiredParameter( level);
    if (missingFieldName!=null) headerError[sizeNum] = 17;
    if (headerError[sizeNum] > 0) isError = true;
    isHeaderError = isError;
  }
  /**
   *  nolasa un parbauda batch upload datus
   *
   */
  public void endOfAnalysis()throws Exception { //test all rows
    boolean simsOpen = false;
    HashSet<String> fileNames = new HashSet<String>();
    String[]filex = null;
    int iFilex;
    File zipFile = (isFtpDirec)?null:(isFtpFile)?ftpFile:session.getZipTempFile();
    ZipProcessor zipProc = null;
    recordList = new ArrayList<String[]>();
    errorList = new ArrayList<byte[]>();
    if (fis==null) return;
    if (dataFileNum > 0 || protocolFileNum > 0){
      filex = new String[dataFileNum+protocolFileNum];	
      if (zipFile!=null) zipProc = new ZipProcessor( zipFile);
    }
    try{
      getStartOfLine();
      while (!eof){
        String[] myRecord = new String[sizeNum];
        myRecord[0]=""; myRecord[1]=topId;  myRecord[2]=middleId;
        myRecord[3]="0";  myRecord[4]="";
        byte[] myError = new byte[sizeNum + 1];
        iFilex = 0;
        for (int k = 0; k <= sizeNum; k++) myError[k] = 0;
        for (int k = startNum; k < sizeNum; k++){
          if (eol) {//to few
            myError[k] = 5; isError = true;
            myRecord[k] = "error";
          } else {
            String lex = getLexem().trim();
            if (k==viewNum){
            	if (topEl!=null||level==2) myError[viewNum] = 123;
            } else
            if (k==studyNum){
            	if (middleEl!=null||level==0) myError[studyNum] = 123;
            } else
            if (k==assayNum){
            	if (level < 2)myError[assayNum] = 123;
            } else {	
              String alex;
              TempMetaData param = paramArray[k];
              if (param == null) { //unknown keyword
                if (unrecIds==0) {isError = true; myError[k] = 2;}
                else myError[k] = 102;
              }
              else {
                int num = param.getValueNumber();
//                Util.writeLog("endOfAnalysisRownum",
//                          lex,
//                          String.valueOf(num));
                switch (num) {
                case AssayFieldname.PROTOCOLTYPEnum: //protfile type
                    if (lex.equals(""))break; //empty value valid for all types
                    ProtocolType obj1 = (ProtocolType)session.
                         getObjectByNameForCurrentTechnology(ProtocolType.class, lex);
                    if (obj1 == null){
                      myError[k] = 3;
                      isError = true; //
                    } else
                     lex = lex + '\r' + String.valueOf(obj1.getId());
                    break;
                case AssayFieldname.DATAFILESTYPEnum: //data file type
                    if (lex.equals(""))break; //empty value valid for all types
                    DataType obj2 = (DataType)session.
                         getObjectByNameForCurrentTechnology(DataType.class, lex);
                    if (obj2 == null){
                      myError[k] = 3;
                      isError = true; //
                    } else
                     lex = lex + '\r' + String.valueOf(obj2.getId());
                    break;
                case AssayFieldname.DATAFILESnum: //data file
                    if (lex.equals(""))break; //empty value valid for all types
                    if (fileNames.contains(lex)) {
                      myError[k] = 18; //repeated use
                      isError = true; //
                      break;
                    }
                    for (int i = 0; i < iFilex; i++)
                      if (lex.equals(filex[i])){	
                        myError[k] = 18; //repeated use
                        isError = true; //
                        break;
                      }
                    filex[iFilex++]=lex;
//                    fileNames.add(lex);
                    if (isFtpDirec) {
                      File tfile = new File(ftpDirec, lex);
                      if (!tfile.exists()) {
                        myError[k] = 15;
                        isError = true; //
                      } else
                      if (!tfile.canRead()) {
                        myError[k] = 26;
                        isError = true; //
                      }
                    }
                    else
                    if (zipProc == null) {
                      isZipError = true;
                    }
                    else { //zip file (local or ftp)
                      Integer zipNum = zipProc.existsFile(lex);
                      if (zipNum == null) {
                        myError[k] = 9;
                        isError = true; //
                      }
                      else
                      if (isFtpFile) lex = lex + '\r' + zipNum.toString();
                    }
                    break;   //data file
                case AssayFieldname.PROTOCOLnum: //protocol file
                    if (lex.equals(""))break; //empty value valid for all types
                    if (fileNames.contains(lex)) {
                      myError[k] = 18; //repeated use
                      isError = true; //
                      break;
                    }
                    for (int i = 0; i < iFilex; i++)
                        if (lex.equals(filex[i])){	
                          myError[k] = 18; //repeated use
                          isError = true; //
                          break;
                        }
                    filex[iFilex++]=lex;
//                    fileNames.add(lex);
                    if (isFtpDirec) {
                      File tfile = new File(ftpDirec, lex);
                      if (!tfile.exists()) {
                        myError[k] = 15;
                        isError = true; //
                      } else
                      if (!tfile.canRead()) {
                        myError[k] = 26;
                        isError = true; //
                      }
                    }
                    else
                    if (zipProc == null) {
                      isZipError = true;
                    }
                    else { //zip file (local or ftp)
                      Integer zipNum = zipProc.existsFile(lex);
                      if (zipNum == null) {
                        myError[k] = 9;
                        isError = true; //
                      }
                      else
                      if (isFtpFile) lex = lex + '\r' + zipNum.toString();
                    }
                    break;   //protocol file
                      
                default:   //all other
                    if (lex.equals("")) {
                      if (param.isRequired()) {
                        myError[k] = 16;
                        isError = true;
                      }
                      break;
                    } //empty value valid for all types
                    if (num > AssayTypeName.COMMON_PARAM_COUNT) { //Fxxx
                      int baseType = param.getBaseType();
                      if (baseType == AssayTypeName.NUMBER) {
                        if (!Util.checkIntegerValue(lex)) {
                          myError[k] = 13;
                          isError = true;
                        }
                      }

                      else if (baseType == AssayTypeName.FLOAT) {
                        if (!Util.checkFloatValue(lex)) {
                          myError[k] = 13;
                          isError = true;
                        }
                      }
                      else if (baseType == AssayTypeName.BOOLEAN) {
                        if (!Util.checkBooleanValue(lex)) {
                          myError[k] = 13;
                          isError = true;
                        }
                      }
                      else if (baseType == AssayTypeName.FLOAT_ARRAY) {
                        alex = lex + ',';
                        if (!Util.checkFloatArray(alex)) {
                          myError[k] = 13;
                          isError = true;
                        }
                        else lex = lex + '\r' + alex;
                      }
                      else if (baseType == AssayTypeName.NUMBER_ARRAY) {
                        alex = lex + ',';
                        if (!Util.checkIntegerArray(alex)) {
                          myError[k] = 13;
                          isError = true;
                        }
                        else lex = lex + '\r' + alex;
                      }
                      else if (baseType == AssayTypeName.DATETIME) {
                        alex = Util.checkDateTimeValue(lex, param.getAttribute1());
                        if (alex == null) {
                          myError[k] = 13;
                          isError = true;
                        }
                        else lex = lex + '\r' + alex;
                      }
                      else if (baseType == AssayTypeName.TIME) {
                        lex = lex + ',';
                        alex = Util.checkTimeValue(lex, param.getAttribute1());
                        if (alex == null) {
                          myError[k] = 13;
                          isError = true;
                        }
                        else lex = lex + '\r' + alex;
                      }
                      else if (baseType == AssayTypeName.TABLE) {
                        Vocabulary xyz = (Vocabulary) session.
                              getObjectById(Vocabulary.class, param.getVocabularyId());
                        String id = xyz.getIdByValue(lex);
                        if (id.equals("0")) {
                          myError[k] = 13;
                          isError = true;
                        }
                        lex = lex + '\r' + id;
                      }
                    }
                }
              }
            }
            myRecord[k] = lex;
          }
        }
        if (!eol) { //to much
          flashLine();
          myError[sizeNum] = 6;
          isError = true;
        }
//----------------------------------------------------------------
        if (simsCollectNum>=0){
          String collectId = myRecord[simsCollectNum];	
          if (collectId.equals("")){
        	if (simsTopNum>=0&&!myRecord[simsTopNum].equals("")){myError[simsTopNum] = 10;isError = true;}  
        	if (simsMiddleNum>=0&&!myRecord[simsMiddleNum].equals("")){myError[simsMiddleNum] = 10;isError = true;}  
        	if (simsBottomNum>=0&&!myRecord[simsBottomNum].equals("")){myError[simsBottomNum] = 10;isError = true;}  
          } else {
            if (!simsOpen){session.openSampleSession(); simsOpen = true;}
        	boolean flag = false;
        	if (simsTopNum>=0){
              Long aid = session.checkSimsId( collectId, myRecord[simsTopNum],1);
              if (aid != null) { flag = true;
                if (aid.longValue()==0){myError[simsTopNum] = 10;isError = true;}
                else myRecord[4] = aid.toString();
              }
        	}
        	if (simsMiddleNum>=0){
              Long aid = session.checkSimsId( collectId, myRecord[simsMiddleNum],2);
              if (aid != null) { 
                if (flag){ myError[simsMiddleNum] = 10;isError = true;}
                else { flag =true;
                  if (aid.longValue()==0){myError[simsMiddleNum] = 10;isError = true;}
                  else myRecord[4] = aid.toString();
                }
              }  
          	}
        	if (simsBottomNum>=0){
              Long aid = session.checkSimsId( collectId, myRecord[simsBottomNum],3);
              if (aid != null) { 
                if (flag){ myError[simsBottomNum] = 10;isError = true;}
                else { flag =true;
                  if (aid.longValue()==0){myError[simsBottomNum] = 10;isError = true;}
                  else myRecord[4] = aid.toString();
                }
              }  
            }
        	if (!flag){ myError[simsCollectNum] = 10;isError = true;}
          }
        }
//----------------------------------------------------------------
        String viewIdent = null;
        String studyIdent = null;
        String assayIdent= null;
        StudyView myView;
        StudyGroup myGroup;
//----------------------------------------------------------------
        if (generIds>0){
          if (viewNum>0) myError[viewNum] = 123; 
          if (studyNum>0) myError[studyNum] = 123; 
          if (assayNum>0) myError[assayNum] = 123; 
        } else {
            if (viewNum > 0 && !underFix && level < 2) { //
              viewIdent = myRecord[viewNum];
              int checkP = session.checkStudyViewId( viewIdent);
              if (level==0 && checkP == 3){
                if (duplicIds>0){myError[viewNum] = 107;myRecord[0]="DUPL";}
                else {myError[viewNum] = 7; isError = true;}
              } else
              if (level==0 && checkP != 0){
                myError[viewNum] = 20; //missing
                isError = true;
              } else
              if (level>0 && checkP != 3){
                myError[viewNum] = 20; //not exists
                isError = true;
              } else {
                Iterator iter = recordList.iterator();
                boolean found = false;
                while (iter.hasNext()) {
                  String[] record = (String[]) iter.next();
                  if (record[viewNum].equals(viewIdent)) {
                    myRecord[1] = record[1]; myRecord[3] = record[3];
                    found = true;
                    if (level==0){
                      if (duplicIds>0){myError[viewNum] = 111;myRecord[0]="DUPL";}
                      else {myError[viewNum] = 11; isError = true;}
                    } else
                    if (myRecord[1] == null) {
                       myError[viewNum] = 19; //not exists
                       isError = true;
                    } else
                    if (myRecord[3]==null||!myRecord[3].equals("OK")) {
                      myError[viewNum] = 25; //unsuff rights
                      isError = true;
                    }
                    break;
                  }
                }
                if (!found) {
                	myView = session.getStudyViewFromId( viewIdent);
                    if (myView == null) {
                      myRecord[1] = null;
                      if (level > 0) {
                        myError[viewNum] = 19; //not exists
                        isError = true;
                      }
                    } else {
                      myRecord[1] = myView.getId().toString();
                      myRecord[3] = (session.getGrantedRights( myView)<3000)?"INSUF":"OK";
                      if (level == 0) {
                        if (duplicIds>0){myError[viewNum] = 111;myRecord[0]="DUPL";}
                        else {myError[viewNum] = 11; isError = true;}
                      } else
                        if (myRecord[3]==null||!myRecord[3].equals("OK")) {
                          myError[viewNum] = 25; //unsuff rights
                          isError = true;
                      }
                    }
                  }
                }
              }
//    ----------------------------------------------------------------
            if (studyNum > 0 && (level==1 || (level==2 && !underFix))){
              studyIdent = myRecord[studyNum];
              if (studyIdent==null||studyIdent.equals("")){
                myError[studyNum] = 21; isError = true;//missing
                isError = true;
              } else {
                Iterator iter = recordList.iterator();
                boolean found = false;
                while (iter.hasNext()) {
                  String[] record = (String[]) iter.next();
                  if (record[studyNum].equals(studyIdent)){
                    myRecord[2] = record[2];
                    found = true;
                    if (level==1){
                      if (duplicIds>0){myError[studyNum] = 111;myRecord[0]="DUPL";}
                                else {myError[studyNum] = 11; isError = true;}
                    } else
                    if (myRecord[2] == null && level == 2) {
                      myError[studyNum] = 19; isError = true;//not exists
                    }
                    break;
                  }
                }
                if (!found) {
                  myGroup = session.getStudyGroupFromId( studyIdent);
                  if (myGroup == null) {
                    myRecord[2] = null;
                    if (level == 2) {
                      myError[studyNum] = 19;isError = true; //not exists
                    }
                  } else {
                    myRecord[2] = myGroup.getId().toString();
                    if (level == 1) {
                      if (duplicIds>0){myError[studyNum] = 111;myRecord[0]="DUPL";}
                      else {myError[studyNum] = 11; isError = true;}
                    }
                  }
                }
              }
            }
//    ----------------------------------------------------------------
            if (assayNum > 0 && level > 1 && myRecord[2]!=null){
              assayIdent = myRecord[assayNum];
//                Util.writeLog("BottomNum", String.valueOf(bottomNum), aliqIdent);
              if (assayIdent == null || assayIdent.equals("")) {
                myError[assayNum] = 22; //not exists
                isError = true;
              } else {
                Iterator iter = recordList.iterator();
                boolean found = false;
                while (iter.hasNext()) {
                  String[] record = (String[]) iter.next();
                  if (record[assayNum].equals(assayIdent) && myRecord[2].equals(record[2])){
                    found = true;
                    if (duplicIds>0){myError[assayNum] = 111;myRecord[0]="DUPL";}
                    else {myError[assayNum] = 11; isError = true;}
                  }
                }
                if (!found) {
                  int checkP = session.checkAssayId(new Long(myRecord[2]), assayIdent);
                  if (checkP==3) {
                    if (duplicIds>0){myError[assayNum] = 111;myRecord[0]="DUPL";}
                    else {myError[assayNum] = 11; isError = true;}
                  }
                }
              }
            }
          }   //generIds==0
          if (!myRecord[0].equals("DUPL")){
        	for (int i = 0; i < iFilex; i++) fileNames.add(filex[i]);  
          }
          recordList.add(myRecord);
          errorList.add(myError);
          getStartOfLine();
      }
    } catch ( Exception ex ){
    	throw ex;
    }
/*    finally {
      try{ fis.close();
           if (zipProc!=null) zipProc.closeFile();}catch(IOException ex){}
    }*/
  }
//-----------------------------------------------------------------
  public void takeRequest( RequestParser requestI){
//    String val1 = requestI.getParameter("protocolfileType");
//    if (val1!= null) protocolType = val1;
//    val1 = requestI.getParameter("datafileType");
//    if (val1!= null) dataType = val1;
    String val1;  
    if (level==2){  //assejas
      val1 = requestI.getParameter("understd");
      if (val1.equals("0")){ underFix = true;
        middleId = requestI.getParameter("middle");
        middleEl = (StudyGroup)session.getObjectById( StudyGroup.class, middleId); 
      }
    }
    else
    if (level==1){  //study groups
      underView = (Util.getIntegerValue(requestI.getParameter("undervw"))>0);
      if (underView){
        val1 = requestI.getParameter("understd");
        if (val1!=null && val1.equals("0")){ underFix = true;
           topId = requestI.getParameter("top");
           topEl = (StudyView)session.getObjectById( StudyView.class, topId);
        } 
      }
    }
    val1 = requestI.getParameter("ftpfile");
    if (val1 !=null && !val1.equals("")){
      isFtpFile = true;
      ftpFile = new File( WebappConfig.getFtpDirectory(),val1);
    }
    val1 = requestI.getParameter("ftpdirec");
    if (val1!=null){
      isFtpDirec = true;
      ftpDirec = new File( WebappConfig.getFtpDirectory(), val1);
    }
    generIds = Util.getIntegerValue(requestI.getParameter("gener_ids"));
    unrecIds = Util.getIntegerValue(requestI.getParameter("unrec_ids"));
    duplicIds = Util.getIntegerValue(requestI.getParameter("duplic_ids"));
  }
  public boolean getUnderFix(){
    return underFix ;
  }
  public StudyView getTopElement(){
	return topEl;
  }
  public StudyGroup getMiddleElement(){
	return middleEl;
  }
  public int getGenerIds(){
    return generIds ;
  }

  private void appendString( StringBuffer xyz, String value){
    for (int i = 0; i < value.length(); i++){
      char c = value.charAt(i);
      switch(c){
        case '<': xyz.append("&lt;"); break;
        case '>': xyz.append("&gt;"); break;
        default : xyz.append(c);
      }
    }
  }
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
  public String getHeaderHTML(){
    StringBuffer xyz = new StringBuffer();
    for (int i = startNum; i < sizeNum; i++){
      if (headerError[i]>100)
        xyz.append("<th id=\"bridin\" title=\"")
           .append(errorMessage[headerError[i]-100])
           .append("\">");
      else
      if (headerError[i]>0)
        xyz.append("<th id=\"kluda\" title=\"")
           .append(errorMessage[headerError[i]])
           .append("\">");
      else
        xyz.append("<th>");
      appendString( xyz, headerRecord[i]);
      xyz.append("</th>");
    }
    if (headerError[sizeNum] > 0){
      xyz.append("<th id=\"kluda\" title=\"");
      if (headerError[sizeNum] == 22)
        xyz.append("Missing ")
          .append(MetadataManager.getBottomSingular())
          .append(" id");
      else
      if (headerError[sizeNum] == 21)
        xyz.append("Missing ")
          .append(MetadataManager.getMiddleSingular())
          .append(" id");
      else
      if (headerError[sizeNum] == 20)
        xyz.append("Missing ")
          .append(MetadataManager.getTopSingular(topNum))
          .append(" id");
      else
        xyz.append(errorMessage[headerError[sizeNum]]);
      if (headerError[sizeNum] == 17)
        xyz.append(missingFieldName);
      xyz.append("\">error</th>");
    }
    return xyz.toString();
  }
//----------------------------------------------------------
  public String getHeaderString(){
    StringBuffer xyz = new StringBuffer();
    boolean ef = false;
    for (int i = startNum; i < sizeNum; i++){
      xyz.append(headerRecord[i]);
      if (headerError[i]>100)
        xyz.append("<warning:")
           .append(errorMessage[headerError[i]-100])
           .append(">");
      else
      if (headerError[i]>0){
        ef = true;
        xyz.append("<error:")
            .append(errorMessage[headerError[i]])
            .append(">");
      }
      xyz.append('\t');
    }
    if (headerError[sizeNum] > 0){
      if (headerError[sizeNum] == 22)
        xyz.append("<error:Missing ")
          .append(MetadataManager.getBottomSingular())
          .append(" id");
      else
      if (headerError[sizeNum] == 21)
        xyz.append("<error:Missing ")
          .append(MetadataManager.getMiddleSingular())
          .append(" id");
      else
      if (headerError[sizeNum] == 20)
        xyz.append("<error:Missing ")
          .append(MetadataManager.getTopSingular(topNum))
          .append(" id");
      else
      xyz.append("<error:")
          .append(errorMessage[headerError[sizeNum]]);
      if (headerError[sizeNum] == 17)
        xyz.append(missingFieldName);
      xyz.append(">");
    }
    else
    if (ef)
      xyz.append("NOK");
    else
      xyz.append("OK");
    return xyz.toString();
  }


//----------------------------------------------------------
//---------Iterator while create HTML---------------------
//----------------------------------------------------------
  public Iterator iterator(){
    recordIterator = recordList.iterator();
    errorIterator = errorList.iterator();
    return this;
  }

  public boolean hasNext(){
    return recordIterator.hasNext();
  }

  public Object next(){
    StringBuffer xyz = new StringBuffer();
    String[] myRecord = (String[])recordIterator.next();
    byte[] myError = (byte[])errorIterator.next();
    for (int i = startNum; i < sizeNum; i++){
      if (myError[i]>100)
        xyz.append("<td id=\"bridin\" title=\"")
           .append(errorMessage[myError[i]-100])
           .append("\">");
      else
      if (myError[i]>0)
        xyz.append("<td id=\"kluda\" title=\"")
           .append(errorMessage[myError[i]])
           .append("\">");
      else
        xyz.append("<td>");
      String value = myRecord[i];
      if (value.equals("")) xyz.append("&nbsp;");
      else {
        int l = value.indexOf('\r');
        if (l > 0)
          appendString(xyz, value.substring(0, l));
        else
          appendString(xyz, value);
      }
      xyz.append("</td>");
    }
    if (myError[sizeNum] > 0)
      xyz.append("<td id=\"kluda\" title=\"")
         .append(errorMessage[myError[sizeNum]])
         .append("\">error</td>");
    return xyz.toString();
  }

  public void remove(){
  }
//----------------------------------------------------------
//----------------------------------------------------------
  public boolean isError(){
    return isError;
  }

  public boolean isHeaderError(){
    return isHeaderError;
  }

  public boolean isZipError(){
    return isZipError;
  }
//----------------------------------------------------------
//---------Iterator while create objects---------------------
//----------------------------------------------------------
  public void startIterator(){
    recordIterator = recordList.iterator();
    if (dataFileNum>0)
      dataFileNames = new String[dataFileNum];
    if (protocolFileNum>0)
        protocolFileNames = new String[protocolFileNum];
    if (level==0 && generIds > 0)
    	generNum = session.getStudyViewMax();
    if (level==1 && generIds > 0)
    	generNum = session.getStudyGroupMax();
    if (level==2 && generIds > 0)
    	generNum = session.getAssayMax( middleEl.getId());
  }

  public boolean hasNextElement(){
    boolean xyz = recordIterator.hasNext();
    while (xyz){
      myNextRecord = (String[])recordIterator.next();
      if (!myNextRecord[0].equals("DUPL"))break;
      xyz = recordIterator.hasNext();
    }  
    return xyz;
  }
/*
  private void setTargetValue( String value, TempMetaData param, Object target) throws Exception {
    Class targetClass = target.getClass();
    int baseType = param.getBaseType();
    if (baseType==AssayTypeName.STRING){
      Class[] paramTypes = {String.class};
      Method meth = targetClass.getMethod( param.getSetMethodName(), paramTypes);
      Object[] args = {value};
      meth.invoke(target, args);
    }
    else
    if (baseType==AssayTypeName.NUMBER){
      Integer ivalue = Util.getInteger(value);
      Class[] paramTypes = {Integer.class};
      Method meth = targetClass.getMethod( param.getSetMethodName(),
                                          paramTypes);
      Object[] args = {ivalue};
      meth.invoke(target, args);
    }
    else
    if (baseType==AssayTypeName.FLOAT){
      Double fvalue = Util.getFloat(value);
      Class[] paramTypes = {Double.class};
      Method meth = targetClass.getMethod( param.getSetMethodName(),
                                           paramTypes);
      Object[] args = {fvalue};
      meth.invoke(target, args);
    }
    else
    if (baseType==AssayTypeName.TABLE || baseType==AssayTypeName.IDENTIFICY){
      int l = value.indexOf('\r');
      String idstr = value.substring(l+1);
      Class xyz = param.getBaseClass();
      AssayPersistent myObj = (AssayPersistent) session.getObjectById(xyz, idstr);
      Class[] paramTypes = {xyz};
      Method meth = targetClass.getMethod( param.getSetMethodName(),
                                           paramTypes);
      Object[] args = {myObj};
      meth.invoke(target, args);
    }
    else if (baseType == AssayTypeName.DATETIME) {
      Date dvalue = Util.getDateTimeValue(value, 2);
      Class[] paramTypes = {Date.class};
      Method meth = targetClass.getMethod( param.getSetMethodName(),
                                           paramTypes);
      Object[] args = {dvalue};
      meth.invoke(target, args);
    }
  }
*/
/*
  private void setTargetParameters( String value, int type, Object target) throws Exception {
    Class targetClass = target.getClass();
    for (int i = 1; i <= VocabulName.getIdentificyCount(); i++) {
      String key = VocabulName.getFieldNameIVT(i);
      if (mdm.hasField(type, key)) {
        if (value!=null){
          Class xyz = VocabulName.getIdentificyClass(i);
          Persistent myObj = (Persistent) getObjectById(xyz, value);
          Class[] paramTypes = {xyz};
          Method meth = targetClass.getMethod(VocabulName.getSetMethodNameIVT(i),
                                              paramTypes);
          Object[] args = {myObj};
          meth.invoke(target, args);
        }
      }
    }

    for (int i = 1; i <= VocabulName.getVocabularyCount(); i++) {
      String key = VocabulName.getFieldNameVT(i);
      if (mdm.hasField(type, key)) {
        String value = request.getParameter(key);
        Class xyz = Class.forName(VocabulName.getClassNameVT(i));
        Persistent myObj = (Persistent) getObjectById(xyz, value);
        Class[] paramTypes = {xyz};
        Method meth = targetClass.getMethod(VocabulName.getSetMethodNameVT(i),
                                          paramTypes);
        Object[] args = {myObj};
        meth.invoke( target, args);
      }
    }

    for (int i = 1; i <= VocabulName.getDateCount(); i++) {
      String itxx = VocabulName.getFieldNameDT(i);
      if (mdm.hasField( type, itxx)) {
        Date dvalue = getDate(request, itxx);
        Class[] paramTypes = {Date.class};
        Method meth = targetClass.getMethod(VocabulName.getSetMethodNameDT(i),
                       paramTypes);
        Object[] args = {dvalue};
        meth.invoke(target, args);
      }
    }
  }
*/
  public StudyView getStudyView(){
	StudyView stw = topEl;
	if (topEl==null && myNextRecord[1]!=null)
	  stw = (StudyView)session.getObjectById(StudyView.class,myNextRecord[1]);	
    return stw;
  }
  public void nextElement( Assay tempAssay) throws Exception {
    String[] myRecord = myNextRecord;
    String dataFiles ="\r";
    String protocolFiles = "\r";
    dataFileNum1 = 0; protocolFileNum1 = 0;
    int pendingCount = 0;
    if (middleEl!=null)
      tempAssay.setStudyGroup( middleEl);
    else
    if (myRecord[2]!=null){
      StudyGroup stg = (StudyGroup)session.getObjectById(StudyGroup.class,myRecord[2]);
      tempAssay.setStudyGroup( stg);
    }
    for (int k = startNum; k < sizeNum; k++){
      String value = myRecord[k];
      TempMetaData param = paramArray[k];
      if (param==null) continue;    //unknown keyword
      int num = param.getValueNumber();
      switch(num){
        case AssayFieldname.SIMSCOLLECTIONnum:
          if (!value.equals("")){
            tempAssay.setSimsCollectionName(value);
          } break;
        case AssayFieldname.SIMSBOTTOMnum:
          if (!value.equals("")){
            tempAssay.setSimsRefId(value);
            tempAssay.setSimsReference(new Long(myRecord[4]),3);
          } break;
        case AssayFieldname.SIMSMIDDLEnum:
          if (!value.equals("")){
            tempAssay.setSimsRefId(value);
            tempAssay.setSimsReference(new Long(myRecord[4]),2);
          } break;
        case AssayFieldname.SIMSTOPnum:
          if (!value.equals("")){
            tempAssay.setSimsRefId(value);
            tempAssay.setSimsReference(new Long(myRecord[4]),1);
          } break;
        case AssayFieldname.IDENTIFSTRINGnum: if (generIds==0){
        	tempAssay.setIdentifString(value); 
        	tempAssay.setIdentifFromString();
        } break;
        case AssayFieldname.VISIBLENAMEnum: tempAssay.setVisibleName(value); break;
        case AssayFieldname.COMMENTnum: tempAssay.setComment(value); break;
        case AssayFieldname.DATAFILESnum: if (!value.equals("")){  //datafile
          dataFileNames[ dataFileNum1++] = value;
          if (isFtpFile){
            int l = value.indexOf('\r');
            value = value.substring( 0,l);
          }
          String typname = dataType;
          int m = fileToTypeKey[k];
          if (m >= 0){
            typname = myRecord[m];
            if (!typname.equals("")){
              int l = typname.indexOf('\r');
              if (l>0)typname = typname.substring( l+1);
            }
          }
          dataFiles += FileString.getNewContents(value, typname, dataFileNum1);
          if (isFtpDirec || isFtpFile) pendingCount++;
          }
          break;
        case AssayFieldname.PROTOCOLnum: if (!value.equals("")){  //protocolfile
          protocolFileNames[ protocolFileNum1++] = value;
          if (isFtpFile){
            int l = value.indexOf('\r');
            value = value.substring( 0,l);
          }
          String typname = protocolType;
          int m = fileToTypeKey[k];
          if (m >= 0){
            typname = myRecord[m];
            if (!typname.equals("")){
              int l = typname.indexOf('\r');
              if (l>0)typname = typname.substring( l+1);
            }
          }
          protocolFiles += FileString.getNewContents(value, typname, protocolFileNum1);
          if (isFtpDirec || isFtpFile) pendingCount++;
          }
          break;
        default: if (num > AssayTypeName.COMMON_PARAM_COUNT){
          int l = value.indexOf('\r');
          if (l > 0) value = value.substring( l + 1);
          Class[] paramTypes = {String.class};
          String fieldName = Util.getFieldNameL( num - AssayTypeName.COMMON_PARAM_COUNT);
          Object[] args = {value};
          Method xyz = null;
          try {
            xyz = Assay.class.getMethod("set" + fieldName, paramTypes);
            xyz.invoke(tempAssay, args);
          }
          catch (Exception ex) {}
        }
      }
    }
    if (generIds > 0){
        tempAssay.setIdentif( new Long(generNum));
        tempAssay.setIdentifString(
                Assay.makeIdentifString(middleEl.getIdentifString(),generNum++));
    } 
    if (protocolFileNum1>0)
      tempAssay.setProtocolFiles(protocolFiles);
    if (dataFileNum1>0)
      tempAssay.setDataFiles(dataFiles);
    tempAssay.setPendingX(new Integer( pendingCount));
  }
  public void nextElement( StudyGroup tempStudyGroup)throws Exception {
    String[] myRecord = myNextRecord;
    String dataFiles ="\r";
    String protocolFiles = "\r";
    dataFileNum1 = 0; protocolFileNum1 = 0;
    int pendingCount = 0;
    for (int k = startNum; k < sizeNum; k++){
      String value = myRecord[k];
      TempMetaData param = paramArray[k];
      if (param==null) continue;    //unknown keyword
      int num = param.getValueNumber();
      switch(num){
      case AssayFieldname.SIMSCOLLECTIONnum:
        if (!value.equals("")){
       	  tempStudyGroup.setSimsCollectionName(value);
        } break;
      case AssayFieldname.SIMSBOTTOMnum:
        if (!value.equals("")){
          tempStudyGroup.setSimsRefId(value);
          tempStudyGroup.setSimsReference(new Long(myRecord[4]),3);
        } break;
      case AssayFieldname.SIMSMIDDLEnum:
        if (!value.equals("")){
          tempStudyGroup.setSimsRefId(value);
          tempStudyGroup.setSimsReference(new Long(myRecord[4]),2);
        } break;
      case AssayFieldname.SIMSTOPnum:
        if (!value.equals("")){
          tempStudyGroup.setSimsRefId(value);
          tempStudyGroup.setSimsReference(new Long(myRecord[4]),1);
        } break;
      case AssayFieldname.IDENTIFSTRINGnum: if (generIds==0){
       	tempStudyGroup.setIdentifString(value); 
       	tempStudyGroup.setIdentifFromString();
      } break;
      case AssayFieldname.VISIBLENAMEnum: tempStudyGroup.setVisibleName(value); break;
      case AssayFieldname.COMMENTnum: tempStudyGroup.setComment(value); break;
      case AssayFieldname.DATAFILESnum: if (!value.equals("")){  //datafile
          dataFileNames[ dataFileNum1++] = value;
          if (isFtpFile){
            int l = value.indexOf('\r');
            value = value.substring( 0,l);
          }
          String typname = dataType;
          int m = fileToTypeKey[k];
          if (m >= 0){
            typname = myRecord[m];
            if (!typname.equals("")){
              int l = typname.indexOf('\r');
              if (l>0)typname = typname.substring( l+1);
            }
          }
          dataFiles += FileString.getNewContents(value, typname, dataFileNum1);
          if (isFtpDirec || isFtpFile) pendingCount++;
          }
          break;
        case AssayFieldname.PROTOCOLnum: if (!value.equals("")){  //protocolfile
          protocolFileNames[ protocolFileNum1++] = value;
          if (isFtpFile){
            int l = value.indexOf('\r');
            value = value.substring( 0,l);
          }
          String typname = protocolType;
          int m = fileToTypeKey[k];
          if (m >= 0){
            typname = myRecord[m];
            if (!typname.equals("")){
              int l = typname.indexOf('\r');
              if (l>0)typname = typname.substring( l+1);
            }
          }
          protocolFiles += FileString.getNewContents(value, typname, protocolFileNum1);
          if (isFtpDirec || isFtpFile) pendingCount++;
          }
          break;
        default: if (num > AssayTypeName.COMMON_PARAM_COUNT){
          int l = value.indexOf('\r');
          if (l > 0) value = value.substring( l + 1);
          Class[] paramTypes = {String.class};
          String fieldName = Util.getFieldNameL( num - AssayTypeName.COMMON_PARAM_COUNT);
          Object[] args = {value};
          Method xyz = null;
          try {
            xyz = StudyGroup.class.getMethod("set" + fieldName, paramTypes);
            xyz.invoke(tempStudyGroup, args);
          }
          catch (Exception ex) {}
        }
      }
    }
    if (generIds > 0){
      tempStudyGroup.setIdentif( new Long(generNum));
      tempStudyGroup.setIdentifString( session.makeStudyGroupIdentif( generNum++));
    } 
    if (protocolFileNum1>0)
      tempStudyGroup.setProtocolFiles(protocolFiles);
    if (dataFileNum1>0)
      tempStudyGroup.setDataFiles(dataFiles);
    tempStudyGroup.setPendingX(new Integer( pendingCount));
  }
  public void nextElement( StudyView tempStudyView)throws Exception {
    String[] myRecord = myNextRecord;
    String dataFiles ="\r";
    String protocolFiles = "\r";
    dataFileNum1 = 0; protocolFileNum1 = 0;
    int pendingCount = 0;
    for (int k = startNum; k < sizeNum; k++){
      String value = myRecord[k];
      TempMetaData param = paramArray[k];
      if (param==null) continue;    //unknown keyword
      int num = param.getValueNumber();
      switch(num){
      case AssayFieldname.SIMSCOLLECTIONnum:
        if (!value.equals("")){
       	  tempStudyView.setSimsCollectionName(value);
          } break;
      case AssayFieldname.SIMSBOTTOMnum:
        if (!value.equals("")){
       	  tempStudyView.setSimsRefId(value);
       	  tempStudyView.setSimsReference(new Long(myRecord[4]),3);
        } break;
      case AssayFieldname.SIMSMIDDLEnum:
        if (!value.equals("")){
       	  tempStudyView.setSimsRefId(value);
       	  tempStudyView.setSimsReference(new Long(myRecord[4]),2);
        } break;
      case AssayFieldname.SIMSTOPnum:
        if (!value.equals("")){
       	  tempStudyView.setSimsRefId(value);
       	  tempStudyView.setSimsReference(new Long(myRecord[4]),1);
        } break;
      case AssayFieldname.IDENTIFSTRINGnum:
        if (generIds==0){
          tempStudyView.setIdentifString(value); 
          tempStudyView.setIdentifFromString();
        } break;
      case AssayFieldname.VISIBLENAMEnum: 
       	tempStudyView.setVisibleName(value); break;
      case AssayFieldname.COMMENTnum: 
       	tempStudyView.setComment(value); break;
      case AssayFieldname.DATAFILESnum: if (!value.equals("")){  //datafile
          dataFileNames[ dataFileNum1++] = value;
          if (isFtpFile){
            int l = value.indexOf('\r');
            value = value.substring( 0,l);
          }
          String typname = dataType;
          int m = fileToTypeKey[k];
          if (m >= 0){
            typname = myRecord[m];
            if (!typname.equals("")){
              int l = typname.indexOf('\r');
              if (l>0)typname = typname.substring( l+1);
            }
          }
          dataFiles += FileString.getNewContents(value, typname, dataFileNum1);
          if (isFtpDirec || isFtpFile) pendingCount++;
          }
          break;
        case AssayFieldname.PROTOCOLnum: if (!value.equals("")){  //protocolfile
          protocolFileNames[ protocolFileNum1++] = value;
          if (isFtpFile){
            int l = value.indexOf('\r');
            value = value.substring( 0,l);
          }
          String typname = protocolType;
          int m = fileToTypeKey[k];
          if (m >= 0){
            typname = myRecord[m];
            if (!typname.equals("")){
              int l = typname.indexOf('\r');
              if (l>0)typname = typname.substring( l+1);
            }
          }
          protocolFiles += FileString.getNewContents(value, typname, protocolFileNum1);
          if (isFtpDirec || isFtpFile) pendingCount++;
          }
          break;
        default:
        	if (num > AssayTypeName.COMMON_PARAM_COUNT){
              int l = value.indexOf('\r');
              if (l > 0) value = value.substring( l + 1);
              Class[] paramTypes = {String.class};
              String fieldName = Util.getFieldNameL( num - AssayTypeName.COMMON_PARAM_COUNT);
              Object[] args = {value};
              Method xyz = null;
              try {
                xyz = StudyView.class.getMethod("set" + fieldName, paramTypes);
                xyz.invoke(tempStudyView, args);
              }
              catch (Exception ex) {}
            }
	      }
	    }
	    if (generIds > 0){
	      tempStudyView.setIdentif( new Long(generNum));
	      tempStudyView.setIdentifString( session.makeStudyViewIdentif( generNum++));
	    } 
	    if (protocolFileNum1>0)
	      tempStudyView.setProtocolFiles(protocolFiles);
	    if (dataFileNum1>0)
	      tempStudyView.setDataFiles(dataFiles);
	    tempStudyView.setPendingX(new Integer( pendingCount));
	  }
//----------------------------------------------------------
//---------Iterator while create export string---------------------
//----------------------------------------------------------
  public void startExportIterator(){
    recordIterator = recordList.iterator();
    errorIterator = errorList.iterator();
  }

  public boolean hasNextExportElement(){
    boolean xyz = recordIterator.hasNext();
    return xyz;
  }

  public String nextExportElement(){
    StringBuffer xyz = new StringBuffer();
    String[] myRecord = (String[])recordIterator.next();
    byte[] myError = (byte[])errorIterator.next();
    boolean ef = false;
    for (int i = startNum; i < sizeNum; i++){
      String value = myRecord[i];
      if (!value.equals("")){
        int l = value.indexOf('\r');
        if (l > 0)
          appendString(xyz, value.substring(0, l));
        else
          appendString(xyz, value);
      }
      if (myError[i]>100)
        xyz.append("<warning:")
           .append(errorMessage[myError[i]-100])
           .append(">");
      else
      if (myError[i]>0){
        ef = true;
        xyz.append("<error:")
            .append(errorMessage[myError[i]])
            .append(">");
      }
      xyz.append('\t');
    }
    if (myError[sizeNum] > 0){
      if (myError[sizeNum]>100)
        xyz.append("<warning:")
           .append(errorMessage[myError[sizeNum]-100]);
      else
      xyz.append("<error:")
          .append(errorMessage[myError[sizeNum]]);
      xyz.append(">");
    }
    else
    if (ef)
      xyz.append("NOK");
    else
      xyz.append("OK");
    return xyz.toString();
  }
//----------------------------------------------------------
//----------------------------------------------------------
  public void ProcessFiles(TechnologyData top){//used by session.ImportBatchStudyGroup
    File zipFile = (isFtpFile)?ftpFile:session.getZipTempFile();
    File directory, permFile; String fileName;
    directory = session.getProtTechnDirectory();
    for (int i = 0; i < protocolFileNum1;){
      String value = protocolFileNames[ i++];
      fileName = FileString.getNewFileName( level, false, top.getId(),i);
      permFile = new File(directory, fileName);
      if (isFtpDirec){
        File tfile = new File( ftpDirec, value);
        PendingTask pendingProtocol = new PendingTask();
        pendingProtocol.setTaskType(new Long(0));
        pendingProtocol.setFromFile( tfile.getAbsolutePath());
        pendingProtocol.setToFile(permFile.getAbsolutePath());
        session.addPendingTask(pendingProtocol, top, level);
      }
      else
      if (isFtpFile){
        int l = value.indexOf('\r');
        String zipNum = value.substring( l + 1);
        value = value.substring( 0,l);
        PendingTask pendingProtocol = new PendingTask();
        pendingProtocol.setTaskType(new Long(zipNum));
        pendingProtocol.setFromFile( ftpFile.getAbsolutePath());
        pendingProtocol.setAttribute1( value);
        pendingProtocol.setToFile(permFile.getAbsolutePath());
        session.addPendingTask(pendingProtocol, top, level);
      }
      else{
        ZipProcessor.getFile(zipFile, value, permFile);
      }
    }
    directory = session.getDataTechnDirectory();
    for (int i = 0; i < dataFileNum1;){
      String value = dataFileNames[ i++];
      fileName = FileString.getNewFileName( level, true, top.getId(),i);
      permFile = new File( directory, fileName);
      if (isFtpDirec){
        File tfile = new File( ftpDirec, value);
        PendingTask pendingData = new PendingTask();
        pendingData.setTaskType(new Long(0));
        pendingData.setFromFile( tfile.getAbsolutePath());
        pendingData.setToFile(permFile.getAbsolutePath());
        session.addPendingTask(pendingData, top, level);
      }
      else
      if (isFtpFile){
        int l = value.indexOf('\r');
        String zipNum = value.substring( l + 1);
        value = value.substring( 0,l);
        PendingTask pendingData = new PendingTask();
        pendingData.setTaskType(new Long(zipNum));
        pendingData.setFromFile( ftpFile.getAbsolutePath());
        pendingData.setAttribute1( value);
        pendingData.setToFile(permFile.getAbsolutePath());
        session.addPendingTask(pendingData, top, level);
      }
      else{
        ZipProcessor.getFile(zipFile, value, permFile);
      }
    }
  }
}

