package assays.com;
import java.util.Iterator;
import java.util.List;
import assays.hibernate.*;
/**
 *   veido reportu - tab-delimited datu exportu.
 *   klasi lieto ExportData.jsp kura tiek saukta
 *    no ViewViews.jsp, ViewGroups.jsp, ViewAssays.jsp
*/
public final class DataExport implements Iterator{
    private UserHttpSession session;
    private Iterator objIterator;
    private byte[] valueIndexArray;
    private int colCount;
    private TempMetaData[] typeArray;
    private List objList;
    private boolean isBatch = false;
    private TechnologyData currentObj = null;
    private ViewBatchManager batchMan; 
//    private boolean isAssayBatch = false;
//    private boolean isStudyBatch = false;
//    private boolean isViewBatch = false;
    private int level;
    public DataExport( UserHttpSession tmpHttpSessObj, boolean isBatch){
        session = tmpHttpSessObj;
        this.isBatch = isBatch;
        batchMan = session.getViewBatchManager();
    }

    public String getHeader(String selectName)
    {
        if (selectName.equals("groups")) return getGroupHeader();
        else
        if (selectName.equals("assays"))  return getAssayHeader();
        else
        if (selectName.equals("views"))  return getViewHeader();
        else return null;
    }

    private String getViewHeader()
    {
        try
        { level = 0;
//          isViewBatch = session.isViewBatchForExport();
          StringBuffer xyz = new StringBuffer();
          MetadataManager mdm = this.session.getMetadataManager();
          Long technId = session.getCurrentTechnologyId();
//      if (isViewBatch)
//        objList = session.getViewBatchArray();
//      else
            objList = session.getAllViews( technId, -1) ;
          typeArray = mdm.getStudyViewParameterArray();
          colCount = typeArray.length;
          valueIndexArray = mdm.getStudyViewIndexArray();

          for (int i = 0; i < colCount; i++){
            if (i > 0) xyz.append("\t");
            TempMetaData type = typeArray[i];
            xyz.append(MetadataManager.getTopPrefix(session.getTopNum()));
            if (type.getValueNumber() > AssayTypeName.COMMON_PARAM_COUNT)
              xyz.append(type.getGroupLongName())
                  .append(".");
            else {
              String name = mdm.getParameterHeaderName(type.getValueNumber());
              if (name!=null){
                xyz.append(name);
                continue;
              }
            }
            xyz.append(type.getUploadName());
          }
          return xyz.toString();
        }
        catch (Exception ex)
        {
            return null;
        }
    }
    private String getGroupHeader()
    {
        try
        { level = 1;
//          isStudyBatch = session.isStudyBatchForExport();
          StringBuffer xyz = new StringBuffer();
          MetadataManager mdm = this.session.getMetadataManager();
          ViewGroupManager vgm = session.getViewGroupManager();
          Long technId = session.getCurrentTechnologyId();
          Long viewId = vgm.getGroupViewId();
//      if (isStudyBatch)
//        objList = session.getStudyBatchArray();
//      else
            objList = session.getAllGroups( technId, viewId, -1) ;
          typeArray = mdm.getStudyGroupParameterArray();
          colCount = typeArray.length;
          valueIndexArray = mdm.getStudyGroupIndexArray();

          for (int i = 0; i < colCount; i++){
            if (i > 0) xyz.append("\t");
            TempMetaData type = typeArray[i];
            xyz.append(MetadataManager.getMiddlePrefix());
            if (type.getValueNumber() > AssayTypeName.COMMON_PARAM_COUNT)
              xyz.append(type.getGroupLongName())
                  .append(".");
            else {
              String name = mdm.getParameterHeaderName(type.getValueNumber());
              if (name!=null){
                xyz.append(name);
                continue;
              }
            }
            xyz.append(type.getUploadName());
          }
          return xyz.toString();
        }
        catch (Exception ex)
        {
            return null;
        }
    }
    private String getAssayHeader()
    {
        try
        { level = 2;
//          isAssayBatch = session.isAssayBatch();
          StringBuffer xyz = new StringBuffer();
          MetadataManager mdm = this.session.getMetadataManager();
          ViewAssayManager vam = session.getViewAssayManager();
          Long technId = session.getCurrentTechnologyId();
          Long groupId = vam.getAssayGroupId();
//      if (isAssayBatch)
//        objList = session.getAssayBatchArray();
//      else
            objList = session.getAllAssays( technId, null, groupId, -1) ;
          typeArray = mdm.getAssayParameterArray();
          colCount = typeArray.length;
          valueIndexArray = mdm.getAssayIndexArray();

            for (int i = 0; i < colCount; i++){
              if (i > 0) xyz.append("\t");
              TempMetaData type = typeArray[i];
              xyz.append(MetadataManager.getBottomPrefix());
              if (type.getValueNumber() > AssayTypeName.COMMON_PARAM_COUNT)
                xyz.append(type.getGroupLongName())
                    .append(".");
              else {
                String name = mdm.getParameterHeaderName(type.getValueNumber());
                if (name!=null){
                  xyz.append(name);
                  continue;
                }
              }
              xyz.append(type.getUploadName());
            }
            return xyz.toString();
        }
        catch (Exception ex)
        {
            return null;
        }
    }

    public Iterator iterator(){
        objIterator =  objList.iterator();
        return this;
    }
    public boolean hasNext(){
    	while (objIterator.hasNext()){
    	  currentObj = (TechnologyData) objIterator.next();
    	  if (!isBatch || batchMan.isSelected(currentObj.getId())) return true;
    	}
    	return false;	
    }
    public Object next(){
/*
        AssayPersistent obj = null; int myRights = 0;
        StringBuffer xyz = new StringBuffer();
        try {
          if (level==0){
            StudyView stw = (isViewBatch)?
                      (StudyView)session.getObjectById(StudyView.class,
                                                        (String) objIterator.next()):
                      (StudyView)objIterator.next();
            myRights = 3000; obj = stw;
          } else
          if (level==1){
           StudyGroup stgr = (isStudyBatch)?
              (StudyGroup)session.getObjectById(StudyGroup.class,
                                                (String) objIterator.next()):
              (StudyGroup)objIterator.next();
            myRights = session.getGrantedRights(stgr); obj = stgr;
          } else
          if (level==2){
            Assay assay = (isAssayBatch)?
              (Assay)session.getObjectById(Assay.class,
                                           (String) objIterator.next()):
              (Assay)objIterator.next();
            myRights = session.getGrantedRights(assay.getStudyGroup()); obj = assay;
          }
*/        int myRights = 0;
    	  if (currentObj == null) return null;
          if (level==0){
              myRights = session.getGrantedRights(
          		  ((StudyView)currentObj).getOwner(), ((StudyView)currentObj).getOwnerGroup());
            } else
            if (level==1){
              myRights = session.getGrantedRights((StudyGroup)currentObj); 
            } else
            if (level==2){
              myRights = session.getGrantedRights(((Assay)currentObj).getStudyGroup());
            }
    	  
          if (myRights < 1000) return null;
          StringBuffer xyz = new StringBuffer();
          String[] var = currentObj.getValueArrayForExport(valueIndexArray, colCount);
          for (int i = 0; i < colCount; i++) {
            if (i > 0) xyz.append("\t");
            TempMetaData type = typeArray[i];
            String value = var[i];
            if (type.getBaseType() == AssayTypeName.TABLE) {
              Vocabulary vocab = (Vocabulary)
                  session.getObjectById(Vocabulary.class,
                                        type.getVocabularyId());
              if (vocab != null) value = vocab.getValueById(value);
            }
            else
            if (type.getBaseType() == AssayTypeName.DATETIME) {
              value = Util.getDateStringForExport( value, type.getAttribute1());
            }
            xyz.append(value == null || value.equals("&nbsp;") ? "" : value);
          }
          return xyz.toString();
        }

    public void remove(){
    }
}
