package assays.com;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import assays.hibernate.AssayFieldname;
import assays.hibernate.MetadataManager;

public final class FilterObject {
  public FilterObject() {
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  private String viewString = null;
  private String groupString = null;
  private String assayString = null;
  private int viewIdLength = 0;
  private int groupIdLength = 0;
  private String ownerStringForView = null;
  private String ownerStringForGroup = null;
//constraints
    public static final int LIKE = 1;
    public static final int EQUAL = 2;
    public static final int LESS_THAN = 3;
    public static final int GREATER_THAN = 4;

    private static final String[] myConstr = {"",
      "like",
      "equal",
      "less than",
      "greater than"
    };

    public boolean isFiltered( int level){
      boolean b = false;
      switch (level){
        case 0: b = (viewString!=null); break;
        case 1: b = (groupString!=null); break;
        case 2: b = (assayString!=null); break;
        case 3: b = (ownerStringForView!=null||ownerStringForGroup!=null); break;
      }
      return b;   	
    }
    public String getFilterText() {
      StringBuffer xyz = new StringBuffer();
      boolean b = false;
      xyz.append( MetadataManager.getString("filter_on"));
      if (viewString!=null){ 
    	  xyz.append(" ")
    	  .append(MetadataManager.getTopPlural());
    	  b = true;  
      }	  
      if (groupString!=null){ 
    	  xyz.append((b)?", ":" ")
    	  .append(MetadataManager.getMiddlePlural());
          b = true;
      }	  
      if (assayString!=null){ 
    	  xyz.append((b)?", ":" ")
    	  .append(MetadataManager.getBottomPlural());
          b = true;
      }    
      if (ownerStringForView!=null||ownerStringForGroup!=null) 
    	  xyz.append((b)?", ":" ")
       	  .append(MetadataManager.getString("owners"));
      return xyz.toString();
    }
    public static String getConstrPrompter( Integer constrId) {
      StringBuffer xyz = new StringBuffer();
      int j = (constrId==null)?0:constrId.intValue();
      for (int i = 1; i < myConstr.length; i++){
          xyz.append("<option ");
          if ( i==j) xyz.append("selected ");
          xyz.append("value=\"")
              .append( i)
              .append("\">")
              .append(myConstr[i]);
        }
      return xyz.toString();
    }
/*
private void processGroupIdentifstring( String input) {
  int i = input.indexOf('-');
  if (i < 0) return;
  i = input.indexOf( '-', i + 1);
  if (i < 0) return;
  i = i + 1;
  if (input.charAt(i)=='0') return;
  int j = i;
  while (j < input.length()){
    char ch = input.charAt(j);
    if (ch < '0' || ch > '9') break;
    j++;
  }
  int l = j - i;
  int k = 5 - l;
}
*/
private static String processApostrophes( String input) {
    StringBuffer xyz = new StringBuffer();
    for (int i = 0; i < input.length(); i++){
      char ch = input.charAt(i);
      xyz.append(ch);
      if (ch=='\'')xyz.append(ch);
    }
    return xyz.toString();
  }

public HashMap<String,String> setFilter( HttpServletRequest request){
	int j; String idvalue;
    HashMap<String,String> uvz = new HashMap<String,String>();
    StringBuffer xyz = new StringBuffer();
//  forms viewstring
    String idp = request.getParameter("sw_id");
    if (idp!=null && idp.equals("0")){
      idvalue = request.getParameter("sw_id11");
      if (idvalue!=null && !idvalue.equals("0")){
     	uvz.put("sw_id11", idvalue);
        xyz.append(" (myView.id = '")
        .append(idvalue)
        .append("') and ");
      }
    } else {
      idvalue = request.getParameter("sw_id12");
      if (idvalue!=null && !idvalue.equals("")){
       	uvz.put("sw_id12", idvalue);
        xyz.append(" (myView.")
         .append(AssayFieldname.IDENTIFSTRING)
         .append(" like '")
         .append(idvalue)
         .append("%') and ");
      }
    }
    viewIdLength = xyz.length();
    String[] keyArray = request.getParameterValues("sw_key");
    if (keyArray!=null && keyArray.length > 1){
//      String[] constrArray = request.getParameterValues("sw_constr");
      String[] valueArray = request.getParameterValues("sw_value");
      for (int i = 0; i < keyArray.length; i++) {
        String value = valueArray[i];
        if (value != null && !value.equals("")) {
          String key = "sw_"+keyArray[i];
          String p = request.getParameter(key);
          if (p!=null && p.equals("1")) value = value + '%';
          uvz.put(key,value);
          if (value.indexOf('\'')>=0) value = processApostrophes( value);
          xyz.append(" (myView.")
          .append(keyArray[i])
          .append(" like '")
          .append(value)
          .append("') and ");
        }
      }
    }
    j = xyz.length();
    if (j > 5){xyz.delete(j - 5, j);viewString = xyz.toString();}
    else viewString = null;
//forms groupstring
    xyz.setLength(0);
    idp = request.getParameter("sg_id");
    if (idp!=null && idp.equals("0")){
      idvalue = request.getParameter("sg_id11");
      if (idvalue!=null && !idvalue.equals("0")){
     	uvz.put("sg_id11", idvalue);
        xyz.append(" (myGroup.id = '")
        .append(idvalue)
        .append("') and ");
      }
    } else {
      idvalue = request.getParameter("sg_id12");
      if (idvalue!=null && !idvalue.equals("")){
       	uvz.put("sg_id12", idvalue);
        xyz.append(" (myGroup.")
         .append(AssayFieldname.IDENTIFSTRING)
         .append(" like '")
         .append(idvalue)
         .append("%') and ");
      }
    }
    groupIdLength = xyz.length();
    keyArray = request.getParameterValues("sg_key");
    if (keyArray!=null && keyArray.length > 1){
//      String[] constrArray = request.getParameterValues("sg_constr");
      String[] valueArray = request.getParameterValues("sg_value");
      for (int i = 0; i < keyArray.length; i++) {
//      	Util.writeLog("sg_key", "sg_"+keyArray[i], "");
        String value = valueArray[i];
        if (value != null && !value.equals("")) {
          String key = "sg_"+keyArray[i];
          String p = request.getParameter(key);
          if (p!=null && p.equals("1")) value = value + '%';
          uvz.put(key,value);
//        	Util.writeLog("sg_key", "sg_values", value);
          if (value.indexOf('\'')>=0) value = processApostrophes( value);
          xyz.append(" (myGroup.")
          .append(keyArray[i])
          .append(" like '")
          .append(value)
          .append("') and ");
        }
      }
    }
    j = xyz.length();
    if (j > 5){xyz.delete(j - 5, j);groupString = xyz.toString();}
    else groupString = null;
//forms assaystring
    xyz.setLength(0);
    keyArray = request.getParameterValues("key");
    if (keyArray!=null && keyArray.length > 1){
//      String[] constrArray = request.getParameterValues("constr");
      String[] valueArray = request.getParameterValues("value");
      for (int i = 0; i < keyArray.length; i++) {
        String value = valueArray[i];
        if (value != null && !value.equals("")) {
          String key = keyArray[i];
          String p = request.getParameter(key);
          if (p!=null && p.equals("1")) value = value + '%';
          uvz.put(key,value);
          if (value.indexOf('\'')>=0) value = processApostrophes( value);
          xyz.append(" (myAssay.")
          .append(keyArray[i])
          .append(" like '")
          .append(value)
          .append("') and ");
//          if (value.indexOf('%')<0) xyz.append("%') and ");
        }
      }
    }
    j = xyz.length();
    if (j > 5){xyz.delete(j - 5, j);assayString = xyz.toString();}
    else assayString = null;
//forms ownerstring for group
    xyz.setLength(0);
    String owgroup = request.getParameter("ow_group");
    if (owgroup != null && !owgroup.equals("")) {
      uvz.put("ow_group",owgroup);
      xyz.append(" (myGroup.ownerGroup = '")
         .append(owgroup)
         .append("') and ");
      }
      String owuser = request.getParameter("ow_user");
      if (owuser != null && !owuser.equals("")) {
        uvz.put("ow_user",owuser);
        xyz.append(" (myGroup.owner = '")
           .append(owuser)
           .append("') and ");
      }
      j = xyz.length();
      if (j > 5){xyz.delete(j - 5, j);ownerStringForGroup = xyz.toString();}
      else ownerStringForGroup = null;
//    forms ownerstring for view
      xyz.setLength(0);
      owgroup = request.getParameter("ow_group");
      if (owgroup != null && !owgroup.equals("")) {
        uvz.put("ow_group",owgroup);
        xyz.append(" (myView.ownerGroup = '")
           .append(owgroup)
           .append("') and ");
        }
        owuser = request.getParameter("ow_user");
        if (owuser != null && !owuser.equals("")) {
          uvz.put("ow_user",owuser);
          xyz.append(" (myView.owner = '")
             .append(owuser)
             .append("') and ");
        }
        j = xyz.length();
        if (j > 5){xyz.delete(j - 5, j);ownerStringForView = xyz.toString();}
        else ownerStringForView = null;
//        Util.writeLog(viewString, groupString, assayString);
    return uvz;
  }

public void setViewId( String idvalue, HashMap<String,String> uvz){
    StringBuffer xyz = new StringBuffer();
    int alength = viewIdLength;
    boolean blength = (viewString==null)?false : viewString.length()>alength;
    uvz.remove("sw_id12");	
    uvz.put("sw_id11", idvalue);
    xyz.append(" (myView.id = '")
       .append(idvalue)
       .append((blength)?"') and ":"')");
    viewIdLength = xyz.length();
    if (blength) xyz.append( viewString.substring( alength));
    viewString = xyz.toString();    
}
public void clearViewId( HashMap<String,String> uvz){
    StringBuffer xyz = new StringBuffer();
    int alength = viewIdLength;
    boolean blength = (viewString==null)?false : viewString.length()>alength;
    uvz.remove("sw_id12");	
    uvz.remove("sw_id11");
    viewIdLength = 0;
    if (blength) xyz.append( viewString.substring( alength));
    viewString = (xyz.length()>0)? xyz.toString():null;    
}
public void setGroupId( String idvalue, HashMap<String,String> uvz){
    StringBuffer xyz = new StringBuffer();
    int alength = groupIdLength;
    boolean blength = (groupString==null)?false : groupString.length()>alength;
    uvz.remove("sg_id12");	
    uvz.put("sg_id11", idvalue);
    xyz.append(" (myGroup.id = '")
       .append(idvalue)
       .append((blength)?"') and ":"')");
    groupIdLength = xyz.length();
    if (blength) xyz.append( groupString.substring( alength));
    groupString = xyz.toString();    
}
public void clearGroupId( HashMap<String,String> uvz){
    StringBuffer xyz = new StringBuffer();
    int alength = groupIdLength;
    boolean blength = (groupString==null)?false : groupString.length()>alength;
    uvz.remove("sg_id12");	
    uvz.remove("sg_id11");
    groupIdLength = 0;
    if (blength) xyz.append( groupString.substring( alength));
    groupString =  (xyz.length()>0)? xyz.toString():null;    
}

private String myViewString(){
// tiek saukta tikai tad, ja  (viewString!=null) 
    StringBuffer xyz = new StringBuffer();
//    xyz.append("select myGroup from StudyGroup as myGroup");
    if (ownerStringForView!=null)
        xyz.append(" and ")
           .append(ownerStringForView);
    if (viewString!=null)
        xyz.append(" and ")
           .append(viewString);
    return xyz.toString();
}

private String myGroupString(){
    StringBuffer xyz = new StringBuffer();
    if (viewString!=null)
        xyz.append(myViewString());
    else
    if (ownerStringForGroup!=null)
        xyz.append(" and ")
           .append(ownerStringForGroup);
    if (groupString!=null)
        xyz.append(" and ")
           .append(groupString);
    return xyz.toString();
}

private String myAssayString(){
    StringBuffer xyz = new StringBuffer();
//    xyz.append("select myAssay from Assay as myAssay");
    xyz.append(myGroupString());
    if (assayString!=null)
        xyz.append(" and ")
           .append(assayString);
    return xyz.toString();
}

public String getViewString(Long technologyId){
String prefix = (viewString!=null)?
	        " where  myView.technology = '"
     	    + technologyId.toString() + "'"
	        + myViewString():
			" where myView.technology = '"
	   		+ technologyId.toString() + "'";
	  return prefix;
}
public String getGroupString(Long technologyId){
String prefix = (viewString!=null)?
        " ,ViewStudyMembership myMembership"
	    + " ,StudyView myView"
	    + " where myView.technology = '"
	    + technologyId.toString() + "' and myMembership.theView = myView.id"
        + " and myMembership.theGroup = myGroup.id"
        + myGroupString():
		" where myGroup.technology = '"
   		+ technologyId.toString() + "'" + myGroupString();
  return prefix;
}
public String getAssayString(Long technologyId){
	String prefix = (viewString!=null)?
	        " ,ViewStudyMembership myMembership"
		    + " ,StudyView myView"
		    + " ,StudyGroup myGroup"
		    + " where myView.technology = '"
		    + technologyId.toString() + "' and myMembership.theView = myView.id"
	        + " and myMembership.theGroup = myGroup.id"
	        + " and myAssay.studyGroup = myGroup.id "
	        + myAssayString():
			" ,StudyGroup myGroup"
			+ " where myGroup.technology = '"
	   		+ technologyId.toString()
	        + "' and myAssay.studyGroup = myGroup.id "
	   		+ myAssayString();
	  return prefix;
	}
/*
private boolean addValues( String fieldName, String[] values, HashMap toAppend){
 if (values==null || values.length == 0) return false;
 for (int i = 0; i < values.length; i++){
   String key = fieldName + values[i];
   toAppend.put(key, null);
 }
 return true;
}

private boolean addConjunct( String prefix, String[] values, StringBuffer toAppend){
 if (values==null || values.length == 0) return false;
 toAppend.append("(");
 for (int i = 0; i < values.length; i++){
   if (i > 0) toAppend.append("' or ");
   toAppend.append(prefix);
   toAppend.append("='");
   toAppend.append(values[i]);
 }
 toAppend.append("')");
 return true;
}

private Date getLowDate( String year, String month, String day){
    Date myDate = null;
    try {
        int yy = Integer.parseInt(year);
        if (yy>1900&&yy<2100){
            int mm = (month.equals(""))?1:Integer.parseInt(month);
            if (mm>0&&mm<13){
                int dd = (day.equals(""))?1:Integer.parseInt(day);
                if (dd > 0 & dd < 32) {
                    Calendar myCal = Calendar.getInstance();
                    myCal.set(yy, mm - 1, dd, 0, 0);
                    myDate = myCal.getTime();
                }
            }
        }
    } catch (Exception ex) {
    }
    return myDate;
}
private Date getHighDate( String year, String month, String day){
    Date myDate = null;
    try {
        int yy = Integer.parseInt(year);
        if (yy>1900&&yy<2100){
            int mm = (month.equals(""))?12:Integer.parseInt(month);
            if (mm>0&&mm<13){
                int dd = (day.equals(""))?31:Integer.parseInt(day);
                if (dd > 0 & dd < 32) {
                    Calendar myCal = Calendar.getInstance();
                    myCal.set(yy, mm - 1, dd, 23, 59);
                    myDate = myCal.getTime();
                }
            }
        }
    } catch (Exception ex) {
    }
    return myDate;
}
private Date getLowDate( String year){
    Date myDate = null;
    try {
        int yy = Integer.parseInt(year);
        if (yy>1900&&yy<2100){
                    Calendar myCal = Calendar.getInstance();
                    myCal.set(yy, 0, 1, 0, 0);
                    myDate = myCal.getTime();
        }
    } catch (Exception ex) {
    }
    return myDate;
}
private Date getHighDate( String year){
    Date myDate = null;
    try {
        int yy = Integer.parseInt(year);
        if (yy>1900&&yy<2100){
                    Calendar myCal = Calendar.getInstance();
                    myCal.set(yy, 11, 31, 23, 59);
                    myDate = myCal.getTime();
        }
    } catch (Exception ex) {
    }
    return myDate;
}
*/
  private void jbInit() throws Exception {
  }
}
