package assays.com;

import java.util.*;

import assays.hibernate.Parameter;
import assays.hibernate.CommonParameter;
import assays.hibernate.ParameterType;
import assays.hibernate.TempMetaData;
import assays.hibernate.ParameterGroup;
import assays.hibernate.AssayFieldname;
import javax.servlet.http.HttpServletRequest;
import assays.hibernate.AssayTypeName;
import java.io.File;
import javax.xml.parsers.DocumentBuilder;
import org.w3c.dom.Document;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
/**
 *
 * <p>Title: </p>
 *
 * <p>Description:Maintains metadata of particulary technology.
 *   Created and maintained by UserHttpSession. Used by many jsp
 *  </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public final class MetadataManager  implements Comparator<TempMetaData>{
  public MetadataManager() {
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  private HashMap<String,TempMetaData> assayData = null;
  private HashMap<String,TempMetaData> groupData = null;
  private HashMap<String,TempMetaData> viewData = null;
  private int assayViewSize = 0;
  private int groupViewSize = 0;
  private int viewViewSize = 0;
  private static int myUplCount = 0;
  private static String[] myParamName;
  private static int[] myParamNum;
  
  public static String getUploadName(int paramNum){
    for (int i = 0; i < myUplCount; i++) {
      if (myParamNum[i]==paramNum)return myParamName[i];	
    }
    return "";  
  }
  public static String getUploadName(String colName){
    int paramNum = AssayFieldname.getCommonColumnNameNumeric(colName);	
    if (paramNum >= 0)
      for (int i = 0; i < myUplCount; i++) {
        if (myParamNum[i]==paramNum)return myParamName[i];	
      }
    return "";  
  }

  private static int getColumnNameNumeric( String colName){
     int result = 0;
     if (colName.charAt(0)=='F'||colName.charAt(0)=='f')
     try {
         result = Integer.parseInt( colName.substring(1)) +
                            AssayTypeName.COMMON_PARAM_COUNT;
     } catch (Exception ex) {}
     return result ;
  }

  public void buildAssayData(List assayCommonMD, List assayMD) {
    int viewSize = 0;
    assayData = new HashMap<String,TempMetaData>( assayCommonMD.size()+assayMD.size());
    Iterator iter1 = assayCommonMD.iterator();
    while (iter1.hasNext()) {
      CommonParameter metadata = (CommonParameter) iter1.next();
      String key = metadata.getAssayColumnName();
      if (key == null || key.equals("") || assayData.get(key)!=null) continue;
      int pm = AssayFieldname.getCommonColumnNameNumeric(key) ;
      if ( pm < 0) continue;
      TempMetaData meta = new TempMetaData(metadata, 2, false);
      assayData.put(key, meta);
      meta.setUploadName( getUploadName(pm));
      meta.setValueNumber( pm);
      int n = meta.getTempColumnNumber();
      if (n > viewSize) viewSize = n;
      if (pm==AssayFieldname.PROTOCOLnum){  //make protocolfiletype
          meta = new TempMetaData(metadata, 2, false);
          meta.setUploadName( getUploadName(AssayFieldname.PROTOCOLTYPEnum));
          meta.setShortName( "PT");
          meta.setValueNumber( AssayFieldname.PROTOCOLTYPEnum);
          meta.setTempColumnNumber(0);
          assayData.put(AssayFieldname.PROTOCOLTYPE, meta);
      } else
      if (pm==AssayFieldname.DATAFILESnum){  //make datafiletype
          meta = new TempMetaData(metadata, 2, false);
          meta.setUploadName( getUploadName(AssayFieldname.DATAFILESTYPEnum));
          meta.setShortName( "DT");
          meta.setValueNumber( AssayFieldname.DATAFILESTYPEnum);
          meta.setTempColumnNumber(0);
          assayData.put(AssayFieldname.DATAFILESTYPE, meta);
      }
    }
    Iterator iter2 = assayMD.iterator();
    while (iter2.hasNext()) {
      Parameter metadata = (Parameter) iter2.next();
      String key = metadata.getAssayColumnNamef();
      if (key != null && !key.equals("") && assayData.get(key)==null) {
        TempMetaData meta = new TempMetaData(metadata, 2, true);
        assayData.put(key, meta);
        ParameterType paramType = metadata.getParameterType();
        int baseType = paramType.getBaseType().intValue();
        meta.setBaseType( baseType);
        ParameterGroup paramGroup = metadata.getParameterGroup();
        meta.setGroupName( paramGroup.getShortName());
        meta.setGroupLongName( paramGroup.getVisibleName());
        meta.setAttribute1( paramType.getAttribute1());
        meta.setAttribute2( paramType.getAttribute2());
        meta.setRequired(metadata.isRequired());
        if (baseType==AssayTypeName.TABLE && paramType.getVocabulary()!=null)
          meta.setVocabularyId( paramType.getVocabulary().getId());
        meta.setValueNumber( getColumnNameNumeric( key));
        int n = meta.getTempColumnNumber();
        if (n > viewSize) viewSize = n;
      }
    }
// normalization of column numbers
    int target = 0;
    for ( int destin = 1; destin <= viewSize; destin++){
      Iterator iter = assayData.values().iterator();
      while (iter.hasNext()) {
        TempMetaData meta = (TempMetaData) iter.next();
        if (meta.getTempColumnNumber() == destin) {
          target++;
          meta.setViewColumnNumber(target);
        }
      }
    }
    assayViewSize = target;
  }

  public void buildStudyGroupData(List stgrCommonMD, List stgrMD) {
    int viewSize = 0;
    groupData = new HashMap<String,TempMetaData>(stgrCommonMD.size()+stgrMD.size());
    Iterator iter1 = stgrCommonMD.iterator();
    while (iter1.hasNext()) {
      CommonParameter metadata = (CommonParameter) iter1.next();
      String key = metadata.getStgrColumnName();
      if (key == null || key.equals("") || groupData.get(key)!=null) continue;
      int pm = AssayFieldname.getCommonColumnNameNumeric(key) ;
      if ( pm < 0) continue;
        TempMetaData meta = new TempMetaData(metadata, 1, false);
        groupData.put(key, meta);
        meta.setUploadName( getUploadName(pm));
        meta.setValueNumber( pm);
        int n = meta.getTempColumnNumber();
        if (n > viewSize) viewSize = n;
        if (pm==AssayFieldname.PROTOCOLnum){  //make protocolfiletype
          meta = new TempMetaData(metadata, 1, false);
          meta.setUploadName( getUploadName(AssayFieldname.PROTOCOLTYPEnum));
          meta.setShortName( "PT");
          meta.setValueNumber( AssayFieldname.PROTOCOLTYPEnum);
          meta.setTempColumnNumber(0);
          groupData.put(AssayFieldname.PROTOCOLTYPE, meta);
        } else
        if (pm==AssayFieldname.DATAFILESnum){  //make datafiletype
          meta = new TempMetaData(metadata, 1, false);
          meta.setUploadName( getUploadName(AssayFieldname.DATAFILESTYPEnum));
          meta.setShortName( "DT");
          meta.setValueNumber( AssayFieldname.DATAFILESTYPEnum);
          meta.setTempColumnNumber(0);
          groupData.put(AssayFieldname.DATAFILESTYPE, meta);
        }
      }
    Iterator iter2 = stgrMD.iterator();
    while (iter2.hasNext()) {
      Parameter metadata = (Parameter) iter2.next();
      String key = metadata.getStgrColumnNamef();
      if (key != null && !key.equals("") && groupData.get(key)==null) {
        TempMetaData meta = new TempMetaData(metadata, 1, true);
        groupData.put(key, meta);
        ParameterType paramType = metadata.getParameterType();
        int baseType = paramType.getBaseType().intValue();
        meta.setBaseType( baseType);
        ParameterGroup paramGroup = metadata.getParameterGroup();
        meta.setGroupName( paramGroup.getShortName());
        meta.setGroupLongName( paramGroup.getVisibleName());
        meta.setAttribute1( paramType.getAttribute1());
        meta.setAttribute2( paramType.getAttribute2());
        meta.setRequired(metadata.isRequired());
        if (baseType==AssayTypeName.TABLE && paramType.getVocabulary()!=null)
          meta.setVocabularyId( paramType.getVocabulary().getId());
        meta.setValueNumber( getColumnNameNumeric( key));
        int n = meta.getTempColumnNumber();
        if (n > viewSize) viewSize = n;
      }
    }
    // normalization of column numbers
        int target = 0;
        for ( int destin = 1; destin <= viewSize; destin++){
          Iterator iter = groupData.values().iterator();
          while (iter.hasNext()) {
            TempMetaData meta = (TempMetaData) iter.next();
            if (meta.getTempColumnNumber() == destin) {
              target++;
              meta.setViewColumnNumber(target);
            }
          }
        }
        groupViewSize = target;
  }

  public void buildStudyViewData(List stvwCommonMD, List stvwMD) {
    int viewSize = 0;
    viewData = new HashMap<String,TempMetaData>(stvwCommonMD.size()+stvwMD.size());
    Iterator iter1 = stvwCommonMD.iterator();
    while (iter1.hasNext()) {
      CommonParameter metadata = (CommonParameter) iter1.next();
      String key = metadata.getViewColumnName();
      if (key == null || key.equals("") || viewData.get(key)!=null) continue;
      int pm = AssayFieldname.getCommonColumnNameNumeric(key) ;
      if ( pm < 0) continue;
        TempMetaData meta = new TempMetaData(metadata, 0, false);
        viewData.put(key, meta);
        meta.setUploadName( getUploadName(pm));
        meta.setValueNumber( pm);
        int n = meta.getTempColumnNumber();
        if (n > viewSize) viewSize = n;
        if (pm==AssayFieldname.PROTOCOLnum){  //make protocolfiletype
          meta = new TempMetaData(metadata, 0, false);
          meta.setUploadName( getUploadName(AssayFieldname.PROTOCOLTYPEnum));
          meta.setShortName( "PT");
          meta.setValueNumber( AssayFieldname.PROTOCOLTYPEnum);
          meta.setTempColumnNumber(0);
          viewData.put(AssayFieldname.PROTOCOLTYPE, meta);
        } else
        if (pm==AssayFieldname.DATAFILESnum){  //make datafiletype
          meta = new TempMetaData(metadata, 0, false);
          meta.setUploadName( getUploadName(AssayFieldname.DATAFILESTYPEnum));
          meta.setShortName( "DT");
          meta.setValueNumber( AssayFieldname.DATAFILESTYPEnum);
          meta.setTempColumnNumber(0);
          viewData.put(AssayFieldname.DATAFILESTYPE, meta);
        }
      }
    Iterator iter2 = stvwMD.iterator();
    while (iter2.hasNext()) {
      Parameter metadata = (Parameter) iter2.next();
      String key = metadata.getViewColumnNamef();
      if (key != null && !key.equals("") && viewData.get(key)==null) {
        TempMetaData meta = new TempMetaData(metadata, 0, true);
        viewData.put(key, meta);
        ParameterType paramType = metadata.getParameterType();
        int baseType = paramType.getBaseType().intValue();
        meta.setBaseType( baseType);
        ParameterGroup paramGroup = metadata.getParameterGroup();
        meta.setGroupName( paramGroup.getShortName());
        meta.setGroupLongName( paramGroup.getVisibleName());
        meta.setAttribute1( paramType.getAttribute1());
        meta.setAttribute2( paramType.getAttribute2());
        meta.setRequired(metadata.isRequired());
        if (baseType==AssayTypeName.TABLE && paramType.getVocabulary()!=null)
          meta.setVocabularyId( paramType.getVocabulary().getId());
        meta.setValueNumber( getColumnNameNumeric( key));
        int n = meta.getTempColumnNumber();
        if (n > viewSize) viewSize = n;
      }
    }
    // normalization of column numbers
        int target = 0;
        for ( int destin = 1; destin <= viewSize; destin++){
          Iterator iter = viewData.values().iterator();
          while (iter.hasNext()) {
            TempMetaData meta = (TempMetaData) iter.next();
            if (meta.getTempColumnNumber() == destin) {
              target++;
              meta.setViewColumnNumber(target);
            }
          }
        }
        viewViewSize = target;
  }

  public boolean isAssayFieldPresent(String key) {
    TempMetaData metadata = (TempMetaData) assayData.get(key);
    return (metadata != null);
  }
  public boolean isStudyGroupFieldPresent(String key) {
    TempMetaData metadata = (TempMetaData) groupData.get(key);
    return (metadata != null);
  }
  public boolean isStudyViewFieldPresent(String key) {
    TempMetaData metadata = (TempMetaData) viewData.get(key);
    return (metadata != null);
  }
  public String getAssayLongName(String key) {
    TempMetaData metadata = (TempMetaData) assayData.get(key);
    return (metadata != null) ? metadata.getLongName() : key;
  }
  public String getStudyGroupLongName(String key) {
    TempMetaData metadata = (TempMetaData) groupData.get(key);
    return (metadata != null) ? metadata.getLongName() : key;
  }
  public String getStudyViewLongName(String key) {
    TempMetaData metadata = (TempMetaData) viewData.get(key);
    return (metadata != null) ? metadata.getLongName() : key;
  }

  public TempMetaData[] getAssayParameterArray(){
    TempMetaData[] typeArray = new TempMetaData[assayViewSize];
    Iterator iter = assayData.values().iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      if (metadata.getViewColumnNumber() > 0) {
        typeArray[metadata.getViewColumnNumber() - 1] = metadata;
      }
    }
    return typeArray;
  }
  public TempMetaData[] getStudyGroupParameterArray(){
    TempMetaData[] typeArray = new TempMetaData[groupViewSize];
    Iterator iter = groupData.values().iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      if (metadata.getViewColumnNumber() > 0) {
        typeArray[metadata.getViewColumnNumber() - 1] = metadata;
      }
    }
    return typeArray;
  }
  public TempMetaData[] getStudyViewParameterArray(){
    TempMetaData[] typeArray = new TempMetaData[viewViewSize];
    Iterator iter = viewData.values().iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      if (metadata.getViewColumnNumber() > 0) {
        typeArray[metadata.getViewColumnNumber() - 1] = metadata;
      }
    }
    return typeArray;
  }

  public String[] getAssayGroupNames() {
    String[] groupArray = new String[assayViewSize];
    Iterator iter = assayData.values().iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      if (metadata.getViewColumnNumber() > 0) {
        groupArray[metadata.getViewColumnNumber() - 1] =
            metadata.getGroupName();
      }
    }
    return groupArray;
  }

  public void printAssayIndexArray() {
    System.out.println("---get Assay Index Array");
    Iterator iter = assayData.values().iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      String key = metadata.getColumnName();
      if (key != null && !key.equals("")) System.out.print(key);
      int n = metadata.getViewColumnNumber();
      if (n > 0) {
        System.out.print("=");
        System.out.print(n);
        System.out.print("=");
        System.out.print(metadata.getValueNumber());
      }
      System.out.print(";");
    }
    System.out.println(";");
  }

  public void printAssayData() {
    System.out.println("---get Assay Data");
    Iterator iter = assayData.values().iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      String key = metadata.getColumnName();
      if (key != null && !key.equals("")) System.out.print(key);
      System.out.print("=");
      String longn = metadata.getLongName();
      System.out.print(longn);
      System.out.print("=");
      System.out.print(metadata.getValueNumber());
      System.out.println(";");
    }
  }

  public byte[] getAssayIndexArray() {
    byte[] indexArray =
        new byte[AssayTypeName.COMMON_PARAM_COUNT+AssayTypeName.PARAM_COUNT];
    Iterator iter = assayData.values().iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      if (metadata.getViewColumnNumber() > 0) {
        indexArray[metadata.getValueNumber()] =
            (byte)metadata.getViewColumnNumber();
      }
    }
    return indexArray;
  }

  public String[] getStudyGroupGroupNames() {
    String[] groupArray = new String[groupViewSize];
    Iterator iter = groupData.values().iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      if (metadata.getViewColumnNumber() > 0) {
        groupArray[metadata.getViewColumnNumber() - 1] =
            metadata.getGroupName();
      }
    }
    return groupArray;
  }
  public byte[] getStudyGroupIndexArray() {
    byte[] indexArray =
        new byte[AssayTypeName.COMMON_PARAM_COUNT + AssayTypeName.PARAM_COUNT];
    Iterator iter = groupData.values().iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      if (metadata.getViewColumnNumber() > 0) {
        indexArray[metadata.getValueNumber()] =
            (byte)metadata.getViewColumnNumber();
      }
    }
    return indexArray;
  }

  public String[] getStudyViewGroupNames() {
    String[] groupArray = new String[viewViewSize];
    Iterator iter = viewData.values().iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      if (metadata.getViewColumnNumber() > 0) {
        groupArray[metadata.getViewColumnNumber() - 1] =
            metadata.getGroupName();
      }
    }
    return groupArray;
  }
  public byte[] getStudyViewIndexArray() {
    byte[] indexArray =
        new byte[AssayTypeName.COMMON_PARAM_COUNT + AssayTypeName.PARAM_COUNT];
    Iterator iter = viewData.values().iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      if (metadata.getViewColumnNumber() > 0) {
        indexArray[metadata.getValueNumber()] =
            (byte)metadata.getViewColumnNumber();
      }
    }
    return indexArray;
  }

  public int[] getGroupAlternation(String[] groupArray) {
    int size = groupArray.length;
    String current = null; int asize = 0;
    for (int i = 0; i < size; i++){
      if (!groupArray[i].equals(current)){
        current = groupArray[i]; asize++;
      }
    }
    int[] altArray = new int[asize];
    if (asize>0){
      current = groupArray[0];
      int k = 0;
      int l = 0;
      for (int i = 0; i < size; i++) {
        if (!groupArray[i].equals(current)) {
          altArray[k++] = l;
          l = 1;
          current = groupArray[i];
        }
        else
          l++;
      }
      altArray[k] = l;
    }
    return altArray;
  }
//folloving methods used by DefineView
/*
  public Collection getStudyGroupMetadata(){
    return groupData.values();
  }

  public Collection getAssayMetadata(){
    TempMetaData metadata = (TempMetaData) groupData.get(key);
    return assayData.values();
  }
*/
public TempMetaData getStudyGroupMetadata( String key){
  TempMetaData metadata = (TempMetaData) groupData.get(key);
  return metadata;
}
public TempMetaData getAssayMetadata( String key){
  TempMetaData metadata = (TempMetaData) assayData.get(key);
  return metadata;
}
public TempMetaData getStudyViewMetadata( String key){
  TempMetaData metadata = (TempMetaData) viewData.get(key);
  return metadata;
}

public int getStudyGroupViewColumnNumber( String key){
    TempMetaData metadata = (TempMetaData)groupData.get(key);
    return (metadata!=null)?metadata.getViewColumnNumber():0;
}
public int getAssayViewColumnNumber( String key){
    TempMetaData metadata = (TempMetaData)assayData.get(key);
    return (metadata!=null)?metadata.getViewColumnNumber():0;
}
public int getStudyViewViewColumnNumber( String key){
    TempMetaData metadata = (TempMetaData)viewData.get(key);
    return (metadata!=null)?metadata.getViewColumnNumber():0;
}

public void copyStudyGroupColumnNumbers() {
  Iterator iter = groupData.values().iterator();
  while (iter.hasNext()) {
    TempMetaData metadata = (TempMetaData) iter.next();
    metadata.setTempColumnNumber(metadata.getViewColumnNumber());
  }
}
public void copyAssayColumnNumbers() {
  Iterator iter = assayData.values().iterator();
  while (iter.hasNext()) {
    TempMetaData metadata = (TempMetaData) iter.next();
    metadata.setTempColumnNumber(metadata.getViewColumnNumber());
  }
}
public void copyStudyViewColumnNumbers() {
  Iterator iter = viewData.values().iterator();
  while (iter.hasNext()) {
    TempMetaData metadata = (TempMetaData) iter.next();
    metadata.setTempColumnNumber(metadata.getViewColumnNumber());
  }
}

public void saveStudyGroupColumnNumbers() {
  Iterator iter = groupData.values().iterator();
  groupViewSize = 0;
  while (iter.hasNext()) {
    TempMetaData metadata = (TempMetaData) iter.next();
    int num = metadata.getTempColumnNumber();
    if ( num > 0) groupViewSize++;
    metadata.setViewColumnNumber( num);
  }
}
public void saveAssayColumnNumbers() {
  Iterator iter = assayData.values().iterator();
  assayViewSize = 0;
  while (iter.hasNext()) {
    TempMetaData metadata = (TempMetaData) iter.next();
    int num = metadata.getTempColumnNumber();
    if ( num > 0) assayViewSize++;
    metadata.setViewColumnNumber( num);
  }
}
public void saveStudyViewColumnNumbers() {
  Iterator iter = viewData.values().iterator();
  viewViewSize = 0;
  while (iter.hasNext()) {
    TempMetaData metadata = (TempMetaData) iter.next();
    int num = metadata.getTempColumnNumber();
    if ( num > 0) viewViewSize++;
    metadata.setViewColumnNumber( num);
  }
}

  public List getAssayMetadataOrdered(){
    ArrayList<TempMetaData> dataList = new ArrayList<TempMetaData>( assayData.values());
    Collections.sort(dataList, this);
    return dataList;
  }
  public List getStudyGroupMetadataOrdered(){
    ArrayList<TempMetaData> dataList = new ArrayList<TempMetaData>( groupData.values());
    Collections.sort(dataList, this);
    return dataList;
  }
  public List getStudyViewMetadataOrdered(){
    ArrayList<TempMetaData> dataList = new ArrayList<TempMetaData>( viewData.values());
    Collections.sort(dataList, this);
    return dataList;
  }

  public int compare(TempMetaData data1, TempMetaData data2)
  {

      if (data1.getTempColumnNumber() != data2.getTempColumnNumber()){
        if (data1.getTempColumnNumber() == 0)return 1;
        if (data2.getTempColumnNumber() == 0)return -1;
        return data1.getTempColumnNumber() - data2.getTempColumnNumber();
      }
      return -1;
  }
//used by DefineAssayView
  public void processAssayColumns( HttpServletRequest request)
  {
    String[] keyArray = request.getParameterValues("key");
    if (keyArray!=null && keyArray.length > 1){
      String[] num1Array = request.getParameterValues("column");
      String[] num2Array = request.getParameterValues("column_10");
      int[]numArray = new int[keyArray.length];
      int max = 0;
      for (int i = 0; i < keyArray.length; i++){
        numArray[i] = Util.getIntegerValue( num1Array[i] + num2Array[i]);
        if (numArray[i] > max) max = numArray[i];
      }
      clearTempColumnNumber(2);
      int target = 0;
      for ( int destin = 1; destin <= max; destin++){
        for (int i = 0; i < keyArray.length; i++){
          if (numArray[i] == destin) {
            TempMetaData metadata = getAssayMetadata( keyArray[i]);
            metadata.setTempColumnNumber( ++target);
          }
        }
      }
    }
  }
//used by DefineStudyGroupView
  public void processStudyGroupColumns( HttpServletRequest request)
  {
    String[] keyArray = request.getParameterValues("key");
    if (keyArray!=null && keyArray.length > 1){
      String[] num1Array = request.getParameterValues("column");
      String[] num2Array = request.getParameterValues("column_10");
      int[]numArray = new int[keyArray.length];
      int max = 0;
      for (int i = 0; i < keyArray.length; i++){
        numArray[i] = Util.getIntegerValue( num1Array[i] + num2Array[i]);
        if (numArray[i] > max) max = numArray[i];
      }
      clearTempColumnNumber(1);
      int target = 0;
      for ( int destin = 1; destin <= max; destin++){
        for (int i = 0; i < keyArray.length; i++){
          if (numArray[i] == destin) {
            TempMetaData metadata = getStudyGroupMetadata( keyArray[i]);
            metadata.setTempColumnNumber( ++target);
          }
        }
      }
    }
  }
  //used by DefineViewsView
    public void processStudyViewColumns( HttpServletRequest request)
    {
      String[] keyArray = request.getParameterValues("key");
      if (keyArray!=null && keyArray.length > 1){
        String[] num1Array = request.getParameterValues("column");
        String[] num2Array = request.getParameterValues("column_10");
        int[]numArray = new int[keyArray.length];
        int max = 0;
        for (int i = 0; i < keyArray.length; i++){
          numArray[i] = Util.getIntegerValue( num1Array[i] + num2Array[i]);
          if (numArray[i] > max) max = numArray[i];
        }
        clearTempColumnNumber(0);
        int target = 0;
        for ( int destin = 1; destin <= max; destin++){
          for (int i = 0; i < keyArray.length; i++){
            if (numArray[i] == destin) {
              TempMetaData metadata = getStudyViewMetadata( keyArray[i]);
              metadata.setTempColumnNumber( ++target);
            }
          }
        }
      }
    }
//--------------------------------------------------------------------
//---------------- Report/import -------------------------------------
//--------------------------------------------------------------------
//  private static String[] myParam;
//  private static int[] myParamValue;
  // this method uses BatchAnalyser by analysis of header
  public TempMetaData findParameter(int level, String gName, String pName){
    Iterator iter = (level==2)?assayData.values().iterator():
                    (level==1)?groupData.values().iterator():
                    viewData.values().iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      if (metadata.getGroupLongName().equals( gName) &&
          metadata.getUploadName().equals( pName)) return metadata;
    }
    return null;
  }
// this method uses BatchAnalyser by analysis of header
  public String findKey( String pName){
    int j = pName.indexOf('#');
    String key = (j < 3) ? pName : pName.substring(0, j);
    for (int i = 0; i < myParamName.length; i++) {
      if (key.equals(myParamName[i])) {
        int k = myParamName[i].length();
        return pName.substring(k);
      }
    }
    return "";
  }
  public TempMetaData findParameter(int level, String pName){
    int j = pName.indexOf('#');
    String key = (j<3)?pName:pName.substring(0,j);
    for (int i = 0; i < myParamName.length; i++){
      if (key.equals(myParamName[ i])){
        int num = myParamNum[i];
        Iterator iter = (level==2)?assayData.values().iterator():
                        (level==1)?groupData.values().iterator():
                        viewData.values().iterator();
        while (iter.hasNext()) {
          TempMetaData metadata = (TempMetaData) iter.next();
          if (metadata.getValueNumber()==num) return metadata;
        }
        break;
      }
    }
    return null;
  }
//this uses ExportData.jsp
  public String getParameterHeaderName( int num){
    for (int i = 0; i < myParamName.length; i++){
      if (num == myParamNum[i]) return myParamName[i];
    }
    return null;
  }
//this uses ExportBatchHeader.jsp
  private boolean checkParamNum( int paramNum){
	boolean result = (paramNum==AssayFieldname.CREATORnum)?false:
		(paramNum==AssayFieldname.CREATEDATEnum)?false:
		(paramNum==AssayFieldname.CREATORnum)?false:
		(paramNum==AssayFieldname.MODIFDATEnum)?false:
		(paramNum==AssayFieldname.MODIFIERnum)?false:
		(paramNum==AssayFieldname.DATAFILESTYPEnum)?false:
		(paramNum==AssayFieldname.EXPORTSTATUSnum)?false:
		(paramNum==AssayFieldname.PROTOCOLTYPEnum)?false:
		(paramNum==AssayFieldname.SIMSREFIDnum)?false:true;
	return result;
  }
  public String getAssayParameterHeader( List params){
    StringBuffer xyz = new StringBuffer();  
    boolean flag = true;
    for (int i = 0; i < myParamName.length; i++){  //without types
      if (checkParamNum(myParamNum[ i])){
    	if (flag) flag = false; else xyz.append('\t');
        xyz.append( getBottomPrefix());
        xyz.append(myParamName[ i]);
      }  
    }
    Iterator iter = params.iterator();
    while (iter.hasNext()) {
      Parameter param = (Parameter) iter.next();
      String key = param.getAssayColumnNamef();
      TempMetaData metadata = (TempMetaData) assayData.get(key);
      if (metadata!=null && metadata.getValueNumber() > AssayTypeName.COMMON_PARAM_COUNT){
      	if (flag) flag = false; else xyz.append('\t');
        xyz.append( getBottomPrefix())
           .append(metadata.getGroupLongName())
           .append('.')
           .append(metadata.getUploadName());
      }  
    }
    return xyz.toString();
  }
  public String getStudyGroupParameterHeader( List params){
    StringBuffer xyz = new StringBuffer();
    boolean flag = true;
    for (int i = 0; i < myParamName.length; i++){  //without types
      if (checkParamNum(myParamNum[ i])){
      	if (flag) flag = false; else xyz.append('\t');
        xyz.append( getMiddlePrefix());
        xyz.append(myParamName[ i]);
      }  
    }
    Iterator iter = params.iterator();
    while (iter.hasNext()) {
      Parameter param = (Parameter) iter.next();
      String key = param.getStgrColumnNamef();
      TempMetaData metadata = (TempMetaData) groupData.get(key);
      if (metadata!=null && metadata.getValueNumber() > AssayTypeName.COMMON_PARAM_COUNT){
      	if (flag) flag = false; else xyz.append('\t');
        xyz.append( getMiddlePrefix())
           .append(metadata.getGroupLongName())
           .append('.')
           .append(metadata.getUploadName());
      } 
    }
    return xyz.toString();
  }
  public String getStudyViewParameterHeader( List params){
    StringBuffer xyz = new StringBuffer();
    boolean flag = true;
    for (int i = 0; i < myParamName.length; i++){  //without types
      if (checkParamNum(myParamNum[ i])){
      	if (flag) flag = false; else xyz.append('\t');
        xyz.append( getTopPrefix(0));  //topnum=???
        xyz.append(myParamName[ i]);
      }  
    }
    Iterator iter = params.iterator();
    while (iter.hasNext()) {
      Parameter param = (Parameter) iter.next();
      String key = param.getStgrColumnNamef();
      TempMetaData metadata = (TempMetaData) viewData.get(key);
      if (metadata!=null && metadata.getValueNumber() > AssayTypeName.COMMON_PARAM_COUNT){
       	if (flag) flag = false; else xyz.append('\t');
        xyz.append( getTopPrefix(0))  //topnum=???
           .append(metadata.getGroupLongName())
           .append('.')
           .append(metadata.getUploadName());
      }  
    }
    return xyz.toString();
  }
// this method not used by BatchAnalyser before it works
  public void clearTempColumnNumber(int level) {
    Iterator iter = (level==2)?assayData.values().iterator():
                    (level==1)?groupData.values().iterator():
                    viewData.values().iterator();
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      metadata.setTempColumnNumber(0);
    }
  }
//this method uses BatchAnalyser after it fills tempColumnNumbers
  public TempMetaData[] getInputParameterArray( int level, int size) {
    Iterator iter = (level==2)?assayData.values().iterator():
                    (level==1)?groupData.values().iterator():
                    viewData.values().iterator();
    TempMetaData[] paramArray = new TempMetaData[ size];
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      if (metadata.getTempColumnNumber() > 0) {
        paramArray[metadata.getTempColumnNumber()] = metadata;
      }
    }
    return paramArray;
  }
//this method used by BatchAnalyser to get missing required field name
  public String checkRequiredParameter(int level){
    Iterator iter = (level==2)?assayData.values().iterator():
                    (level==1)?groupData.values().iterator():
                    viewData.values().iterator();
    String prefix = (level==2)? getBottomPrefix():
                               getMiddlePrefix();
// te vel japieliek
    while (iter.hasNext()) {
      TempMetaData metadata = (TempMetaData) iter.next();
      if (metadata.isRequired() && metadata.getTempColumnNumber()==0)
        return prefix + metadata.getGroupLongName() + '.' + metadata.getUploadName();
    }
    return null;
  }
//--------------------------------------------------------------------
//-----------------   lEVEL NAMES  -----------------------------------
//--------------------------------------------------------------------
  private static String[][] myLevelName
  = {
   {"Views", "View", "View."},
   {"Studies", "Study", "Study."},
   {"Assays", "Assay", "Assay."}
  };

  private static String[][] myTopLevelNameNew
 = {
  {"Views", "View", "View.", "VA-"},
  {"ViewsB", "ViewB", "ViewB.", "VB-"},
  {"ViewsC", "ViewC", "ViewC.", "VC-"}
 };
 private static int viewCount = 1;
 public static final int MAX_VIEW_COUNT = 4; //not used pagaidam
 public static int getViewCount(){ return viewCount;}
 public static String getTopPlural(int num){ return myTopLevelNameNew[num][0];}
 public static String getTopSingular(int num){ return myTopLevelNameNew[num][1];}
 public static String getTopPrefix(int num){ return myTopLevelNameNew[num][2];}
 public static String getTopNamePrefix(int num){ return myTopLevelNameNew[num][3];}
 public static String getTopPlural(){ return myLevelName[0][0];}
 public static String getMiddlePlural(){ return myLevelName[1][0];}
 public static String getMiddleSingular(){ return myLevelName[1][1];}
 public static String getMiddlePrefix(){ return myLevelName[1][2];}
 public static String getBottomPlural(){ return myLevelName[2][0];}
 public static String getBottomSingular(){ return myLevelName[2][1];}
 public static String getBottomPrefix(){ return myLevelName[2][2];}

 private static int processMainNames( Element root) throws Exception {
   int result = 0;
   myLevelName = new String[3][3];
   NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XBottom);
   int k = nodeLst1.getLength();
   if (k != 1){ result = 1;
     Util.writeAccessLog("System constants:","Invalid Bottom name","");
   }
   else {
     Element bottom = (Element) nodeLst1.item(0);
     myLevelName[2][0] = bottom.getAttribute(XMLTags.Xplural);
     myLevelName[2][1] = bottom.getAttribute(XMLTags.Xsingular);
     myLevelName[2][2] = bottom.getAttribute(XMLTags.Xprefix);
   }
   nodeLst1 = root.getElementsByTagName(XMLTags.XMiddle);
   k = nodeLst1.getLength();
   if (k != 1){ result = 1;
     Util.writeAccessLog("System constants:","Invalid Middle name","");
   }
   else {
     Element middle = (Element) nodeLst1.item(0);
     myLevelName[1][0] = middle.getAttribute(XMLTags.Xplural);
     myLevelName[1][1] = middle.getAttribute(XMLTags.Xsingular);
     myLevelName[1][2] = middle.getAttribute(XMLTags.Xprefix);
   }
   nodeLst1 = root.getElementsByTagName(XMLTags.XTop);
   k = nodeLst1.getLength();
   if (k != 1){ result = 1;
     Util.writeAccessLog("System constants:","Invalid Top name","");
   }
   else {
     Element top = (Element) nodeLst1.item(0);
     nodeLst1 = top.getElementsByTagName(XMLTags.XView);
     k = nodeLst1.getLength();
     if (k < 1){ result = 1;
       Util.writeAccessLog("System constants:","Too few View names","");
     }
     else {
       Element view = (Element) nodeLst1.item(0);
       myLevelName[0][0] = view.getAttribute(XMLTags.Xplural);
       myLevelName[0][1] = view.getAttribute(XMLTags.Xsingular);
       myLevelName[0][2] = view.getAttribute(XMLTags.Xprefix);
       viewCount = k;
       myTopLevelNameNew = new String[k][4];
       for (int i = 0; i < k; i++) {
         view = (Element) nodeLst1.item(i);
         myTopLevelNameNew[i][0] = view.getAttribute(XMLTags.Xplural);
         myTopLevelNameNew[i][1] = view.getAttribute(XMLTags.Xsingular);
         myTopLevelNameNew[i][2] = view.getAttribute(XMLTags.Xprefix);
         myTopLevelNameNew[i][3] = view.getAttribute(XMLTags.Xname_prefix);
       }
     }
   }
   return result;
 }
  private static int processUploadNames( Element root) throws Exception {
    int result = 0;  myUplCount = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XUploadName);
    int k = nodeLst1.getLength();
    if (k < 1){ result = 1;
      Util.writeAccessLog("System constants:","Too few uploadname","");
    }
    else {
      myParamName = new String[k];
      myParamNum = new int[k];
      for (int i = 0; i < k; i++) {
        Element group = (Element) nodeLst1.item(i);
        String columnname = group.getAttribute(XMLTags.Xcolumn);
        String uploadname = group.getAttribute(XMLTags.Xupload);
        int m = AssayFieldname.getCommonColumnNameNumeric(columnname);
        if (m < 0) {
          Util.writeAccessLog("System constants:","Invalid column name",columnname);
          result = 2;
        } else {
          myParamNum[myUplCount] = m; myParamName[myUplCount] = uploadname;
          myUplCount++;
        }
      }
    }
    return result;
  }
  private static int processRoot( Element root) throws Exception{
    int result = 0;
    String version = root.getAttribute(XMLTags.Xversion);
    if (version==null||!version.equals("1.17")){
      Util.writeAccessLog("System constants:","Invalid version","");
      return 1;
    }
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XAssayUploadNames);
    int num = nodeLst1.getLength();
    if ( num != 1){
      Util.writeAccessLog("System constants:","Invalid upload names","");
      return 1;
    }
    result = processUploadNames( (Element)nodeLst1.item(0));
    nodeLst1 = root.getElementsByTagName(XMLTags.XAssayMainNames);
    num = nodeLst1.getLength();
    if ( num != 1){
      Util.writeAccessLog("System constants:","Invalid main names","");
      return 1;
    }
    result = processMainNames( (Element)nodeLst1.item(0));
    return result;
  }
  public static int processConstants( File systemConst){
    int result = 0;
    try {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      DocumentBuilder db = dbf.newDocumentBuilder();
      Document doc = db.parse(systemConst);
      Element root = doc.getDocumentElement();
      root.normalize();
      result = processRoot( root);
    }
    catch (Exception e) {
      if (e!=null){
      java.io.CharArrayWriter cw = new java.io.CharArrayWriter();
      java.io.PrintWriter pw = new java.io.PrintWriter(cw,true);
      e.printStackTrace(pw);
      Util.writeAccessLog(cw.toString(),"","");
     }
     result = 1;
    }

    return result;
  }

  public static String getLevelName(Integer level){
	if (level!=null)
      switch (level.intValue()){
        case 3: return getTopSingular(0);
        case 2: return getMiddleSingular();
        case 1: return getBottomSingular();
      }
	return "no";  
  }
  public static String getLevelPrompter(Integer level){
	int lValue = (level==null)? 0:level.intValue();
    StringBuffer xyz = new StringBuffer();
    xyz.append("<option ");
    if (lValue==0)xyz.append("selected ");	        
    xyz.append("value='0'>no");
    xyz.append("<option ");
    if (lValue==1)xyz.append("selected ");	        
    xyz.append("value='1'>");
    xyz.append(getBottomSingular());
    xyz.append("<option ");
    if (lValue==2)xyz.append("selected ");	        
    xyz.append("value='2'>");
    xyz.append(getMiddleSingular());
    xyz.append("<option ");
    if (lValue==3)xyz.append("selected ");	        
    xyz.append("value='3'>");
    xyz.append(getTopSingular(0));
    return xyz.toString();
  }


  private void jbInit() throws Exception {
  }
}
