package assays.com;

import java.util.*;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;

public final class SessionListener implements HttpSessionListener {

  private static HashMap<HttpSession, UserHttpSession> userSessions =
                        	  new HashMap<HttpSession, UserHttpSession>();

  public void sessionCreated(HttpSessionEvent e) {
    HttpSession httpSess = e.getSession();
    synchronized(userSessions)
    {
     if(!userSessions.containsKey(httpSess))
      userSessions.put(httpSess, new UserHttpSession(httpSess));
    }
  }

  public void sessionDestroyed(HttpSessionEvent e) {
    HttpSession httpSess = e.getSession();
    synchronized(userSessions)
    {
      UserHttpSession tmpSession = (UserHttpSession)userSessions.get( httpSess);
      if (tmpSession != null) {
        tmpSession.destroySession(httpSess.getLastAccessedTime());
        userSessions.remove(httpSess);
      }
    }
  }

  public static int getConcurrentUsers() {
    return userSessions.size();
  }

  public static UserHttpSession getUserHttpSession(HttpSession httpSess) {
    return (UserHttpSession) userSessions.get( httpSess);
  }
}
