package assays.com;

import java.util.Iterator;
import java.util.List;
import assays.hibernate.AssayPersistent;
import assays.hibernate.AssayUser;
import assays.hibernate.*;

public final class UserBrowser implements Iterator{
    private UserHttpSession session;
    private Iterator objIterator;
    private List objList;
    private AssayUser me = null;
    private Class curClass;

    public UserBrowser( UserHttpSession tmpHttpSessObj, AssayUser someUser){
        session = tmpHttpSessObj;
        me = someUser;
    }

    public int processStudyTable()
    { int cnt = -1;
      curClass = StudyGroup.class;
      Long userId = me.getId();
      try {
        cnt = session.getAllUserGroupsCount( userId);
        if (cnt < 1000){
          objList = session.getAllUserGroups( userId);
          return cnt;
        }
      }
      catch (Exception ex) {
        Util.writeLog("UserBrowser", ex.getMessage(),"");
        cnt = -1;
      }
      return cnt;
    }

    public int processAssayTable()
    { int cnt = -1;
      curClass = Assay.class;
      Long userId = me.getId();
      try {
        cnt = session.getAllUserAssaysCount( userId);
        if (cnt < 1000){
          objList = session.getAllUserAssays( userId);
          return cnt;
        }
      }
      catch (Exception ex) {
        Util.writeLog("UserBrowser", ex.getMessage(),"");
        cnt = -1;
      }
      return cnt;
    }
    public boolean processTable( Class xyz)
    { curClass = xyz;
      try {
        objList = session.getAllObjects(xyz);
        return true;
      }
      catch (Exception ex) {
        Util.writeLog("UserBrowser", ex.getMessage(),"");
        return false;
      }
    }

    public Iterator iterator(){
        objIterator =  objList.iterator();
        return this;
    }

    public boolean hasNext(){
        return objIterator.hasNext();
    }

    public Object next(){
        AssayPersistent obj;
        boolean empty = true;
        obj = (AssayPersistent) objIterator.next();
        AssayUser creat = obj.getCreator();
        AssayUser modif = obj.getModifier();
        StringBuffer xyz = new StringBuffer();
        xyz.append(obj.toString())
           .append("\t");
        if (me.isEqual(creat)){ xyz.append("creator"); empty = false;}
        xyz.append("\t");
        if (me.isEqual(modif)){ xyz.append("modifier"); empty = false;}
        xyz.append("\t");
        if (curClass.equals(StudyGroup.class)){
          if (me.isEqual(((StudyGroup)obj).getOwner())){
            xyz.append("owner"); empty = false;
          }
        }
        else
        if (curClass.equals(AssayUserRights.class)){
          if (me.isEqual(((AssayUserRights)obj).getGrantedBy())){
            xyz.append("granted by"); empty = false;
          }
          xyz.append("\t");
          if (me.isEqual(((AssayUserRights)obj).getGrantedTo())){
            xyz.append("granted to"); empty = false;
          }
        }
        else
        if (curClass.equals(TechnologyAccess.class)){
          if (me.isEqual(((TechnologyAccess)obj).getUser())){
            xyz.append("user"); empty = false;
          }
        }
        return (empty)? null: xyz.toString();
    }

    public void remove(){
    }

}
