package assays.com;
/**
 *
 * <p>Title: </p>
 *
 * <p>Description: glaba informaciju par daudzlappusu datu tekoso poziciju
 *   Created and maintained by UserHttpSession. Used by ViewAssays.jsp
 *  </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public final class ViewAssayManager {
  private UserHttpSession parent;
  private int total;
  private int first;
  private int step;
  private Long groupId;
  private Long viewId;
  private int assayCount;
  public ViewAssayManager(UserHttpSession tmpHttpSessObj) {
    parent = tmpHttpSessObj;
    step = 0;
    total = -1;
    first = 0;
    groupId = null;
    viewId = null;
  }

  public void clearValues() {
    total = -1;
    first = 0;
    step = parent.getViewLimit();
    groupId = null;
    viewId = null;
  }

  public int getAssayTotal() throws Exception {
    if ((step > 0) && (total < 0))
      total = parent.getAllAssaysCount(parent.getCurrentTechnologyId(), viewId, groupId);
    return total;
  }

  public void changeAssayTotal( int diff) {
    total += diff;
  }

  public void setAssayCount( int val) {
    assayCount = val;
    if (total < assayCount) total = assayCount;
  }

  public boolean hasAssayPrevious() {
    return (step > 0) && (first > 0);
  }

  public void setAssayPrevious() {
    first -= step;
    if (first < 0) first = 0;
  }

  public boolean hasAssayNext() {
    return (step > 0) && (first + step < total - 1);
  }

  public void setAssayNext() {
    first += step;
    if (first >= total) setAssayPrevious();
  }

  public void setAssayFirst() {
    first = 0;
  }

  public void setAssayLast() {
    first = total - step;
    if (first < 0) first = 0;
  }

  public int getAssayStep() {
    return step;
  }

  public int getAssayCurrent() {
    return first;
  }

  public boolean setAssayGroupId(Long newGroupId) {
    boolean change = false;
    if (newGroupId == null) {
      if (groupId != null) change = true;
    }
    else
    if (!newGroupId.equals(groupId)) change = true;
    if (change){
      total = -1;
      first = 0;
      groupId = newGroupId;
    }
    return change;
  }
  public boolean setAssayViewAndGroupId(Long newViewId, Long newGroupId) {
    boolean change = false;
    if (newViewId == null) {
      if (viewId != null) change = true;
    }
    else
    if (!newViewId.equals(viewId)) change = true;
    if (newGroupId == null) {
      if (groupId != null) change = true;
    }
    else
    if (!newGroupId.equals(groupId)) change = true;
    if (change){
      total = -1;
      first = 0;
      groupId = newGroupId;
      viewId = newViewId;
    }
    return change;
  }

  public Long getAssayGroupId() {
    return groupId;
  }
  public Long getAssayViewId() {
    return groupId;
  }

  public String getAssayControlString() {
    StringBuffer xyz = new StringBuffer();
    if ((step > 0) && (total > step)) {
      if (first > 0){
        xyz.append("<button type='button' onclick='gotoFirst()' title='first' class='lines'>")
            .append("<img border='0' src='./images/left_d_10_b.gif' title='first' alt=''>")
            .append("</button>");
        xyz.append("<button type='button' onclick='gotoPrevious()' title='previous' class='lines'>")
            .append("<img border='0' src='./images/left_10_b.gif' title='previous' alt=''>")
            .append("</button>");
      }
     else{
       xyz.append("<button type='button' disabled class='lines'>")
           .append("<img border='0' src='./images/left_d_10_h.gif' alt=''>")
           .append("</button>");
       xyz.append("<button type='button' disabled class='lines'>")
           .append("<img border='0' src='./images/left_10_h.gif' alt=''>")
           .append("</button>");
     }
      xyz.append(first+1)
         .append('-')
         .append(first+assayCount)
         .append("&nbsp;of&nbsp;")
         .append(total)
         .append("&nbsp;items&nbsp;");
       if (first + assayCount < total){
         xyz.append("<button type='button' onclick='gotoNext()' title='next' class='lines'>")
             .append("<img border='0' src='./images/right_10_b.gif' title='next' alt=''>")
             .append("</button>");
         xyz.append("<button type='button' onclick='gotoLast()' title='last' class='lines'>")
             .append("<img border='0' src='./images/right_d_10_b.gif' title='last' alt=''>")
             .append("</button>");
       }
      else{
        xyz.append("<button type='button' disabled class='lines'>")
            .append("<img border='0' src='./images/right_10_h.gif' alt=''>")
            .append("</button>");
        xyz.append("<button type='button' disabled class='lines'>")
            .append("<img border='0' src='./images/right_d_10_h.gif' alt=''>")
            .append("</button>");
      }
    }
    else
        xyz.append("<span class='textb'>")
         .append(assayCount)
         .append("&nbsp;items&nbsp;</span>");
    return xyz.toString();
  }
}
