package assays.com;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import assays.hibernate.*;

public class ViewBatchManager {
  private UserHttpSession userSession;
  private int total;
  private HashSet<Long> batch;
  private boolean checked;
  private int level;    //2-assay; 1-study; 0-view;  3-study for view define
  private int cause;    //1-edit;  2-export;3-define view 
  public ViewBatchManager( UserHttpSession tmpHttpSessObj, int count, int level, int cause) {
	total = count;
	userSession = tmpHttpSessObj;
	batch = new HashSet<Long>( count);
	checked = true;
	this.level = level;
	this.cause = cause;
  }
  
  public void checkAll() {
	checked = false;
	batch.clear();
	  List objList = null;	
      Long technId = userSession.getCurrentTechnologyId();
	  try{	
	    if (level==2){
          ViewAssayManager vam = userSession.getViewAssayManager();
          Long groupId = vam.getAssayGroupId();
          objList = userSession.getAllAssays( technId, null, groupId, -1) ;
        } else
        if (level==1){	
          ViewGroupManager vgm = userSession.getViewGroupManager();
          Long viewId = vgm.getGroupViewId();
          objList = userSession.getAllGroups( technId, viewId, -1) ;
        } else
        if (level==0){
          objList = userSession.getAllViews( technId, -1) ;
        } else
        if (level==3){   //define view
          return;
//        objList = userSession.getAllGroups( technId, null, -1) ;
        }
		Iterator liter = objList.iterator();
        if (level==2)
		while (liter.hasNext()){
		  Assay assay = (Assay)liter.next();
	      int myRights =userSession.getGrantedRights( assay.getStudyGroup());
	      Long objId = assay.getId();
		  if ((cause==1&myRights<3000)|(cause==2&myRights<1000)) batch.add(objId);
		}
        else
        if (level==1)	
   		while (liter.hasNext()){
  		  StudyGroup group = (StudyGroup)liter.next();
  	      int myRights =userSession.getGrantedRights( group);
    	  Long objId = group.getId();
    	  if ((cause==1&myRights<3000)|(cause==2&myRights<1000)) batch.add(objId);
    	}
        else
        if (level==0)	
       	while (liter.hasNext()){
      	  StudyView view = (StudyView)liter.next();
          int myRights = userSession.getGrantedRights(
        		  view.getOwner(), view.getOwnerGroup());
       	  Long objId = view.getId();
       	  if ((cause==1&myRights<3000)|(cause==2&myRights<1000)) batch.add(objId);
       	}
      }
      catch (Exception ex)
      {
      }
  }
  public void uncheckAll() {
	checked = true;
	batch.clear();
  }
  public void changeCheck( Long objId){
    if (!batch.add(objId))batch.remove(objId);	
  }
  public int getSelectedCount(){
	int size = batch.size();
	return (checked)?size:total-size;
  }
  public boolean isSelected( Long objId){
	return (checked)?batch.contains(objId):!batch.contains(objId);
  }
  public Long[] getBatchArray(){
	int size = getSelectedCount();
	if (size < 1) return null;
	Long[] barray = new Long[size];
    int ind = 0;
	if (checked){
	  Iterator<Long> biter = batch.iterator();
	  while (biter.hasNext()){
		barray[ind++] = biter.next();  
	  }
	} else{
	  List objList = null;	
      Long technId = userSession.getCurrentTechnologyId();
	  try{	
	    if (level==2){
          ViewAssayManager vam = userSession.getViewAssayManager();
          Long groupId = vam.getAssayGroupId();
          objList = userSession.getAllAssays( technId, null, groupId, -1) ;
        } else
        if (level==1){	
          ViewGroupManager vgm = userSession.getViewGroupManager();
          Long viewId = vgm.getGroupViewId();
          objList = userSession.getAllGroups( technId, viewId, -1) ;
        } else
        if (level==0){
          objList = userSession.getAllViews( technId, -1) ;
        } else
        if (level==3){   //define view
          objList = userSession.getAllGroups( technId, null, -1) ;
        }
		Iterator liter = objList.iterator();
		while (liter.hasNext()){
		  TechnologyData xyz = (TechnologyData)liter.next();
		  Long objId = xyz.getId();
		  if (!batch.contains(objId)) barray[ind++] = objId;
		}
      }
      catch (Exception ex)
      {
          return null;
      }
	}
	return barray;
  }
}
