package assays.com;
/**
 *
 * <p>Title: </p>
 *
 * <p>Description: glaba informaciju par daudzlappusu datu tekoso poziciju
 *   Created and maintained by UserHttpSession. Used by ViewGroups.jsp
 *  </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public final class ViewGroupManager {
  private UserHttpSession parent;
  private int total;
  private int first;
  private int step;
  private Long viewId;
  private int groupCount;

  public ViewGroupManager(UserHttpSession tmpHttpSessObj) {
    parent = tmpHttpSessObj;
    step = 0;
    total = -1;
    first = 0;
    viewId = null;
  }

  public void clearValues() {
    total = -1;
    first = 0;
    step = parent.getViewLimit();
    viewId = null;
  }

  public int getGroupTotal() throws Exception {
    if ((step > 0) && (total < 0))
      total = parent.getAllGroupsCount(parent.getCurrentTechnologyId(), viewId);
    return total;
  }

  public void changeGroupTotal( int diff) {
    total += diff;
  }

  public void setGroupCount( int val) {
    groupCount = val;
    if (total < groupCount) total = groupCount;
  }

  public boolean hasGroupPrevious() {
    return (step > 0) && (first > 0);
  }

  public void setGroupPrevious() {
    first -= step;
    if (first < 0) first = 0;
  }

  public boolean hasGroupNext() {
    return (step > 0) && (first + step < total - 1);
  }

  public void setGroupNext() {
    first += step;
    if (first >= total) setGroupPrevious();
  }

  public void setGroupFirst() {
    first = 0;
  }

  public void setGroupLast() {
    first = total - step;
    if (first < 0) first = 0;
  }

  public int getGroupStep() {
    return step;
  }

  public int getGroupCurrent() {
    return first;
  }

  public boolean setGroupViewId(Long newViewId) {
    boolean change = false;
    if (newViewId == null) {
      if (viewId != null) change = true;
    }
    else
    if (!newViewId.equals(viewId)) change = true;
    if (change){
      total = -1;
      first = 0;
      viewId = newViewId;
    }
    return change;
  }

  public Long getGroupViewId() {
    return viewId;
  }

  public String getGroupControlString() {
    StringBuffer xyz = new StringBuffer();
    if ((step > 0) && (total > step)) {
      if (first > 0){
        xyz.append("<button type='button' onclick='gotoFirst()' title='first' class='lines'>")
            .append("<img border='0' src='./images/left_d_10_b.gif' title='first' alt=''>")
            .append("</button>");
        xyz.append("<button type='button' onclick='gotoPrevious()' title='previous' class='lines'>")
            .append("<img border='0' src='./images/left_10_b.gif' title='previous' alt=''>")
            .append("</button>");
      }
     else{
       xyz.append("<button type='button' disabled class='lines'>")
           .append("<img border='0' src='./images/left_d_10_h.gif' alt=''>")
           .append("</button>");
       xyz.append("<button type='button' disabled class='lines'>")
           .append("<img border='0' src='./images/left_10_h.gif' alt=''>")
           .append("</button>");
     }
      xyz.append(first+1)
         .append('-')
         .append(first+groupCount)
         .append("&nbsp;of&nbsp;")
         .append(total)
         .append("&nbsp;items&nbsp;");
      if (first + groupCount < total){
        xyz.append("<button type='button' onclick='gotoNext()' title='next' class='lines'>")
            .append("<img border='0' src='./images/right_10_b.gif' title='next' alt=''>")
            .append("</button>");
        xyz.append("<button type='button' onclick='gotoLast()' title='last' class='lines'>")
            .append("<img border='0' src='./images/right_d_10_b.gif' title='last' alt=''>")
            .append("</button>");
      }
       else{
         xyz.append("<button type='button' disabled class='lines'>")
             .append("<img border='0' src='./images/right_10_h.gif' alt=''>")
             .append("</button>");
         xyz.append("<button type='button' disabled class='lines'>")
             .append("<img border='0' src='./images/right_d_10_h.gif' alt=''>")
             .append("</button>");
      }
    }
    else
      xyz.append("<span class='textb'>")
       .append(groupCount)
       .append("&nbsp;items&nbsp;</span>");
    return xyz.toString();
  }
}
