package assays.com;
/**
 *
 * <p>Title: </p>
 *
 * <p>Description: glaba informaciju par daudzlappusu datu tekoso poziciju
 *   Created and maintained by UserHttpSession. Used by ViewViews.jsp
 *  </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
  public final class ViewViewManager {
    private UserHttpSession parent;
    private int total;
    private int first;
    private int step;
    private int viewCount;

    public ViewViewManager(UserHttpSession tmpHttpSessObj) {
      parent = tmpHttpSessObj;
      step = 0;
      total = -1;
      first = 0;
    }

    public void clearValues() {
      total = -1;
      first = 0;
      step = parent.getViewLimit();
    }

    public int getViewTotal() throws Exception {
      if ((step > 0) && (total < 0))
        total = parent.getAllViewsCount(parent.getCurrentTechnologyId());
      return total;
    }

    public void changeViewTotal( int diff) {
      total += diff;
    }

    public void setViewCount( int val) {
      viewCount = val;
      if (total < viewCount) total = viewCount;
    }

    public boolean hasViewPrevious() {
      return (step > 0) && (first > 0);
    }

    public void setViewPrevious() {
      first -= step;
      if (first < 0) first = 0;
    }

    public boolean hasViewNext() {
      return (step > 0) && (first + step < total - 1);
    }

    public void setViewNext() {
      first += step;
      if (first >= total) setViewPrevious();
    }

    public void setViewFirst() {
      first = 0;
    }

    public void setViewLast() {
      first = total - step;
      if (first < 0) first = 0;
    }

    public int getViewStep() {
      return step;
    }

    public int getViewCurrent() {
      return first;
    }

    public String getViewControlString() {
      StringBuffer xyz = new StringBuffer();
      if ((step > 0) && (total > step)) {
        if (first > 0){
          xyz.append("<button type='button' onclick='gotoFirst()' title='first' class='lines'>")
              .append("<img border='0' src='./images/left_d_10_b.gif' title='first' alt=''>")
              .append("</button>");
          xyz.append("<button type='button' onclick='gotoPrevious()' title='previous' class='lines'>")
              .append("<img border='0' src='./images/left_10_b.gif' title='previous' alt=''>")
              .append("</button>");
        }
       else{
         xyz.append("<button type='button' disabled class='lines'>")
             .append("<img border='0' src='./images/left_d_10_h.gif' alt=''>")
             .append("</button>");
         xyz.append("<button type='button' disabled class='lines'>")
             .append("<img border='0' src='./images/left_10_h.gif' alt=''>")
             .append("</button>");
       }
        xyz.append(first+1)
           .append('-')
           .append(first+viewCount)
           .append("&nbsp;of&nbsp;")
           .append(total)
           .append("&nbsp;items&nbsp;");
        if (first + viewCount < total){
          xyz.append("<button type='button' onclick='gotoNext()' title='next' class='lines'>")
              .append("<img border='0' src='./images/right_10_b.gif' title='next' alt=''>")
              .append("</button>");
          xyz.append("<button type='button' onclick='gotoLast()' title='last' class='lines'>")
              .append("<img border='0' src='./images/right_d_10_b.gif' title='last' alt=''>")
              .append("</button>");
        }
         else{
           xyz.append("<button type='button' disabled class='lines'>")
               .append("<img border='0' src='./images/right_10_h.gif' alt=''>")
               .append("</button>");
           xyz.append("<button type='button' disabled class='lines'>")
               .append("<img border='0' src='./images/right_d_10_h.gif' alt=''>")
               .append("</button>");
        }
      }
      else
        xyz.append("<span class='textb'>")
         .append(viewCount)
         .append("&nbsp;items&nbsp;</span>");
      return xyz.toString();
    }

}
