package assays.com;
import java.io.File;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import assays.hibernate.*;
import java.util.List;
import java.util.ArrayList;
/**
 *
 * <p>Title: </p>
 *
 * <p>Description:Imports and creates new technology from XML file.
 *    Used by ImportTechnologyUpload.jsp called from AdminPage.jsp
 * </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class XMLImport {
  private Technology technObj = null;
  private UserHttpSession session;
  private String namex = "xyz";
  private List<String> errorlist = null;
  public XMLImport( UserHttpSession tmpHttpSessObj) {
    session = tmpHttpSessObj;
    errorlist = new ArrayList<String>();
  }
  private int processDataFileTypes( Element root) throws Exception {
    int result = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XFileType);
    for (int i = 0; i < nodeLst1.getLength(); i++){
      Element param = (Element) nodeLst1.item(i);
      String type = param.getAttribute(XMLTags.Xtype);
      DataType obj = (DataType)session.
          getObjectByNameForTechnology(DataType.class, technObj, type);
      if (obj == null){
        if (type != null && !type.trim().equals("")) {
          obj = (DataType) DataType.class.newInstance();
          String fileExt = param.getAttribute(XMLTags.Xfile_ext);
          obj.setFileExtension(fileExt); 
          String comment = param.getAttribute(XMLTags.Xcomment);
          obj.setTechnology(technObj);
          if (!session.addPersistentWithoutClose(obj, type, comment)) result = 1;
        }
      }
    }
    return result;
  }
  private int processProtocolFileTypes( Element root) throws Exception {
    int result = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XFileType);
    for (int i = 0; i < nodeLst1.getLength(); i++){
      Element param = (Element) nodeLst1.item(i);
      String type = param.getAttribute(XMLTags.Xtype);
      ProtocolType obj = (ProtocolType)session.
          getObjectByNameForTechnology(ProtocolType.class, technObj, type);
      if (obj == null){
        if (type != null && !type.trim().equals("")) {
          obj = (ProtocolType) ProtocolType.class.newInstance();
          String fileExt = param.getAttribute(XMLTags.Xfile_ext);
          obj.setFileExtension(fileExt); 
          String comment = param.getAttribute(XMLTags.Xcomment);
          obj.setTechnology(technObj);
          if (!session.addPersistentWithoutClose(obj, type, comment)) result = 1;
        }
      }
    }
    return result;
  }

  private int processParameters( Element root) throws Exception {
    int result = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XParameter);
    for (int i = 0; i < nodeLst1.getLength(); i++){
      Element param = (Element) nodeLst1.item(i);
      Element confa = null;
      Element confs = null;
      Element confv = null;
      NodeList nodeLst2a = param.getElementsByTagName(XMLTags.XAssayConf);
      if (nodeLst2a.getLength() > 0) {
        confa = (Element) nodeLst2a.item(0);
        String cname = confa.getAttribute(XMLTags.Xcolumn);
        if (!Util.checkFieldNameNumeric(cname)) {
          errorlist.add("Invalid assay column name:" + cname);
          return 1;
        } else {
          Parameter obj = (Parameter) session.
              getParameterByAssayColumnName(Parameter.class, technObj, cname);
          if ( obj != null){
            errorlist.add("Duplicate assay column name:" + cname);
            return 1;
          }
        }
      }
      NodeList nodeLst2s = param.getElementsByTagName(XMLTags.XSGConf);
      if (nodeLst2s.getLength() > 0) {
        confs = (Element) nodeLst2s.item(0);
        String cname = confs.getAttribute(XMLTags.Xcolumn);
        if (!Util.checkFieldNameNumeric(cname)) {
          errorlist.add("Invalid stgr column name:" + cname);
          return 1;
        } else {
          Parameter obj = (Parameter) session.
              getParameterByStgrColumnName(Parameter.class, technObj, cname);
          if ( obj != null){
            errorlist.add("Duplicate stgr column name:" + cname);
            return 1;
          }
        }
      }
      NodeList nodeLst2v = param.getElementsByTagName(XMLTags.XViewConf);
      if (nodeLst2v.getLength() > 0) {
        confv = (Element) nodeLst2v.item(0);
        String cname = confv.getAttribute(XMLTags.Xcolumn);
        if (!Util.checkFieldNameNumeric(cname)) {
          errorlist.add("Invalid view column name:" + cname);
          return 1;
        } else {
          Parameter obj = (Parameter) session.
              getParameterByViewColumnName(Parameter.class, technObj, cname);
          if ( obj != null){
            errorlist.add("Duplicate view column name:" + cname);
            return 1;
          }
        }
      }
      String shortname = param.getAttribute(XMLTags.Xshortname);
      if (shortname != null && !shortname.trim().equals("")) {
        Parameter obj = (Parameter) Parameter.class.newInstance();
        String comment = param.getAttribute(XMLTags.Xcomment);
        String longname = param.getAttribute(XMLTags.Xname);
        obj.setLongName(longname);
        String uploadname = param.getAttribute(XMLTags.Xupload);
        obj.setUploadName(uploadname);
        String required = param.getAttribute(XMLTags.Xrequired);
        obj.setRequiredX(Util.getInteger( required));
        String filter = param.getAttribute(XMLTags.Xfilter);
        obj.setShowInFilterX(Util.getInteger( filter));
        String note = param.getAttribute(XMLTags.Xnote);
        obj.setNoteToDisplay(note);     
        String groupname = param.getAttribute(XMLTags.Xgroup);
        ParameterGroup group = (ParameterGroup) session.
            getObjectByName(ParameterGroup.class, groupname);
        obj.setParameterGroup(group);
        String typename = param.getAttribute(XMLTags.Xtype);
        ParameterType ptype = (ParameterType) session.
            getObjectByNameForTechnology(ParameterType.class, null,
                                         typename);
        if (ptype != null)
          obj.setParameterType(ptype);
        else {
          ptype = (ParameterType) session.
              getObjectByNameForTechnology(ParameterType.class, technObj,
                                           typename);
          obj.setParameterType(ptype);
        }
        if (confa!=null){
          String cname = confa.getAttribute(XMLTags.Xcolumn);
          obj.setAssayColumnName(cname);
          String colnum = confa.getAttribute(XMLTags.Xcol_numb);
          obj.setAssayViewColumnNumber(Util.getInteger(colnum));
          String rownum = confa.getAttribute(XMLTags.Xrow_numb);
          obj.setAssayRowNumber(Util.getInteger(rownum));
          String sortable = confa.getAttribute(XMLTags.Xsortable);
          obj.setAssaySortableX(Util.getInteger( sortable));
        }
        if (confs!=null){
          String cname = confs.getAttribute(XMLTags.Xcolumn);
          obj.setStgrColumnName(cname);
          String colnum = confs.getAttribute(XMLTags.Xcol_numb);
          obj.setStgrViewColumnNumber(Util.getInteger(colnum));
          String rownum = confs.getAttribute(XMLTags.Xrow_numb);
          obj.setStgrRowNumber(Util.getInteger(rownum));
          String sortable = confs.getAttribute(XMLTags.Xsortable);
          obj.setStgrSortableX(Util.getInteger( sortable));
        }
        if (confv!=null){
          String cname = confv.getAttribute(XMLTags.Xcolumn);
          obj.setViewColumnName(cname);
          String colnum = confv.getAttribute(XMLTags.Xcol_numb);
          obj.setViewViewColumnNumber(Util.getInteger(colnum));
          String rownum = confv.getAttribute(XMLTags.Xrow_numb);
          obj.setViewRowNumber(Util.getInteger(rownum));
          String sortable = confv.getAttribute(XMLTags.Xsortable);
          obj.setViewSortableX(Util.getInteger( sortable));
        }
        obj.setTechnology(technObj);
        if (!session.addPersistentWithoutClose(obj, shortname, comment))
            result = 1;
      }
    }
    return result;
  }

  private int processCommonParameters( Element root, Technology techn) throws Exception {
    int result = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XParameter);
    for (int i = 0; i < nodeLst1.getLength(); i++){
      Element param = (Element) nodeLst1.item(i);
      Element confa = null;
      Element confs = null;
      Element confv = null;
      NodeList nodeLst2a = param.getElementsByTagName(XMLTags.XAssayConf);
      if (nodeLst2a.getLength() > 0) {
        confa = (Element) nodeLst2a.item(0);
        String cname = confa.getAttribute(XMLTags.Xcolumn);
        if (cname.equals("aliquotId")) cname = "simsRefId";
        if (!AssayFieldname.checkAimsFieldname(cname)) {
          errorlist.add("Invalid assay column name:" + cname);
          return 1;
        } else {
          Object obj = session.
              getParameterByAssayColumnName(CommonParameter.class, techn, cname);
          if ( obj != null){
            if (techn == null) continue;
            errorlist.add("Duplicate assay column name:" + cname);
            return 1;
          }
        }
      }
      NodeList nodeLst2s = param.getElementsByTagName(XMLTags.XSGConf);
      if (nodeLst2s.getLength() > 0) {
        confs = (Element) nodeLst2s.item(0);
        String cname = confs.getAttribute(XMLTags.Xcolumn);
        if (cname.equals("aliquotId")) cname = "simsRefId";
        if (!AssayFieldname.checkAimsFieldname(cname)) {
          errorlist.add("Invalid stgr column name:" + cname);
          return 1;
        } else {
          Object obj = session.
              getParameterByStgrColumnName(CommonParameter.class, techn, cname);
          if ( obj != null){
            if (techn == null) continue;
            errorlist.add("Duplicate stgr column name:" + cname);
            return 1;
          }
        }
      }
      NodeList nodeLst2v = param.getElementsByTagName(XMLTags.XViewConf);
      if (nodeLst2v.getLength() > 0) {
        confv = (Element) nodeLst2v.item(0);
        String cname = confv.getAttribute(XMLTags.Xcolumn);
        if (cname.equals("aliquotId")) cname = "simsRefId";
        if (!AssayFieldname.checkAimsFieldname(cname)) {
          errorlist.add("Invalid view column name:" + cname);
          return 1;
        } else {
          Object obj = session.
              getParameterByViewColumnName(CommonParameter.class, techn, cname);
          if ( obj != null){
            if (techn == null) continue;
            errorlist.add("Duplicate view column name:" + cname);
            return 1;
          }
        }
      }
      String shortname = param.getAttribute(XMLTags.Xshortname);
      if (shortname != null && !shortname.trim().equals("")) {
        String longname = param.getAttribute(XMLTags.Xname);
        String uploadname = param.getAttribute(XMLTags.Xupload);
        String comment = param.getAttribute(XMLTags.Xcomment);
        String filter = param.getAttribute(XMLTags.Xfilter);
        CommonParameter obj = (CommonParameter) CommonParameter.class.newInstance();
        obj.setLongName(longname);
        obj.setUploadName(uploadname);
        obj.setShowInFilterX(Util.getInteger( filter));
        if (confa!=null){
          String cname = confa.getAttribute(XMLTags.Xcolumn);
          if (cname.equals("aliquotId")) cname = "simsRefId";
          obj.setAssayColumnName(cname);
          String colnum = confa.getAttribute(XMLTags.Xcol_numb);
          obj.setAssayViewColumnNumber(Util.getInteger( colnum));
          String sortable = confa.getAttribute(XMLTags.Xsortable);
          obj.setAssaySortableX(Util.getInteger( sortable));
        }
        if (confs!=null){
          String cname = confs.getAttribute(XMLTags.Xcolumn);
          if (cname.equals("aliquotId")) cname = "simsRefId";
          obj.setStgrColumnName(cname);
          String colnum = confs.getAttribute(XMLTags.Xcol_numb);
          obj.setStgrViewColumnNumber(Util.getInteger( colnum));
          String sortable = confs.getAttribute(XMLTags.Xsortable);
          obj.setStgrSortableX(Util.getInteger( sortable));
        }
        if (confv!=null){
          String cname = confv.getAttribute(XMLTags.Xcolumn);
          if (cname.equals("aliquotId")) cname = "simsRefId";
          obj.setViewColumnName(cname);
          String colnum = confv.getAttribute(XMLTags.Xcol_numb);
          obj.setViewViewColumnNumber(Util.getInteger( colnum));
          String sortable = confv.getAttribute(XMLTags.Xsortable);
          obj.setViewSortableX(Util.getInteger( sortable));
        }

        obj.setTechnology(techn);
        if (!session.addPersistentWithoutClose(obj, shortname, comment)) result = 1;
      }
    }
    return result;
  }

  private int processParameterTypes( Element root, Technology techn) throws Exception {
    int result = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XParameterType);
    for (int i = 0; i < nodeLst1.getLength(); i++){
      Element ptype = (Element) nodeLst1.item(i);
      String name = ptype.getAttribute(XMLTags.Xname);
      ParameterType obj = (ParameterType)session.
          getObjectByNameForTechnology(ParameterType.class, techn, name);
      if (obj == null){
        if (name != null && !name.trim().equals("")) {
          String comment = ptype.getAttribute(XMLTags.Xcomment);
          String popup = ptype.getAttribute(XMLTags.Xpopup);
          obj = (ParameterType) ParameterType.class.newInstance();
          obj.setPopupName(popup);
          String baseType = ptype.getAttribute(XMLTags.Xbasetype);
          obj.setBaseType(AssayTypeName.getBaseType(baseType));
          String attr1 = ptype.getAttribute(XMLTags.Xattr1);
          obj.setDisplay1(Util.getInteger( attr1));
          String attr2 = ptype.getAttribute(XMLTags.Xattr2);
          obj.setDisplay2(Util.getInteger( attr2));
          String table = ptype.getAttribute(XMLTags.Xtable);
//          if (techn != null){
            Vocabulary vocab = (Vocabulary) session.
                getObjectByNameForTechnology(Vocabulary.class, techn, table);
            obj.setVocabulary(vocab);
//          }
          obj.setTechnology(techn);
          if (!session.addPersistentWithoutClose(obj, name, comment)) result = 1;
        }
      }
    }
    return result;
  }
  private int processVocabularies( Element root, Technology techn) throws Exception {
    int result = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XVocabulary);
    for (int i = 0; i < nodeLst1.getLength(); i++){
      Element vocab = (Element) nodeLst1.item(i);
      String table = vocab.getAttribute(XMLTags.Xtable);
      Vocabulary obj = (Vocabulary) session.
          getObjectByNameForTechnology(Vocabulary.class, technObj, table);
      if (obj == null) {
        if (table != null && !table.trim().equals("")) {
          String comment = vocab.getAttribute(XMLTags.Xcomment);
          String lname = vocab.getAttribute(XMLTags.Xname);
          obj = (Vocabulary) Vocabulary.class.newInstance();
          obj.setLongName(lname);
          NodeList nodeLst2 = vocab.getElementsByTagName(XMLTags.XItem);
          for (int j = 0; j < nodeLst2.getLength(); j++){
            Element item = (Element) nodeLst2.item(j);
            String value = item.getAttribute(XMLTags.Xname);
            String valueId = item.getAttribute(XMLTags.Xseq_numb);
            obj.addValueAndId(valueId, value);
          }
          obj.setTechnology(technObj);
          if (!session.addPersistentWithoutClose(obj, table, comment)) result = 1;
        }
      }
    }
    return result;
  }
  private int processTechnology( Element techn) throws Exception {
    int result = 0;
    String name = techn.getAttribute(XMLTags.Xname);
    if (name == null || name.trim().equals("")) {
      errorlist.add("Invalid technology name");
      return 1;
    }
    String prefix = techn.getAttribute(XMLTags.Xprefix);
    String ftp = techn.getAttribute(XMLTags.Xftp);
    String isPublic = techn.getAttribute(XMLTags.Xpublic);
    String viewLevels = techn.getAttribute(XMLTags.XviewLevel);

    String comment = techn.getAttribute(XMLTags.Xcomment);
    String transferT = techn.getAttribute(XMLTags.XTransferType);
    int s = 0; namex = name;
    technObj = (Technology)session.getObjectByName(Technology.class, namex);
    while (technObj != null){
      s++; namex = name + String.valueOf(s);
      technObj = (Technology)session.getObjectByName(Technology.class, namex);
    }
    technObj = (Technology) Technology.class.newInstance();
    technObj.setIdPrefix(prefix);
    technObj.setFtpDirectory(ftp);
    technObj.setPublicX(Util.getInteger( isPublic));
    technObj.setShowViewLevelsX(Util.getInteger( viewLevels));
    TransferType tt = (TransferType)session.getObjectByName(TransferType.class, transferT);
    technObj.setTransferType(tt);
    if (!session.addPersistentWithoutClose(technObj, namex, comment)){
      errorlist.add("Invalid technology");
      return 1;
    }
//import Vocabularies
    NodeList nodeLst1 = techn.getElementsByTagName(XMLTags.XVocabularies);
    int num = nodeLst1.getLength();
    if ( num != 1){
      errorlist.add("Invalid vocabularies");
      return 1;
    }
    result = processVocabularies( (Element)nodeLst1.item(0), technObj);
    if (result > 0) return result;
//import Parameter Types
    nodeLst1 = techn.getElementsByTagName(XMLTags.XParameterTypes);
    num = nodeLst1.getLength();
    if ( num != 1){
      errorlist.add("Invalid parameter types");
      return 1;
    }
    result = processParameterTypes( (Element)nodeLst1.item(0), technObj);
    if (result > 0) return result;
//import Common Parameters
    nodeLst1 = techn.getElementsByTagName(XMLTags.XCommonParameters);
    num = nodeLst1.getLength();
    if ( num != 1){
      errorlist.add("Invalid or missing common parameter");
      return 1;
    }
    result = processCommonParameters( (Element)nodeLst1.item(0), technObj);
    if (result > 0) return result;
//import Parameters
    nodeLst1 = techn.getElementsByTagName(XMLTags.XParameters);
    num = nodeLst1.getLength();
    if ( num != 1){
      errorlist.add("Invalid or missing parameter");
      return 1;
    }
    result = processParameters( (Element)nodeLst1.item(0));
    if (result > 0) return result;
//import Protocol File Types
    nodeLst1 = techn.getElementsByTagName(XMLTags.XProtocolFileTypes);
    num = nodeLst1.getLength();
    if ( num != 1){
      errorlist.add("Invalid or missing protocol file type");
      return 1;
    }
    result = processProtocolFileTypes( (Element)nodeLst1.item(0));
    if (result > 0) return result;
//import Data File Types
    nodeLst1 = techn.getElementsByTagName(XMLTags.XDataFileTypes);
    num = nodeLst1.getLength();
    if ( num != 1){
      errorlist.add("Invalid or missing data file type");
      return 1;
    }
    result = processDataFileTypes( (Element)nodeLst1.item(0));
    return result;
  }
/*
  private int processCommonParameterTypes( Element root) throws Exception {
    int result = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XParameterType);
    for (int i = 0; i < nodeLst1.getLength(); i++){
      Element ptype = (Element) nodeLst1.item(i);
      String name = ptype.getAttribute(XMLTags.Xname);
      ParameterType obj = (ParameterType)session.
          getObjectByNameForTechnology(ParameterType.class, null, name);
      if (obj == null){
        if (name != null && !name.trim().equals("")) {
          String comment = ptype.getAttribute(XMLTags.Xcomment);
          String popup = ptype.getAttribute(XMLTags.Xpopup);
          obj = (ParameterType) ParameterType.class.newInstance();
          obj.setPopupName(popup);
          String baseType = ptype.getAttribute(XMLTags.Xbasetype);
          obj.setBaseType(TypeName.getBaseType(baseType));
          String attr1 = ptype.getAttribute(XMLTags.Xattr1);
          obj.setDisplay1(Util.getInteger( attr1));
          String attr2 = ptype.getAttribute(XMLTags.Xattr2);
          obj.setDisplay2(Util.getInteger( attr2));
          if (!session.addPersistentWithoutClose(obj, name, comment)) result = 1;
        }
      }
    }
    return result;
  }
*/
  private int processParameterGroups( Element root) throws Exception {
    int result = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XGroup);
    for (int i = 0; i < nodeLst1.getLength(); i++){
      Element group = (Element) nodeLst1.item(i);
      String name = group.getAttribute(XMLTags.Xname);
      ParameterGroup obj = (ParameterGroup)session.getObjectByName(ParameterGroup.class, name);
      if (obj == null){
        String shortname = group.getAttribute(XMLTags.Xshortname);
        String comment = group.getAttribute(XMLTags.Xcomment);
        if (name != null && !name.trim().equals("")) {
          obj = (ParameterGroup) ParameterGroup.class.newInstance();
          obj.setShortName(shortname);
          NodeList nodeLst2 = group.getElementsByTagName(XMLTags.XAssayConf);
          if (nodeLst2.getLength()>0){
            Element conf = (Element) nodeLst2.item(0);
            String position = conf.getAttribute(XMLTags.Xrow_numb);
            obj.setAssayPosition(Util.getInteger( position));
          }
          nodeLst2 = group.getElementsByTagName(XMLTags.XSGConf);
          if (nodeLst2.getLength()>0){
            Element conf = (Element) nodeLst2.item(0);
            String position = conf.getAttribute(XMLTags.Xrow_numb);
            obj.setStgrPosition(Util.getInteger( position));
          }
          nodeLst2 = group.getElementsByTagName(XMLTags.XViewConf);
          if (nodeLst2.getLength()>0){
            Element conf = (Element) nodeLst2.item(0);
            String position = conf.getAttribute(XMLTags.Xrow_numb);
            obj.setViewPosition(Util.getInteger( position));
          }
          if (!session.addPersistentWithoutClose(obj, name, comment)) result = 1;
        }
      }
    }
    return result;
  }
  private int processTransferTypes( Element root) throws Exception {
    int result = 0;
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XTransferType);
    for (int i = 0; i < nodeLst1.getLength(); i++){
      Element transferType = (Element) nodeLst1.item(i);
      String name = transferType.getAttribute(XMLTags.Xname);
      TransferType obj = (TransferType)session.getObjectByName(TransferType.class, name);
      if (obj == null){
        if (name != null && !name.trim().equals("")) {
          String comment = transferType.getAttribute(XMLTags.Xcomment);
          obj = (TransferType) TransferType.class.newInstance();
          String abbr = transferType.getAttribute(XMLTags.Xabbr);
          obj.setAbbr(abbr);
          String dataDirectory = transferType.getAttribute(XMLTags.XdataDirectory);
          obj.setDataDirectory(dataDirectory);
          String transferLevel = transferType.getAttribute(XMLTags.XtransferLevel);
          obj.setTransferFromLevel(Util.getInteger( transferLevel));
          if (!session.addPersistentWithoutClose(obj, name, comment)) result = 1;
        }
      }
    }
    return result;
  }

  private int processRoot( Element root) throws Exception{
    int result = 0;
    String version = root.getAttribute(XMLTags.Xversion);
    if (version==null||!version.equals("1.17")){
      errorlist.add("Invalid version");
      return 1;
    }
    NodeList nodeLst1 = root.getElementsByTagName(XMLTags.XTransferTypes);
    int num = nodeLst1.getLength();
    if ( num > 1){
      errorlist.add("Invalid transfer types");
      return 1;
    }
    if (num == 1) result = processTransferTypes( (Element)nodeLst1.item(0));
    if (result > 0) return result;
    
    nodeLst1 = root.getElementsByTagName(XMLTags.XParameterGroups);
    num = nodeLst1.getLength();
    if ( num > 1){
      errorlist.add("Invalid parameter groups");
      return 1;
    }
    if (num == 1) result = processParameterGroups( (Element)nodeLst1.item(0));
    if (result > 0) return result;
    nodeLst1 = root.getElementsByTagName(XMLTags.XCommonVocabularies);
    num = nodeLst1.getLength();
    if ( num > 1){
      errorlist.add("Invalid common vocabularies");
      return 1;
    }
    if (num == 1)  result = processVocabularies( (Element)nodeLst1.item(0), null);
    if (result > 0) return result;

    nodeLst1 = root.getElementsByTagName(XMLTags.XCommonParameterTypes);
    num = nodeLst1.getLength();
    if ( num > 1){
      errorlist.add("Invalid common parameter types");
      return 1;
    }
    if (num == 1)  result = processParameterTypes( (Element)nodeLst1.item(0), null);
    if (result > 0) return result;

    nodeLst1 = root.getElementsByTagName(XMLTags.XDefaultCommonParameters);
    num = nodeLst1.getLength();
    if ( num > 1){
      errorlist.add("Invalid default common parameters");
      return 1;
    }
    if (num == 1)  result = processCommonParameters( (Element)nodeLst1.item(0), null);
    if (result > 0) return result;

    nodeLst1 = root.getElementsByTagName(XMLTags.XTechnology);
    num = nodeLst1.getLength();
    if ( num != 1){
      errorlist.add("Invalid or missing technology");
      return 1;
    }
    for (int i = 0; i < num; i++)
      result = processTechnology( (Element)nodeLst1.item(i));
    return result;
  }

  public int importTechn() throws Exception {
    int result = 0;
    try {
      File file = session.getZipTempFile();
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      DocumentBuilder db = dbf.newDocumentBuilder();
      Document doc = db.parse(file);
      Element root = doc.getDocumentElement();
      root.normalize();
      result = processRoot( root);
    }
    catch (Exception e) {
      if (e!=null){
      java.io.CharArrayWriter cw = new java.io.CharArrayWriter();
      java.io.PrintWriter pw = new java.io.PrintWriter(cw,true);
      e.printStackTrace(pw);
      Util.writeLog(cw.toString(),"","");
      errorlist.add(e.getMessage());
     }
     result = 1;
    }
    if (result > 0)
      errorlist.add("import partially incomplete");
    return result;
  }

  public int getErrorCount() {
    return errorlist.size();
  }
  public String getErrorMsg(int index) {
    return (String)errorlist.get(index);
  }
  public String getTechnologyName() {
    return namex;
  }
}
