package assays.export;
/*
tag UNIT from config.xml creates a tag in a result.xml file
class Attribute process different types of attributes of a tag UNIT:
	"const" - attribute value is a constant from config.xml
	"db" - attribute value is obtained from DB
	"func" - attribute value is created by convertors.FN class methods
 */

//import org.apache.log4j.Logger;

import assays.com.Util;

import java.util.*;

import convertors.FN;

public class Attribute {

	//Java reflection for class convertors.FN
	private ReflectionMethod rfConvertor=new ReflectionMethod("convertors.FN");

	public String name; //attribute name in a result.xml file
	public String val; // attribute value in a result.xml file
	public String col; // DB field name where value of a "db" type attribute is stored
	public String format; // for type "db" - the way to format DB value using internal convertors
	// for type "func" and "fnxml" - external function from convertors.FN class to create attribute value
	public String type; // type of a attribute: "const", "db", "func", "fnxml"
	//private Logger log; // MolPage xml export utility log
	private String sessionID;
	public Vector<String> param = new Vector<String>(); //parameters for external function from convertors.FN class
	//after the Attribute object initialization contains DB field name for parameteres from DB (format "db_<DB field name>")
	//; parameters from config file (format "conf_<field>") and values for constant parameters


//Constructor for attribute type "db" and "func" (typeVal)
	Attribute(String nameVal, String colVal, String formatVal, String typeVal, String sessId){
		sessionID = sessId;
		//"DB"
		if (typeVal.equals("db")){
			type="db";
			name=nameVal;
			col=colVal;
			format=formatVal;
			//log=logFile;
		}
		//"FUNC", "FNXML"
		else{
			type=typeVal;
			name=nameVal;
			format=colVal;
			//log=logFile;
			val="N/A";
			//Parse String with parameters
			int i = 0;
			String p = formatVal;
			int j = p.indexOf(";");
			while (j>0){
					param.addElement(p.substring(i, j));
					//System.out.println("PARAM "+p.substring(i, j));
					i = j+1;p = p.substring(i);i = 0;
					j = p.indexOf(";");
			}
			param.addElement(p);

		}
	}

//Constructor for attribute type "const"
	Attribute(String nameVal, String valVal, String sessId){
		type="const";
		name=nameVal;
		val=valVal;
		//log=logFile;
		sessionID = sessId;
	}

//Set obtained attribute value
	public void setVal(String valVal){
		if (valVal==null)
			val="";
		else val=valVal;
	}

//	Set obtained attribute value
	public void setParamVal(Vector<String> paramVal){
		//param=paramVal;
		for(int b=0; b<paramVal.size() ; b++){
			param.set(b,paramVal.get(b));
		}
	}


//Processes all formating and converting tasks and returns final attribute value
	public String getVal(){
		String[] result = new String[2];
		result[0]="";
		result[1]="";
		if (val.length()>0 && format.length()>0){
			if (type.equals("func")){
				//Load convertors.FN methods to obtained a value
				try {
					FN fn = new FN();
					//System.out.println(format);
					ArrayList<Class<String[]>> types = new ArrayList<Class<String[]>>();//List of types of arguments (String[])
 				    types.add(String[].class);
					ArrayList<String[]> args = new ArrayList<String[]>();//List of arguments for method
					//From vector to String[]
 				    String[] p = new String[param.size()];
 				    for(int b=0; b<param.size() ; b++) {
 				    	p[b]=(String)param.get(b).toString();
 				    	//System.out.println(p[b]);
 				    }
 				    args.add(p);
					Class[] argTypes = types.toArray(new Class[1]); //From List to Class[] for invoke method
					Object[] argValues = args.toArray(); //From List to Object[] for invoke method
					result = (String[]) rfConvertor.getMethod(format,argTypes).invoke(fn,argValues);
					//System.out.println(result[0]);
					val=result[0];
					//System.out.println(val);
					if (result[1].length()>1)
						//log.warn(result[1]);
						Util.writeLog("AIMS/SIMS export - Attribute class",
							result[1],
			                sessionID);
				}
				catch (Exception e) {
					//System.out.println("ERROR:"+e.getMessage());
					Util.writeLog("AIMS/SIMS export - Attribute class",
							e.getMessage(),
			                sessionID);
				}
			}
			//Format DB value using internal Convertor
			else{
				Convertor c = new Convertor();
				result=c.getResult(format, val, col);
				val=result[0];
				if (result[1].length()>1)
					//log.warn(result[1]);
					Util.writeLog("AIMS/SIMS export - Attribute class",
						result[1],
		                sessionID);

			}
			return ReplaceReservedCharacters(val);
		}
		else {
			return ReplaceReservedCharacters(val);
		}
	}

//	Processes all formating and converting tasks and returns final attribute value
	public String getFuncVal(Vector paramVal){
		String[] result = new String[2];
		result[0]="";
		result[1]="";
		//Load convertors.FN methods to obtained a value
				try {
					FN fn = new FN();
					//System.out.println(format);
					ArrayList<Class<String[]>> types = new ArrayList<Class<String[]>>();//List of types of arguments (String[])
 				    types.add(String[].class);
					ArrayList<String[]> args = new ArrayList<String[]>();//List of arguments for method
					//From vector to String[]
 				    String[] p = new String[paramVal.size()];
 				    for(int b=0; b<paramVal.size() ; b++) {
 				    	p[b]=(paramVal.get(b) != null) ? (String)paramVal.get(b).toString() : null;
 				    	//System.out.println(p[b]);
 				    }
 				    args.add(p);
					Class[] argTypes = types.toArray(new Class[1]); //From List to Class[] for invoke method
					Object[] argValues = args.toArray(); //From List to Object[] for invoke method
					result = (String[]) rfConvertor.getMethod(format,argTypes).invoke(fn,argValues);
					//System.out.println(result[0]);
					//val=result[0];
					//System.out.println(val);
					if (result[1].length()>1)
						//log.warn(result[1]);
						Util.writeLog("AIMS/SIMS export - Attribute class",
								result[1],
				                sessionID);
				}
				catch (Exception e) {
					//e.printStackTrace();
					//log.error(e.getMessage());
					Util.writeLog("AIMS/SIMS export - Attribute class",
							e.getMessage(),
			                sessionID);
				}
//				Format DB value using internal Convertor
				return ReplaceReservedCharacters(result[0]);
			}

	//	Processes all formating and converting tasks and returns final attribute values *
	@SuppressWarnings("unchecked")
	public Vector<String> getFuncValArray(String formatVal,Vector paramVal){
				Vector<String> result = new Vector<String>();
				Vector<String> result2 = new Vector<String>();
				String[] p = new String[paramVal.size()];
				//Load convertors.FN methods to obtained a value
				try{
					FN fn = new FN();
					//System.out.println(format);
					ArrayList<Class<String[]>> types = new ArrayList<Class<String[]>>();//List of types of arguments (String[])
 				    types.add(String[].class);
					ArrayList<String[]> args = new ArrayList<String[]>();//List of arguments for method
					//From vector to String[]
 				    for(int b=0; b<paramVal.size() ; b++) {
 				    	p[b]=(paramVal.get(b) != null) ? (String)paramVal.get(b).toString() : null;
 				    	//System.out.println(p[b]);
 				    }
 				    args.add(p);
					Class[] argTypes = types.toArray(new Class[1]); //From List to Class[] for invoke method
					Object[] argValues = args.toArray(); //From List to Object[] for invoke method
					result2 = (Vector<String>) rfConvertor.getMethod(formatVal,argTypes).invoke(fn,argValues);
					//result2 = FN.DataFileNamePath(p);
				}
				catch (Exception e){
					e.printStackTrace();
				}

//				Format DB value using internal Convertor
				for(int b=0; b<result2.size(); b++){
					result.add(ReplaceReservedCharacters(result2.get(b)));
				}
				return result;
			}

	private static String ReplaceReservedCharacters(String val){
		String result = val;
		result.replaceAll(">", "&gt;");
		result.replaceAll("<", "&lt;");
		result.replaceAll("\"", "&quot;");
		result.replaceAll("&", "&amp;");
		result.replaceAll("\'", "&apos;");
		return result;
	}
}
