package assays.export;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;


public class DateTypeDefinitions 
{
	// <db name="value" col="Person.age" format="Date_0_1"/>g
	// will convert from dateInputFormat[0] to dateOutputFormat[1] 

	private static String typeName = "datetime";
	private static String[] dateInputFormat = 
	 {
		 "",
		 "yyyy,,,,",
		 "yyyy,MM,dd,,",
		 "yyyy,MM,dd,HH,mm",
		 "yyyy-MM-dd HH:mm:ss.S",
		 "HH,mm,,",
		 "yyyy"

		 
	 };

	private static String[] dateOutputFormat = 
	{
		 "",						
		 "yyyy",						
		 "dd/MM/yyyy",						
		 "dd/MM/yyyy HH:mm",
		 "dd/MM/yyyy HH:mm.S",
		 "HH:mm"
	};

	public DateTypeDefinitions()
	{
		// test date input formats
		/*for (int i = dateInputFormat.length - 1; i >= 0; i--)
		{
			try
			{
				new SimpleDateFormat(dateInputFormat[i]);
			}
			catch (Exception e) 
			{
				System.out.println("### DateTypeDefinitions:1: Wrong input data format:: '" + dateInputFormat[i] + "'");
				e.printStackTrace();
			} 
		}

		// test date output formats
		for (int i = dateOutputFormat.length - 1; i >= 0; i--)
		{
			try
			{
				new SimpleDateFormat(dateOutputFormat[i]);
			}
			catch (Exception e) 
			{
				System.out.println("### DateTypeDefinitions:2: Wrong input data format:: '" + dateOutputFormat[i] + "'");
			} 
		}*/
	}
	
	public static String getName()
	{
		return typeName;
	}

	protected static String[] convert(String dateValue, int fromTypeId, int toTypeId, String outputMessage, String fromYear)
	{
		String[] result = new String [2];
		result[0]=dateValue;
		result[1]="";
		if (fromTypeId < dateInputFormat.length && toTypeId < dateOutputFormat.length && dateValue != null)
		{
			try
			{
				SimpleDateFormat fromDateFormat = new SimpleDateFormat(dateInputFormat[fromTypeId]);
				SimpleDateFormat fromYearFormat = (fromYear != null) ? new SimpleDateFormat("yyyy") : null;

				try
				{
					String parsedDateValue = new SimpleDateFormat(dateOutputFormat[toTypeId]).format(fromDateFormat.parse(dateValue));
					
					if (parsedDateValue != null) 
					{
						if (fromYear != null)
						{
							Calendar c = new GregorianCalendar();
							c.setTime(fromDateFormat.parse(dateValue));
							
							int toY= c.get(Calendar.YEAR);
							
							c.setTime(fromYearFormat.parse(fromYear));
							
							int fromY = c.get(Calendar.YEAR);
							
							if (fromY >= toY) result[0]=Integer.toString(fromY - toY);
							else result[0]="0";
							//else result[1]="Date Conversion Problem-6: Wrong input data value:: '" + dateValue + "';  fromType ='" + 
								//dateInputFormat[fromTypeId] + "'; toType = '" + dateOutputFormat[toTypeId] + "'; fromYear = '" + fromYear + "'; outputMessage = '" +outputMessage+ "';";//System.out.println("### DateTypeDefinitions:3: Wrong input data value:: '" + dateValue + "'");
						}
						else result[0]=parsedDateValue;//return pharseDateValue;
					}
					else result[1]="Date Conversion Problem-3: Wrong input data value:: '" + dateValue + "';  fromType ='" + 
					dateInputFormat[fromTypeId] + "'; toType = '" + dateOutputFormat[toTypeId] + "'; fromYear = '" + fromYear + "'; outputMessage = '" +outputMessage+ "';";//System.out.println("### DateTypeDefinitions:3: Wrong input data value:: '" + dateValue + "'");
				}
				catch (Exception e) 
				{
					result[1]="Date Conversion Problem-4: Wrong output data value:: '" + dateValue + "';  fromType ='" + 
					dateInputFormat[fromTypeId] + "'; toType = '" + dateOutputFormat[toTypeId] + "'; fromYear = '" + fromYear + "'; outputMessage = '" +outputMessage+ "';";//System.out.println("### DateTypeDefinitions:3: Wrong input data value:: '" + dateValue + "'");
				}
			}
			catch (Exception e) 
			{
				result[1]="Date Conversion Problem-5: Wrong input data value:: '" + dateValue + "';  fromType ='" + 
				dateInputFormat[fromTypeId] + "'; toType = '" + dateOutputFormat[toTypeId] + "'; fromYear = '" + fromYear + "'; outputMessage = '" +outputMessage+ "';";//System.out.println("### DateTypeDefinitions:3: Wrong input data value:: '" + dateValue + "'");
			}
		}

		return result; //dateValue;
	}
}
