package assays.export;
/*
 Class to deal with Hibernate Sessions
*/
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.cfg.Configuration;
import java.io.File;
import java.util.Properties;
import java.util.Vector;
import java.io.FileInputStream;

import javax.xml.parsers.*;   // JAXP classes for parsing
import org.w3c.dom.*;         // W3C DOM classes for traversing the document

public class HibernateSessionFactory {
     private static org.hibernate.SessionFactory sessionFactory1; //For Assay DB
     private static org.hibernate.SessionFactory sessionFactory2; //For Sample DB
     private static Configuration cfg,cfg2; 

//=========================================================================================================

     public Session getSession(String CH_path, String dbVal) throws HibernateException {


         System.out.println("<<<<<<<<<<<< getSession >>>>>>>>>>>>>>>> "+CH_path+" "+dbVal);
         AssayExport.log.info("<<<<<<<<<<<< getSession >>>>>>>>>>>>>>>> "+CH_path+" "+dbVal);


    	 org.hibernate.SessionFactory sessionFactory=sessionFactory1;
    	 String urlVal="";
         String usernameVal="";
         String passwordVal="";
         String dataDir="";
         String protocolDir="";
         cfg = new Configuration();
         cfg2 = new Configuration();
         try {
        	 		System.out.println("CATALINA_HOME: "+CH_path);        	 		 
               	  	FileInputStream fis = new FileInputStream(CH_path+"//WEB-INF//classes//hibernate.properties");
               	  	Vector params = parserWebXML(CH_path+"//WEB-INF//web.xml");
               	  	for(int i = 0; i < params.size(); i++) {
            	  		Params p = (Params)params.get(i);
            	  		String currentVal=dbVal+".url";
            	  		if (p.name.equals(currentVal)){
            	  			urlVal=p.value;
            	  		}
            	  		currentVal=dbVal+".username";
            	  		if (p.name.equals(currentVal)){
            	  			usernameVal=p.value;
            	  		}
            	  		currentVal=dbVal+".password";
            	  		if (p.name.equals(currentVal)){
            	  			passwordVal=p.value;
            	  		}
            	  		currentVal="data.directory";
            	  		if (p.name.equals(currentVal)){
            	  			dataDir=p.value;
            	  		}
            	  		currentVal="protocol.directory";
            	  		if (p.name.equals(currentVal)){
            	  			protocolDir=p.value;
            	  		}
               	  	}
               	  	Properties props = new Properties();
               	  	props.load(fis);
               	  	if (urlVal.length()>0 && usernameVal.length()>0 && passwordVal.length()>0){
               	  		props.setProperty("hibernate.connection.url", urlVal);
               	  		props.setProperty("hibernate.connection.username", usernameVal);
               	  		props.setProperty("hibernate.connection.password", passwordVal);
               	  		props.setProperty("data.directory", dataDir);
               	  	    props.setProperty("protocol.directory", protocolDir);
               	  		System.out.println("URL: "+props.getProperty("hibernate.connection.url"));
               	  		cfg.setProperties(props);
                	  	if (dbVal.equals("assay")){
                  	  		File file = new File(CH_path+"//WEB-INF//classes//assays//com//");
                   	  		cfg.addDirectory(file);
                   	  		file = new File(CH_path+"//WEB-INF//classes//assays//hibernate//");
                   	  		cfg.addDirectory(file);
                   	  		cfg.createMappings();
               	  			sessionFactory1 = cfg.buildSessionFactory();
               	  			sessionFactory=sessionFactory1;
               	  		}               	  		
               	  	}
               	  	if (dbVal.equals("sample")){
               	  		cfg2.setProperties(props);
               	  		File file = new File(CH_path+"//WEB-INF//classes//molpage//com//");
            	  		cfg2.addDirectory(file);
            	  		file = new File(CH_path+"//WEB-INF//classes//sims//hibernate//");
            	  		System.out.println(CH_path+"//WEB-INF//classes//sims//hibernate//");
            	  		cfg2.addDirectory(file);
            	  		cfg2.createMappings();
        	  			sessionFactory2 = cfg2.buildSessionFactory();
        	  			sessionFactory=sessionFactory2;
        	  		}
                 }       	 
                 catch (Exception e) {
                     System.err.println("%%%% Error Creating SessionFactory %%%%"+e.getMessage());
                     
                 }
             Session session = sessionFactory.openSession();
             return session;
    }

//=========================================================================================================
    
 //Parse config xml files (web.xml)
    private static Vector parserWebXML(String fileName){
 		Vector<Params> paramList = new Vector<Params>();
 		try{

                     System.out.println(" <<<<<<<<<<< parserWebXML >>>>>>>>>>>>>>>>>>> " + fileName);
                     AssayExport.log.info("parserWebXML "+ fileName);



 	        //Create instance of DocumentBuilderFactory
 	        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
 	        //Get the DocumentBuilder
 	        DocumentBuilder docBuilder = factory.newDocumentBuilder();
 	        //Create blank DOM Document
 	        Document docConfig = docBuilder.parse (new File(fileName));
 	        docConfig.getDocumentElement ().normalize ();
 		    NodeList unitList = docConfig.getElementsByTagName("context-param");
  		    for(int s=0; s<unitList.getLength() ; s++){
                 Node currentNode = unitList.item(s);
                 if(currentNode.getNodeType() == Node.ELEMENT_NODE){
                	 	Element paramName = (Element)((Element)currentNode).getElementsByTagName("param-name").item(0);
                	 	Element paramValue = (Element)((Element)currentNode).getElementsByTagName("param-value").item(0);
                	 	Params element = new Params(paramName.getTextContent(),paramValue.getTextContent());
                        paramList.addElement(element);
                 }
            }     
  		   
 	    }catch(Exception e){
 	          System.out.println(e.getMessage());
 	    }
 	    return paramList;
 	}

//=========================================================================================================
   
 //Return config property   
    public static String getProperty(String propName){
    	String result="";
    	result=cfg.getProperty(propName);
    	return result;
    }

//=========================================================================================================
 
 //Close all HS Factories   
    public void closeAll(){
   	 try {
   		 sessionFactory1.close();
   		 sessionFactory2.close();
   	 }catch (Exception e) {
            System.err.println("%%%% Error Closing SessionFactory %%%%"+e.getMessage());
        }
    }
     
}