package assays.export;
/*Class ReflectionMethod to deal with Java reflection
 which help to obtain the properties of Java components (class methods) as they are dynamically loaded.
 */
import java.lang.reflect.Method;

import assays.com.Util;

public class ReflectionMethod {
  public Class cl;

//Constructor creates a reflection for particular class
  public ReflectionMethod(String className) {
	  try {
		  cl = Class.forName(className);
	  }
	  catch (ClassNotFoundException e) {
  		 Util.writeLog("AIMS/SIMS export","Class not found.",className);
	  }
  }

//Dynamically load a method (by name) without parameters
  public Method getMethod(String methodName) {
	  Method m = null;// = cl.getEnclosingMethod();
	  try {
//		Class[] pm = new Class[0];
		m = cl.getMethod(methodName, (Class[])null);
	  }
	  catch (NoSuchMethodException e) {
  		Util.writeLog("AIMS/SIMS export:method not found.",cl.getName(),methodName);
	  }
  	  return m;
  }

//Dynamically load a method (by name) with parameters
  public Method getMethod(String methodName, Class[] param) {
	  Method m = null;//cl.getEnclosingMethod();
	  try {
		m = cl.getMethod(methodName, param);
	  }
	  catch (NoSuchMethodException e) {
  		Util.writeLog("AIMS/SIMS export:method not found.",cl.getName(),methodName);
	  }
  	  return m;
  }

//Prints all methods of a class
  public static void printMethods(Class cl) {
    Method[] methods = cl.getDeclaredMethods();

    for (int i = 0; i < methods.length; i++) {
      Method m = methods[i];
      //Class retType = m.getReturnType();
      Class[] paramTypes = m.getParameterTypes();
      //String name = m.getName();
      //System.out.print(Modifier.toString(m.getModifiers()));
      //System.out.print(" " + retType.getName() + " " + name + "(");
      for (int j = 0; j < paramTypes.length; j++) {
        if (j > 0)
          System.out.print(", ");
        System.out.print(paramTypes[j].getName());
      }
      System.out.println(");");
    }
  }
}
