package assays.export;

import org.w3c.dom.*;
import java.util.HashMap;
import java.util.Map;
import java.util.Vector;
import java.io.*;


public class TSV {
	
	static Map<String, Integer> levels = new HashMap<String, Integer>();
	static Map<String, Integer> visited_rm = new HashMap<String, Integer>();
	static Vector<Level> level_visited = new Vector<Level>(); //to store all visited levels with name of elements
	static Vector<String> element_visited = new Vector<String>();//to store name of elements that have to be removed during current row processing
	static int minEl = 0;
	static String minElement = "aaa";
	static boolean minVisited = false;
	static boolean stopTitles = false;
	static int z = 0;
	static Vector<String> Titles = new Vector<String>();
	static Vector<String> Row = new Vector<String>(); //all Row to print
	static Vector<String> currentRow = new Vector<String>();//for creation of current row 


	public TSV(Element el,DataOutputStream dos) 
	{
		TSV.printElement(el,0,dos);
	}
	public TSV(Element el,String type, DataOutputStream dos) 
	{
		TSV.printPlanar(el,0,dos);
	}


	
	//delete previous elements
	private static void deleteFromCurrentRow(Element el){
		int a=0;
		
		if (minVisited && element_visited.contains(el.getNodeName()) && levels.containsKey(el.getNodeName())) {//minVisited				
				a=(Integer)levels.get(el.getNodeName());
				System.out.println(el.getNodeName()+":"+a);
				for(int j=0; j<a;j++)
					if (currentRow.size()>0) currentRow.remove(currentRow.size()-1);
				
		}
		
	}

	
	private static int getValueCnt(Element el, int val){
		int currVal = val;
		NodeList tagList = el.getChildNodes();
		int a = 0;
		if (!visited_rm.containsKey(el.getNodeName())){
			if (levels.get(el.getNodeName())!=null) a=(Integer)levels.get(el.getNodeName());
			currVal = currVal + a;
			visited_rm.put(el.getNodeName(),0);
		}
		for (int i=0; i<tagList.getLength(); i++){			
			Element currentEl = (Element)tagList.item(i);
			currVal=getValueCnt(currentEl,currVal);
		}
		return currVal;
	}
	
	private static void levelsReview(Element el){
		NodeList tagList = el.getChildNodes();
		for (int i=0; i<tagList.getLength(); i++){			
			Element currentEl = (Element)tagList.item(i);
			visited_rm.clear();
			if (levels.get(currentEl.getNodeName())!=null){
				levels.put(currentEl.getNodeName(), getValueCnt((Element)currentEl.getParentNode(),0));
			}
			levelsReview(currentEl);
		}
	}
	
	//finds the minimal level for a given XML fragment
	private static void findMinLevel(Element el, int level){
		NodeList tagList = el.getChildNodes();
		Element parent = null;
		if (minEl<level) minEl=level;
		int cnt = 0;
		for (int i=0; i<tagList.getLength(); i++){			
			Element currentEl = (Element)tagList.item(i);
			//check only tags with attributes pair "name" "value"
			if (currentEl.getAttribute("name").length () > 0){
				parent =  (Element)currentEl.getParentNode();
				cnt++;
				if (level==minEl) minElement=currentEl.getNodeName();
			}
			findMinLevel(currentEl,level+1);
		}
		if (cnt>0) {
			//save the number of values for a every given level of XML
			levels.put(parent.getNodeName(), cnt);			
		}
		
	}

	
	private static void printElement(Element el,int level,DataOutputStream dos){	
		try{
		NodeList tagList = el.getChildNodes();		
		for (int i=0; i<tagList.getLength(); i++){
			Element currentEl = (Element)tagList.item(i);
			
			
			//New element in stack
			if (levels.get(currentEl.getNodeName())!=null){ //if element has "names"-"values"
				Level currentLevel = new Level(currentEl.getNodeName(),level);				
				if (!level_visited.isEmpty()){
					Level previousLevel = level_visited.lastElement();
					int a = 0;
						while(currentLevel.level<previousLevel.level){//if now it is higher level 
							a++;
							element_visited.remove(previousLevel.name);//then remove all lower levels from "element_visited" list
							previousLevel = level_visited.elementAt(level_visited.size()-a);
						}
				}
				level_visited.add(currentLevel); // add as a visited level
			}
			
			if (level==0) {
				minEl=0;
				minElement="aaa";
				stopTitles=false;
				minVisited = false;
				for (int j=0;j<Row.size();j++)
					dos.writeBytes(Row.elementAt(j));
				Row.clear();
				currentRow.clear();
				Titles.clear();
				levels.clear();
				findMinLevel(currentEl,0);
				levelsReview(currentEl);
			}
					
			deleteFromCurrentRow(currentEl);		
			
			//Add new values into current row
			if (currentEl.getAttribute("name").length () > 0){
				if (!stopTitles) {
					Titles.addElement(currentEl.getAttribute("name"));
					Titles.addElement("\t");
				}
				currentRow.addElement(currentEl.getAttribute("value"));
			}
			
			printElement(currentEl,level+1,dos);	

			//if the minimal element of XML fragment is visited , then program will print row at previous level
			if (currentEl.getNodeName().equals(minElement)) {minVisited = true;z=level-1;}
			if (level==z && currentRow.size()>0) {//z>level && currentRow.size()>0
				if (!stopTitles) {
					for (int j=0;j<Titles.size();j++)
						dos.writeBytes(Titles.elementAt(j));
					if (Titles.size()>0) dos.writeBytes("\n");
				}
				for (int j=0;j<currentRow.size();j++)
					Row.addElement(currentRow.elementAt(j)+"\t");
				Row.addElement("\n");
				z=10000;
				stopTitles=true;
			}		
			
			if (level==0) {
				System.out.println(currentEl.getNodeName());
				minEl=0;
				minElement="aaa";
				stopTitles=false;
				minVisited = false;
				for (int j=0;j<Row.size();j++)
					dos.writeBytes(Row.elementAt(j));
				Row.clear();
				currentRow.clear();
				Titles.clear();
				levels.clear();
				findMinLevel(currentEl,0);
				levelsReview(currentEl);
			}
			
			element_visited.add(currentEl.getNodeName());
		 }
	
		
		}catch(Exception e){
        	e.printStackTrace();
        }
	}
	
	private static void printPlanar(Element el,int level,DataOutputStream dos){	
		try{

                    System.out.println(" <<<<<<<<<<< PP >>>>>>>>>>>>>>>>>>> ");
                    
		NodeList tagList = el.getChildNodes();		
		for (int i=0; i<tagList.getLength(); i++){
			Element currentEl = (Element)tagList.item(i);
		
			if (currentEl.getAttribute("name").length () > 0){
				dos.writeBytes(currentEl.getAttribute("name"));
				dos.writeBytes("\t");
				dos.writeBytes(currentEl.getAttribute("value"));
				dos.writeBytes("\n");
			}
			
			printPlanar(currentEl,level+1,dos);
		}
		}catch(Exception e){
        	e.printStackTrace();
        }
	}
  
 }