package assays.export;

import java.text.SimpleDateFormat;

public class TimeTypeDefinitions 
{
	// <db name="value" col="Person.age" format="Date_0_1"/>
	// will convert from dateInputFormat[0] to dateOutputFormat[1] 

	private static String typeName = "time";
	private static String[] timeInputFormat = 
	 {
		 "",
		 ",,ss,",
		 ",mm,,",
		 ",mm,ss,",
		 "HH,,,",
		 "",
		 "HH,mm,,",
		 "HH,mm,ss,"
	 };

	private static String[] timeOutputFormat = 
	{
		 "",
		 "ss",
		 "mm",
		 "mm:ss",
		 "HH",
		 "",
		 "HH:mm",
		 "HH:mm:ss"
	};
	
	public TimeTypeDefinitions()
	{
		// test date input formats
		/*for (int i = timeInputFormat.length - 1; i >= 0; i--)
		{
			try
			{
				new SimpleDateFormat(timeInputFormat[i]);
			}
			catch (Exception e) 
			{
				System.out.println("### DateTypeDefinitions:1: Wrong input data format:: '" + timeInputFormat[i] + "'");
				e.printStackTrace();
			} 
		}

		// test date input formats
		for (int i = timeOutputFormat.length - 1; i >= 0; i--)
		{
			try
			{
				new SimpleDateFormat(timeOutputFormat[i]);
			}
			catch (Exception e) 
			{
				System.out.println("### DateTypeDefinitions:2: Wrong input data format:: '" + timeOutputFormat[i] + "'");
			} 
		}*/
	}
	
	public static String getName()
	{
		return typeName;
	}

	protected static String[] convert(String dateValue, int fromTypeId, int toTypeId, String outputMessage)
	{
		String[] result = new String [2];
		result[0]=dateValue;
		result[1]="";

		if (fromTypeId < timeInputFormat.length && toTypeId < timeOutputFormat.length && dateValue != null)
		{
			try
			{
				SimpleDateFormat fromDateFormat = new SimpleDateFormat(timeInputFormat[fromTypeId]);

				try
				{
					String parsedDateValue = new SimpleDateFormat(timeOutputFormat[toTypeId]).format(fromDateFormat.parse(dateValue));
					
					if (parsedDateValue != null) result[0]=parsedDateValue;
					else result[1]="Time Conversion Problem-1: Wrong input data value:: '" + dateValue + "';  fromType ='" + 
					timeInputFormat[fromTypeId] + "'; toType = '" + timeOutputFormat[toTypeId] + "'; outputMessage = '" +outputMessage+ "';";
					
				}
				catch (Exception e) 
				{
					result[1]="Time Conversion Problem-2: Wrong input data value:: '" + dateValue + "';  fromType ='" + 
					timeInputFormat[fromTypeId] + "'; toType = '" + timeOutputFormat[toTypeId] + "'; outputMessage = '" +outputMessage+ "';";}
			}
			catch (Exception e) 
			{
				result[1]="Time Conversion Problem-3: Wrong input data value:: '" + dateValue + "';  fromType ='" + 
				timeInputFormat[fromTypeId] + "'; toType = '" + timeOutputFormat[toTypeId] + "'; outputMessage = '" +outputMessage+ "';";}
		}

		return result;
	}
}
