package assays.hibernate;

public abstract class AbstractParameter extends TechnologyPersistent {
  private String longName;
  private String uploadName;
  private String assayColumnName;
  private String stgrColumnName;
  private String viewColumnName;
  private Integer assayViewColumnNumber;
  private Integer stgrViewColumnNumber;
  private Integer viewViewColumnNumber;
  private Integer assaySortableX;
  private Integer stgrSortableX;
  private Integer viewSortableX;
  private Integer showInFilterX;
  private int valueAssayNumber;
  private int valueStgrNumber;
  private int valueViewNumber;

  public AbstractParameter() {
    assayColumnName = "";
    stgrColumnName = "";
    viewColumnName = "";
    assayViewColumnNumber = new Integer(0);
    stgrViewColumnNumber = new Integer(0);
    viewViewColumnNumber = new Integer(0);
    assaySortableX = new Integer(0);
    stgrSortableX  = new Integer(0);
    viewSortableX  = new Integer(0);
    showInFilterX  = new Integer(0);
  }

  public String getLongName() {
          return longName;
  }
  public String getUploadName() {
          return uploadName;
  }
  public String getVisualUploadName() {
          return (uploadName!=null)?uploadName:"";
  }

  public String getAssayColumnName() {
          return assayColumnName;
  }
  public String getStgrColumnName() {
          return stgrColumnName;
  }
  public String getViewColumnName() {
          return viewColumnName;
  }
  public Integer getAssayViewColumnNumber() {
          return assayViewColumnNumber;
  }
  public Integer getStgrViewColumnNumber() {
          return stgrViewColumnNumber;
  }
  public Integer getViewViewColumnNumber() {
          return (viewViewColumnNumber==null)?0:viewViewColumnNumber;
  }

  public int getValueAssayNumber() {
          return valueAssayNumber;
  }
  public int getValueStgrNumber() {
          return valueStgrNumber;
  }
  public int getValueViewNumber() {
          return valueViewNumber;
  }

  public Integer getAssaySortableX() {
          return assaySortableX;
  }
  public Integer getStgrSortableX() {
          return stgrSortableX;
  }
  public Integer getViewSortableX() {
          return (viewSortableX==null)?0:viewSortableX;
  }

  public Integer getShowInFilterX() {
          return showInFilterX;
  }

  public boolean isAssaySortable() {
    return assaySortableX!=null && assaySortableX.byteValue() > 0;
  }
  public boolean isStgrSortable() {
    return stgrSortableX!=null && stgrSortableX.byteValue() > 0;
  }
  public boolean isViewSortable() {
    return viewSortableX!=null && viewSortableX.byteValue() > 0;
  }

  public boolean isShowInFilter() {
    return showInFilterX!=null && showInFilterX.byteValue()>0;
  }

//------------------------------------------------------
//------------------------------------------------------
    public void setLongName(String val) {
            longName = val;
    }
    public void setUploadName(String val) {
            uploadName = val;
    }

    public void setAssayColumnName(String colname) {
            assayColumnName = colname;
    }
    public void setStgrColumnName(String colname) {
            stgrColumnName = colname;
    }
    public void setViewColumnName(String colname) {
            viewColumnName = colname;
    }

    public void setAssayViewColumnNumber(Integer num) {
            assayViewColumnNumber = num;
    }
    public void setStgrViewColumnNumber(Integer num) {
            stgrViewColumnNumber = num;
    }
    public void setViewViewColumnNumber(Integer num) {
            viewViewColumnNumber = num;
    }

    public void setAssaySortableX(Integer sort) {
            assaySortableX = sort;
    }
    public void setStgrSortableX(Integer sort) {
            stgrSortableX = sort;
    }
    public void setViewSortableX(Integer sort) {
            viewSortableX = sort;
    }

    public void setValueAssayNumber(int cNumber) {
            valueAssayNumber = cNumber;
    }
    public void setValueStgrNumber(int cNumber) {
            valueStgrNumber = cNumber;
    }
    public void setValueViewNumber(int cNumber) {
            valueViewNumber = cNumber;
    }
/*
    public void setColumnNumberInReports(Integer cNumber) {
            columnNumberInReports = cNumber;
    }
*/
    public void setShowInFilterX(Integer show) {
            showInFilterX = show;
    }

    public void CopyTo( AbstractParameter target){
      super.CopyTo(target);
      target.setLongName(longName);
      target.setUploadName(uploadName);
      target.setAssayColumnName(assayColumnName);
      target.setStgrColumnName(stgrColumnName);
      target.setViewColumnName(viewColumnName);
      target.setAssayViewColumnNumber(assayViewColumnNumber);
      target.setStgrViewColumnNumber(stgrViewColumnNumber);
      target.setViewViewColumnNumber(viewViewColumnNumber);
      target.setAssaySortableX(assaySortableX);
      target.setStgrSortableX(stgrSortableX);
      target.setViewSortableX(viewSortableX);
      target.setShowInFilterX(showInFilterX);
    }
}
