package assays.hibernate;

public final class Parameter extends AbstractParameter{
  private ParameterGroup parameterGroup;
  private ParameterType parameterType;
  private Integer requiredX;
  private Integer assayRowNumber;
  private Integer stgrRowNumber;
  private Integer viewRowNumber;
  private String noteToDisplay;
/*
  private String longName;
  private String assayColumnName;
  private String stgrColumnName;
  private Integer assayViewColumnNumber;
  private Integer stgrViewColumnNumber;
  private Integer columnNumberInReports;
  private int valueAssayNumber;
  private int valueStgrNumber;
*/
  public Parameter() {
    assayRowNumber = new Integer(0);
    stgrRowNumber = new Integer(0);
    viewRowNumber = new Integer(0);
    requiredX = new Integer(0);
  }

  public String getNoteToDisplay(){
    return noteToDisplay;
  }
  public String getVisibleNoteToDisplay(){
    return (noteToDisplay==null)?"":noteToDisplay;
  }
  public void setNoteToDisplay(String val){
	noteToDisplay = val;
  }
  public ParameterGroup getParameterGroup(){
    return parameterGroup;
  }
  public ParameterType getParameterType(){
    return parameterType;
  }
  public Integer getAssayRowNumber() {
          return assayRowNumber;
  }
  public Integer getStgrRowNumber() {
          return stgrRowNumber;
  }
  public Integer getViewRowNumber() {
          return (viewRowNumber==null)?0:viewRowNumber;
  }
  public Integer getRequiredX() {
          return requiredX;
  }
  public boolean isRequired() {
    return requiredX!=null && requiredX.byteValue() > 0;
  }

  public String getAssayColumnNameF() {
    String c = super.getAssayColumnName();
    if (c == null || c.length() < 4) return c;
    else return  "F" + c.substring(1);
  }
  public String getStgrColumnNameF() {
    String c = super.getStgrColumnName();
    if (c == null || c.length() < 4) return c;
    else return  "F" + c.substring(1);
  }
  public String getViewColumnNameF() {
    String c = super.getViewColumnName();
    if (c == null || c.length() < 4) return c;
    else return  "F" + c.substring(1);
  }

  public String getAssayColumnNamef() {
    String c = super.getAssayColumnName();
    if (c == null || c.length() < 4) return c;
    else return  "f" + c.substring(1);
  }
  public String getStgrColumnNamef() {
    String c = super.getStgrColumnName();
    if (c == null || c.length() < 4) return c;
    else return  "f" + c.substring(1);
  }
  public String getViewColumnNamef() {
    String c = super.getViewColumnName();
    if (c == null || c.length() < 4) return c;
    else return  "f" + c.substring(1);
  }

  public int getFieldCount(){
    int result = 1;
    ParameterType paramType = getParameterType();
    int baseType = paramType.getBaseType().intValue();
    if (baseType == AssayTypeName.FLOAT_ARRAY ||
          baseType == AssayTypeName.NUMBER_ARRAY)
      result = paramType.getAttribute1();
    else
    if (baseType == AssayTypeName.DATETIME) {
      int m = paramType.getAttribute1();
      switch (m){
        case 2: result = 3;  break;//yyyy-MM-dd
        case 3: result = 5;  break;//yyyy-MM-dd hh:mm
      }
    }
    else
    if (baseType == AssayTypeName.TIME) {
      int m = paramType.getAttribute1();
      switch (m){
        case 3: result = 2;  break;//mm:ss
        case 6: result = 2;  break;//hh:mm
        case 7: result = 3;  break;//hh:mm:ss
      }
    }
    return result;
  }
//------------------------------------------------------
//------------------------------------------------------
  public void setParameterGroup(ParameterGroup cat){
    parameterGroup = cat;
  }
  public void setParameterType(ParameterType cat){
    parameterType = cat;
  }
  public void setRequiredX( Integer val) {
          requiredX = val;
  }
  public void setAssayRowNumber(Integer num) {
          assayRowNumber = num;
  }
  public void setStgrRowNumber(Integer num) {
          stgrRowNumber = num;
  }
  public void setViewRowNumber(Integer num) {
          viewRowNumber = num;
  }
}

