package assays.hibernate;

public final class TechnologyAccess
    extends TechnologyPersistent {
  private AssayUser user;
  private Integer canCreateSGX;
  private Integer canCreateViewX;
  private Integer vocabularyAccess;
  private Integer configurationAccess;
  private Integer dataTransferRightsX;
  private Integer dataExportRights;
  private Integer dataFileExportRightsX;

  public AssayUser getUser() {
    return user;
  }
  public void setUser(AssayUser val) {
    user = val;
  }
  public Integer getCanCreateSGX() {
    return canCreateSGX;
  }
  public void setCanCreateSGX(Integer val) {
    canCreateSGX = val;
  }
  public boolean canCreateSG() {
    return canCreateSGX!=null && canCreateSGX.byteValue() > 0;
  }
  public Integer getCanCreateViewX() {
    return canCreateViewX;
  }
  public void setCanCreateViewX(Integer val) {
    canCreateViewX = val;
  }
  public boolean canCreateView() {
    return canCreateViewX!=null && canCreateViewX.byteValue() > 0;
  }
  public Integer getVocabularyAccess() {
    return (vocabularyAccess==null)?new Integer(0):vocabularyAccess;
  }
  public void setVocabularyAccess(Integer val) {
    vocabularyAccess = val;
  }
  public Integer getConfigurationAccess() {
    return (configurationAccess==null)?new Integer(0):configurationAccess;
  }
  public void setConfigurationAccess(Integer val) {
    configurationAccess = val;
  }
  public Integer getDataTransferRightsX() {
    return (dataTransferRightsX==null)?new Integer(0):dataTransferRightsX;
  }
  public void setDataTransferRightsX(Integer val) {
	dataTransferRightsX = val;
  }
  public boolean hasDataTransferRights() {
    return dataTransferRightsX!=null && dataTransferRightsX.byteValue() > 0;
  }
  public Integer getDataExportRights() {
    return (dataExportRights==null)?new Integer(0):dataExportRights;
  }
  public void setDataExportRights(Integer val) {
	dataExportRights = val;
  }
  public Integer getDataFileExportRightsX() {
    return (dataFileExportRightsX==null)?new Integer(0):dataFileExportRightsX;
  }
  public void setDataFileExportRightsX(Integer val) {
	dataFileExportRightsX = val;
  }
  public boolean hasDataFileExportRights() {
    return dataFileExportRightsX!=null && dataFileExportRightsX.byteValue() > 0;
  }
  private static final String[] dataExportVariants = {
      "non-accessible",
      "predefined",
      "user defined",
  };
  private static final int[] dataExportValues = {
      0, 1000, 2000
  };

  private static final String[] accessVariants = {
      "non-accessible",
      "view only",
      "limited editing",
      "full editing"
  };
  private static final int[] accessValues = {
      0, 1000, 2000, 3000
  };
  public static String getAccessRightSelectionNew(){
    StringBuffer xyz = new StringBuffer();
    for (int i = 0; i < accessVariants.length; i++){
        xyz.append("<option ");
        xyz.append("value=\"")
            .append( accessValues[i])
            .append("\">")
            .append(accessVariants[i]);
      }
    return xyz.toString();
  }
  public static String getDataExportRightSelectionNew(){
    StringBuffer xyz = new StringBuffer();
    for (int i = 0; i < dataExportVariants.length; i++){
        xyz.append("<option ");
        xyz.append("value=\"")
            .append( dataExportValues[i])
            .append("\">")
            .append(dataExportVariants[i]);
      }
    return xyz.toString();
  }

  public String getVocabRightSelection(){
    StringBuffer xyz = new StringBuffer();
    int j = 1; int v = (vocabularyAccess!=null)?vocabularyAccess.intValue():0;
    while ( j < accessValues.length && v >= accessValues[j]) j++;
    j--;
    for (int i = 0; i < accessVariants.length; i++){
        xyz.append("<option ");
        if ( i==j) xyz.append("selected ");
        xyz.append("value=\"")
            .append( accessValues[i])
            .append("\">")
            .append(accessVariants[i]);
      }
    return xyz.toString();
  }
  public String getConfigRightSelection(){
    StringBuffer xyz = new StringBuffer();
    int j = 1; int v = (configurationAccess!=null)?configurationAccess.intValue():0;
    while ( j < accessValues.length && v >= accessValues[j]) j++;
    j--;
    for (int i = 0; i < accessVariants.length; i++){
        xyz.append("<option ");
        if ( i==j) xyz.append("selected ");
        xyz.append("value=\"")
            .append( accessValues[i])
            .append("\">")
            .append(accessVariants[i]);
      }
    return xyz.toString();
  }
  
  public String getDataExportRightSelection(){
    StringBuffer xyz = new StringBuffer();
    int j = 1; int v = (dataExportRights!=null)?dataExportRights.intValue():0;
    while ( j < dataExportValues.length && v >= dataExportValues[j]) j++;
    j--;
    for (int i = 0; i < dataExportVariants.length; i++){
        xyz.append("<option ");
        if ( i==j) xyz.append("selected ");
        xyz.append("value=\"")
            .append( dataExportValues[i])
            .append("\">")
            .append(dataExportVariants[i]);
    }
    return xyz.toString();
  }
  public String getVocabRightText(){
    int j = 1; int v = (vocabularyAccess!=null)?vocabularyAccess.intValue():0;
    while ( j < accessValues.length && v >= accessValues[j]) j++;
    return accessVariants[--j];
  }
  public String getConfigRightText(){
    int j = 1; int v = (configurationAccess!=null)?configurationAccess.intValue():0;
    while ( j < accessValues.length && v >= accessValues[j]) j++;
    return accessVariants[--j];
  }
  public String getDataExportRightText(){
    int j = 1; int v = (dataExportRights!=null)?dataExportRights.intValue():0;
    while ( j < dataExportValues.length && v >= dataExportValues[j]) j++;
    return dataExportVariants[--j];
  }
}
