package assays.hibernate;

public abstract class TechnologyData extends TechnologyPersistent {
  private String simsCollectionName;
  private String simsRefId;
  private Long simsBottomRef;
  private Long simsMiddleRef;
  private Long simsTopRef;
  private String uuId;

  private String protocolFiles;
  private String dataFiles;
  private Integer pendingX;
  private Integer exportStatus;

  private Long identif;
  private String identifString;
  private String batchId;
//--------------------------------------------------
  public boolean isPendingStatus(){
    int expStat = (exportStatus==null)?0:exportStatus.intValue(); 
    return (expStat >= 1000 && expStat <= 2000) || isPending();
  }
  public boolean isExported() {
      return exportStatus!=null && exportStatus.intValue()>0;
  }
  public String getBatchId() {
      return batchId;
  }
  public void setBatchId(String val) {
      batchId = val;
  }
//--------------------------------------------------
  public Long getIdentif() {
      return identif;
  }
  public String getIdentifString() {
      return identifString;
  }
  public void setIdentif(Long val) {
      identif = val;
  }
  public void setIdentifString(String val) {
      identifString = val;
  }
//--------------------------------------------------
  public String getProtocolFiles() {
      return protocolFiles;
  }
  public String getDataFiles() {
      return dataFiles;
  }
  public void setProtocolFiles(String protfiles) {
      protocolFiles = protfiles;
  }
  public void setDataFiles(String datfiles) {
      dataFiles = datfiles;
  }
  public Integer getPendingX() {
      return pendingX;
  }
  public void setPendingX(Integer isp) {
      pendingX = isp;
  }
  public boolean isPending(){
    return (pendingX!=null && pendingX.byteValue() > 0);
  }
  public boolean isFileError(){
    return (pendingX!=null && pendingX.byteValue() < 0);
  }
  public Integer getExportStatus() {
      return exportStatus;
  }
  public void setExportStatus(Integer isp) {
	  exportStatus = isp;
  }
  private boolean hasDataFiles() {
      return (dataFiles!=null && dataFiles.length() > 5 && dataFiles.charAt(0)=='\r');
  }
  private boolean hasProtocolFiles() {
      return (protocolFiles!=null && protocolFiles.length() > 5 && protocolFiles.charAt(0)=='\r');
  }
  public boolean hasFiles() {
      return (hasDataFiles() || hasProtocolFiles());
  }
//--------------------------------------------------
  public String getSimsCollectionName() {
      return simsCollectionName;
  }
  public String getSimsRefId() {
      return simsRefId;
  }
  public String getUuId() {
      return uuId;
  }
  public Long getSimsBottomRef() {
      return simsBottomRef;
  }
  public Long getSimsMiddleRef() {
      return simsMiddleRef;
  }
  public Long getSimsTopRef() {
      return simsTopRef;
  }
//--------------------------------------------------
  public String getSimsBottomReference() {
      return (simsBottomRef!=null)?simsRefId:"";
  }
  public String getSimsMiddleReference() {
      return (simsMiddleRef!=null)?simsRefId:"";
  }
  public String getSimsTopReference() {
      return (simsTopRef!=null)?simsRefId:"";
  }
//--------------------------------------------------
/*
  public String getSimsBottomRefId() {
      return (simsBottomRef!=null)?simsRefId:null;
  }
  public String getSimsMiddleRefId() {
      return (simsMiddleRef!=null)?simsRefId:null;
  }
  public String getSimsTopRefId() {
      return (simsTopRef!=null)?simsRefId:null;
  }
*/  
//--------------------------------------------------

  public void setSimsReference(Long id, int type) {
    switch (type){
      case 0:
        simsCollectionName = null;  
    	simsRefId = null;
        simsBottomRef = null;
        simsMiddleRef = null;
        simsTopRef = null;
        break;
      case 1:
        simsBottomRef = null;
        simsMiddleRef = null;
        simsTopRef = id;
        break;
      case 2:
        simsBottomRef = null;
        simsMiddleRef = id;
        simsTopRef = null;
        break;
      case 3:
        simsBottomRef = id;
        simsMiddleRef = null;
        simsTopRef = null;
        break;
    }
  }
  public int getSimsReferenceType() {
    int rez = 0;
    if (simsBottomRef != null) rez = 3;
    else
    if (simsMiddleRef != null) rez = 2;
    else
    if (simsTopRef != null) rez = 1;
    return rez;
  }
//--------------------------------------------------
  public void setSimsCollectionName(String val) {
      simsCollectionName = val;
  }
  public void setSimsRefId(String val) {
      simsRefId = val;
  }
  public void setUuId(String id) {
      uuId = id;
  }
  public void setSimsBottomRef(Long id) {
      simsBottomRef = id;
  }
  public void setSimsMiddleRef(Long id) {
      simsMiddleRef = id;
  }
  public void setSimsTopRef(Long id) {
      simsTopRef = id;
  }
//--------------------------------------------------
/*
  private String f001;
  private String f002;
  private String f003;
  private String f004;
  private String f005;
  private String f006;
  private String f007;
  private String f008;
  private String f009;
  private String f010;
  private String f011;
  private String f012;
  private String f013;
  private String f014;
  private String f015;
  private String f016;
  private String f017;
  private String f018;
  private String f019;
  private String f020;
  private String f021;
  private String f022;
  private String f023;
  private String f024;
  private String f025;
  private String f026;
  private String f027;
  private String f028;
  private String f029;
  private String f030;
  private String f031;
  private String f032;
  private String f033;
  private String f034;
  private String f035;
  private String f036;
  private String f037;
  private String f038;
  private String f039;
  private String f040;
  private String f041;
  private String f042;
  private String f043;
  private String f044;
  private String f045;
  private String f046;
  private String f047;
  private String f048;
  private String f049;
  private String f050;
  private String f051;
  private String f052;
  private String f053;
  private String f054;
  private String f055;
//-----------reserved------------------
  private String F056;
  private String F057;
  private String F058;
  private String F059;
  private String F060;
  private String F061;
  private String F062;
  private String F063;
  private String F064;
//--------------------------------------------------
  public String getF001() {
      return f001;
  }
  public String getF002() {
      return f002;
  }
  public String getF003() {
      return f003;
  }
  public String getF004() {
      return f004;
  }
  public String getF005() {
      return f005;
  }
  public String getF006() {
      return f006;
  }
  public String getF007() {
      return f007;
  }
  public String getF008() {
      return f008;
  }
  public String getF009() {
      return f009;
  }
  public String getF010() {
      return f010;
  }
  public String getF011() {
      return f011;
  }
  public String getF012() {
      return f012;
  }
  public String getF013() {
      return f013;
  }
  public String getF014() {
      return f014;
  }
  public String getF015() {
      return f015;
  }
  public String getF016() {
      return f016;
  }
  public String getF017() {
      return f017;
  }
  public String getF018() {
      return f018;
  }
  public String getF019() {
      return f019;
  }
  public String getF020() {
      return f020;
  }
  public String getF021() {
      return f021;
  }
  public String getF022() {
      return f022;
  }
  public String getF023() {
      return f023;
  }
  public String getF024() {
      return f024;
  }
  public String getF025() {
      return f025;
  }
  public String getF026() {
      return f026;
  }
  public String getF027() {
      return f027;
  }
  public String getF028() {
      return f028;
  }
  public String getF029() {
      return f029;
  }
  public String getF030() {
      return f030;
  }
  public String getF031() {
      return f031;
  }
  public String getF032() {
      return f032;
  }
  public String getF033() {
      return f033;
  }
  public String getF034() {
      return f034;
  }
  public String getF035() {
      return f035;
  }
  public String getF036() {
      return f036;
  }
  public String getF037() {
      return f037;
  }
  public String getF038() {
      return f038;
  }
  public String getF039() {
      return f039;
  }
  public String getF040() {
      return f040;
  }
  public String getF041() {
      return f041;
  }
  public String getF042() {
      return f042;
  }
  public String getF043() {
      return f043;
  }
  public String getF044() {
      return f044;
  }
  public String getF045() {
      return f045;
  }
  public String getF046() {
      return f046;
  }
  public String getF047() {
      return f047;
  }
  public String getF048() {
      return f048;
  }
  public String getF049() {
      return f049;
  }
  public String getF050() {
      return f050;
  }
  public String getF051() {
      return f051;
  }
  public String getF052() {
      return f052;
  }
  public String getF053() {
      return f053;
  }
  public String getF054() {
      return f054;
  }
  public String getF055() {
      return f055;
  }
//-----------reserved------------------
  public String getF056() {
      return F056;
  }
  public String getF057() {
      return F057;
  }
  public String getF058() {
      return F058;
  }
  public String getF059() {
      return F059;
  }
  public String getF060() {
      return F060;
  }
  public String getF061() {
      return F061;
  }
  public String getF062() {
      return F062;
  }
  public String getF063() {
      return F063;
  }
  public String getF064() {
      return F064;
  }
//--------------------------------------------------
//--------------------------------------------------
  public void setF001(String val) {
      f001 = val;
  }
  public void setF002(String val) {
      f002 = val;
  }
  public void setF003(String val) {
      f003 = val;
  }
  public void setF004(String val) {
      f004 = val;
  }
  public void setF005(String val) {
      f005 = val;
  }
  public void setF006(String val) {
      f006 = val;
  }
  public void setF007(String val) {
      f007 = val;
  }
  public void setF008(String val) {
      f008 = val;
  }
  public void setF009(String val) {
      f009 = val;
  }
  public void setF010(String val) {
      f010 = val;
  }
  public void setF011(String val) {
      f011 = val;
  }
  public void setF012(String val) {
      f012 = val;
  }
  public void setF013(String val) {
      f013 = val;
  }
  public void setF014(String val) {
      f014 = val;
  }
  public void setF015(String val) {
      f015 = val;
  }
  public void setF016(String val) {
      f016 = val;
  }
  public void setF017(String val) {
      f017 = val;
  }
  public void setF018(String val) {
      f018 = val;
  }
  public void setF019(String val) {
      f019 = val;
  }
  public void setF020(String val) {
      f020 = val;
  }
  public void setF021(String val) {
      f021 = val;
  }
  public void setF022(String val) {
      f022 = val;
  }
  public void setF023(String val) {
      f023 = val;
  }
  public void setF024(String val) {
      f024 = val;
  }
  public void setF025(String val) {
      f025 = val;
  }
  public void setF026(String val) {
      f026 = val;
  }
  public void setF027(String val) {
      f027 = val;
  }
  public void setF028(String val) {
      f028 = val;
  }
  public void setF029(String val) {
      f029 = val;
  }
  public void setF030(String val) {
      f030 = val;
  }
  public void setF031(String val) {
      f031 = val;
  }
  public void setF032(String val) {
      f032 = val;
  }
  public void setF033(String val) {
      f033 = val;
  }
  public void setF034(String val) {
      f034 = val;
  }
  public void setF035(String val) {
      f035 = val;
  }
  public void setF036(String val) {
      f036 = val;
  }
  public void setF037(String val) {
      f037 = val;
  }
  public void setF038(String val) {
      f038 = val;
  }
  public void setF039(String val) {
      f039 = val;
  }
  public void setF040(String val) {
      f040 = val;
  }
  public void setF041(String val) {
      f041 = val;
  }
  public void setF042(String val) {
      f042 = val;
  }
  public void setF043(String val) {
      f043 = val;
  }
  public void setF044(String val) {
      f044 = val;
  }
  public void setF045(String val) {
      f045 = val;
  }
  public void setF046(String val) {
      f046 = val;
  }
  public void setF047(String val) {
      f047 = val;
  }
  public void setF048(String val) {
      f048 = val;
  }
  public void setF049(String val) {
      f049 = val;;
  }
  public void setF050(String val) {
      f050 = val;;
  }
  public void setF051(String val) {
      f051 = val;;
  }
  public void setF052(String val) {
      f052 = val;;
  }
  public void setF053(String val) {
      f053 = val;;
  }
  public void setF054(String val) {
      f054 = val;;
  }
  public void setF055(String val) {
      f055 = val;;
  }
//-----------reserved------------------
  public void setF056(String val) {
      F056 = val;;
  }
  public void setF057(String val) {
      F057 = val;;
  }
  public void setF058(String val) {
      F058 = val;;
  }
  public void setF059(String val) {
      F059 = val;;
  }
  public void setF060(String val) {
      F060 = val;;
  }
  public void setF061(String val) {
      F061 = val;;
  }
  public void setF062(String val) {
      F062 = val;;
  }
  public void setF063(String val) {
      F063 = val;;
  }
  public void setF064(String val) {
      F064 = val;;
  }
*/
//--------------------------------------------------
//--------------------------------------------------
}
