package assays.hibernate;

public final class UserGroupRights extends AssayPersistent {
  private UserGroup grantedBy;
  private UserGroup grantedTo;
  private Integer accessRights;
  private Integer defineViewRights;

  public UserGroup getGrantedBy(){
    return grantedBy;
  }
  public UserGroup getGrantedTo(){
    return grantedTo;
  }
  public Integer getAccessRights(){
    return accessRights;
  }
  public Integer getDefineViewRights(){
    return defineViewRights;
  }
  public int getDefineViewRightsValue(){
    return (defineViewRights==null)?0:defineViewRights.intValue();
  }

  public void setGrantedBy(UserGroup val){
    grantedBy = val;
  }
  public void setGrantedTo(UserGroup val){
    grantedTo = val;
  }
  public void setAccessRights(Integer val){
    accessRights = val;
  }
  public void setDefineViewRights(Integer val){
	defineViewRights = val;
  }

  private static final String[] accessVariants = {
      "non-accessible",
      "view only, data files non-accessible",
      "view only, data files accessible",
      "full access"
  };
  private static final int[] accessValues = {
      0, 1000, 2000, 3000
  };
  public static String getAccessRightSelectionNew(){
    StringBuffer xyz = new StringBuffer();
    for (int i = 0; i < accessVariants.length; i++){
        xyz.append("<option ");
        xyz.append("value=\"")
            .append( accessValues[i])
            .append("\">")
            .append(accessVariants[i]);
      }
    return xyz.toString();
  }

  public String getAccessRightSelection(){
    StringBuffer xyz = new StringBuffer();
    int j = 1; int v = (accessRights!=null)?accessRights.intValue():0;
    while ( j < accessValues.length && v >= accessValues[j]) j++;
    j--;
    for (int i = 0; i < accessVariants.length; i++){
        xyz.append("<option ");
        if ( i==j) xyz.append("selected ");
        xyz.append("value=\"")
            .append( accessValues[i])
            .append("\">")
            .append(accessVariants[i]);
      }
    return xyz.toString();
  }
  public String getAccessRightText(){
    int j = 1; int v = (accessRights!=null)?accessRights.intValue():0;
    while ( j < accessValues.length && v >= accessValues[j]) j++;
    return accessVariants[--j];
  }
  public String getDefineViewRightText(){
	int v = (defineViewRights!=null)?defineViewRights.intValue():0;  
	return (v==0)?"no":"yes";
  }
  public boolean canDefineView(){
	return defineViewRights!=null&&defineViewRights.intValue()>0;
  }
}
