package assays.hibernate;

import assays.com.Util;
import java.util.ArrayList;
import java.util.List;

public final class Vocabulary extends TechnologyPersistent {
  private String contents;  //format: pk \n fk \n visibleText \r
  private String longName;

  public String getContents(){
    return contents;
  }

  public String getLongName(){
    return longName;
  }

  public boolean existsValue( String value){
    String key = value;
    if (contents!=null){
      int k = 0;
      int l = contents.indexOf('\n');
      while (l > k){
        k = l + 1; l = contents.indexOf('\n', k);
        k = l + 1; l = contents.indexOf('\r', k);
        if (contents.substring(k, l).equals( key)) return true;
        k = l + 1; l = contents.indexOf('\n', k);
      }
    }
    return false;
  }

  public String getIdByValue( String value){
    String key = value;
    String id = "0";
    if (contents!=null){
      int k = 0, k1, l1;
      int l = contents.indexOf('\n');
      while (l > k){
        k1 = k; l1 = l;
        k = l + 1; l = contents.indexOf('\n', k);
        k = l + 1; l = contents.indexOf('\r', k);
        if (contents.substring(k, l).equals( key)) {
          id = contents.substring(k1, l1); break;
        }
        k = l + 1; l = contents.indexOf('\n', k);
      }
    }
    return id;
  }

  public String findIdByValue( String value){
    String key = value;
    int size = value.length();
    boolean found = false;
    String id = "0";
    if (contents!=null){
      int k = 0, k1, l1, ke;
      int l = contents.indexOf('\n');
      while (l > k){
        k1 = k; l1 = l;
        k = l + 1; l = contents.indexOf('\n', k);
        k = l + 1; l = contents.indexOf('\r', k);
        ke = k + size;
        if ( l >= ke && contents.substring(k, ke).equals( key)) {
          if ( found){ id = "0"; break; }
          id = contents.substring(k1, l1);
          found = true;
        }
        k = l + 1; l = contents.indexOf('\n', k);
      }
    }
    return id;
  }

  public String getValueById( String id){
    String result = null;
    String key = id;
    if (contents!=null){
      int k = 0;
      int l = contents.indexOf('\n');
      while (l > k){
        if (contents.substring(k, l).equals(key)) {
          k = l + 1; l = contents.indexOf('\n', k);
          k = l + 1; l = contents.indexOf('\r', k);
          result = contents.substring(k, l);
          break;
        }
        k = l + 1; l = contents.indexOf('\r', k);
        k = l + 1; l = contents.indexOf('\n', k);
      }
    }
    return result;
  }

  public void shiftUp( String id){
    String key = id;
    if (contents!=null){
      int k = 0;  int prev = 0, me;
      int l = contents.indexOf('\n');
      while (l > k){
        if (contents.substring(k, l).equals(key)) {
          if (k > 0){
            me = k;
            k = l + 1; l = contents.indexOf('\r', k);
            contents = contents.substring(0,prev)
                +contents.substring(me, l+1)
                +contents.substring(prev, me)
                +contents.substring(l+1);
          }
          break;
        }
        prev = k;
        k = l + 1; l = contents.indexOf('\r', k);
        k = l + 1; l = contents.indexOf('\n', k);
      }
    }
  }

  public void shiftDown( String id){
    String key = id;
    if (contents!=null){
      int k = 0;  int next, me;
      int l = contents.indexOf('\n');
      while (l > k){
        if (contents.substring(k, l).equals(key)) {
          me = k;
          k = l + 1; l = contents.indexOf('\r', k);
          k = l + 1; next = k;
          l = contents.indexOf('\r', k);
          if (l > k){
            contents = contents.substring(0, me)
                + contents.substring(next, l + 1)
                + contents.substring(me, next)
                + contents.substring(l + 1);
          }
          break;
        }
        k = l + 1; l = contents.indexOf('\r', k);
        k = l + 1; l = contents.indexOf('\n', k);
      }
    }
  }

public String getTableView( String jspRef, boolean canEdit) {
  StringBuffer xyz = new StringBuffer();
  xyz.append("<tbody>");
  if (contents!=null){
    boolean stripOn = true;
    int k = 0; int me;
    int l = contents.indexOf('\n');
    while (l > k){
      String currStripe = (stripOn) ? "son" : "soff";
      stripOn = !stripOn;
      me = k;
      String key = contents.substring(k, l);
      k = l + 1; l = contents.indexOf('\n', k);
      k = l + 1; l = contents.indexOf('\r', k);
      String value = contents.substring(k, l);

      xyz.append("<tr class=\"")
         .append(currStripe)
         .append("\"><td>")
         .append(Util.getHTMLString(value))
         .append("</td><td>");
      if (canEdit)
        xyz.append("<a HREF=\"")
           .append(jspRef)
           .append("?tabId=")
           .append(getId())
           .append("&objId=")
           .append(key)
           .append("\">")
           .append("<img border=\"0\" src=\"./images/edit_a.gif\"")
           .append(" onmouseover=\"this.src='./images/edit_b.gif'\"")
           .append(" onmouseout=\"this.src='./images/edit_a.gif'\"")
           .append(" title=\"edit\" alt=\"\"></a>");
      else
        xyz.append("&nbsp;");
      xyz.append("</td><td>");
      if (me > 0)
        xyz.append("<a HREF=\"")
         .append(jspRef)
         .append("?upId=")
         .append(getId())
         .append("&objId=")
         .append(key)
         .append("&aname=")
         .append(getVisibleName())
         .append("\">")
         .append("<img border=\"0\" src=\"./images/up_10.gif\"")
         .append(" title=\"up\" alt=\"\"></a>");
      else
        xyz.append("&nbsp;");
      xyz.append("</td><td>");
      k = l + 1; l = contents.indexOf('\n', k);
      if (l > k)
        xyz.append("<a HREF=\"")
        .append(jspRef)
        .append("?downId=")
        .append(getId())
        .append("&objId=")
        .append(key)
        .append("&aname=")
        .append(getVisibleName())
        .append("\">")
        .append("<img border=\"0\" src=\"./images/down_10.gif\"")
        .append(" title=\"down\" alt=\"\"></a>");
      else
        xyz.append("&nbsp;");
      xyz.append("</td></tr>");
    }
  }
  xyz.append("</tbody>");
  return xyz.toString();
}

public String getTableView1( String jspRef, boolean canEdit) {
	  StringBuffer xyz = new StringBuffer();
	  xyz.append("<tbody>");
	  if (contents!=null){
	    boolean stripOn = true;
	    int k = 0; int me;
	    int l = contents.indexOf('\n');
	    while (l > k){
	      String currStripe = (stripOn) ? "son" : "soff";
	      stripOn = !stripOn;
	      me = k;
	      String key = contents.substring(k, l);
	      k = l + 1; l = contents.indexOf('\n', k);
	      k = l + 1; l = contents.indexOf('\r', k);
	      String value = contents.substring(k, l);

	      xyz.append("<tr class=\"")
	         .append(currStripe)
	         .append("\"><td>");
	if (canEdit) {      
		xyz.append("<a onclick=\"goEdit('") 
	       .append(getId())
	   	   .append("','")
	       .append(key)
	   	   .append("')\"> ")
	       .append("<img border=\"0\" src=\"./images/edit_a.gif\" onmouseover=\"In2(this)\" onmouseout=\"Out2(this)\"")
	       .append( "title=\"edit\" alt=\"\"/></a>");
	} else {
		xyz.append("<a disabled>") 
	       .append("<img border=\"0\" src=\"./images/edit_a.gif\"></a>");
	} 
    xyz.append("</td><td>")
    .append(Util.getHTMLString(value))
    .append("</td><td>");
    if (me > 0)
	        xyz.append("<a HREF=\"")
	         .append(jspRef)
	         .append("?upId=")
	         .append(getId())
	         .append("&objId=")
	         .append(key)
	         .append("&aname=")
	         .append(getVisibleName())
	         .append("\">")
	         .append("<img border=\"0\" src=\"./images/up_10.gif\"")
	         .append(" title=\"up\" alt=\"\"></a>");
	      else
	        xyz.append("&nbsp;");
	      xyz.append("</td><td>");
	      k = l + 1; l = contents.indexOf('\n', k);
	      if (l > k)
	        xyz.append("<a HREF=\"")
	        .append(jspRef)
	        .append("?downId=")
	        .append(getId())
	        .append("&objId=")
	        .append(key)
	        .append("&aname=")
	        .append(getVisibleName())
	        .append("\">")
	        .append("<img border=\"0\" src=\"./images/down_10.gif\"")
	        .append(" title=\"down\" alt=\"\"></a>");
	      else
	        xyz.append("&nbsp;");
	      xyz.append("</td></tr>");
	    }
	  }
	  xyz.append("</tbody>");
	  return xyz.toString();
	}
  public String getObjectPrompter(String objId) {
    StringBuffer xyz = new StringBuffer();
    xyz.append("<option value=\"\">")
       .append(MetadataManager.getString("-selval-"))
       .append("</option>");
    if (contents!=null){
      int k = 0;
      int l = contents.indexOf('\n');
      while (l > k){
        String key = contents.substring(k, l);
        k = l + 1; l = contents.indexOf('\n', k);
        k = l + 1; l = contents.indexOf('\r', k);
        if (key.equals(objId))
          xyz.append("<option selected value=\"");
        else
          xyz.append("<option value=\"");
        xyz.append(key)
          .append("\">")
          .append(Util.getHTMLString(contents.substring(k, l)))
          .append("</option>");
        k = l + 1; l = contents.indexOf('\n', k);
      }
    }
    return xyz.toString();
  }
  private String getFigureBackgr( int styl) {
    String myBackgr = (styl<1)?"":
      (styl<2)?" disabled style=\"background-color:#FFFFFF;\"":
      (styl<3)?" disabled style=\"background-color:#E5EAF0;\"":
               " style=\"background-color:#F0C0C0;\"";
    return myBackgr;
  }
  public String getObjectPrompter(String objId, String fieldName, int styl) {
	    StringBuffer xyz = new StringBuffer();
//	    xyz.append("<option value=\"\">")
//	       .append(MetadataManager.getString("-selval-"));
	    if (contents!=null){
	      int k = 0;
	      int l = contents.indexOf('\n');
	      while (l > k){
	        String key = contents.substring(k, l);
	        k = l + 1; l = contents.indexOf('\n', k);
	        k = l + 1; l = contents.indexOf('\r', k);
	        
	         xyz.append("<nobr><input type=\"radio\" name=\"")
	          .append(fieldName)
	          .append("\" value=\"")
	          .append(key)
	          .append("\"");
	         if (key.equals(objId)) xyz.append(" checked");
	         xyz.append(getFigureBackgr(styl))
	          .append("/>")
              .append(Util.getHTMLString(contents.substring(k, l)))
              .append("</nobr> &nbsp;");
	        k = l + 1; l = contents.indexOf('\n', k);
	      }
	    }
	    return xyz.toString();
	  }

  public List getValueList() {
    ArrayList<String> xyz = new ArrayList<String>(getEntryCount());
    if (contents!=null){
      int k = 0;
      int l = contents.indexOf('\n');
      while (l > k){
        k = l + 1; l = contents.indexOf('\n', k);
        k = l + 1; l = contents.indexOf('\r', k);
        xyz.add(Util.getHTMLString(contents.substring(k, l)));
        k = l + 1; l = contents.indexOf('\n', k);
      }
    }
    return xyz;
  }

  public List getKeyList() {
    ArrayList<String> xyz = new ArrayList<String>(getEntryCount());
    if (contents!=null){
      int k = 0;
      int l = contents.indexOf('\n');
      while (l > k){
        xyz.add(contents.substring(k, l));
        k = l + 1; l = contents.indexOf('\n', k);
        k = l + 1; l = contents.indexOf('\r', k);
        k = l + 1; l = contents.indexOf('\n', k);
      }
    }
    return xyz;
  }

  public int getEntryCount(){
    int result = 0;
    if (contents!=null){
      int k = 0;
      int l = contents.indexOf('\r');
      while (l > k){
        result++;
        k = l + 1; l = contents.indexOf('\r', k);
      }
    }
    return result;
  }

  public String getFreeId(){
    int result = 0;
    if (contents!=null){
      int k = 0;
      int l = contents.indexOf('\n');
      while (l > k){
        int x = Util.getIntegerValue( contents.substring(k, l));
        if (x > result) result = x;
        k = l + 1; l = contents.indexOf('\r', k);
        k = l + 1; l = contents.indexOf('\n', k);
      }
    }
    return String.valueOf(++result);
  }

  public void addValue( String value){
    String key = getFreeId();
    if (contents!=null)
      contents = contents + key + "\n0\n" + value + '\r';
    else
      contents = key + "\n0\n" + value + '\r';
  }

  public void addValueAndId( String id, String value){
    if (contents!=null)
      contents = contents + id + "\n0\n" + value + '\r';
    else
      contents = id + "\n0\n" + value + '\r';
  }

  public void updateValue( String id, String value){
    String key = id;
    if (contents!=null){
      int k = 0;
      int l = contents.indexOf('\n');
      while (l > k){
        if (contents.substring(k, l).equals(key)) {
          k = l + 1; l = contents.indexOf('\n', k);
          k = l + 1; l = contents.indexOf('\r', k);
          contents = contents.substring(0, k)+value+contents.substring(l);
          break;
        }
        k = l + 1; l = contents.indexOf('\r', k);
        k = l + 1; l = contents.indexOf('\n', k);
      }
    }
  }

  public void deleteValue( String id){
    String key = id;
    if (contents!=null){
      int k = 0;
      int l = contents.indexOf('\n');
      while (l > k){
        if (contents.substring(k, l).equals(key)) {
          l = contents.indexOf('\r', l + 1) + 1;
          if (k==0)
            if (l < contents.length())
              contents = contents.substring(l);
            else
              contents = null;
          else
            if (l < contents.length())
              contents = contents.substring(0, k)+contents.substring(l);
            else
              contents = contents.substring(0, k);
          break;
        }
        k = l + 1; l = contents.indexOf('\r', k);
        k = l + 1; l = contents.indexOf('\n', k);
      }
    }
  }

  public String getBookForType( String type, String objId) {
    StringBuffer xyz = new StringBuffer();
    xyz.append("<option value=\"\">")
      .append(MetadataManager.getString("-selval-"))
      .append("</option>");
    if (contents!=null){
      int k = 0;
      int l = contents.indexOf('\n');
      while (l > k){
        String key = contents.substring(k, l);
        k = l + 1; l = contents.indexOf('\n', k);
        String typeKey = contents.substring(k, l);
        k = l + 1; l = contents.indexOf('\r', k);
        if (type.equals(typeKey)){
          if (objId.equals(key))
            xyz.append("<option selected value='");
          else
            xyz.append("<option value='");
          xyz.append(key)
            .append("'>")
            .append(Util.getHTMLString(contents.substring(k, l)))
            .append("</option>");
        }
        k = l + 1; l = contents.indexOf('\n', k);
      }
    }
    return xyz.toString();
  }

  public void setContents( String val){
    contents = val;
  }

  public void setLongName( String val){
    longName = val;
  }
}
