package assays.pri;

import org.hibernate.SessionFactory;
import java.io.File;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContext;
import assays.hibernate.*;
import sims.hibernate.*;

import org.hibernate.cfg.Configuration;
import assays.com.Util;

public class WebappConfig {

private static String applicationPath = null;
private static File protocolDirectory = null;
private static File dataDirectory = null;
private static File workDirectory = null;
private static File exportMetadataFileDirectory = null;
private static File exportEGAConfigurationDirectory = null;
private static File dataTransferConfigurationDirectory = null;
private static boolean isFtp = false;
private static File ftpDirectory = null;
private static String ftpServerHint = null;
private static String ftpDirectoryHint = null;

private static String smtpHost = null;
private static String smtpFrom = null;
private static String smtpSubjectPrefix = null;
private static String smtpUser = null;
private static String smtpPassword = null;
private static String serviceEmail = null;

private static String logoutProc = null;
private static String secondUser = null;
private static SessionFactory hibFactory = null;
private static SessionFactory sampleFactory = null;
private static int viewLimit = 0;
private static boolean useSamples = false;
private static Configuration assayCfg = null;
private static Configuration sampleCfg = null;
private static File systemConstants = null;
private static File stringConstants = null;

public static void destroy(){
  try {
    if (hibFactory != null) {
      hibFactory.close();
      hibFactory = null;
    }
    if (sampleFactory != null) {
      sampleFactory.close();
      sampleFactory = null;
    }
    Util.writeEndOfApplication();
  }
  catch (Exception ex) {
    Util.writeLog("Close factory",
                   ex.getMessage(),
                   "");
  }
}

public static  void contextInitialized(ServletContextEvent sctx)
  {
    contextInitialized( sctx.getServletContext());
  }
public static  void contextInitialized(ServletContext sct)
  {
	applicationPath = sct.getRealPath("");
	File logDirectory = new File( sct.getRealPath("/log"));
    logDirectory.mkdir();
    Util.initializeLog( logDirectory);
	File confDirectory = new File( sct.getRealPath("/conf"));
    confDirectory.mkdir();
    systemConstants = new File( confDirectory, "systemConst.xml");
    stringConstants = new File( confDirectory, "stringConst.xml");
    assayCfg = new Configuration();
    String url = sct.getInitParameter("assay.url");
    String username = sct.getInitParameter("assay.username");
    String password = sct.getInitParameter("assay.password");
    String sampleTomdir = null ;
    if (password != null) assayCfg.setProperty("hibernate.connection.password",password);
    if (username != null) assayCfg.setProperty("hibernate.connection.username",username);
    if (url != null) assayCfg.setProperty("hibernate.connection.url",url);
/*--------------------------------------*/
/*--------------------------------------*/
    assayCfg.addClass(AssayUser.class)
        .addClass(assays.hibernate.AssayProjectPartner.class)
        .addClass(AssayUserRights.class)
        .addClass(TechnologyAccess.class)
        .addClass(assays.hibernate.UserGroup.class)
        .addClass(assays.hibernate.UserGroupRights.class)
        .addClass(assays.hibernate.UserGroupMembership.class)
        .addClass(Assay.class)
        .addClass(StudyGroup.class)
        .addClass(StudyView.class)
        .addClass(ViewStudyMembership.class)
        .addClass(assays.hibernate.TransferType.class)
        .addClass(Technology.class)
        .addClass(ParameterGroup.class)
        .addClass(ParameterType.class)
        .addClass(Parameter.class)
        .addClass(CommonParameter.class)
        .addClass(assays.hibernate.ProtocolType.class)
        .addClass(assays.hibernate.DataType.class)
        .addClass(assays.hibernate.Vocabulary.class)
        .addClass(assays.hibernate.VersionNumber.class)
        .addClass(assays.hibernate.PendingTask.class)
        .addClass(assays.hibernate.PendingExport.class);
//    hibFactory = assayCfg.buildSessionFactory();
    String tmp11 = sct.getInitParameter("usesamples");
    useSamples = (tmp11 != null)&&(tmp11.equals("yes"));
    if (useSamples){
      url = sct.getInitParameter("sample.url");
      username = sct.getInitParameter("sample.username");
      password = sct.getInitParameter("sample.password");
      sampleTomdir = sct.getInitParameter("sample.tomcat_directory"); 
      if (url==null) { useSamples = false;
        Util.writeLog("Context Initialize error", "Missing parameter for SIMS use", "sample.url");
      }
      if (username==null) { useSamples = false;
        Util.writeLog("Context Initialize error", "Missing parameter for SIMS use", "sample.username");
      }
      if (password==null) { useSamples = false;
        Util.writeLog("Context Initialize error", "Missing parameter for SIMS use", "sample.password");
      }
      if (sampleTomdir==null) { useSamples = false;
        Util.writeLog("Context Initialize error", "Missing parameter for SIMS use", "sample.tomcat_directory");
      }
//      if (!useSamples)
//        Util.writeLog("Context Initialize error", "Missing parameter for SIMS use", "");
    }  
    if (useSamples){
      sampleCfg = new Configuration();
      sampleCfg.setProperty("hibernate.connection.password", password);
      sampleCfg.setProperty("hibernate.connection.username", username);
      sampleCfg.setProperty("hibernate.connection.url", url); 
 	  File sampleConfDirectory = new File( sampleTomdir, "conf");
   	  sampleConfDirectory.mkdir();
   	  File sampleSystemConstants = new File( sampleConfDirectory, "systemConst.xml");
      VocabulName.processConstants( sampleSystemConstants);
      try {
//    	File simsDirectory = new File(sct.getRealPath("//WEB-INF//classes//sims//hibernate//"));
    	File simsDirectory = new File( sampleTomdir, "//WEB-INF//classes//sims//hibernate//");
 		sampleCfg.addDirectory(simsDirectory);
  		sampleCfg.createMappings();
/*    	  
        sampleCfg.addClass(User.class)
         .addClass(sims.hibernate.ProjectPartner.class)
         .addClass(STechnologyAccess.class)
         .addClass(STechnology.class)
         .addClass(sims.hibernate.UserGroup.class)
         .addClass(sims.hibernate.UserGroupMembership.class)
         .addClass(sims.hibernate.UserRights.class)
         .addClass(sims.hibernate.UserGroupRights.class);
        sampleCfg.addClass(Bottom.class)
                 .addClass(Middle.class)
                 .addClass(Top.class);
      } catch (Exception ex) {
        Util.writeLog("WebappConfig",
                     "addClassSimsFactory1",
                      ex.getMessage());
      }

    try {
      sampleCfg.addClass(Relation.class)
         .addClass(RelationType.class)
         .addClass(TopMetaData.class)
         .addClass(MiddleMetaData.class)
         .addClass(BottomMetaData.class);
    } catch (Exception ex) {
      Util.writeLog("WebappConfig",
                   "addClassSimsFactory1",
                    ex.getMessage());
    }
    for (int i = 1; i <= VocabulName.getVocabularyCount() ; i++) {
         try {
           Class cvtxy = Class.forName(VocabulName.getClassNameVT(i));
           sampleCfg.addClass(cvtxy);
         } catch (Exception ex) {
           Util.writeLog("WebappConfig",
                        "addClassSimsFactory2",
                         ex.getMessage());
         }
       }
       for (int i = 1; i <= VocabulName.getDependencyCount() ; i++) {
         try {
           Class cvtxy = VocabulName.getDependencyClass(i);
           sampleCfg.addClass(cvtxy);
         } catch (Exception ex) {
           Util.writeLog("WebappConfig",
                        "addClassSimsFactory3",
                         ex.getMessage());
         }
       }
       for (int i = 1; i <= VocabulName.getIdentificyCount() ; i++) {
         try {
           Class cvtxy = VocabulName.getIdentificyClass(i);
           sampleCfg.addClass(cvtxy);
         } catch (Exception ex) {
           Util.writeLog("WebappConfig",
                        "addClassSimsFactory4",
                         ex.getMessage());
         }
       }
*/
      } catch (Exception ex) {
         Util.writeLog("WebappConfig",
                       "addClassSimsFactory",
                        ex.getMessage());
      }
    }
    tmp11 = sct.getInitParameter("protocol.directory");
    if (tmp11 != null) {
//      if (tmp11.indexOf(':') < 1)
//        protocolDirectory = new File( applicationPath, tmp11);
//      else
        protocolDirectory = new File( tmp11);
      protocolDirectory.mkdir();
    }
    tmp11 = sct.getInitParameter("data.directory");
    if (tmp11 != null) {
//      if (tmp11.indexOf(':') < 1)
//    	dataDirectory = new File( applicationPath, tmp11);
//      else
    	dataDirectory = new File( tmp11);
      dataDirectory.mkdir();
    }
    tmp11 = sct.getInitParameter("export_file.directory");
    if (tmp11 != null) {
//      if (tmp11.indexOf(':') < 1)
//    	exportMetadataFileDirectory = new File( applicationPath, tmp11);
//      else
    	exportMetadataFileDirectory = new File( tmp11);
  	  exportMetadataFileDirectory.mkdir();
    }
    tmp11 = sct.getInitParameter("export_ega_configuration.directory");
    if (tmp11 != null) {
//      if (tmp11.indexOf(':') < 1)
//      	exportEGAConfigurationDirectory = new File( applicationPath, tmp11);
//      else
      	exportEGAConfigurationDirectory = new File( tmp11);
      exportEGAConfigurationDirectory.mkdir();
    }
    tmp11 = sct.getInitParameter("data_transfer_configuration.directory");
    if (tmp11 != null) {
      dataTransferConfigurationDirectory = new File( tmp11);
      dataTransferConfigurationDirectory.mkdir();
    }
    if (protocolDirectory == null) {
      protocolDirectory = new File(sct.getRealPath("/protocol_files"));
      protocolDirectory.mkdir();
    }
    if (dataDirectory == null) {
      dataDirectory = new File(sct.getRealPath("/data_files"));
      dataDirectory.mkdir();
    }
    workDirectory = new File( sct.getRealPath("/work"));
    workDirectory.mkdir();
    // Prepares limit of view tables row number
    tmp11 = sct.getInitParameter("viewlimit");
    if (tmp11 != null) {
        viewLimit = Util.getIntegerValue( tmp11);
    }
    tmp11 = sct.getInitParameter("ftp.directory");
    if (tmp11 != null) {
      ftpDirectory = new File( tmp11);
      isFtp = (ftpDirectory != null);
    }
    ftpServerHint = sct.getInitParameter("ftp.server.popup");
    ftpDirectoryHint = sct.getInitParameter("ftp.directory.popup");
    logoutProc = sct.getInitParameter("logoutproc");
    secondUser = sct.getInitParameter("seconduser");


    smtpHost = sct.getInitParameter("smtp.host");
    smtpFrom = sct.getInitParameter("smtp.from");
    smtpSubjectPrefix = sct.getInitParameter("smtp.subject.prefix");
    smtpUser = sct.getInitParameter("smtp.user");
    smtpPassword = sct.getInitParameter("smtp.password");
    serviceEmail = sct.getInitParameter("service.email");
  }
  public static String getApplicationPath(){
	return applicationPath;  
  }

  public static String getDataDirectoryPath(){
    if (dataDirectory==null)return "not exists";
    else
      return dataDirectory.getAbsolutePath();
  }

  public static String getProtocolDirectoryPath(){
    if (protocolDirectory==null)return "not exists";
    else
      return protocolDirectory.getAbsolutePath();
  }
  
  public static String getDataTransferConfigurationPath(){
    if (dataTransferConfigurationDirectory==null)return "not exists";
    else
      return dataTransferConfigurationDirectory.getAbsolutePath();
  }

  public static String getExportMetadataFileDirectoryPath(){
    if (exportMetadataFileDirectory==null)return "not exists";
    else
      return exportMetadataFileDirectory.getAbsolutePath();
  }

  public static String getFtpDirectoryPath(){
    if (ftpDirectory==null)return "not exists";
    else
      return ftpDirectory.getAbsolutePath();
  }

  public static File getProtocolDirectory(){
      return protocolDirectory;
  }

  public static File getDataDirectory(){
      return dataDirectory;
  }
  
  public static File getExportEGAConfigurationDirectory(){
	return exportEGAConfigurationDirectory; 
  }

  public static File getDataTransferConfigurationDirectory(){
	return dataTransferConfigurationDirectory; 
  }
  
  public static File getExportMetadataFileDirectory(){
	if (exportMetadataFileDirectory==null){  
   	  exportMetadataFileDirectory = new File( applicationPath, "export_metadata_files");
	  exportMetadataFileDirectory.mkdir();
	}
	return exportMetadataFileDirectory;
  }

  public static File getWorkDirectory(){
      return workDirectory;
  }

  public static boolean isFtp(){
      return isFtp;
  }

  public static File getFtpDirectory(){
      return ftpDirectory;
  }

  public static String getFtpServerHint(){
      return ftpServerHint;
  }

  public static String getFtpDirectoryHint(){
      return ftpDirectoryHint;
  }
  public static String getLogoutProc(){
      return logoutProc;
  }

  public static String getSecondUser(){
      return secondUser;
  }

  public static int getViewLimit(){
      return viewLimit;
  }

  public static boolean isUseSamples(){
      return useSamples;
  }

  public static String getSmtpHost(){
      if (smtpHost==null) return "";
      else return smtpHost;
  }
  public static String getSmtpFrom(){
      if (smtpFrom==null) return "";
      else return smtpFrom;
  }
  public static String getSmtpUser(){
      if (smtpUser==null) return "";
      else return smtpUser;
  }
  public static String getSmtpPassword(){
      if (smtpPassword==null) return "";
      else return smtpPassword;
  }
  public static String getSmtpSubjectPrefix(){
      if (smtpSubjectPrefix==null) return "";
      else return smtpSubjectPrefix;
  }
  public static String getServiceEmail(){
      if (serviceEmail==null) return "";
      else return serviceEmail;
  }
//------------------------------------------------------------------  
  public static SessionFactory getAssaySessionFactory(){
    if (hibFactory == null)
 	  try {
    	hibFactory = assayCfg.buildSessionFactory();
      }
      catch (Exception ex) {
        Util.writeLog("Build AIMS factory error", ex.getMessage(), "");
      }  
    return hibFactory;
  }

  public static SessionFactory getSamplesSessionFactory(){
    if (useSamples && sampleFactory == null)
      try {
        sampleFactory = sampleCfg.buildSessionFactory();
      }
      catch (Exception ex) {
        Util.writeLog("Build SIMS factory error", ex.getMessage(),"");
      }
    return sampleFactory;
  }
//------------------------------------------------------------------  
  public static void setSecondUser( String val){
      secondUser = val;
  }

  public static File getSystemConstants(){
      return systemConstants;
  }

  public static File getStringConstants(){
      return stringConstants;
  }
}
